{|
  Unit   : uEstSearchDialogConst
  Datum  : 6-12-2003
  Auteur : Erik Stok
  Doel   : Searchdialog constanten.
|}           

unit uEstSearchDialogConst;

interface

uses
  DB;

type
  TSearchComparison = (scLess, scLessEqual, scEqual, scGreater, scGreaterEqual, scNotEqual,
                       scBeginsWith, scNotBeginsWith, scContains, scNotContains, scEndsWith, scNotEndsWith,
                       scLessString, scLessEqualString, scEqualString, scGreaterString, scGreaterEqualString, scNotEqualString,
                       scEmpty, scNotEmpty);

  TSearchComparisons = set of TSearchComparison;

  TSearchComparisonRecord = record
    FieldType   : TFieldType;
    Comparisons : TSearchComparisons;
  end;

  TSearchOperator = (soAnd, soOr, soAndAll, soOrAll);

  TSearchEmptyOperation = (eoNull, eoEmptyString, eoBoth);

  TSearchStyle = (ssModal, ssNormal, ssMDIChild);

const

  REG_SDL_COUNT = 'CriteriaCount';
  REG_SDL_FIELD = 'Field';
  REG_SDL_COMPARISON = 'Comparison';
  REG_SDL_OPERATOR = 'Operator';
  REG_SDL_VALUE = 'Value';

  WHERE_TAG = '%WHERE%';

  SPECIALVALUE_NOW = 'NOW';
  SPECIALVALUE_SECOND = 'SECOND';
  SPECIALVALUE_MINUTE = 'MINUTE';
  SPECIALVALUE_HOUR = 'HOUR';
  SPECIALVALUE_DAY = 'DAY';
  SPECIALVALUE_WEEK = 'WEEK';
  SPECIALVALUE_MONTH = 'MONTH';
  SPECIALVALUE_QUARTER = 'QUARTER';
  SPECIALVALUE_YEAR = 'YEAR';

  EMPTYCOMPARISON: array[eoNull..eoBoth] of String =
                     ('%s IS NULL', '%s = ""', '(%s IS NULL) OR (%s = "")'); 

  NOTEMPTYCOMPARISON: array[eoNull..eoBoth] of String =
                      ('%s IS NOT NULL', '%s <> ""', '(%s IS NOT NULL) OR (%s <> "")');

  SEARCH_COMPARISON: array[scLess..scNotEmpty] of String =
                       ('< %s',
                        '<= %s',
                        '= %s',
                        '> %s',
                        '>= %s',
                        '<> %s',
                        'LIKE "%s%%"',
                        'NOT LIKE "%s%%"',
                        'LIKE "%%%s%%"',
                        'NOT LIKE "%%%s%%"',
                        'LIKE "%%%s"',
                        'NOT LIKE "%%%s"',
                        '< "%s"',
                        '<= "%s"',
                        '= "%s"',
                        '> "%s"',
                        '>= "%s"',
                        '<> "%s"',
                        '<determined by field empty operation setting>',
                        '<determined by field empty operation setting>');

  SEARCH_COMPARISONTEXT: array[scLess..scNotEmpty] of String =
                           ('<',
                            '<=',
                            '=',
                            '>',
                            '>=',
                            '<>',
                            'starts with',
                            'does not start with',
                            'contains',
                            'does not contain',
                            'ends with',
                            'does not end with',
                            '<',
                            '<=',
                            '=',
                            '>',
                            '>=',
                            '<>',
                            'is empty',
                            'is not empty');

{ Alle veldtypen:
  TFieldType = ftUnknown, ftString, ftSmallint, ftInteger, ftWord,
    ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
    ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic, ftFmtMemo,
    ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor, ftFixedChar, ftWideString,
    ftLargeint, ftADT, ftArray, ftReference, ftDataSet, ftOraBlob, ftOraClob,
    ftVariant, ftInterface, ftIDispatch, ftGuid, ftTimeStamp, ftFMTBcd);
}

  VALIDCOMPARISON_NONE = [];
  VALIDCOMPARISON_NUMBER = [scLess, scLessEqual, scEqual, scGreater, scGreaterEqual, scNotEqual, scEmpty, scNotEmpty];
  VALIDCOMPARISON_BOOLEAN = [scEqual, scNotEqual, scEmpty, scNotEmpty];
  VALIDCOMPARISON_DATETIME = VALIDCOMPARISON_NUMBER;
  VALIDCOMPARISON_STRING = [scLessString, scLessEqualString, scEqualString, scGreaterString, scGreaterEqualString,
                            scBeginsWith, scNotBeginsWith, scContains, scNotContains, scEndsWith, scNotEndsWith,
                            scEmpty, scNotEmpty];

  QUOTEDFIELDTYPES = [ftString, ftFixedChar, ftWideString];

  VALIDCOMPARISONS: array[0..37] of TSearchComparisonRecord = (
                        (FieldType:ftUnknown;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftString;         Comparisons:VALIDCOMPARISON_STRING),
                        (FieldType:ftSmallint;       Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftInteger;        Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftWord;           Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftBoolean;        Comparisons:VALIDCOMPARISON_BOOLEAN),
                        (FieldType:ftFloat;          Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftCurrency;       Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftBCD;            Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftDate;           Comparisons:VALIDCOMPARISON_DATETIME),
                        (FieldType:ftTime;           Comparisons:VALIDCOMPARISON_DATETIME),
                        (FieldType:ftDateTime;       Comparisons:VALIDCOMPARISON_DATETIME),
                        (FieldType:ftBytes;          Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftVarBytes;       Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftAutoInc;        Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftBlob;           Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftMemo;           Comparisons:VALIDCOMPARISON_STRING),
                        (FieldType:ftGraphic;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftFmtMemo;        Comparisons:VALIDCOMPARISON_STRING),
                        (FieldType:ftParadoxOle;     Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftDBaseOle;       Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftTypedBinary;    Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftCursor;         Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftFixedChar;      Comparisons:VALIDCOMPARISON_STRING),
                        (FieldType:ftWideString;     Comparisons:VALIDCOMPARISON_STRING),
                        (FieldType:ftLargeint;       Comparisons:VALIDCOMPARISON_NUMBER),
                        (FieldType:ftADT;            Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftArray;          Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftReference;      Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftDataSet;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftOraBlob;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftOraClob;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftVariant;        Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftInterface;      Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftIDispatch;      Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftGuid;           Comparisons:VALIDCOMPARISON_NONE),
                        (FieldType:ftTimeStamp;      Comparisons:VALIDCOMPARISON_DATETIME),
                        (FieldType:ftFMTBcd;         Comparisons:VALIDCOMPARISON_NONE));


  OPERATOR_TEXT: array[soAnd..soOrAll] of String =
                   ('and',
                    'or',
                    'and all',
                    'or all');

  OPERATOR_SQL: array[soAnd..soOrAll] of String =
                   ('AND',
                    'OR',
                    'AND',
                    'OR');

implementation

end.
