<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/
//  based on FormMail v1
//  (c) 2003 webverbund.de Oliver Georgi (info@webverbund.de)


require("../inc_lib/general.inc.php");
include("../inc_lang/formmailer/lang.formmailer.inc.php");

//check which language to use
$lang = "EN";
if(isset($_POST["language"])) {
	$lang = trim($_POST["language"]);
	unset($_POST["language"]);
}
if(!isset($translate[$lang])) $lang = "EN";

//getting the required fields list
if(isset($_POST["required"])) {
	$req_key = explode(",", trim($_POST["required"]));
	if(count($req_key)) {
		$err_num=0;
		foreach($req_key as $value) {
			$required_val[$value] = 1;
			if(!isset($_POST[$value])) {
				$form_error[400+$err_num] = str_replace("###value###", strtoupper($value), $translate[$lang]["error400"]);
				$err_num+=10;
			}
		}
	}
	unset($_POST["required"]);
}

//echo "<pre>"; print_r($required); echo "</pre>";

//getting the label fields list
if(isset($_POST["label"])) {
	$label = explode(",", trim($_POST["label"]));
	if($label) {
		foreach($label as $value) {
			list($field_name, $field_label) = explode("|", $value);
			$form_label[$field_name] = $field_label;
		}
	}
	unset($_POST["label"]);
}

//checking for base values
//recipient, recipient name:
if(isset($_POST["recipient"])) {
	$recipient = trim($_POST["recipient"]);
	unset($_POST["recipient"]);
}
if(MailVal($recipient,2)) { //if recipient mail address is invalid
	$form_error[100] = $translate[$lang]["error100"];
}
if(isset($_POST["recipient_name"])) {
	$recipient_name = trim($_POST["recipient_name"]);
	unset($_POST["recipient_name"]);
}
//subject:
if(isset($_POST["subject"])) {
	$subject = trim($_POST["subject"]);
	unset($_POST["subject"]);
}
if(isEmpty($subject)) { //if recipient mail address is invalid
	$form_error[200] = $translate[$lang]["error200"];
}
//send copy to form sender
if(isset($_POST["send_copy"])) {
	if(intval($_POST["send_copy"])) {
		$send_copy_to = trim($_POST["email"]);
		if(MailVal($send_copy_to, 2)) {
			$form_error[300] = $translate[$lang]["error300"];
			unset($send_copy_to);
		}
	}
	unset($_POST["send_copy"]);
}
//get values for redirecting
if(isset($_POST["redirect"])) {
	$redirect = trim($_POST["redirect"]);
	unset($_POST["redirect"]);
}
if(isset($_POST["redirect_template"])) {
	$redirect_template = trim($_POST["redirect_template"]);
	unset($_POST["redirect_template"]);
}
if(isset($_POST["redirect_error"])) {
	$redirect_error = trim($_POST["redirect_error"]);
	unset($_POST["redirect_error"]);
}
if(isset($_POST["redirect_error_template"])) {
	$redirect_error_template = trim($_POST["redirect_error_template"]);
	unset($_POST["redirect_error_template"]);
}

if(isset($_POST["submit"])) unset($_POST["submit"]);

//checking values and setting labels
if(count($_POST)) {
	$err_num = 0;
	foreach($_POST as $key => $value) {
		
		//Check for required fields
		if($required_val[$key] && isEmpty($value)) {
			if(isset($form_label[$key])) {
				$form_error[500+$err_num] = str_replace("###value###", $form_label[$key], $translate[$lang]["error400"]);
			} else {
				$form_error[500+$err_num] = str_replace("###value###", strtoupper($key), $translate[$lang]["error400"]);
			}			
			$err_num+=10;
		}
				
		if(is_array($value)) { //if field value is an array then split form name
			$x = 1;
			foreach($value as $field_value) {
				$form[$key."[".$x."]"] = trim($field_value);
				$x++;
			}
		} else {
			$form[$key] = trim($value);
		}
	}
}




if(isset($form_error)) {
	if(isset($redirect_error)) {
		header("Location: ".$redirect_error);
		exit();
	} else {
		//if error show error template
		$table = "";
		foreach($form_error as $key => $value) {
  			$table .= "<tr bgcolor=\"#F4F4F4\">";
    		$table .= "<td class=\"error\">[".$key."]</td>";
    		$table .= "<td class=\"error\">".html_specialchars($value)."</td>";
  			$table .= "</tr>\n";
		}
		
		$error_template = read_textfile("../inc_lang/formmailer/".$lang."_formmailer.error.html");
		$error_template = str_replace("<!-- RESULT //-->", $table, $error_template);
		echo $error_template;
		
	}

} else {
	$translate[$lang]["bodyLine1"] = str_replace("###date###", date($translate[$lang]["dateFormat"]), $translate[$lang]["bodyLine1"]);
	$translate[$lang]["bodyLine1"] = str_replace("###time###", date($translate[$lang]["timeFormat"]), $translate[$lang]["bodyLine1"]);
	$body = $translate[$lang]["bodyLine1"]."\n";
	$body.= $translate[$lang]["bodyLine2"]."\n";
	$body.= $_SERVER['HTTP_REFERER']." \n\n";
	$body.= "====================================================================\n\n";
	$body.= $translate[$lang]["bodyRecipient"];
	if($recipient_name) {
		$body.= $recipient_name." (".$recipient.")\n\n";
	} else {
		$body.= $recipient."\n\n";
	}
	$body.= "====================================================================\n\n";
	$body.= $subject."\n";
	$body.= "--------------------------------------------------------------------\n";
	$l=0;
	foreach($form as $key => $value) {
		$x = strlen($key);
		if($x > $l) $l = $x;
	}
	foreach($form as $key => $value) {
		$body.= str_pad($key, $l, ".").": ".$value."\n";
	}
	
	$body.= "\n====================================================================\n";
	$body.= "phpwcms formmailer  | Copyright (C) 2003 \n";

	if(isset($send_copy_to)) {
		$from = "From: ".$send_copy_to."\n";
		if(!ini_get('safe_mode')) {
			mail($send_copy_to, $subject, $body, "From: ".$recipient."\n", "-f ".$recipient);
		} else {
			mail($send_copy_to, $subject, $body, "From: ".$recipient."\n");
		}
	} else {
		$from = "From: ".$recipient."\n";
	}
	if(!ini_get('safe_mode')) {
		mail($recipient, $subject, $body, $from, "-f ".$from);
	} else {
		mail($recipient, $subject, $body, $from);
	}
	
	if(isset($redirect)) {
		header("Location: ".$redirect);
		exit();
	} else {
	
		//Success show form success template
		$table = "";
		foreach($form as $key => $value) {
			$table .= "<tr bgcolor=\"#F4F4F4\">";
			$table .= "<td>".html_specialchars($key)."</td>";
			$table .= "<td>".html_specialchars($value)."</td>";
			$table .= "</tr>\n";
		}
		
		$success_template = read_textfile("../inc_lang/formmailer/".$lang."_formmailer.success.html");
		$success_template = str_replace("<!-- RESULT //-->", $table, $success_template);
		echo $success_template;
				
	}
}

?>