<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

session_start();

require_once ("../inc_conf/conf.inc.php");
require_once ("../inc_lib/default.inc.php");
require_once ("../inc_lib/general.inc.php");
require_once ("../inc_lib/checklogin.inc.php");

if($_SESSION["wcs_user_admin"] == 1) { //Wenn Benutzer Admin-Rechte hat

	$pagelayout_conf  = "<?php\n";
	$pagelayout_conf .= "/*************************************************************************************\n";
	$pagelayout_conf .= "Copyright notice\n\n";
	$pagelayout_conf .= "(c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.\n\n";
	$pagelayout_conf .= "This script is part of PHPWCMS. The PHPWCMS web content management system is\n";
	$pagelayout_conf .= "free software; you can redistribute it and/or modify it under the terms of\n";
	$pagelayout_conf .= "the GNU General Public License as published by the Free Software Foundation;\n";
	$pagelayout_conf .= "either version 2 of the License, or (at your option) any later version.\n\n";
	$pagelayout_conf .= "The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html\n";
	$pagelayout_conf .= "A copy is found in the textfile GPL.txt and important notices to the license \n";
	$pagelayout_conf .= "from the author is found in LICENSE.txt distributed with these scripts.\n\n";
	$pagelayout_conf .= "This script is distributed in the hope that it will be useful, but WITHOUT ANY \n";
	$pagelayout_conf .= "WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A\n";
	$pagelayout_conf .= "PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n\n";
	$pagelayout_conf .= "This copyright notice MUST APPEAR in all copies of the script!\n";
	$pagelayout_conf .= "*************************************************************************************/\n\n\n";
	
	$pagelayout_conf .= "//pagelayout configuration values\n";
	$pagelayout_conf .= "//last changed: ".date("Y-m-d H:i:s")."\n\n"; 
	
	$pagelayout_conf .= "\$pagelayout[\"layout_align\"]               = ".intval($_POST["layout_align"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_type\"]                = ".intval($_POST["layout_type"]).";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_border_top\"]          = ".intval($_POST["layout_border_top"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_border_bottom\"]       = ".intval($_POST["layout_border_bottom"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_border_left\"]         = ".intval($_POST["layout_border_left"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_border_right\"]        = ".intval($_POST["layout_border_right"]).";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_title\"]               = \"".quotereplace(clean_slweg($_POST["layout_title"], 100))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_title_cat\"]           = ".intval($_POST["layout_title_cat"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_title_article\"]       = ".intval($_POST["layout_title_article"]).";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_bgcolor\"]             = \"".quotereplace(clean_slweg($_POST["layout_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_bgimage\"]             = \"".quotereplace(clean_slweg($_POST["layout_bgimage"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_jsonload\"]            = \"".quotereplace(slweg($_POST["layout_jsonload"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_textcolor\"]           = \"".quotereplace(clean_slweg($_POST["layout_textcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_linkcolor\"]           = \"".quotereplace(clean_slweg($_POST["layout_linkcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_vcolor\"]              = \"".quotereplace(clean_slweg($_POST["layout_vcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_acolor\"]              = \"".quotereplace(clean_slweg($_POST["layout_acolor"],7))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_all_width\"]           = ".get_pix_or_percent($_POST["layout_all_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_all_bgcolor\"]         = \"".quotereplace(clean_slweg($_POST["layout_all_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_all_bgimage\"]         = \"".quotereplace(clean_slweg($_POST["layout_all_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_all_class\"]           = \"".quotereplace(clean_slweg($_POST["layout_all_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_content_width\"]       = ".get_pix_or_percent($_POST["layout_content_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_content_bgcolor\"]     = \"".quotereplace(clean_slweg($_POST["layout_content_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_content_bgimage\"]     = \"".quotereplace(clean_slweg($_POST["layout_content_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_content_class\"]       = \"".quotereplace(clean_slweg($_POST["layout_content_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_left_width\"]          = ".get_pix_or_percent($_POST["layout_left_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_left_bgcolor\"]        = \"".quotereplace(clean_slweg($_POST["layout_left_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_left_bgimage\"]        = \"".quotereplace(clean_slweg($_POST["layout_left_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_left_class\"]          = \"".quotereplace(clean_slweg($_POST["layout_left_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_right_width\"]         = ".get_pix_or_percent($_POST["layout_right_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_right_bgcolor\"]       = \"".quotereplace(clean_slweg($_POST["layout_right_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_right_bgimage\"]       = \"".quotereplace(clean_slweg($_POST["layout_right_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_right_class\"]         = \"".quotereplace(clean_slweg($_POST["layout_right_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_leftspace_width\"]     = ".get_pix_or_percent($_POST["layout_leftspace_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_leftspace_bgcolor\"]   = \"".quotereplace(clean_slweg($_POST["layout_leftspace_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_leftspace_bgimage\"]   = \"".quotereplace(clean_slweg($_POST["layout_leftspace_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_leftspace_class\"]     = \"".quotereplace(clean_slweg($_POST["layout_leftspace_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_rightspace_width\"]    = ".get_pix_or_percent($_POST["layout_rightspace_width"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_rightspace_bgcolor\"]  = \"".quotereplace(clean_slweg($_POST["layout_rightspace_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_rightspace_bgimage\"]  = \"".quotereplace(clean_slweg($_POST["layout_rightspace_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_rightspace_class\"]    = \"".quotereplace(clean_slweg($_POST["layout_rightspace_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_header_height\"]       = ".get_pix_or_percent($_POST["layout_header_height"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_header_bgcolor\"]      = \"".quotereplace(clean_slweg($_POST["layout_header_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_header_bgimage\"]      = \"".quotereplace(clean_slweg($_POST["layout_header_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_header_class\"]        = \"".quotereplace(clean_slweg($_POST["layout_header_class"]))."\";\n";
		
	$pagelayout_conf .= "\$pagelayout[\"layout_topspace_height\"]     = ".get_pix_or_percent($_POST["layout_topspace_height"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_topspace_bgcolor\"]    = \"".quotereplace(clean_slweg($_POST["layout_topspace_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_topspace_bgimage\"]    = \"".quotereplace(clean_slweg($_POST["layout_topspace_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_topspace_class\"]      = \"".quotereplace(clean_slweg($_POST["layout_topspace_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_bottomspace_height\"]  = ".get_pix_or_percent($_POST["layout_bottomspace_height"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_bottomspace_bgcolor\"] = \"".quotereplace(clean_slweg($_POST["layout_bottomspace_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_bottomspace_bgimage\"] = \"".quotereplace(clean_slweg($_POST["layout_bottomspace_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_bottomspace_class\"]   = \"".quotereplace(clean_slweg($_POST["layout_bottomspace_class"]))."\";\n";
	
	$pagelayout_conf .= "\$pagelayout[\"layout_footer_height\"]       = ".get_pix_or_percent($_POST["layout_footer_height"]).";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_footer_bgcolor\"]      = \"".quotereplace(clean_slweg($_POST["layout_footer_bgcolor"],7))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_footer_bgimage\"]      = \"".quotereplace(clean_slweg($_POST["layout_footer_bgimage"]))."\";\n";
	$pagelayout_conf .= "\$pagelayout[\"layout_footer_class\"]        = \"".quotereplace(clean_slweg($_POST["layout_footer_class"]))."\";\n";
		
	$pagelayout_conf .= "\n\n?>";
	
	$page_layout_conf_file = PHPWCMS_ROOT."/include/inc_conf/conf.pagelayout.inc.php";
	write_textfile($page_layout_conf_file, $pagelayout_conf);
} //Ende Abarbeiten Aktion

header("Location: ".$_SERVER['HTTP_REFERER']);
exit();

?>