<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

//predefine values
if($phpwcms["rewrite_url"]) {
	header ("Expires: Mon, 01 Jan 1990 01:00:00 GMT"); 
	header ("Content-type: text/html"); 
	header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
	header ("Cache-Control: no-cache, must-revalidate"); 
	header ("Pragma: no-cache");
}

$content["main"]				= "";
$content["cat"]					= "";
$content["metakey"]				= "";
$content["struct"]				= get_struct_data ($db); //reads the complete structure as array
$content["article_date"]		= time();
$content["redirect"]["code"]	= "";

//method to get the right action values
//if there is only the ?alias try to find the right category
if(isset($_GET["id"])) {

	if($phpwcms["rewrite_url"]) $_GET['id'] = str_replace(".",",",$_GET['id']);

	$aktion = explode(",", $_GET["id"]);
	if(sizeof($aktion)) {
		foreach($aktion as $key => $value) {
			$aktion[$key] = intval($value);
		}
	}

} else {
	// check the alias
	$aktion = array(0,0,0,1,0,0);	
	if($_SERVER['QUERY_STRING']) {
		$query = explode("&", $_SERVER['QUERY_STRING']);
		$alias = $query[0];
		if(!strpos($alias, "=")) { // check alias for "=" what means no alias
			$sql = "SELECT acat_id FROM ".DB_PREPEND."phpwcms_articlecat WHERE acat_alias LIKE '".aporeplace($alias)."' LIMIT 1;";
			if($result = mysql_query($sql, $db)) {
				if($row = mysql_fetch_row($result)) $aktion[0] = $row[0];
				mysql_free_result($result);
			}
		}
	}
}


//define the current article category ID
$content["cat_id"]	 = $aktion[0];
//now check if current category is only visible to logged on frontend users
/*
if(!$_SESSION["frontend_user_in"]) {
	//run $content["struct"] against frontend visible check
	
}
*/

//reads all articles for active cat into array
$content["articles"] = get_actcat_articles_data ($content["cat_id"], $db);
//reads all active category IDs beginning with the current cat ID - without HOME
$content["cat_path"] = get_active_categories($content["struct"], $content["cat_id"]);

// -------------------------------------------------------------

// read the template information for page based on structure
// 22-10-2003: putted before any rednering content is received makes it easier to 
//             handle different pagelayouts and template configuration values
if($content["struct"][ $content["cat_id"] ]["acat_template"]) {
	//if there is a template defined for this structure level
	//then choose the template information based on this ID
	$sql  = "SELECT template_var FROM ".DB_PREPEND."phpwcms_template WHERE template_trash=0 AND ";
	$sql .= "template_id=".$content["struct"][ $content["cat_id"] ]["acat_template"]." LIMIT 1;";
	if($result = mysql_query($sql, $db)) {
		if($row = mysql_fetch_row($result)) $block = unserialize($row[0]);
		mysql_free_result($result);
	}
}
if(!isset($block)) {
	// if template ID is not defined or the were a problem with level's template ID then
	// choose the default template or if no default template defined choose the next one
	$sql  = "SELECT template_var FROM ".DB_PREPEND."phpwcms_template ";
	$sql .= "WHERE template_trash=0 ORDER BY template_default DESC LIMIT 1;";
	if($result = mysql_query($sql, $db)) {
		if($row = mysql_fetch_row($result)) $block = unserialize($row[0]);
		mysql_free_result($result);
	}
}

// -------------------------------------------------------------

// retrieve pagelayout info
if($aktion[2] == 0) {

	//check how the content should be rendered based on pagelayout render value
	$block["layout"] = intval($block["layout"]);
	//1.) get page layout
	$sql  = "SELECT pagelayout_var FROM ".DB_PREPEND."phpwcms_pagelayout WHERE pagelayout_trash=0 ";
	$sql .= ($block["layout"]) ? "AND pagelayout_id=".$block["layout"] : "ORDER BY pagelayout_default DESC";
	$sql .= " LIMIT 1;";
	if($result = mysql_query($sql, $db)) {
		if(mysql_num_rows($result)) {
			if($row = mysql_fetch_row($result)) {
				$pagelayout = unserialize(base64_decode($row[0]));
			}
		} else {
			// if no db result load base values from file
			include_once (PHPWCMS_ROOT."/include/inc_conf/conf.pagelayout.inc.php");
			$pagelayout["layout_render"] = 0;
		}
		mysql_free_result($result);
	}
}
//check for additional template based onLoad JavaScript Code
if($block["jsonload"]) {
	$pagelayout["layout_jsonload"] .= (($pagelayout["layout_jsonload"]) ? ";" : "") . $block["jsonload"].";";
	$pagelayout["layout_jsonload"]  = str_replace(";;", ";", $pagelayout["layout_jsonload"]);
}
$content["body"] = get_body_attributes($pagelayout);
$content["pagetitle"] = $pagelayout["layout_title"];

//generate the colspan attribute
$colspan = get_colspan($pagelayout);

// -------------------------------------------------------------

// generating a list of articles inside the current article category
if(!$aktion[4]) {
	$content["article_list_count"] = sizeof($content["articles"]);
	if($content["article_list_count"]) {
		
		if($content["article_list_count"] == 1) {   //if($temp_counter == 1) {
			// if only 1 article for this category available
			// then show this article directly
			// sets article ID to this only 1 article
			foreach($content["articles"] as $key => $value) $aktion[1] = intval($key);
			$aktion[4] = 1; // this needs to be set to 1 for showing the article

		} else {
			// there is more than 1 article inside this category
			// -> list all - the 1st will be shown with summary and such stuff
			$content["main"] .= list_articles_summary ($content["articles"], $template_default);

		}
	
	} else {
		/*
		 * 2003-10-21 : disabled because of the new multiple template system
		 */
		// $content["main"] .= read_textfile(PHPWCMS_ROOT.$phpwcms["templates"]."inc_error/error_page.tmpl");
		$no_content_for_this_page = 1;
	}
}

// -------------------------------------------------------------

// generating the complete article
if($aktion[4]==1 && $aktion[1]) include_once "include/inc_front/content.article.inc.php";

// -------------------------------------------------------------

//check for no content error
if($no_content_for_this_page) $content["main"] .= $block["errortext"];

// -------------------------------------------------------------

//check if one of needed block texts and values are empty and if then fill with content
if(!$block["maintext"]) $block["maintext"] = $content["main"];

// -------------------------------------------------------------

//normal page opreation
if($aktion[2] == 0) {
	
	switch($pagelayout["layout_render"]) {
	
		case 0:	//create the page layout table (header, left, content, right, footer)
				$content["all"]  = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"";	//start main table
				$content["all"] .= td_attributes($pagelayout, "all", 0);
				$content["all"] .= align_base_layout($pagelayout["layout_align"]).">\n";		// align table

				//header
				$content["all"] .= colspan_table_row($pagelayout, "header", $colspan, $block["headertext"]); //header row
				if($pagelayout["layout_topspace_height"]) { //header space
					$content["all"] .= colspan_table_row($pagelayout, "topspace", $colspan, spacer($pagelayout["layout_topspace_height"]));
				}

				//returns the main blocks: left column, content column, right column
				$content["all"] .= get_table_block($pagelayout, $block["maintext"], $block["lefttext"], $block["righttext"]);

				//footer
				if($pagelayout["layout_bottomspace_height"]) { //bottom space
					$content["all"] .= colspan_table_row($pagelayout, "bottomspace", $colspan, spacer($pagelayout["layout_bottomspace_height"]));
				}
				$content["all"] .= colspan_table_row($pagelayout, "footer", $colspan, $block["footertext"]); //footer row
				$content["all"] .= "</table>\n"; //end main table
				
				break;
		
				
		case 1:	//create the page layout based on DIV (layer)
		
				//header DIV
				$content["all"] = ($block["headertext"]) ? '<div id="header_block">'.$block["headertext"]."</div>\n" : "";
				//left DIV if 3column or 2column (with left block)
				if($pagelayout["layout_type"] == 0 || $pagelayout["layout_type"] == 1) {
					$content["all"] .= '<div id="left_block">'.$block["lefttext"]."</div>\n";
				}
				//main block
				$content["all"] .= '<div id="main_block">'.$block["maintext"]."</div>\n";
				//right DIV if 3column or 2column (with right block)
				if($pagelayout["layout_type"] == 0 || $pagelayout["layout_type"] == 2) {
					$content["all"] .= '<div id="right_block">'.$block["righttext"]."</div>\n";
				}
				//footer DIV
				$content["all"] .= ($block["footertext"]) ? '<div id="footer_block">'.$block["footertext"]."</div>" : "";
		
				break;
		
		
		case 2: //create the page layout based only on the content of main block
				$content["all"]	= $block["maintext"];
				
				break;
	
	}

} elseif ($aktion[2] == 1) {

	//if print layout should be showed
	$content["all"]	= $block["maintext"];
	$block["css"]	= "print_layout.css"; //sets css to standard printing layout
	
}

// -------------------------------------------------------------

// put in the complete rendered content
$content["all"] = str_replace('{CONTENT}', $content["main"], $content["all"]);

// -------------------------------------------------------------

//breadcrumb replacement
if( ! ( strpos($content["all"],'{BREADCRUMB')===false ) ) {
	$content["all"] = str_replace('{BREADCRUMB}', '{BREADCRUMB:0}', $content["all"]);
	$replace = 'breadcrumb($content["cat_id"], $content["struct"], $1, "index.php", $template_default["breadcrumb_spacer"]);';
	$content["all"] = preg_replace('/\{BREADCRUMB:(\d+)\}/e', $replace, $content["all"]);
	//$content["all"] = str_replace('{BREADCRUMB}', $replace, $content["all"]);
}

// -------------------------------------------------------------

// Simple Navigation table
if( ! ( strpos($content["all"],'{NAV_TABLE_SIMPLE}')===false ) ) {
	$replace = nav_table_simple_struct($content["struct"], $content["cat_id"]);
	$content["all"] = str_replace('{NAV_TABLE_SIMPLE}', $replace, $content["all"]);
}

// -------------------------------------------------------------

// Left table based rollover navigation
if( ! ( strpos($content["all"],'{NAV_TABLE_COLUMN')===false ) ) {
	$content["all"] = str_replace('{NAV_TABLE_COLUMN}', '{NAV_TABLE_COLUMN:0}', $content["all"]);
	$replace = 'nav_table_struct($content["struct"],intval($content["cat_id"]),"$1",$template_default["nav_table_struct"]);';
	$content["all"] = preg_replace('/\{NAV_TABLE_COLUMN:(\d+)\}/e', $replace, $content["all"]);
}

// -------------------------------------------------------------

// List based navigation with Top Level - default settings
if( ! ( strpos($content["all"],'{NAV_LIST_TOP')===false ) ) {
	$content["all"] = str_replace('{NAV_LIST_TOP}', css_list_top($content["struct"],$content["cat_path"]), $content["all"]);
	// creates a list styled top nav menu, + optional Home | {NAV_LIST_TOP:home_name:class_name} | default class name = list_top
	$content["all"] = preg_replace('/\{NAV_LIST_TOP:(.*?):(.*?)\}/e', 'css_list_top($content["struct"],$content["cat_path"], "$1", "$2")', $content["all"]);
}

// -------------------------------------------------------------

// List based navigation with Top Level - default settings
if( ! ( strpos($content["all"],'{NAV_LIST_CURRENT')===false ) ) {
	$content["all"] = str_replace('{NAV_LIST_CURRENT}', css_list_current_level($content["struct"],$content["cat_path"],$content["cat_id"]), $content["all"]);
	// creates a list styled nav menu of current level {NAV_LIST_CURRENT:1:back_name:class_name} | default class name = list_top
	$content["all"] = preg_replace('/\{NAV_LIST_CURRENT:(\d+):(.*?):(.*?)\}/e', 'css_list_current_level($content["struct"],$content["cat_path"],$content["cat_id"],"$2","$1","$3")', $content["all"]);
}

// -------------------------------------------------------------

// include external PHP script (also normal HTML snippets)
if( ! ( strpos($content["all"],'{PHP:')===false ) ) {
	// includes external PHP script and returns the content
	$content["all"] = preg_replace('/\{PHP:(.*?)\}/e', 'include_ext_php("$1");', $content["all"]);
}

// -------------------------------------------------------------

// date replacement
if( ! ( strpos($content["all"],'{DATE_')===false ) ) {
	$content["all"] = str_replace('{DATE_LONG}',    international_date_format($template_default["date"]["language"], $template_default["date"]["long"]),   $content["all"]);
	$content["all"] = str_replace('{DATE_MEDIUM}',  international_date_format($template_default["date"]["language"], $template_default["date"]["medium"]), $content["all"]);
	$content["all"] = str_replace('{DATE_SHORT}',   international_date_format($template_default["date"]["language"], $template_default["date"]["short"]),  $content["all"]);
	$content["all"] = str_replace('{DATE_ARTICLE}', international_date_format($template_default["date"]["language"], $template_default["date"]["short"],   $content["article_date"]),  $content["all"]);
}

// -------------------------------------------------------------

// time replacement
if( ! ( strpos($content["all"],'{TIME_')===false ) ) {
	$content["all"] = str_replace('{TIME_LONG}',    date($template_default["time"]["long"]) ,                            $content["all"] );
	$content["all"] = str_replace('{TIME_SHORT}',   date($template_default["time"]["short"]),                            $content["all"] );
	$content["all"] = str_replace('{TIME_ARTICLE}', date($template_default["time"]["short"] , $content["article_date"]), $content["all"] );
}

// -------------------------------------------------------------

// print layout button replacement
if( ! ( strpos($content["all"],'[PRINT]')===false ) ) {
	$content["all"] = str_replace('[PRINT]', '<a href="index.php?id='.$aktion[0].','.$aktion[1].',1,'.$aktion[3].','.$aktion[4].','.$aktion[5].'" target="_blank">', $content["all"]);
	$content["all"] = str_replace('[/PRINT]', '</a>', $content["all"]);
}

// -------------------------------------------------------------

// replace custom search form input field and action with right target
if( ! ( strpos($content["all"],'###search_input_action')===false ) ) {
	$content["all"] = str_replace('###search_input_field###', 'search_input_field', $content["all"]);
	$content["all"] = str_replace('###search_input_value###', html_specialchars($_POST["search_input_field"]), $content["all"]);
	// create serahc form action
	if( ! ( strpos($content["all"],'###search_input_action:')===false ) ) {
		$content["all"] = preg_replace('/###search_input_action:(\d+)###/e','get_search_action("$1", $db);', $content["all"]);
	}
}

// -------------------------------------------------------------

// related articles based on keywords, inspired by Magnar Stav Johanssen
if( ! ( strpos($content["all"],'{RELATED:')===false ) ) {
	if (!$no_content_for_this_page && $content["articles"][$aktion[1]]["article_keyword"]) {
		$related_keywords = $content["articles"][$aktion[1]]["article_keyword"];
	}
	$content["all"] = preg_replace('/\{RELATED:(\d+)\}/e','get_related_articles($related_keywords,$aktion[1],$template_default["related"],"$1",$db);',$content["all"]);
	$content["all"] = preg_replace('/\{RELATED:(\d+):(.*?)\}/e','get_related_articles("$2",$aktion[1],$template_default["related"],"$1",$db);',$content["all"]);
}

// -------------------------------------------------------------

// AUTHOR replacement tag: by Magnar Stav Johanssen
if( ! (strpos($content["all"],'{AUTHOR}')===false)) {
	$content["all"] = str_replace('{AUTHOR}', $content["articles"][$aktion[1]]["article_username"], $content["all"]);
}

// -------------------------------------------------------------

// all new article list sorted by date
if( ! ( strpos($content["all"],'{NEW:')===false ) ) {
	$content["all"] = preg_replace('/\{NEW:(\d+)\}/e','get_new_articles($template_default["news"],$1,$db);',$content["all"]);
}

// -------------------------------------------------------------

//parses complete list of preg_replace definitions
$content["all"]	= preg_replace('/\[ID (\d+)\](.*?)\[\/ID\]/e', 'get_article_idlink($1, "$2", $db);', $content["all"]);
$content["all"] = html_parser($content["all"]);

// -------------------------------------------------------------

// create link to articles for found keywords
if( ! ( strpos($content["all"],'{KEYWORD:')===false ) ) {
	$content["all"] = preg_replace('/\{KEYWORD:(.*?)\}/e','get_keyword_link("$1", $db);',$content["all"]);
}

// -------------------------------------------------------------

// add possible redirection code (article summary) to $block["htmlhead"];
$block["htmlhead"] = $content["redirect"]["code"].$block["htmlhead"]."\n";
// insert description meta tag if not definied
if(!stristr($block["htmlhead"], '"description"') && $content["struct"][$aktion[0]]["acat_info"]) {
	$block["htmlhead"] .= '<meta name="description" content="';
	$block["htmlhead"] .= html_specialchars($content["struct"][$aktion[0]]["acat_info"])."\">\n";
}
// insert keywords meta tag if not definied
if(!stristr($block["htmlhead"], '"keywords"') && $content["articles"][$aktion[1]]["article_keyword"]) {
	$block["htmlhead"] .= '<meta name="keywords" content="';
	$block["htmlhead"] .= html_specialchars($content["articles"][$aktion[1]]["article_keyword"])."\">\n";
}

?>