<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/


//specific functions for the frontend

// -------------------------------------------------------------

function spacer($width=1, $height=1) {
	//creates a placeholder image (transparent gif)
	$width  = intval($width); $height = intval($height);
	return ($width && $height) ? ("<img src=\"img/leer.gif\" width=\"".$width."\" height=\"".$height."\">") : "";
}

// -------------------------------------------------------------

function headline($head, $subhead, $layout) {
	$c  = ($head) ? 
				$layout["content_head_before"].
				span_class(html_specialchars($head), $layout["content_head_class"]).
				$layout["content_head_after"]
				: "";
	$c .= ($subhead) ? 
				$layout["content_subhead_before"].
				span_class(html_specialchars($subhead), $layout["content_subhead_class"]).
				$layout["content_subhead_after"]
				: "";
	return $c;
}

// -------------------------------------------------------------

function imagetable($phpwcms, $image, $rand="0:0:0:0", $align=0, $class="imgCaption" ) {
	// creates the image tags if text w/image
	// read content image info
	$imagename  = $phpwcms["content_path"].$phpwcms["cimage_path"].$image[6];
	$caption	= nl2br(html_specialchars(base64_decode($image[7])));
	$image_info = getimagesize(PHPWCMS_ROOT."/".$imagename);
	
	$tablewidth = $image_info[0];
	$imagewidth = $image_info[3]; //width + height

	$rand = explode(":", $rand);
	if(count($rand)) { foreach($rand as $key => $value) $rand[$key] = intval($value); } else { $rand = array(0,0,0,0); }
	if($rand[2] && $rand[3]) {
		$colspan = " colspan=\"3\"";
	} else {
		if($rand[2] || $rand[3]) { $colspan = " colspan=\"2\""; } else { $colspan = ""; }
	}
	$tablewith += $rand[2] + $rand[3];
	$table = "<table width=\"".$tablewidth."\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" ".(($align)?"align=\"".$align."\"":"").">\n";
	$table .= ($rand[0]) ? "<tr><td".$colspan.">".spacer(1,$rand[0])."</td></tr>\n" : "";
	$table .= "<tr>";
	$table .= ($rand[2]) ? "<td>".spacer($rand[2],1)."</td>" : "";
	if($image[8]) {
		$zoominfo = getimagesize(PHPWCMS_ROOT."/".$phpwcms["file_tmp"].$phpwcms["dir_preview"].$image[2]);
		$open_popup_link = "image_zoom.php?show=".base64_encode($image[2]);
		$table .= "<td><a href=\"".$open_popup_link."\" onClick=\"window.open('".$open_popup_link."','previewpic','width=";
		$table .= $zoominfo[0].",height=".$zoominfo[1]."');return false;\">";
		$table .= "<img src=\"".$imagename."\" ".$imagewidth." border=\"0\"></a></td>";
	} else {
		$table .= "<td><img src=\"".$imagename."\" ".$imagewidth." border=\"0\"></td>";
	}
	$table .= ($rand[3]) ? "<td>".spacer($rand[3],1)."</td>" : "";
	$table .= "</tr>\n";
	if($caption) {
	
		$table .= "<tr><td".$colspan.">".spacer(1,3)."</td></tr>\n";
		$table .= "<tr>";
		$table .= ($rand[2]) ? "<td>".spacer($rand[2],1)."</td>" : "";
		$table .= "<td".(($class)?" class=\"".$class."\"":"").">".$caption."</td>";
		$table .= ($rand[3]) ? "<td>".spacer($rand[3],1)."</td>" : "";
		$table .= "</tr>\n";
	}	
	$table .= ($rand[1]) ? "<tr><td".$colspan.">".spacer(1,$rand[1])."</td></tr>\n" : "";		
	$table .= "</table>";
	return $table;
}

// -------------------------------------------------------------

function imagelisttable($imagelist, $rand="0:0:0:0", $align=0, $class="imgCaption") {
	$align = ((!$align) ? "" : " align=\"".$align."\" ");
	$rand = explode(":", $rand);
	if(sizeof($rand)) { foreach($rand as $key => $value) $rand[$key] = intval($value); } else { $rand = array(0,0,0,0); }
	$col_rand = ($rand[2] && $rand[3]) ? 2 : (($rand[2] || $rand[3]) ? 1 : 0 );
	
	if($count_images = sizeof($imagelist)) {
	
		//Tabelle starten
		$table = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" ".$align.">\n";
		$x=0; $y=0; $z=0;
		foreach($imagelist as $key => $value) {
			$y++;
			if($z && $x==1) $table .= ($col_space) ? "<tr><td".(($col_total>1)?" colspan=\"".$col_total."\"":"").">".spacer(1,$col_space)."</td></tr>\n" : "";
	
			if(!$x) {
				//Festlegen der Standardwerte
				$table_pos = $imagelist[$key]["pos"];	//Bildtabellen-Position
				$col_space = $imagelist[$key]["s"];		//Abstand zwischen Bildern
				$col_count = $imagelist[$key]["col"];	//Anzahl Bildspalten
				$col_total = $col_count + (($col_space)?($col_count-1):(0)) + $col_rand;
				//Wenn oberer Rand definiert
				$table .= ($rand[0]) ? "<tr><td".(($col_total>1)?" colspan=\"".$col_total."\"":"").">".spacer(1,$rand[0])."</td></tr>\n" : "";
				$x=1;
			}
			if($x==1) {
				$table .= "<tr>"; //Neue Tabellenzeile
				$table .= ($rand[2]) ? "<td width=\"".$rand[2]."\">".spacer($rand[2],1)."</td>" : ""; //wenn linker Rand
			}
			//Aktuelle Bildspalte ausgeben
			$table .= "<td align=\"center\" valign=\"bottom\"".(($class)?" class=\"".$class."\"":"")." width=\"".$imagelist[$key]["w"]."\">";
			$list_img_temp  = "<img src=\"".$imagelist[$key]["pic"]."\" ".$imagelist[$key]["wxh"]." border=\"0\">";
			if($imagelist[$key]["zoom"]) {
				// if click enlarge the image
				$open_popup_link = "image_zoom.php?show=".$imagelist[$key]["zoomimage"];
				$table .= "<a href=\"".$open_popup_link."\" onClick=\"window.open('".$open_popup_link."','previewpic','width=";
				$table .= $imagelist[$key]["zoomw"].",height=".$imagelist[$key]["zoomh"]."');return false;\">";
				$table .= $list_img_temp."</a>";
			} else {
				// if not click enlarge
				$table .= $list_img_temp;
			}
			
			$table .= ($imagelist[$key]["cap"]) ? ("<br />".spacer(1,3)."<br />".html_specialchars(chop(base64_decode($imagelist[$key]["cap"]))).(($col_space)?"":("<br />".spacer(1,3)))) : "";
			$table .= "</td>";
		
			//Gegenchecken wieviele Tabellenspalten als Rest bleiben und ergnzen
			if($y == $count_images && $col_count > 1) {	//wenn eigentlich alle Bilder durchlaufen sind
				$table .= ($col_space && $x<$col_count) ? "<td>".spacer($col_space,1)."</td>" : "";
				$rest_image = (ceil($count_images / $col_count) * $col_count) - $count_images;
				for ($i=1; $i <= $rest_image; $i++) {
					$table .= "<td>&nbsp;</td>";
					if($i < $rest_image) $table .= ($col_space) ? "<td width=\"".$col_space."\">".spacer($col_space,1)."</td>" : "";
					$x++;
				}
			}
			
			if($x==$col_count) {	//Wenn maximale Anzahl Bildspalten erreicht
				$table .= ($rand[3]) ? "<td width=\"".$rand[3]."\">".spacer($rand[3],1)."</td>" : "";
				$table .= "</tr>\n";
				$x=1; $z++;
			} else {
				$table .= ($col_space) ? "<td width=\"".$col_space."\">".spacer($col_space,1)."</td>" : "";
				$x++;
			}
		}
	
		$table .= ($rand[1]) ? "<tr><td".(($col_total>1)?" colspan=\"".$col_total."\"":"").">".spacer(1,$rand[1])."</td></tr>\n" : "";	
		$table .= "</table>";
	}
	return $table;
}

// -------------------------------------------------------------

//defines multimedia plugin specific values for width or height
function plugin_size($mediatype, $player, $width, $height) {

	switch($mediatype) {
		case 0: //Video
				switch($player) {
					case 0:	//Quicktime
							$width = ($width) ? $width : "";
							$height = ($height) ? $height+16 : "";
							break;
							
					case 1:	//RealPlayer
							$width = ($width) ? $width : "";
							$width = ($height) ? $height+36 : "";
							break;
					
					case 2:	//MediaPlayer
							$width = ($width) ? $width : "";
							$width = ($height) ? $height : "";
							break;
					
					case 3:	//Flash
							$width = ($width) ? $width : "";
							$width = ($height) ? $height : "";
							break;				
				}
				break;
				
		case 1:	//Audio
				break;
				
		case 2:	//Flash
				break;

	}
}

// -------------------------------------------------------------

function must_filled($c) {
	//spaceholder for form fields that have to be filled
	//with some content or has to be marked or like that
	return (intval($c)) ? "<img src=\"img/article/fill_in_here.gif\">" : "";
}

// -------------------------------------------------------------

function add_attribute($baseval, $attribute, $val, $space=" ") {
	//to add all relevant attributes that contains
	//values to a string maybe a html tag
	$attribute = (!isEmpty(strval($val))) ? $attribute."=\"".$val."\"" : "";
	$attribute = ($baseval && !isEmpty($val)) ? $space.$attribute : $attribute;
	return $attribute;
}

// -------------------------------------------------------------

function html_attribute($attribute, $val) {
	//to return only 1 well formatted attributes and values
	return (!isEmpty($val)) ? $attribute."=\"".$val."\"" : "";
}

// -------------------------------------------------------------

function get_body_attributes($values) {
	//return a standard list of standard html body attributes
	//based on the pagelayout definitions
	if(is_array($values)) {
		$body  = "";
		$body .= add_attribute($body, "bgcolor", $values["layout_bgcolor"]);
		$body .= add_attribute($body, "background", $values["layout_bgimage"]);
		$body .= add_attribute($body, "text", $values["layout_textcolor"]);
		$body .= add_attribute($body, "link", $values["layout_linkcolor"]);
		$body .= add_attribute($body, "vlink", $values["layout_vcolor"]);
		$body .= add_attribute($body, "alink", $values["layout_acolor"]);
		if(!$values["layout_noborder"]) {
			$body .= add_attribute($body, "topmargin", $values["layout_border_top"]);
			$body .= add_attribute($body, "leftmargin", $values["layout_border_left"]);
			$body .= add_attribute($body, "marginwidth", $values["layout_border_right"]);
			$body .= add_attribute($body, "marginheight", $values["layout_border_bottom"]);
		}		
		$body .= add_attribute($body, "onLoad", $values["layout_jsonload"]);
		return " ".$body;
	} else {
		return "";
	}
}

// -------------------------------------------------------------

function align_base_layout($value) {
	//to get the alignment of the base layout table
	switch($value) {
		case  1: $align = "center"; break;
		case  2: $align = "right"; break;
		default: $align = 0;
	}
	return ($align) ? " align=\"".$align."\"" : "";
}

// -------------------------------------------------------------

function get_colspan($value) {
	//returns colspan value back to table row
	switch($value["layout_type"]) {
		case  0:	$col=3; break;
		case  1:	$col=2; break;
		case  2:	$col=2; break;
		case  3:	$col=0; break;
		default:	$col=3;
	}
	if($value["layout_leftspace_width"]) $col++;
	if($value["layout_rightspace_width"]) $col++;
	//if($value["layout_leftspace_width"] && ($value["layout_type"]==0 || $value["layout_type"]==1)) $col++;
	//if($value["layout_rightspace_width"] && ($value["layout_type"]==0 || $value["layout_type"]==2)) $col++;
	return ($col) ? (" colspan=\"".$col."\"") : "";
}

// -------------------------------------------------------------

function colspan_table_row($val, $block, $colspan="", $rowcontent="&nbsp;") {
	//creates a new table row for header or footer or such rows
	return ($rowcontent) ? "<tr>\n<td".$colspan.td_attributes($val, $block, 0).">".$rowcontent."</td>\n</tr>\n" : "";
}

// -------------------------------------------------------------

function get_table_block($val, $content="", $leftblock="", $rightblock="") {
	//creates the string with all relevant main block data
	//$val = $pagelayout array values
	$mainblock  = "<tr>\n"; //start row
	
	//if 3column or 2column (with left block)
	if($val["layout_type"]==0 || $val["layout_type"]==1) {
		$mainblock .= "<td".td_attributes($val, "left").">".$leftblock."</td>\n";
	}
	
	//if there is a spacer column between left and main block
	if($val["layout_leftspace_width"]) {
		$mainblock .= "<td".td_attributes($val, "leftspace").">";
		$mainblock .= spacer($val["layout_leftspace_width"]);
		$mainblock .= "</td>\n";
	}
	
	$mainblock .= "<td".td_attributes($val, "content").">".$content."</td>\n";
	
	//if there is a spacer column between main block and right column
	if($val["layout_rightspace_width"]) {
		$mainblock .= "<td".td_attributes($val, "rightspace").">";
		$mainblock .= spacer($val["layout_rightspace_width"]);
		$mainblock .= "</td>\n";
	}
	
	//if 3column or 2column (with right block)
	if($val["layout_type"]==0 || $val["layout_type"]==2) {
		$mainblock .= "<td".td_attributes($val, "right").">".$rightblock."</td>\n";
	}
	
	$mainblock .= "</tr>\n"; //end row
	return $mainblock;
}

// -------------------------------------------------------------

function td_attributes($val, $block, $top=1) {
	//creates a string with all relevant cell attributes like nackground color/image, class
	$td_attrib  = ($top) ? " valign=\"top\"" : "";
	$td_attrib .= html_attribute(" height", $val["layout_".$block."_height"]);
	$td_attrib .= html_attribute(" width", $val["layout_".$block."_width"]);
	$td_attrib .= html_attribute(" bgcolor", $val["layout_".$block."_bgcolor"]);
	$td_attrib .= html_attribute(" background", $val["layout_".$block."_bgimage"]);
	$td_attrib .= html_attribute(" class", $val["layout_".$block."_class"]);
	return $td_attrib;
}

// -------------------------------------------------------------

function table_attributes($val, $var_part, $top=1) {
	//creates a string with all relevant cell attributes like background color/image, class
	//P.S. it is nearly the same as td_attributes - but it was boring to rewrite code ;-)
	$td_attrib  = ($top) ? " valign=\"top\"" : "";
	$td_attrib .= html_attribute(" border", $val[$var_part."_border"]);
	$td_attrib .= html_attribute(" height", $val[$var_part."_height"]);
	$td_attrib .= html_attribute(" width", $val[$var_part."_width"]);
	$td_attrib .= html_attribute(" bgcolor", $val[$var_part."_bgcolor"]);
	$td_attrib .= html_attribute(" background", $val[$var_part."_bgimage"]);
	$td_attrib .= html_attribute(" class", $val[$var_part."_class"]);
	$td_attrib .= html_attribute(" cellspacing", $val[$var_part."_cspace"]);
	$td_attrib .= html_attribute(" cellpadding", $val[$var_part."_cpad"]);
	return $td_attrib;
}

// -------------------------------------------------------------

function get_breadcrumb ($start_id, $struct_array) {
	//returns the breadcrumb path starting with given start_id
	while ($start_id) {
		$data[$start_id] = $struct_array[$start_id]["acat_name"];
		$start_id		 = $struct_array[$start_id]["acat_struct"];
	}
	$data[$start_id] = $struct_array[$start_id]["acat_name"];
	return array_reverse($data, 1);
}

// -------------------------------------------------------------

function breadcrumb ($start_id, $struct_array, $end_id, $link_to="index.php", $spacer=" &gt; ") {
	//builds the breadcrumb menu based on given values
	//$link_to = the page on which the breadcrum part links
	//$root_name = name of the breadcrumb part if empty/false/0 $start_id
	//$spacer = how should breadcrumb parts be divided
	
	$start_id = intval($start_id);
	$end_id = intval($end_id);
	$act_id = $start_id; //store actual ID for later comparing
		
	while ($start_id) { //get the breadcrumb path starting with given start_id
		$data[$start_id] = $struct_array[$start_id]["acat_name"];
		$start_id		 = $struct_array[$start_id]["acat_struct"];
		if($end_id && $start_id == $end_id) break;
	}
	$data[$start_id] = $struct_array[$start_id]["acat_name"];
	$crumbs_part = array_reverse($data, 1);	
	
	if(sizeof($crumbs_part)) {
		$breadcrumb = "";
		foreach($crumbs_part as $key => $value) {
			if ($act_id != $key) {
				$breadcrumb .= ($breadcrumb) ? $spacer : "";
				$breadcrumb .= "<a href=\"".$link_to."?id=".$key.",0,0,1,0,0\">";
				$breadcrumb .= html_specialchars($crumbs_part[$key])."</a>";
			} else {
				$breadcrumb .= (($breadcrumb) ? $spacer : "").html_specialchars($crumbs_part[$key]);
			}
		}
	} else {
		$breadcrumb = "";
	}
	return $breadcrumb;
}

// -------------------------------------------------------------

function get_struct_data ($dbcon, $root_name="Home", $root_info="") {
	//returns the complete active and public struct data as array
	//so it is reusable by many menu functions -> lower db access
	$data[0] = array(	"acat_id"		=> 0,
						"acat_name"		=> $root_name,
						"acat_info"		=> $root_info,
						"acat_struct"	=> 0,
						"acat_sort"		=> 0,
						"acat_hidden"	=> 0,
						"acat_regonly"	=> 0,
						"acat_ssl"		=> 0,
						"acat_template"	=> 0 );
	$sql = "SELECT * FROM ".DB_PREPEND."phpwcms_articlecat WHERE ".
	   	   "acat_aktiv=1 AND acat_public=1 AND acat_trash=0 ORDER BY acat_struct, acat_sort;";
	if($result = mysql_query($sql, $dbcon)) {
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$data[$row["acat_id"]] = array(	"acat_id"		=> $row["acat_id"],
									"acat_name"		=> $row["acat_name"],
									"acat_info"		=> $row["acat_info"],
									"acat_struct"	=> $row["acat_struct"],
									"acat_sort"		=> $row["acat_sort"],
									"acat_hidden"	=> $row["acat_hidden"],
									"acat_regonly"	=> $row["acat_regonly"],
									"acat_ssl"		=> $row["acat_ssl"],
									"acat_template"	=> $row["acat_template"] );
		}
		mysql_free_result($result);
	}
	return (sizeof($data)) ? $data : array();
}

// -------------------------------------------------------------

function get_articles_data ($dbcon) {
	//returns the complete active and public article data as array (basic infos only)
	//so it is reusable by many functions -> lower db access
	
	$sql  = "SELECT *, UNIX_TIMESTAMP(article_tstamp) AS article_date FROM ".DB_PREPEND."phpwcms_article ";
	$sql .= "WHERE article_public=1 AND article_aktiv=1 AND article_deleted=0 ";
	$sql .= "AND article_begin<NOW() AND article_end>NOW() ";
	$sql .= "ORDER BY article_cid, article_sort, article_tstamp DESC;";
	
	if($result = mysql_query($sql, $dbcon)) {
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$data[$row["article_id"]] = array(	"article_id"		=> $row["article_id"],
									"article_cid"		=> $row["article_cid"],
									"article_title"		=> $row["article_title"],
									"article_subtitle"	=> $row["article_subtitle"],
									"article_keyword"	=> $row["article_keyword"],
									"article_summary"	=> $row["article_summary"],
									"article_redirect"	=> $row["article_redirect_to"],
									"article_date"		=> $row["article_date"],
									"article_username"	=> $row["article_username"],
									"article_sort"		=> $row["article_sort"] );
		}
		mysql_free_result($result);
	}
	return (sizeof($data)) ? $data : array();
}

// -------------------------------------------------------------

function get_actcat_articles_data ($act_cat_id, $dbcon) {
	//returns the complete active and public article data as array (basic infos only)
	//so it is reusable by many functions -> lower db access
	
	$sql  = "SELECT *, UNIX_TIMESTAMP(article_tstamp) AS article_date FROM ".DB_PREPEND."phpwcms_article ";
	$sql .= "WHERE article_cid=".intval($act_cat_id)." AND article_public=1 AND article_aktiv=1 AND article_deleted=0 ";
	$sql .= "AND article_begin<NOW() AND article_end>NOW() ";
	//$sql .= "ORDER BY article_cid, article_sort, article_tstamp DESC;";
	$sql .= "ORDER BY article_sort;";
	
	if($result = mysql_query($sql, $dbcon)) {
		while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$data[$row["article_id"]] = array(
									"article_id"		=> $row["article_id"],
									"article_cid"		=> $row["article_cid"],
									"article_title"		=> $row["article_title"],
									"article_subtitle"	=> $row["article_subtitle"],
									"article_keyword"	=> $row["article_keyword"],
									"article_summary"	=> $row["article_summary"],
									"article_redirect"	=> $row["article_redirect_to"],
									"article_date"		=> $row["article_date"],
									"article_username"	=> $row["article_username"],
									"article_sort"		=> $row["article_sort"] );
		}
		mysql_free_result($result);
	}
	return (sizeof($data)) ? $data : array();
}

// -------------------------------------------------------------

//menu creating
function nav_table_simple_struct($struct, $act_cat_id, $link_to="index.php") {
	//returns a simple table based navigation menu of possible
	//structure levels based on current structure level
	$nav_table  = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n<tr>\n";
	$nav_table .= "<td width=\"10\"><img src=\"img/leer.gif\" width=\"10\" height=\"1\"></td>\n";
	$nav_table .= "<td width=\"100%\"><strong>";
	$nav_table .= html_specialchars($struct[$act_cat_id]["acat_name"]);
	$nav_table .= "</strong></td>\n<tr>";
	foreach($struct as $key => $value) {
		if($struct[$key]["acat_struct"] == $act_cat_id && $key != $act_cat_id && !$struct[$key]["acat_hidden"]) {
			$nav_table .= "<tr>\n";
			$nav_table .= "<td width=\"10\"><img src=\"img/leer.gif\" width=\"10\" height=\"1\"></td>\n";
			$nav_table .= "<td width=\"100%\"><a href=\"".$link_to."?id=".$key.",0,0,1,0,0\">";;
			$nav_table .= html_specialchars($struct[$key]["acat_name"]);
			$nav_table .= "</a></td>\n<tr>";
		}
	}
	$nav_table .= "</table>";
	return $nav_table;
}

// -------------------------------------------------------------

function nav_table_struct ($struct, $act_cat_id, $level, $nav_table_struct, $link_to="index.php") {
	// start with home directory for the listing = top nav structure
	// 1. Build the recursive tree for given actual article category ID
	
	// return the tree starting with given start_id (like breadcrumb)
	// if the $start_id = 0 then this stops because 0 = top level
	
	$level = intval($level);
	$start_id = $act_cat_id;
	
	while ($start_id) {
		$data[$start_id] = 1;
		$start_id		 = $struct[$start_id]["acat_struct"];
	}
	$temp_tree = (sizeof($data)) ? array_reverse($data, 1) : false;
	
	foreach($struct as $key => $value) {
		if($struct[$key]["acat_struct"] == $act_cat_id && $key && !$struct[$key]["acat_hidden"]) $c++;
	}
	$c = (!$c) ? 1 : 0;
	
	//get depth of level
	$level_depth = 0; $start_level = $level;
	while ($start_level) {
		$start_level = $struct[$start_level]["acat_struct"];
		$level_depth++;
	}
	$temp_menu = build_levels ($struct, $level, $temp_tree, $act_cat_id, $nav_table_struct, $level_depth, $c, $link_to); //starts at root level
	return ($temp_menu) ? ("<table".table_attributes($nav_table_struct, "table", 0).">\n".$temp_menu."</table>") : "";
}

// -------------------------------------------------------------

function build_levels ($struct, $level, $temp_tree, $act_cat_id, $nav_table_struct, $count, $div, $link_to) {
	// this returns the level structure based on given arrays
	// it is special for browsing from root levels
	$depth = sizeof($temp_tree)-$div; $count++; $depth2 = $depth-$count+2;
	
	$right_cell = ""; $left_cell = ""; $cell_top = ""; $cell_bottom = ""; $space_right = ""; $space_cell = ""; $space_row = "";
	$cell_height = ($nav_table_struct["cell_height"]) ? $nav_table_struct["cell_height"] : 1;
	if($nav_table_struct["space_right"]) {
		$right_cell  = "<td width=\"".$nav_table_struct["space_left"]."\">";
		$right_cell .= spacer($nav_table_struct["space_right"], $cell_height)."</td>\n";
		$space_right = "<td>".spacer(1, 1)."</td>";
	}
	if($nav_table_struct["space_left"]) {
		$colspan	= ($count > 1) ? " colspan=\"".$count."\"" : "";
		$left_cell	= "<td width=\"".$nav_table_struct["space_left"]."\"".$colspan.">";
		$left_cell .= spacer($nav_table_struct["space_left"], $cell_height)."</td>\n";
		$space_cell = "<td".$colspan.">".spacer(1, 1)."</td><td>".spacer(1, 1)."</td>";
	} else {
		if($count > 1) {
			$colspan	= ($count > 2) ? " colspan=\"".($count-1)."\"" : "";
			$left_cell	= "<td ".$colspan.">".spacer(1, 1)."</td>\n";
			$space_cell = "<td".$colspan.">".spacer(1, 1)."</td><td>".spacer(1, 1)."</td>";
		}
	}
	if($nav_table_struct["space_celltop"]) $cell_top = spacer(1, $nav_table_struct["space_celltop"])."<br />";
	if($nav_table_struct["space_cellbottom"]) $cell_bottom = "<br />".spacer(1, $nav_table_struct["space_cellbottom"]);
	
	$temp_menu	= ""; $js = "";
	$colspan	= ($depth2 > 1) ? " colspan=\"".$depth2."\"" : "";
	
	foreach($struct as $key => $value) {
		if($_SESSION["frontend_user_in"] && $struct[$key]["acat_regonly"]) $struct[$key]["acat_regonly"] = 0;
		if($struct[$key]["acat_struct"] == $level && $key && !$struct[$key]["acat_hidden"] && !$struct[$key]["acat_regonly"]) {
			
			$link_image_id	= "linkid".randpassword(6);
			$link_name_id 	= " name=\"".$link_image_id."\" id=\"".$link_image_id."\"";
			$link			= $link_to."?id=".$key.",0,0,1,0,0";
			
			if($nav_table_struct["js_over_effects"]) {
				$js		 = " onClick=\"location.href='".$link."';\"";
				$js_act	 = " onMouseOver=\"this.style.cursor='pointer';\"".$js;
				$js		.= " onMouseOver=\"this.bgColor='".$nav_table_struct["row_over_bgcolor"]."';this.style.cursor='pointer';".$link_image_id.".src='".$nav_table_struct["linkimage_over"]."';\"";
				$js		.= " onMouseOut=\"this.bgColor='".$nav_table_struct["row_norm_bgcolor"]."';".$link_image_id.".src='".$nav_table_struct["linkimage_norm"]."';\"";
			}
			
			//spacer row
			if($nav_table_struct["row_space"]) {
				$space_row  = "<tr".table_attributes($nav_table_struct, "row_space", 0).">\n".$space_cell;
				$space_row .= "<td".$colspan.">".spacer(1, $nav_table_struct["row_space"])."</td>";
				$space_row .= $space_right."\n</tr>\n";
				$temp_menu .= $space_row;
			}
			
			if($temp_tree[$key]) {
				if($act_cat_id == $key) {
					$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_active", 0).$js_act.">\n".$left_cell;
					$temp_menu .= "<td valign=\"top\"><img src=\"".$nav_table_struct["linkimage_active"]."\" border=\"0\"".$link_name_id."></td>\n";
					$temp_menu .= "<td".table_attributes($nav_table_struct, "cell_active", 1).$colspan.">".$cell_top;				
					$temp_menu .= "<a href=\"".$link."\">".html_specialchars($struct[$key]["acat_name"])."</a>";
				} else {
					$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_norm", 0).$js.">\n".$left_cell;
					$temp_menu .= "<td valign=\"top\"><img src=\"".$nav_table_struct["linkimage_norm"]."\" border=\"0\"".$link_name_id."></td>\n";
					$temp_menu .= "<td".table_attributes($nav_table_struct, "cell", 1).$colspan.">".$cell_top;				
					$temp_menu .= "<a href=\"".$link."\">".html_specialchars($struct[$key]["acat_name"])."</a>";
				}
				
				$temp_menu .= $cell_bottom."</td>\n".$right_cell."</tr>\n";
				$temp_menu .= build_levels ($struct, $key, $temp_tree, $act_cat_id, $nav_table_struct, $count, $div, $link_to);
			} else {
				$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_norm", 0).$js.">\n".$left_cell;
				$temp_menu .= "<td valign=\"top\"><img src=\"".$nav_table_struct["linkimage_norm"]."\" border=\"0\"".$link_name_id."></td>\n";
				$temp_menu .= "<td".table_attributes($nav_table_struct, "cell", 1).$colspan.">".$cell_top;
				$temp_menu .= "<a href=\"".$link."\">".html_specialchars($struct[$key]["acat_name"])."</a>";
				$temp_menu .= $cell_bottom."</td>\n".$right_cell."</tr>\n";
			}
		}
	}
	
	if($nav_table_struct["row_space"] && $count == 1) $temp_menu .= $space_row;
	
	return $temp_menu;
}

// -------------------------------------------------------------

function list_articles_summary ($article_list, $template_default, $cat_id=0, $link_to="index.php") {
	// returns an article listing only with headline and summary text
	// and with an listing of all other available articles of this category
	
	$listing = $template_default["space_top"]; //start with space at top
	
	$temp_counter = 0;
	foreach($article_list as $key => $value) {
		
		//$article_link  = $link_to."?id=".$cat_id.",".$article_list[$key]["article_id"].",0,0,1,0";
		$article_link  = $link_to."?id=".$article_list[$key]["article_cid"].",".$article_list[$key]["article_id"].",0,0,1,0";
		
		
		if($temp_counter < $template_default["top_count"]) {
			// as long as the counter is lower than the default "top_count" value
			// show the complete article summary listing
			
			// space between summary listings
			$listing .= ($temp_counter) ? $template_default["space_between_sum"] : "";
			
			if($article_list[$key]["article_title"]) {
				$listing .= get_html_part($article_list[$key]["article_title"], $template_default["top_headline_class"], $article_link);
				$listing .= $template_default["top_headline_space"];
			}
			if($article_list[$key]["article_subtitle"]) {
				$listing .= get_html_part($article_list[$key]["article_subtitle"], $template_default["top_subheadline_class"], $article_link);
				$listing .= $template_default["top_subheadline_space"];
			}
			if($article_list[$key]["article_summary"]) {
				$listing .= "<span class=\"".$template_default["top_text_class"]."\">";
				$listing .= $article_list[$key]["article_summary"];
				$listing .= $template_default["top_readmore_before"];
				$listing .= "<a href=\"".$article_link."\">";
				$listing .= html_specialchars($template_default["top_readmore_link"]);
				$listing .= "</a>".$template_default["top_readmore_after"]."</span>";
			}
		
		} else { 
			// if "top_count" value is equal or larger
			// show only the article headline listing
			if($temp_counter && $temp_counter == $template_default["top_count"]) {
				$listing .= $template_default["space_aftertop_text"];
			} elseif ($temp_counter) {
				$listing .= $template_default["space_between_list"];
			}
			$listing .= "<a href=\"".$article_link."\">";
			$listing .= $template_default["list_startimage"];
			$listing .= get_html_part($article_list[$key]["article_title"], $template_default["list_headline_class"]);
			$listing .= "</a>";
		
		}
		$temp_counter++;
	}
	
	$listing .= $template_default["space_bottom"]; //ends with space at bottom
	return str_replace("<br /><br />", "<br />", $listing);
}

// -------------------------------------------------------------

function get_html_part($value, $class="", $link="", $span_or_div=1) {
	// returns a content part for html output like
	// <span class="xxx">html</span>
	if($value) {
		$html_tag  = ($span_or_div) ? "span" : "div";
		$html_part = ($link) ? "<a href=\"".$link."\">".html_specialchars($value)."</a>" : html_specialchars($value);
		if($class) {
			$html_part = "<".$html_tag." class=\"".$class."\">".$html_part;
		} else {
			$html_part = "<".$html_tag.">".$html_part;
		}
		return $html_part."</".$html_tag.">";
	} else {
		return "";
	}
}

// -------------------------------------------------------------

function span_class($value, $class) {
	return ($class) ? "<span class=\"".$class."\">".$value."</span>" : $value;
}

// -------------------------------------------------------------

function div_class($value, $class) {
	return ($class) ? "<div class=\"".$class."\">".$value."</div>" : $value;
}

// -------------------------------------------------------------

function get_class_attrib($class) {
	return ($class) ? " class=\"".$class."\"" : "";
}

// -------------------------------------------------------------

function html_parser($string) {
	// parse the $string and replace all possible
	// values with $replace
	
	// page TOP link
	$search[0]		= '/\[TOP\](.*?)\[\/TOP\]/i';
	$replace[0]		= '<a href="#top">$1</a>';
	
	// internal Link to category alias (string)
	$search[1]		= '/\[ID (\w+)\](.*?)\[\/ID\]/';
	$replace[1]		= '<a href="index.php?$1">$2</a>';
	
	// external Link (string)
	$search[2]		= '/\[EXT (.*?)\](.*?)\[\/EXT\]/';
	$replace[2]		= '<a href="$1" target="_blank">$2</a>';
	
	// internal Link (string)
	$search[3]		= '/\[INT (.*?)\](.*?)\[\/INT\]/';
	$replace[3]		= '<a href="$1" target="_top">$2</a>';
	
	// random GIF Image
	$search[4]		= '/\{RANDOM_GIF:(.*?)\}/';
	$replace[4]		= '<img src="img/random_image.php?type=0&imgdir=$1" border="0">';
	
	// random JPEG Image
	$search[5]		= '/\{RANDOM_JPEG:(.*?)\}/';
	$replace[5]		= '<img src="img/random_image.php?type=1&imgdir=$1" border="0">';
	
	// random PNG Image
	$search[6]		= '/\{RANDOM_PNG:(.*?)\}/';
	$replace[6]		= '<img src="img/random_image.php?type=2&imgdir=$1" border="0">';
	
	// insert non db image standard
	$search[7]		= '/\{IMAGE:(.*?)\}/';
	$replace[7]		= '<img src="picture/$1" border="0">';
	
	// insert non db image left
	$search[8]		= '/\{IMAGE_LEFT:(.*?)\}/';
	$replace[8]		= '<img src="picture/$1" border="0" align="left">';
	
	// insert non db image right
	$search[9]		= '/\{IMAGE_RIGHT:(.*?)\}/';
	$replace[9]		= '<img src="picture/$1" border="0" align="right">';
	
	// insert non db image center
	$search[10]		= '/\{IMAGE_CENTER:(.*?)\}/';
	$replace[10]		= '<div align="center"><img src="picture/$1" border="0"></div>';
	
	// insert non db image right
	$search[11]	 	= '/\{SPACER:(\d+)x(\d+)\}/';
	$replace[11] 	= '<img src="img/leer.gif" border="0" width="$1" height="$2">';
	
	// RSS feed link based on structure (category) ID
	$search[12]		= '/\[RSS (\d+)\](.*?)\[\/RSS\]/';
	$replace[12]	= '<a href="rss.php?rssfeed=$1" target="_blank">$2</a>';
	
	// RSS feed link based on structure (category) ALIAS
	$search[13]		= '/\[RSS (\w+)\](.*?)\[\/RSS\]/';
	$replace[13]	= '<a href="rss.php?$1" target="_blank">$2</a>';
	
	// back Link (string)
	$search[14]		= '/\[BACK\](.*?)\[\/BACK\]/i';
	$replace[14] 	= '<a href="javascript:history.back();" target="_top" alt="go back">$1</a>';
	
	// random Image Tag
	$search[15]		= '/\{RANDOM:(.*?)\}/e';
	$replace[15]	= 'get_random_image_tag("$1");';

	// span or div style
	$search[16]		= '/\[(span|div)_style:(.*?)\](.*?)\[\/style\]/';
	$replace[16]	= '<$1 style="$2">$3</$1>';
	
	// span or div class
	$search[17]		= '/\[(span|div)_class:(.*?)\](.*?)\[\/class\]/';
	$replace[17]	= '<$1 class="$2">$3</$1>';
	
	// typical html formattings
	$search[18]		= '/\[i\](.*?)\[\/i\]/i';			$replace[18]	= '<i>$1</i>';
	$search[19]		= '/\[u\](.*?)\[\/u\]/i';			$replace[19]	= '<u>$1</u>';
	$search[20]		= '/\[s\](.*?)\[\/s\]/i';			$replace[20]	= '<strike>$1</strike>';
	$search[21]		= '/\[b\](.*?)\[\/b\]/i';			$replace[21]	= '<strong>$1</strong>';
	
	// anchor link
	$search[22]		= '/\{A:(.*?)\}/i';
	$replace[22]	= '<a name="$1"></a>';
	
	// this pharses out an E-Mail Link without subject (by Florian, 21-11-2003)
	$search[23]      = '/\[MAIL (.*?)\](.*?)\[\/MAIL\]/i';
	$replace[23]   = '<a href="mailto:$1">$2</a>'; 
    
	// this tags out a Mailaddress with an predifined subject (by Florian, 21-11-2003)
	$search[24]      = '/\[MAILSUB (.*?) (.*?)\](.*?)\[\/MAILSUB\]/i';
	$replace[24]   = '<a href="mailto:$1?subject=$2">$3</a>';
	
	return preg_replace($search, $replace, $string);
}

// -------------------------------------------------------------

function include_ext_php($inc_file) {
	// includes an external PHP script file and returns
	// the result as string from buffered include content
	$ext_php_content = "";
	ob_start();
	include $inc_file;
	$ext_php_content = ob_get_contents();
	ob_end_clean();
	return $ext_php_content;
}

// -------------------------------------------------------------

function international_date_format($language="EN", $format="Y/m/d", $date_now=0) {
	// formats the given date
	// for the specific language
	// use the normal date format options
	
	if(!$format) $format = "Y/m/d";
	if(!intval($date_now)) $date_now = time();
	$date_format_function = array (	"a" => 1, "A" => 1, "B" => 1, "d" => 1, "g" => 1, "G" => 1, 
									"h" => 1, "H" => 1, "i" => 1, "I" => 1, "j" => 1, "m" => 1,
									"n" => 1, "s" => 1, "t" => 1, "T" => 1, "U" => 1, "w" => 1, 
									"Y" => 1, "y" => 1, "z" => 1, "Z" => 1,									
									"D" => 0, "F" => 0, "l" => 0, "M" => 0, "S" => 0
								   );
	if($language == "EN" || !$language) {
		$date = date($format, $date_now);
	} else {
		$lang_include = PHPWCMS_ROOT.'/include/inc_lang/date/'.strtolower($language).'.date.lang.php';
		if(file_exists($lang_include)) {
			include($lang_include);
		} else {
			$date = date($format, $date_now);
		}
		
		$str_length = strlen($format); $date = "";
		for($i = 0; $i < $str_length; $i++) $date_format[$i] = substr($format, $i, 1);		
		foreach($date_format as $key => $value) {
			if(isset($date_format_function[$value])) {
				if($date_format_function[$value]) {
					$date .= date($value, $date_now);
				} else{
					switch($value) {
						case "D":	$date .= $weekday_short[ intval(date("w", $date_now)) ]; break; //short weekday name
						case "l":	$date .= $weekday_long[ intval(date("w", $date_now)) ]; break; //long weekday name
						case "F":	$date .= $month_long[ intval(date("n", $date_now)) ]; break; //long month name
						case "M":	$date .= $month_short[ intval(date("n", $date_now)) ]; break; //long month name
						case "S":	$date .= ""; break;
					}
				}
			} else {
				$date .= $value;
			}		
		}
	}
	return $date;
}

// -------------------------------------------------------------

function get_random_image_tag($path) {
	// returns an random image from the give path
	// it looks for image of following type:
	// gif, jpg, jpeg, png

	$imgArray = array();
	$imgpath = str_replace("//", "/", PHPWCMS_ROOT."/".$path."/");
	$imageinfo = false;

	if(is_dir($imgpath)) {
		$handle = opendir( $imgpath );
		while($file = readdir( $handle )) {
   			if( $file != "." && $file != ".." ) {
				if( preg_match('/(\.jpg|\.jpeg|\.gif|\.png)$/', strtolower($file)) ) $imgArray[] = $file;
			}
		}
		closedir( $handle );
	}
	
	if(sizeof($imgArray)) $imageinfo = is_random_image($imgArray, $imgpath);
	//return $imageinfo;
	return ($imageinfo) ?	"<img src=\"".$path."/".$imageinfo["imagename"].
							"\" ".$imageinfo[3]." border=\"0\" alt=\"random image: ".
							$imageinfo["imagename"]."\">"
							: "";	
}

// -------------------------------------------------------------

function is_random_image($imgArray, $imagepath, $count=0) {
	// tests if the random choosed image is really an image
	$count++;
	mt_srand( (double)microtime( ) * 1000000 );
	$randval = mt_rand( 0, sizeof( $imgArray ) - 1 );
	$file = $imagepath.$imgArray[ $randval ];
	//gets -> better tests for image info
	$imageinfo = @getimagesize($file);
	//if $imageinfo is not true repeat function and count smaller count all images
	if(!$imageinfo) {
		if($count < sizeof($imgArray)) $imageinfo = is_random_image($imgArray, $imagepath, $count);
	} else {
		$imageinfo["imagename"] = $imgArray[ $randval ];
	}
	return $imageinfo;
}

// -------------------------------------------------------------

function return_struct_level($struct, $struct_id) {
	// walk through the given struct level and returns an array with available levels
	if(sizeof($struct)) {
		$level_entry = array();
		foreach($struct as $key => $value) {
			if($key && $struct[$key]["acat_struct"] == $struct_id && !$struct[$key]["acat_hidden"]) {
				$level_entry[$key] = $value;
			}
		}
	}
	return $level_entry;
}

// -------------------------------------------------------------

function get_active_categories($struct, $act_struct_id) {
	// returns an array with all active categories/structure levels
	
	$which_cat_array = array();
	$which_category = $act_struct_id;
	while($which_category) {
		$which_cat_array[$which_category] = 1;
		$which_category = $content["struct"][$which_category]["acat_struct"];
	}
	return $which_cat_array;
}

// -------------------------------------------------------------

function css_list_top($struct, $struct_path, $homelink="Home", $class="list_top", $link_to="index.php") {
	// returns list <div><ul><li></li></ul></div> of level 0
	// if $homelink is not empty it will also create a "Home" link
	// you can set $homelink to the name you like
	// predefined class for this menu is "list_top"	
	
	if(!trim($class)) $class = "list_top";
	$homelink = trim($homelink);
	$activated = 0; //no active list set
	$css_list = "";
	
	//returns the complete top level AND home of NON hidden categories
	$top_struct = return_struct_level($struct, 0); 
	
	if(sizeof($top_struct)) {
		foreach($top_struct as $key => $value) {
		
			$link = $link_to."?id=".$key.",0,0,1,0,0";
			$css_list .= "    <li";
			if($struct_path[$key]) {
				$css_list .= " id=\"".$class."_active\"";
				$activated = 1;
			}
			$css_list .= '><a href="'.$link.'"';
			$css_list .= (!$struct_path[$key]) ? "" : " id=\"".$class."_active_link\"";
			$css_list .= ' target="_top">'.html_specialchars($top_struct[$key]["acat_name"])."</a>";
			$css_list .= "</li>\n";
		}
	}
	
	if($homelink) {
		$css_list_home  = "    <li id=\"".$class. ((!$activated) ? "_home_active" : "_home") ."\">";
		$css_list_home .= '<a href="'.$link_to.'?id=0,0,0,1,0,0"';
		$css_list_home .= ($activated) ? "" : " id=\"".$class."_home_active_link\"";
		$css_list_home .= ' target="_top">'.html_specialchars($homelink)."</a>";
		$css_list_home .= "</li>\n";
		$css_list = $css_list_home . $css_list;
	}
	if($css_list) {
		$css_list = "<div id=\"".$class."\">\n  <ul id=\"".$class."_ul\">\n". $css_list ."  </ul>\n</div>";
	}
	return $css_list;
}

// -------------------------------------------------------------

function css_list_current_level($struct, $struct_path, $level, $parent_level_name="", $parent_level=1, $class="list_level", $link_to="index.php") {
	// returns list <div><ul><li></li></ul></div> of the current structure level
	// if $parent_level=1 the first list entry will be the parent level
	// $parent_level=0 - only the list of all levels in this structure
	// if $parent_leve_name != "" then it uses the given string
	// predefined class for this menu is "list_level"	
	
	if(!trim($class)) $class = "list_level";
	$parent_level_name = trim($parent_level_name);
	$level = intval($level);
	$parent_level = intval($parent_level);
	$activated = 0; //no active list set
	$css_list = "";
	
	//returns the complete level of NON hidden categories
	$level_struct = return_struct_level($struct, $level); 

	if(sizeof($level_struct)) {
		foreach($level_struct as $key => $value) {
		
			$link = $link_to."?id=".$key.",0,0,1,0,0";
			$css_list .= "    <li";
			/* if($level_struct[$key]) {
				//$css_list .= " id=\"".$class."_active\"";
				$activated = 1;
			}*/
			$css_list .= '><a href="'.$link.'"';
			//$css_list .= (!$struct_path[$key]) ? "" : " id=\"".$class."_active_link\"";
			$css_list .= ' target="_top">'.html_specialchars($level_struct[$key]["acat_name"])."</a>";
			$css_list .= "</li>\n";

		}
	}
	
	if($parent_level && $level) {
		$css_list_home  = "    <li id=\"".$class."_parent\">";
		$css_list_home .= '<a href="'.$link_to.'?id='.$struct[$level]["acat_struct"];
		$css_list_home .= ',0,0,1,0,0" id="'.$class.'_parent_link" target="_top">';
		$css_list_home .= html_specialchars((!$parent_level_name) ? $struct[$level]["acat_name"] : $parent_level_name);
		$css_list_home .= "</a></li>\n";
		$css_list = $css_list_home . $css_list;
	}
	if($css_list) {
		$css_list = "<div id=\"".$class."\">\n  <ul id=\"".$class."_ul\">\n". $css_list ."  </ul>\n</div>";
	}
	return $css_list;
}

// -------------------------------------------------------------

//Rewrite functions
function url_search($query)    
{ 
   $noid = substr($query, 4); 
   $file = str_replace(",", ".", $noid).".html"; //further use 
   //$file = $noid.".html"; 
   $link = "<a href=\"".$file."\""; 
   return($link); 
   //unset($link); 
} 

function js_url_search($query)    
{ 
   $noid = substr($query, 4); 
   $file = str_replace(",", ".", $noid).".html"; //further use 
   //$file = $noid.".html"; 
   $link = "onClick=\"location.href='".$file."'"; 
   return($link); 
   //unset($link); 
} 

// -------------------------------------------------------------

function get_related_articles($keywords, $current_article_id, $template_default, $max_cnt_links=0, $dbcon) {
	// find keyword for current article used for RELATED replacementtag
	// prepared and inspired by Magnar Stav Johanssen

	$keyword_links = ""; $max_cnt_links = intval($max_cnt_links);
		
	// replace unwanted chars and convert to wanted
	$keywords = str_replace(";", ",", $keywords);
	$keywords = str_replace("'", "", $keywords);
	$keywords = str_replace(" ", ",", $keywords);
	
	// choose comma separated keywords
	$keywordarray = explode (",", $keywords);
	// check for empty keywords or keywords smaller than 3 chars
	if(sizeof($keywordarray)) {
		foreach($keywordarray as $key => $value) {
			$keywordarray[$key] = trim($value);			
			if(!$keywordarray[$key] || strlen($keywordarray[$key]) < 3) unset($keywordarray[$key]);		
		}
	}

	if(sizeof($keywordarray)) {
		$where = "";
		foreach($keywordarray as $value) {
			//build where keyword = blabla
			$where .= ($where) ? " OR " : "";
			//replace every "'" to "''" for security reasons with aporeplace()
			$where .= "article_keyword LIKE '%".aporeplace($value)."%'";		
		}
		$limit = ($max_cnt_links) ? " LIMIT ".$max_cnt_links : "";
		$sql =	"SELECT article_id, article_title, article_cid FROM ".DB_PREPEND."phpwcms_article WHERE ".
				"article_id<>".intval($current_article_id)." AND ".
				"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND ".
				"article_begin < NOW() AND article_end > NOW() AND (".$where.") ".
				"ORDER BY article_tstamp DESC".$limit.";";

		// related things
		$target = ($template_default["link_target"]) ? ' target="'.$template_default["link_target"].'"' : "";
		if($result = mysql_query($sql, $dbcon)) {
			$count_results = mysql_num_rows($result); $count = 0;
			while ($row = mysql_fetch_row($result)) {
				$count++;
				if($template_default["link_length"] && strlen($row[1]) > $template_default["link_length"]) {
					$article_title = substr($row[1], 0, $template_default["link_length"]).$template_default["cut_title_add"];
				} else {
					$article_title = $row[1];
				}
				$keyword_links .= $template_default["link_before"].$template_default["link_symbol"];
				$keyword_links .= '<a href="index.php?id='.$row[2].','.$row[0].',0,0,1,0"';
				$keyword_links .= $target.">".html_specialchars($article_title)."</a>";
				
				//try to remove possible unwanted after - if not enclosed before.link.after
				if($keyword_links && !$template_default["link_before"] && $count < $count_results) {
					$keyword_links .= $template_default["link_after"];
				}
			}
			mysql_free_result($result);
		}
	}

	//enclose whole
	if($keyword_links) $keyword_links = $template_default["before"].$keyword_links.$template_default["after"];
	
	return $keyword_links;
}

// -------------------------------------------------------------

function get_new_articles($template_default, $max_cnt_links=0, $dbcon) {
	// find all new articles

	$max_cnt_links = intval($max_cnt_links);
	$limit = ($max_cnt_links) ? " LIMIT ".$max_cnt_links : "";
	
	$sql =	"SELECT article_id, article_title, article_cid, UNIX_TIMESTAMP(article_tstamp) AS article_date ".
			"FROM ".DB_PREPEND."phpwcms_article WHERE ".
			"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND ".
			"article_begin < NOW() AND article_end > NOW() ".
			"ORDER BY article_tstamp DESC".$limit.";";

	// new articles list
	$new_links = "";
	$target = ($template_default["link_target"]) ? ' target="'.$template_default["link_target"].'"' : "";
	if($result = mysql_query($sql, $dbcon)) {
		$count_results = mysql_num_rows($result); $count = 0;
		while ($row = mysql_fetch_row($result)) {
			$count++;
			if($template_default["link_length"] && strlen($row[1]) > $template_default["link_length"]) {
				$article_title = substr($row[1], 0, $template_default["link_length"]).$template_default["cut_title_add"];
			} else {
				$article_title = $row[1];
			}
			if(trim($template_default["date_format"])) {
				$article_title = international_date_format(
									$template_default["date_language"], 
									$template_default["date_format"], 
									$row[3]).$article_title;
			}
			$new_links .= $template_default["link_before"].$template_default["link_symbol"];
			$new_links .= '<a href="index.php?id='.$row[2].','.$row[0].',0,0,1,0"';
			$new_links .= $target.">".html_specialchars($article_title)."</a>";
			
			//try to remove possible unwanted after - if not enclosed before.link.after
			if($new_links && !$template_default["link_before"] && $count < $count_results) {
				$new_links .= $template_default["link_after"];
			}
		}
		mysql_free_result($result);
	}

	//enclose whole
	if($new_links) $new_links = $template_default["before"].$new_links.$template_default["after"];
	
	return $new_links;
}

// -------------------------------------------------------------

function get_article_idlink($article_id=0, $link_text="", $db) {
	// returns the internal article link to given article ID/category
	$article_id		= intval($article_id);
	$article_cid	= 0;
	$link_text		= html_specialchars($link_text);
	$article_title	= $link_text;
	
	if($article_id) {
		$sql =	"SELECT article_id, article_title, article_cid ".
				"FROM ".DB_PREPEND."phpwcms_article WHERE article_id=".$article_id." AND ".
				"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND ".
				"article_begin < NOW() AND article_end > NOW() LIMIT 1;";
		if($result = mysql_query($sql, $db)) {
			if($row = mysql_fetch_row($result)) {
				$article_id		= $row[0];
				$article_cid	= $row[2];
				$article_title	= html_specialchars($row[1]);
			}
			mysql_free_result($result);
		}
	}
	$article_link = '<a href="index.php?id='.$article_cid.','.$article_id.
					',0,0,1,0" title="'.$article_title.'">'.$link_text.'</a>';
	return $article_link;
}

// -------------------------------------------------------------

function get_keyword_link($keywords="", $db) {
	// returns a link or linklist for special article keywords
	// used for replacement tag {KEYWORD:Charlie}
	
	$keywords = explode(",", $keywords); 
	$where = ""; 
	$keyword_list = "";
	$link = "";
	
	if(count($keywords)) {
		foreach($keywords as $value) {
			$value = trim($value);
			if($value) {
				if($where) {
					$where .= " AND ";
					$keyword_list .= ", ";
				}
				$where .= "article_keyword LIKE '%*".aporeplace($value)."*%'";
				//$where .= "article_keyword REGEXP '\\\\*".aporeplace($value)."\\\\*'";
				$keyword_list .= html_specialchars($value);
			}
		}
	} else {
		$keyword_list = $keywords;
	}
	
	if($where) {
		$sql  = "SELECT article_id, article_cid, article_title FROM ".DB_PREPEND."phpwcms_article WHERE ";
		$sql .=	"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND article_begin < NOW() ";
		$sql .=	"AND article_end > NOW() AND (".$where.");";
	
		if($result = mysql_query($sql, $db)) {
			$article_list = array(); $x = 0;
			while($row = mysql_fetch_row($result)) {
				$article_list[$x][0] = $row[0]; //article ID
				$article_list[$x][1] = $row[1]; //article catID
				$article_list[$x][2] = html_specialchars($row[2]); //article title
				$x++;
			}
			mysql_free_result($result);
		}
		
		if($x) {
			// if keyword(s) found
			if($x == 1) {
				// if only 1 article found
				$link .= '<a href="index.php?id='.$article_list[0][1].','.$article_list[0][0];
				$link .= ',0,0,1,0" title="'.$article_list[0][2].'">'.$keyword_list.'</a>';
			} else {
				// if more than one article found
				foreach($article_list as $key => $value) {
					if($link) $link .= '|';
					$link .= '<a href="index.php?id='.$article_list[$key][1].','.$article_list[$key][0];
					$link .= ',0,0,1,0" title="'.$article_list[$key][2].'">'.($key+1).'</a>';					
				}
				$link = $keyword_list.' ['.$link.']';				
			}
		}
	}
	if(!$link) $link = $keyword_list;	
	return '<span class="phpwcms_keywords">'.$link.'</span>';

}

// -------------------------------------------------------------

function clean_replacement_tags($text = '') {
	// strip out special replacement tags
	$text = str_replace('<td>', '<td> ', $text);
	$text = strip_tags($text, '<a><b><i><u>');
	$text = str_replace("|", " ", $text);
	$text = preg_replace('/\{.*?\}/si', "", $text);
	$text = preg_replace('/\[ID.*?\/ID\]/si', "", $text);
	$text = preg_replace('/(\s+)/i', " ", $text);
	return trim($text);
}

// -------------------------------------------------------------

function get_search_action($id, $dbcon) {
	// return the search form action
	$id = intval($id); $cid = 0;
	if($id) {
		$sql  = "SELECT article_cid FROM ".DB_PREPEND."phpwcms_article WHERE ";
		$sql .=	"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND article_begin < NOW() ";
		$sql .=	"AND article_end > NOW() AND article_id=".$id." LIMIT 1;";
		if($result = mysql_query($sql, $dbcon)) {
			if($row = mysql_fetch_row($result)) {
				$cid = $row[0];
			}
			mysql_free_result($result);	
		}
	}
	return ($cid) ? 'index.php?id='.$cid.','.$id.',0,0,1,0' : '';
}


?>