<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

if ($content["aid"] != intval($_POST["caid"])) die("error: wrong form data!");
$content["title"] = clean_slweg($_POST["ctitle"], 250);
$content["subtitle"] = clean_slweg($_POST["csubtitle"], 250);
$content["visible"] = intval($_POST["cvisible"]);
$content["before"] = intval($_POST["cbefore"]);
$content["after"] = intval($_POST["cafter"]);
if (!$content["before"] || $content["before"] > 99) $content["before"] = "";
if (!$content["after"] || $content["after"] > 99) $content["after"] = "";
$content["top"] = intval($_POST["ctop"]);
$content["id"] = intval($_POST["cid"]);
$content["target_type"] = intval($_POST["target_ctype"]);
$content["sorting"] = intval($_POST["csorting"]); 
// Check wegen mglicher nderung des Content-Typs
$content["update_type"] = ($content["target_type"] != $content["type"]) ? 1 : 0; 
// bernahme von Informationen fr unterschiedliche Content Types
switch ($content["type"]) {
    // Text with image
    case 1: $content["text"] = slweg($_POST["ctext"], 65500);
        $content["image_name"] = clean_slweg($_POST["cimage_name"]);
        $content["image_id"] = intval($_POST["cimage_id"]);
        $content["image_pos"] = intval($_POST["cimage_pos"]);
        $content["image_width"] = (intval($_POST["cimage_width"]))?(intval($_POST["cimage_width"])):("");
        $content["image_height"] = (intval($_POST["cimage_height"]))?(intval($_POST["cimage_height"])):("");
        $temp_img_maxwidth = ($content["image_pos"] == 6 || $content["image_pos"] == 7)?(intval($phpwcms["content_width"] / 1.75)):($phpwcms["content_width"]);
        if (($content["image_width"] > $temp_img_maxwidth) || ($content["image_width"] == "")) $content["image_width"] = $temp_img_maxwidth;
        $content["image_caption"] = clean_slweg($_POST["cimage_caption"], 255);
        $content["image_zoom"] = intval($_POST["cimage_zoom"]);

        if ($content["image_id"] || $content["image_name"]) {
            // check for image information and get alle infos from file
            $img_sql = "SELECT f_thumb_preview FROM " . DB_PREPEND . "phpwcms_file WHERE f_id=" . $content["image_id"] . " AND f_name='" . aporeplace($content["image_name"]) . "' LIMIT 1;";
            if ($img_result = mysql_query($img_sql, $db) or die("error while getting content image info")) {
                if ($img_row = mysql_fetch_row($img_result)) {
                    $content["image_prev"] = $img_row[0];
                    $content["image_prev_info"] = getimagesize(PHPWCMS_ROOT . "/" . $phpwcms["file_tmp"] . $phpwcms["dir_preview"] . $content["image_prev"]);
                    $content["image_prev_make"] = 0; 
                    // checken der tatschlich mglichen Bildgre
                    if ($content["image_width"] >= $content["image_prev_info"][0] && $content["image_height"] > $content["image_prev_info"][1]) {
                        copy(PHPWCMS_ROOT . "/" . $phpwcms["file_tmp"] . $phpwcms["dir_preview"] . $content["image_prev"], PHPWCMS_ROOT . "/" . $phpwcms["content_path"] . $phpwcms["cimage_path"] . cut_ext($content["image_prev"]) . "-" . $content["image_prev_info"][0] . "x" . $content["image_prev_info"][1] . "." . which_ext($content["image_prev"]));
                        $content["image_prev_make"] = 1;
                    } 
                    if ($content["image_width"] > $content["image_prev_info"][0]) $content["image_width"] = $content["image_prev_info"][0];
                    if ($content["image_height"] > $content["image_prev_info"][1]) $content["image_height"] = $content["image_prev_info"][1];
                    $content["image_add"] = "-" . $content["image_width"] . "x" . $content["image_height"];
                    $content["image_cname"] = cut_ext($content["image_prev"]) . $content["image_add"] . "." . which_ext($content["image_prev"]);
                    $content["image_info"] = $content["image_id"] . ":" . $content["image_name"] . ":";
                    $content["image_info"] .= $content["image_prev"] . ":" . $content["image_width"] . ":";
                    $content["image_info"] .= $content["image_height"] . ":" . $content["image_pos"] . ":";
                    $content["image_info"] .= $content["image_cname"] . ":" . base64_encode($content["image_caption"]) . ":";
                    $content["image_info"] .= $content["image_zoom"];
                } else {
                    $content["image_info"] = "";
                } 
            } else {
                $content["image_info"] = "";
            } 
        } else {
            $content["image_info"] = "";
        } 

        if ($content["image_info"] && !file_exists(PHPWCMS_ROOT . "/" . $phpwcms["content_path"] . $phpwcms["cimage_path"] . $content["image_cname"]) && sizeof($content["image_prev_info"]) && !$content["image_prev_make"]) {
            include_once "include/inc_lib/imagick.convert.inc.php";
            $old_abort = ignore_user_abort(true);
            $create_cimage = imagick_converting($content["image_prev"], "jpg", $content["image_add"], PHPWCMS_ROOT . "/" . $phpwcms["file_tmp"] . $phpwcms["dir_preview"], PHPWCMS_ROOT . "/" . $phpwcms["content_path"] . $phpwcms["cimage_path"], $content["image_width"], $content["image_height"]);
            ignore_user_abort($old_abort);
            if ($create_cimage["error"]) $content["error"][60] = "Error while creating image preview"; 
        } 
        break; 
    // Image List
    case 2: $content["image_list"] = $_POST["cimage_list"];
        $content["image_pos"] = intval($_POST["cimage_pos"]);
        $content["image_width"] = $temp_width = (intval($_POST["cimage_width"]))?(intval($_POST["cimage_width"])):("");
        $content["image_height"] = $temp_height = (intval($_POST["cimage_height"]))?(intval($_POST["cimage_height"])):("");
        $content["image_space"] = intval($_POST["cimage_space"]);
        $content["image_col"] = intval($_POST["cimage_col"]);
        $content["image_caption"] = clean_slweg($_POST["cimage_caption"], 35000);
        $content["image_cctext"] = explode("\n", $content["image_caption"]);
        $content["image_zoom"] = intval($_POST["cimage_zoom"]);

        if (sizeof($content["image_list"])) {
            // if(!$content["image_width"]) $content["image_width"] = "";
            // if(!$content["image_height"]) $content["image_height"] = "";
            // zuweisen der passenden ImageID und Neuvergabe des Arrays
            $img_sql = "SELECT f_id, f_thumb_preview, f_name FROM " . DB_PREPEND . "phpwcms_file WHERE (";
            $imgx = 0;
            foreach($content["image_list"] as $key => $value) {
                unset ($content["image_list"][$key]); 
                // if(intval($value)) {
                $content["image_list"][$key]["image_id"] = intval($value);
                if ($imgx) $img_sql .= " OR ";
                $img_sql .= "f_id=" . $content["image_list"][$key]["image_id"];
                $imgx++; 
                // }
            } 
            $img_sql .= ");";

            // check for image information and get alle infos from file
            if ($img_result = mysql_query($img_sql, $db) or die("error while getting content image only info")) {
                // Gegenrechnen von Breite zu Anzahl Spalten und Bildabstand
                $temp_count_img = mysql_num_rows($img_result);
                $content["image_col"] = ($content["image_col"] > $temp_count_img) ? $temp_count_img : $content["image_col"];
                $temp_img_maxwidth = $phpwcms["content_width"] - (($content["image_col"] - 1) * $content["image_space"]);
                $temp_img_maxwidth = ($content["image_pos"] == 6 || $content["image_pos"] == 7)?(intval($temp_img_maxwidth / 1.75)):($temp_img_maxwidth);
                $temp_img_maxwidth = intval($temp_img_maxwidth / $content["image_col"]);

                if (($content["image_width"] > $temp_img_maxwidth) || ($content["image_width"] == "")) {
                    $content["image_width"] = $temp_img_maxwidth;
                    $temp_width = $content["image_width"];
                } while ($img_row = mysql_fetch_row($img_result)) {
                    foreach($content["image_list"] as $key => $value) {
                        if ($content["image_list"][$key]["image_id"] == $img_row[0]) {
                            $content["image_list"][$key]["image_prev"] = $img_row[1];
                            $content["image_list"][$key]["image_name"] = $img_row[2];
                            $content["image_list"][$key]["image_prev_info"] = getimagesize(PHPWCMS_ROOT . "/" . $phpwcms["file_tmp"] . $phpwcms["dir_preview"] . $content["image_list"][$key]["image_prev"]);
                            $content["image_list"][$key]["image_prev_make"] = 0;
                            $content["image_list"][$key]["image_width"] = $content["image_width"];
                            $content["image_list"][$key]["image_height"] = $content["image_height"];
                        } 
                    } 
                } 
            } 
            // Bildinformationen zuweisen
            $old_abort = ignore_user_abort(true);

            foreach($content["image_list"] as $key => $value) {
                if ($content["image_width"] >= $content["image_list"][$key]["image_prev_info"][0] && $content["image_height"] > $content["image_list"][$key]["image_prev_info"][1]) {
                    $img_prv_name = PHPWCMS_ROOT . "/";
                    $img_prv_name .= $phpwcms["file_tmp"] . $phpwcms["dir_preview"];
                    $img_prv_name .= $content["image_list"][$key]["image_prev"];

                    $img_cnt_name = PHPWCMS_ROOT . "/";
                    $img_cnt_name .= $phpwcms["content_path"] . $phpwcms["cimage_path"];
                    $img_cnt_name .= cut_ext($content["image_list"][$key]["image_prev"]);
                    $img_cnt_name .= "-" . $content["image_list"][$key]["image_prev_info"][0];
                    $img_cnt_name .= "x" . $content["image_list"][$key]["image_prev_info"][1];
                    $img_cnt_name .= "." . which_ext($content["image_list"][$key]["image_prev"]);

                    copy($img_prv_name, $img_cnt_name);
                    $content["image_list"][$key]["image_prev_make"] = 1;
                } 

                if ($content["image_width"] > $content["image_list"][$key]["image_prev_info"][0]) $content["image_list"][$key]["image_width"] = $content["image_list"][$key]["image_prev_info"][0];
                if ($content["image_height"] > $content["image_list"][$key]["image_prev_info"][1]) $content["image_list"][$key]["image_height"] = $content["image_list"][$key]["image_prev_info"][1];
                $content["image_list"][$key]["image_add"] = "-" . $content["image_list"][$key]["image_width"] . "x" . $content["image_list"][$key]["image_height"];
                $content["image_list"][$key]["image_cname"] = cut_ext($content["image_list"][$key]["image_prev"]) . $content["image_list"][$key]["image_add"] . "." . which_ext($content["image_list"][$key]["image_prev"]);
                $content["image_list"][$key]["image_info"] = $content["image_list"][$key]["image_id"] . ":" . $content["image_list"][$key]["image_name"] . ":";
                $content["image_list"][$key]["image_info"] .= $content["image_list"][$key]["image_prev"] . ":" . $temp_width . ":";
                $content["image_list"][$key]["image_info"] .= $temp_height . ":" . $content["image_pos"] . ":" . $content["image_space"] . ":" . $content["image_col"] . ":";
                $content["image_list"][$key]["image_info"] .= $content["image_list"][$key]["image_cname"] . ":" . base64_encode($content["image_cctext"][$key]) . ":";
                $content["image_list"][$key]["image_info"] .= $content["image_zoom"];

                if (!file_exists(PHPWCMS_ROOT . "/" . $phpwcms["content_path"] . $phpwcms["cimage_path"] . $content["image_list"][$key]["image_cname"]) && $content["image_list"][$key]["image_prev_info"] && !$content["image_list"][$key]["image_prev_make"]) {
                    include_once "include/inc_lib/imagick.convert.inc.php";
                    $create_cimage = imagick_converting($content["image_list"][$key]["image_prev"], "jpg", $content["image_list"][$key]["image_add"], PHPWCMS_ROOT . "/" . $phpwcms["file_tmp"] . $phpwcms["dir_preview"], PHPWCMS_ROOT . "/" . $phpwcms["content_path"] . $phpwcms["cimage_path"], $content["image_list"][$key]["image_width"], $content["image_list"][$key]["image_height"]);
                    if ($create_cimage["error"]) {
                        $content["error"][60] = "Error while creating image preview";
                        unset($content["image_list"][$key]);
                    } 
                } 
            } 

            ignore_user_abort($old_abort);
        } else {
            $content["image_width"] = "";
            $content["image_height"] = "";
        } 
        // Abschlieendes Werte bauen
        if (sizeof($content["image_list"])) {
            foreach($content["image_list"] as $key => $value) {
                $content["image_liste"][$key] = $content["image_list"][$key]["image_info"];
                $content["image_select"][$key]["image_id"] = $content["image_list"][$key]["image_id"];
                $content["image_select"][$key]["image_name"] = $content["image_list"][$key]["image_name"];
                $content["image_select"][$key]["image_thumb"] = $content["image_list"][$key]["image_prev"];
            } 
            $content["image_info"] = implode("\n", $content["image_liste"]);
            unset($content["image_liste"]);
        } 
        break; 
    // Redirect
    case 3: $content["link"] = clean_slweg($_POST["clink"], 245);
        $content["target"] = slweg($_POST["ctarget"], 9);
        $content["redirect"] = $content["link"] . " " . $content["target"];
        break; 
    // Bullet List
    case 4: //$content["text"] = clean_slweg($_POST["ctext"], 65500);
		$content["text"] = html_specialchars(slweg($_POST["ctext"], 65500));
        $cbullet = explode("\n", chop($content["text"]));
        if (count($cbullet)) {
            foreach($cbullet as $key => $value) {
                if (trim($value)) {
                    $cbullet[$key] = trim($value);
                } else {
                    unset($cbullet[$key]);
                } 
            } 
            $content["text"] = implode("\n", $cbullet);
        } 
        break; 
    // Link Liste
    case 5: $content["text"] = str_replace("  ", " ", clean_slweg($_POST["ctext"], 65500));
        $clinklist = explode("\n", chop($content["text"]));
        if (count($clinklist)) {
            foreach($clinklist as $key => $value) {
                if (trim($value)) {
                    list($clink[$key]["name"], $clink[$key]["link"]) = explode("|", trim($value));
                    if (isEmpty($clink[$key]["link"])) {
                        $clink[$key]["link"] = trim($clink[$key]["name"]);
                        $clink[$key]["name"] = "";
                    } else {
                        $clink[$key]["name"] = trim($clink[$key]["name"]);
                        $clink[$key]["link"] = trim($clink[$key]["link"]);
                    } 
                } 
            } 
            if (count($clink)) {
                unset($clinklist);
                foreach($clink as $key => $value) {
                    list($clink[$key]["link"], $clink[$key]["target"]) = explode(" ", $clink[$key]["link"]);
                    $clinklist[$key] = trim($clink[$key]["name"] . "|" . $clink[$key]["link"] . " " . $clink[$key]["target"]);
                } 
                unset($clink);
            } 
            $content["text"] = implode("\n", $clinklist);
        } 
        break; 
    // Content Type Plain HTML
    case 6: $content["html"] = slweg($_POST["chtml"], 65500);
        break; 
	// Content Type WYSIWYG HTML
    case 14: $content["html"] = slweg($_POST["chtml"], 65500);
        break; 
    // Content Type File List
    case 7: $content["file_list"] = $_POST["cfile_list"];
        if (count($content["file_list"])) {
            foreach($content["file_list"] as $key => $value) {
                if (intval($value)) {
                    $content["file_list"][$key] = intval($value);
                } else {
                    unset($content["file_list"][$key]);
                } 
            } 
            if (count($content["file_list"])) {
                $content["file_id_list"] = implode(":", $content["file_list"]);
            } else {
                $content["file_id_list"] = "";
            } 
        } 
        $content["file_descr"] = explode("\n", chop(slweg($_POST["cfile_descr"], 65500)));
        if (count($content["file_descr"])) {
            foreach($content["file_descr"] as $key => $value) {
                $content["file_descr"][$key] = html_specialchars(trim($value));
            } 
            $content["file_descr"] = implode("\n", $content["file_descr"]);
        } else {
            $content["file_descr"] = "";
        } 
        break; 
    // Content Type Link Articles
    case 8: $content["alink"] = $_POST["calink"];
        if (count($content["alink"])) {
            foreach($content["alink"] as $key => $value) {
                if (intval($value)) {
                    $content["alink"][$key] = intval($value);
                } else {
                    unset($content["alink"][$key]);
                } 
            } 
            $content["alink"] = implode(":", $content["alink"]);
        } else {
            $content["alink"] = "";
        } 
        break; 
    // Content Type Multimedia
    case 9: $content["media_type"] = intval($_POST["cmedia_type"]);
        $content["media_player"] = intval($_POST["cmedia_player"]);
        $content["media_src"] = intval($_POST["cmedia_src"]);
        $content["media_auto"] = intval($_POST["cmedia_auto"]);
        $content["media_control"] = intval($_POST["cmedia_control"]);
        $content["media_pos"] = intval($_POST["cimage_pos"]);
        $content["media_width"] = intval($_POST["cmedia_width"]);
        $content["media_width"] = ($content["media_width"]) ? $content["media_width"] : "";
        $content["media_height"] = intval($_POST["cmedia_height"]);
        $content["media_height"] = ($content["media_height"]) ? $content["media_height"] : "";
        $content["media_id"] = intval($_POST["cmedia_id"]);
        $content["media_name"] = clean_slweg($_POST["cmedia_name"]);
        $content["media_extern"] = clean_slweg($_POST["cmedia_extern"]);

        $content["media"] = $content["media_type"] . ":" . $content["media_player"] . ":";
        $content["media"] .= $content["media_pos"] . ":" . $content["media_width"] . ":";
        $content["media"] .= $content["media_height"] . ":" . $content["media_src"] . ":";
        $content["media"] .= ($content["media_src"]) ? base64_encode($content["media_extern"]) : base64_encode($content["media_id"] . ":" . $content["media_name"]);
        $content["media"] .= ":" . $content["media_control"] . ":" . $content["media_auto"];
        break; 
    // Content Type Form Email
    case 10: $content["mailform"] = explode("\n", slweg(chop($_POST["cmailform"])));
        $content["mailsubject"] = clean_slweg($_POST["cmailsubject"], 245);
        if (isEmpty($content["mailsubject"])) $content["mailsubject"] = "online webform email message";
        $content["mailrecipient"] = clean_slweg($_POST["cmailrecipient"], 250);
        if (MailVal($content["mailrecipient"], 2)) $content["error"]["mailrecipient"] = "proof recipient - email format error";
        $content["mailbutton"] = clean_slweg($_POST["cmailbutton"], 35);
        if (isEmpty($content["mailbutton"])) $content["mailbutton"] = "send";
        $content["mailhtml"] = intval($_POST["cmailhtml"]);

        if (count($content["mailform"])) {
            foreach($content["mailform"] as $key => $value) {
                $content["mailform"][$key] = explode("|", chop($value)); 
                // Field-Code
                $content["mailform"][$key][0] = strtoupper(trim($content["mailform"][$key][0]));
                if ($content["mailform"][$key][0] == "IT" || $content["mailform"][$key][0] == "IP" || $content["mailform"][$key][0] == "IH" || $content["mailform"][$key][0] == "TA" || $content["mailform"][$key][0] == "SM" || $content["mailform"][$key][0] == "SL" || $content["mailform"][$key][0] == "IC" || $content["mailform"][$key][0] == "IR" || $content["mailform"][$key][0] == "SC" || $content["mailform"][$key][0] == "IN") {
                    $content["mailform"][$key][1] = trim($content["mailform"][$key][1]);
                    $content["mailform"][$key][1] = ($content["mailform"][$key][1]) ? $content["mailform"][$key][1] : "field_" . randpassword(3);

                    $content["mailform"][$key][2] = intval($content["mailform"][$key][2]);
                    $content["mailform"][$key][3] = trim($content["mailform"][$key][3]);

                    list($field_length, $field_max_height) = explode(",", $content["mailform"][$key][4]);
                    $field_length = intval($field_length); //field length
                    $field_max_height = intval($field_max_height); //max field chars or height
                    $field_length = ($field_length) ? $field_length : 10;
                    switch ($content["mailform"][$key][0]) {
                        case "TA": $field_max_height = ($field_max_height) ? $field_max_height : 3;
                            break;
                        case "SL": $field_max_height = ($field_max_height) ? $field_max_height : 0;
                            break;
                        case "IC": $field_max_height = ($field_max_height) ? $field_max_height : 0;
                            break;
                        case "IR": $field_max_height = ($field_max_height) ? $field_max_height : 0;
                            break;
                        default: $field_max_height = ($field_max_height) ? $field_max_height : 100;
                    } 

                    $content["mailform"][$key][5] = trim($content["mailform"][$key][5]);
                    $content["mailform"][$key][6] = intval($content["mailform"][$key][6]);

                    $content["mailform"][$key]["field"] = $content["mailform"][$key][0] . "|";
                    $content["mailform"][$key]["field"] .= $content["mailform"][$key][1] . "|";
                    $content["mailform"][$key]["field"] .= $content["mailform"][$key][2] . "|";
                    $content["mailform"][$key]["field"] .= $content["mailform"][$key][3] . "|";
                    $content["mailform"][$key]["field"] .= $field_length . ",";
                    $content["mailform"][$key]["field"] .= $field_max_height . "|";
                    $content["mailform"][$key]["field"] .= $content["mailform"][$key][5] . "|";
                    $content["mailform"][$key]["field"] .= $content["mailform"][$key][6];
                } else {
                    unset($content["mailform"][$key]);
                } 
            } 
        } 

        if (count($content["mailform"])) {
            $content["form"] = "";
            $mft = 0;
            foreach($content["mailform"] as $key => $value) {
                $content["form"] .= (($mft) ? "\n" : "") . $content["mailform"][$key]["field"];
                $mft++;
            } 
        } else {
			$content["mailform"] = "";
		}

        $content["form"] = base64_encode($content["form"]) . "#:#" . $content["mailsubject"] . "#:#";
        $content["form"] .= $content["mailrecipient"] . "#:#" . $content["mailbutton"] . "#:#" . $content["mailhtml"];
        break; 
    // Content Type Code
    case 11: $content["code"] = slweg($_POST["ccode"], 65500);
        break; 
		
    // Content Type Newsletter Subscription
    case 12: $content["newsletter"]["text"] = html_specialchars(clean_slweg($_POST["cnewsletter_text"], 65500));
        $content["newsletter"]["label_email"] = html_specialchars(clean_slweg($_POST["cnewsletter_label_email"], 100));
        $content["newsletter"]["label_name"] = html_specialchars(clean_slweg($_POST["cnewsletter_label_name"], 100));
		$content["newsletter"]["label_subscriptions"] = html_specialchars(clean_slweg($_POST["cnewsletter_label_subscriptions"], 100));
		$content["newsletter"]["all_subscriptions"] = html_specialchars(clean_slweg($_POST["cnewsletter_all_subscriptions"], 100));
        $content["newsletter"]["button_text"] = html_specialchars(clean_slweg($_POST["cnewsletter_button_text"], 50));
		$content["newsletter"]["success_text"] = html_specialchars(clean_slweg($_POST["cnewsletter_success_text"], 65500));
        $content["newsletter"]["reg_text"] = html_specialchars(clean_slweg($_POST["cnewsletter_reg_text"], 65500));
        $content["newsletter"]["logoff_text"] = html_specialchars(clean_slweg($_POST["cnewsletter_logoff_text"], 65500));
        $content["newsletter"]["change_text"] = html_specialchars(clean_slweg($_POST["cnewsletter_change_text"], 65500));
        $content["newsletter"]["subscription"] = $_POST["cnewsletter_subscription"];
		$content["newsletter"]["pos"] = intval($_POST["cnewsletter_pos"]);
        break;
		
	// Content Type Search Form
	case 13:	$content["search"]["result_per_page"] = intval($_POST["csearch_result_per_page"]);
				if(!$content["search"]["result_per_page"]) $content["search"]["result_per_page"] = "";
				$content["search"]["newwin"] = intval($_POST["csearch_newwin"]);
				$content["search"]["label_input"] = html_specialchars(clean_slweg($_POST["csearch_label_input"], 250));
				$content["search"]["style_input"] = html_specialchars(clean_slweg($_POST["csearch_style_input"]));
				$content["search"]["label_button"] = html_specialchars(clean_slweg($_POST["csearch_label_button"], 75));
				$content["search"]["style_button"] = html_specialchars(clean_slweg($_POST["csearch_style_button"]));
				$content["search"]["label_result"] = html_specialchars(clean_slweg($_POST["csearch_label_result"], 250));
				$content["search"]["style_result"] = html_specialchars(clean_slweg($_POST["csearch_style_result"]));
				$content["search"]["label_next"] = html_specialchars(clean_slweg($_POST["csearch_label_next"], 200));
				$content["search"]["label_previous"] = html_specialchars(clean_slweg($_POST["csearch_label_previous"], 200));
				$content["search"]["align"] = intval($_POST["csearch_align"]);
				$content["search"]["text_intro"] = html_specialchars(clean_slweg($_POST["csearch_text_intro"], 65500));
				$content["search"]["text_result"] = html_specialchars(clean_slweg($_POST["csearch_text_result"], 65500));
				$content["search"]["text_noresult"] = html_specialchars(clean_slweg($_POST["csearch_text_noresult"], 65500));
				$content["search"]["template"] = slweg($_POST["csearch_template"]);	
    // Content Type Text
    default: $content["text"] = html_specialchars(slweg($_POST["ctext"], 65500));
} 

?>