<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

function isEmpty($string) {
	return ($string == NULL || $string == "") ? 1 : 0;
}

function gib_text($string_to_proof, $string_enthalten, $string_rueckgabe) {
	//Funktion um zu ermitteln, ob im User Status das Benutzerrecht vorhanden ist
	//und dann Rckgabe des Wertes checked="checked" bei bereinstimmung
	if(strstr($string_to_proof, $string_enthalten)) return $string_rueckgabe;
}

function aporeplace($string_to_convert="") {
	//ndert die einfachen Apostrophe fr SQL-Funktionen in doppelte
	$string_to_convert = str_replace("\\", "\\\\", $string_to_convert);
	$string_to_convert = str_replace("'", "''", $string_to_convert );
	return $string_to_convert;
}

function quotereplace($string_to_convert="") {
	//converts quote " to \\" for use as part of saved string values
	return str_replace('"', '\\"', $string_to_convert );
}

function slweg($string_wo_slashes_weg, $string_laenge=0) {
	// Falls die Serverfunktion magic_quotes_gpc aktiviert ist, so
	// sollen die Slashes herausgenommen werden, anderenfalls nicht
	$string_wo_slashes_weg = trim($string_wo_slashes_weg);
	if( get_magic_quotes_gpc() ) $string_wo_slashes_weg = stripslashes ($string_wo_slashes_weg);
	if($string_laenge) $string_wo_slashes_weg = substr($string_wo_slashes_weg, 0, $string_laenge);
	return $string_wo_slashes_weg;
}

function clean_text($string, $string_laenge=0) {
	// Falls die Serverfunktion magic_quotes_gpc aktiviert ist, so
	// sollen die Slashes herausgenommen werden, anderenfalls nicht
	if( get_magic_quotes_gpc() ) $string = stripslashes ($string);
	if($string_laenge) $string = substr($string, 0, $string_laenge);
	return $string;
}

function clean_slweg($string_wo_slashes_weg, $string_laenge=0) {
	// Falls die Serverfunktion magic_quotes_gpc aktiviert ist, so
	// sollen die Slashes herausgenommen werden, anderenfalls nicht
	$string_wo_slashes_weg = trim($string_wo_slashes_weg);
	if( get_magic_quotes_gpc() ) $string_wo_slashes_weg = stripslashes ($string_wo_slashes_weg);
	$string_wo_slashes_weg = strip_tags($string_wo_slashes_weg);
	if($string_laenge) $string_wo_slashes_weg = substr($string_wo_slashes_weg, 0, $string_laenge);
	return $string_wo_slashes_weg;
}

function getpostvar($formvar, $string_laenge=0) {
	//combines trim, stripslashes und apostrophe replace
	$formvar = trim($formvar);
	if( get_magic_quotes_gpc() ) $formvar = stripslashes ($formvar);
	if($string_laenge) $formvar = substr($formvar, 0, $string_laenge);
	return aporeplace($formvar);
}


function html_specialchars($h="") {
	//used to replace the htmlspecialchars original php function
	//not compatible with many internation chars like turkish, polish
	$h = preg_replace("/&(?!#[0-9]+;)/s", '&amp;', $h );
	$h = str_replace( "<", "&lt;"  , $h );
	$h = str_replace( ">", "&gt;"  , $h );
	$h = str_replace( '"', "&quot;", $h );
	$h = str_replace( "'", "&#039;", $h );
	$h = str_replace( "\\", "&#92;", $h );
	return $h;
}
	
function html_despecialchars($h="") {
	//call off html_specialchars
	$h = str_replace( "&amp;" , "&", $h );
	$h = str_replace( "&lt;"  , "<", $h );
	$h = str_replace( "&gt;"  , ">", $h );
	$h = str_replace( "&quot;", '"', $h );
	$h = str_replace( "&#039;", "'", $h );	
	return $h;
}

function html_formvar($h="") {
	//to make some special chars more compatible to form fields
	$h = str_replace( '$', "&#036;", $h);
	if(get_magic_quotes_gpc()) $h = stripslashes($h);	
	$h = preg_replace( "/\\\(?!&amp;#|\?#)/", "&#092;", $h );
	return $h;
}

function trimhtml($h="") {
	//return html_specialchars(trim($name));
	$h = html_specialchars(trim($h));
	return $h;
}

function list_country($c, $dbcon){
	//Create the country list menu for forms 
	//with the given value selected
	//$c = selected value
	if(isEmpty($c)) $c = "DE";
	$sql = mysql_query("SELECT country_iso, country_name FROM ".DB_PREPEND."phpwcms_country ORDER BY country_name", $dbcon);
	$country_list = "";
	while($a = mysql_fetch_array($sql)) {
		$country_list .= "<option value=\"".$a["country_iso"]."\"";
		$country_list .= ($a["country_iso"] != $c) ? "" : " selected";
		$country_list .= ">".html_specialchars($a["country_name"])."</option>\n";
	}
	mysql_free_result($sql);
	return $country_list;
}

function list_profession($c){
	//Create the profession list menu for forms 
	//with the given value selected
	//$c = selected value
	if(isEmpty($c)) $c = " n/a";
	$sql = mysql_query("SELECT prof_name FROM ".DB_PREPEND."phpwcms_profession ORDER BY prof_name");
	while($a = mysql_fetch_array($sql)) {
		if($a["prof_name"] != $c) {
			echo "\t\t\t<option value=\"".$a["prof_name"]."\">".trim($a["prof_name"])."</option>\n";
		} else {
			echo "\t\t\t<option value=\"".$a["prof_name"]."\" selected>".trim($a["prof_name"])."</option>\n";
		}		
	}
	mysql_free_result($sql);
}

function gib_checkbox($c, $chkvalue) {
	//create the form checkbox value statement
	$c = strval($c);
	echo ($c == strval($chkvalue)) ? (" value=\"".$c."\" checked") : (" value=\"".$chkvalue."\"");
}

function is_selected($c, $chkvalue) {
	if(strval($c) == strval($chkvalue)) echo " selected";
}

function is_checked($c, $chkvalue) {
	if(strval($c) == strval($chkvalue)) echo " checked";
}

function check_checkbox($c) {
	//Prft, ob korrekte Werte via Checkbox bergeben wurden
	$c = intval($c);
	if($c != 0 AND $c != 1) $c = 0;
	return $c;
}

function clearfilename($formvar) {
	//Filename anpassen und subern
	$formvar = trim($formvar);
	if( get_magic_quotes_gpc() ) $formvar = stripslashes ($formvar);
	$formvar = str_replace(" ", "_", $formvar);
	return str_replace("'", "", $formvar);
}

function which_ext($dateiname) {
	//gets extension of file
	//$dateiExt = str_replace(".", "", strtolower(strrchr(trim($dateiname), '.')));
	//return substr($dateiExt, 0, 5);
	return str_replace(".", "", strtolower(strrchr(trim($dateiname), '.')));
}

function cut_ext($dateiname) {
	//cuts extension of file
	$cutoff = strrpos($dateiname, ".");
	return ($cutoff) ? (substr($dateiname, 0, $cutoff)) : ($dateiname);
}

function subnav($pic, $picover, $picpfad, $idname, $link, $is, $should, $wrap, $getback=1) {
	//generate subnavigation based on image
	$sn = ""; $isize = getimagesize($picpfad.$picover);
	if($is == $should) {
		$sn .= "<a href='".$link."'><img src='".$picpfad.$picover."' ".$isize[3]." border='0'></a>";	
	} else {
		$sn .= 	"<a href='".$link."'><img src='".$picpfad.$pic."' ".$isize[3]." name='".$idname."' border='0' ".
				"onMouseOver='".$idname.".src=\"".$picpfad.$picover."\"' onMouseOut='".$idname.".src=\"".$picpfad.$pic."\"'></a>";
	}
	if($wrap) $sn .= $wrap;
	if(!$getback) { return $sn; } else { echo $sn; }
}

function subnavtext($text, $link, $is, $should, $getback=1) {
	//generate subnavigation based on text
	//<img src="img/leer.gif" width="1" height="15"><br />
	$id = "subnavid".randpassword(5);
	$sn = "";
	if($is == $should) {
		$sn .= "<tr><td align=\"right\" class=\"subnavactive\"><a href=\"".$link."\">".$text."</a></td>";
		$sn .= "<td><img src=\"img/subnav/subnav_1.gif\" width=\"15\" height=\"13\" border=\"0\"></td></tr>";	
	} else {
		$sn .= "<tr><td align=\"right\" class=\"subnavinactive\"><a href=\"".$link."\" ";
		$sn .= "onMouseOver=\"".$id.".src='img/subnav/subnav_1.gif'\" onMouseOut=\"".$id.".src='img/subnav/subnav_0.gif'\">".$text."</a></td>";
		$sn .= "<td><img name=\"".$id."\" src=\"img/subnav/subnav_0.gif\" width=\"15\" height=\"13\" border=\"0\"></td></tr>";
	}
	$sn .= "\n";
	if(!$getback) { return $sn; } else { echo $sn; }
}

function subnavback ($text, $link, $h_before=0, $h_after=0) {
	$id = "subbackid".randpassword(5);
	$sn  = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
	$sn .= (intval($h_before)) ? "<tr><td colspan=\"2\"><img src=\"img/leer.gif\" width=\"1\" height=\"".intval($h_before)."\"></td></tr>\n" : "";
	$sn .= "<tr>";
	$sn .= "<td><img name=\"".$id."\" src=\"img/subnav/subnav_back_0.gif\" width=\"9\" height=\"9\" border=\"0\"></td>";
	$sn .= "<td class=\"subnavinactive\">&nbsp;<a href=\"".$link."\" onMouseOver=\"".$id.".src='img/subnav/subnav_back_1.gif'\" ";
	$sn .= "onMouseOut=\"".$id.".src='img/subnav/subnav_back_0.gif'\"><strong>".$text."</strong></a></td>";
	$sn .= "</tr>\n";
	$sn .= (intval($h_after)) ? "<tr><td colspan=\"2\"><img src=\"img/leer.gif\" width=\"1\" height=\"".intval($h_after)."\"></td></tr>\n" : "";
	$sn .= "</table>\n";
	echo $sn;
}

function fsize($zahl) {
	//Creates Filesize-Info
	//number_format($_FILES["wcsfile"]["size"] / 1024, 0, ',', '.')." kB)
	if($zahl < 1000) {
		$zahl = $zahl."&nbsp;B";
	} else {
		if($zahl < 1048576) {
			$zahl = number_format($zahl/1024, 2, '.', '.')."&nbsp;K";
		} else {
			$zahl = number_format($zahl/1048576, 2, '.', '.')."&nbsp;M";
		}
	}
	return $zahl;
}

function fsizelong($zahl) {
	//Creates Filesize-Info
	//number_format($_FILES["wcsfile"]["size"] / 1024, 0, ',', '.')." kB)
	if($zahl < 1024) {
		$zahl = number_format($zahl, 0, '.', '.')."&nbsp;Byte";
	} else {
		if($zahl < 1048576) {
			$zahl = number_format($zahl/1024, 2, '.', '.')."&nbsp;KB";
		} else {
			$zahl = number_format($zahl/1048576, 2, '.', '.')."&nbsp;MB";
		}
	}
	return $zahl;
}

function fsizeimg($zahl) {
	//Creates Filesize-Info
	//number_format($_FILES["wcsfile"]["size"] / 1024, 0, ',', '.')." kB)
	if($zahl < 1000) {
		$zahl = $zahl."<img src=\"img/icons/byte.gif\" width=\"21\" height=\"7\">";
	} else {
		if($zahl < 1048576) {
			$zahl = number_format($zahl/1024, 0, ',', '.')."<img src=\"img/icons/kb.gif\" width=\"21\" height=\"7\">";
		} else {
			$zahl = number_format($zahl/1048576, 2, ',', '.')."<img src=\"img/icons/mb.gif\" width=\"21\" height=\"7\">";
		}
	}
	return $zahl;
}

function public($a, $b) {
	//check which state the public value has
	//and set icon and action
	//$a = aktueller public wert
	//$b = file_id
	
	if($a == 0) {
		echo	"<a href=\"include/inc_act/act_do.php?do=2.".
				$b.
				".1\"><img src=\"img/button/public_0.gif\" ".
				"alt=\"make file public\" ".
				"width=\"24\" height=\"15\" border=\"0\"></a>";
	} else {
		echo	"<a href=\"include/inc_act/act_do.php?do=2.".
				$b.
				".0\"><img src=\"img/button/public_1.gif\" ".
				"alt=\"make file personal\" ".
				"width=\"24\" height=\"15\" border=\"0\"></a>";
	}
	
	//echo $a.".".$b;
}

function publiclong($a, $b) {
	//check which state the public value has
	//and set icon and action
	//$a = aktueller public wert
	//$b = file_id
	
	if($a == 0) {
		echo	"<a href=\"include/inc_act/act_do.php?do=2.".
				$b.
				".1\"><img src=\"img/button/publiclong_0.gif\" ".
				"alt=\"make file public\" ".
				"width=\"75\" height=\"9\" border=\"0\"></a>";
	} else {
		echo	"<a href=\"include/inc_act/act_do.php?do=2.".
				$b.
				".0\"><img src=\"img/button/publiclong_1.gif\" ".
				"alt=\"make file personal\" ".
				"width=\"68\" height=\"9\" border=\"0\"></a>";
	}
	
	//echo $a.".".$b;
}

function extimg($ext) {
	//get extension image
	$img =	array	(
		"exe" =>	"icon_exe.gif",		"com" =>	"icon_exe.gif",
		"bat" =>	"icon_exe.gif",		"pdf" =>	"icon_pdf.gif",
		"txt" =>	"icon_txt.gif",		"xls" =>	"icon_xls.gif",
		"cvs" =>	"icon_xls.gif",		"rtf" =>	"icon_txt.gif",
		"htm" =>	"icon_htm.gif",		"html" =>	"icon_htm.gif",
		"pix" =>	"icon_pix.gif",		"tif" =>	"icon_pix.gif",
		"jpg" =>	"icon_pix.gif",		"jpeg" =>	"icon_pix.gif",
		"gif" =>	"icon_pix.gif",		"png" =>	"icon_pix.gif",
		"psd" =>	"icon_pix.gif",		"rar" =>	"icon_rar.gif",
		"zip" =>	"icon_zip.gif",		"tar" =>	"icon_zip.gif",
		"gzip" =>	"icon_zip.gif",		"sit" =>	"icon_sit.gif",
		"sea" =>	"icon_sit.gif",		"doc" =>	"icon_doc.gif",
		"dot" =>	"icon_doc.gif",		"ai"  =>	"icon_ai.gif",
		"ps"  =>	"icon_ps.gif",		"eps" =>	"icon_eps.gif",
		"tar" =>	"icon_tar.gif",		"gz"  =>	"icon_gz.gif",
		"tgz" =>	"icon_gz.gif",		"aif" =>	"icon_snd.gif",
		"aiff" =>	"icon_snd.gif",		"mp3" =>	"icon_snd.gif",
		"snd" =>	"icon_snd.gif",		"wav" =>	"icon_snd.gif",
		"mid" =>	"icon_snd.gif",		"mov" =>	"icon_vid.gif",
		"avi" =>	"icon_vid.gif",		"qt"  =>	"icon_vid.gif",
		"mpeg" =>	"icon_vid.gif"					
				);
	return ($img[$ext]) ? $img[$ext] : "icon_generic.gif";
}

function randpassword($length) {
	//totally random password creation
	mt_srand((double)microtime()*1000000);
    $possible_charactors = "abcdefghijklmnopqrstuvwxyz1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    for($i = 0; $i < $length; $i++){
        $string .= substr($possible_charactors, mt_rand(0,61),1);
    }
    return $string;
}

function generic_string($length, $i=0) {
	$p[0] = "abcdefghijklmnopqrstuvwxyz";
	$p[1] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	$p[2] = "1234567890";
	switch($i) {
		case 1:		$chars = $p[0].$p[2];	break;
		case 2: 	$chars = $p[1].$p[2];	break;
		case 3: 	$chars = $p[0].$p[1];	break;
		case 4: 	$chars = $p[0];			break;
		case 5: 	$chars = $p[1];			break;
		case 6: 	$chars = $p[2];			break;
		default:	$chars = $p[0].$p[2].$p[1];
	}
	mt_srand((double)microtime()*1000000);
	$count = strlen($chars)-1;
    for($i = 0; $i < $length; $i++){
        $gen_string .= substr($chars, mt_rand(0,$count),1);
    }
    return $gen_string;
}

function genpassword($length){  
	//totally generic password creation
	mt_srand((double)microtime()*1000000);
	$vowels = array("a", "e", "i", "o", "u");
	$cons = array(	"b", "c", "d", "g", "h", "j", "k", "l", "m", "n", "p", "r", "s", "t", "u", "v", "w", "tr",  
					"cr", "br", "fr", "th", "dr", "ch", "ph", "wr", "st", "sp", "sw", "pr", "sl", "cl");
	$num_vowels = count($vowels);
	$num_cons = count($cons);
	for($i = 0; $i < $length; $i++){
		$password .= $cons[mt_rand(0, $num_cons - 1)] . $vowels[mt_rand(0, $num_vowels - 1)];
	}
	return substr($password, 0, $length);  
}

function genlogname() {
	$word_arr_one = array (	"rose","pink","blue","cyan","gold", "lime","silk","slim",
							"walk","warm","zoom","high","hell","posh","face","hand",
							"dose","cool","club","clue","baby","body","auto","acid",
							"mini","sexy","come","joke","dot_","clas","zone","blok");
	$word_arr_two = array(	"aunt","love","girl","time","door","disc","book","news",
							"cock","bond","bomb","joke","tall","tank","drum","hill",
							"hand","cook","look","mate","main","pack","page","palm",
							"home","geil","maxi","mixy","hans","otto","flin","mark");
	$arr_one_len=sizeof($word_arr_one);
	$arr_two_len=sizeof($word_arr_two); 
	mt_srand ((double)microtime()*1000000);
	//for($i=0; $i<10; $i++) {
		$pos_one=mt_rand(0, ($arr_one_len-1));
		if($pos_one % 2 == 0 ) {
			$pwd_one = $word_arr_one[$pos_one].$pwd_one;
		} else {
			$pwd_one.= $word_arr_one[$pos_one];
		} 
	//}
	//for($i=0; $i<10; $i++) {
		$pos_two=mt_rand(0, ($arr_two_len-1));
		if($pos_two % 2 == 0 ) {
			$pwd_two.= $word_arr_two[$pos_two];
		} else {
			$pwd_two = $word_arr_two[$pos_two].$pwd_two;
		}
	//}
	//$rnd_int=mt_rand(10,99);
	$pwd=substr($pwd_one,0,4).substr($pwd_two,0,4);
	return $pwd; 
}
 
function is_userexists($name, $email) {
	//1 = Username is empty
	//2 = Email empty or not correct
	//3 = User exists
	$value = "0";
	if(isEmpty($name)) $value .= "1";	
	if(isEmpty($email) || MailVal($email, 3)) $value .= "2";	
	if($name || isEmpty($email)) {	
		$result = mysql_query(	"SELECT COUNT(*) FROM ".DB_PREPEND."phpwcms_user WHERE ".
								"usr_login='".$name."' OR usr_email='".$email."';");
		if($row = mysql_fetch_row($result)) if($row[0] > 0) $value .= "3";
		mysql_free_result($result);
	}
	return $value;
}

function gib_part($value, $part, $separator) {
	//Gibt den Wert an Stelle $part von $value zurck
	$value_array = explode($separator, $value);
	return $value_array[$part];
}

function cut_string($string, $endchar = "&#8230;", $lenght = 20, $trim = 1) {
	if($trim) $string = trim($string);
	if(strlen($string) > $lenght) {
		$string = substr($string, 0, $lenght);
		$string = rtrim($string).$endchar;
	}
	return $string;
}

function word_wrap ($string, $cols = 80, $prefix = "") {
	// Takes $string, and wraps it on a per-word boundary (does not clip
	// words UNLESS the word is more than $cols long), no more than $cols per
	// line. Allows for optional prefix string for each line. (Was written to
	// easily format replies to e-mails, prefixing each line with "> ".
	$t_lines = split( "\n", $string);
	$outlines = "";
	while(list(, $thisline) = each($t_lines)) {
		if(strlen($thisline) > $cols) {
			$newline = "";
			$t_l_lines = split(" ", $thisline);
			while(list(, $thisword) = each($t_l_lines)) {
				while((strlen($thisword) + strlen($prefix)) > $cols) {
					$cur_pos = 0;
					$outlines .= $prefix;
					for($num=0; $num < $cols-1; $num++) {
						$outlines .= $thisword[$num];
						$cur_pos++;
					}
					$outlines .= "\n";
					$thisword = substr($thisword, $cur_pos, (strlen($thisword)-$cur_pos));
				}
				if((strlen($newline) + strlen($thisword)) > $cols) {
					$outlines .= $prefix.$newline."\n";
					$newline = $thisword." ";
				} else {
					$newline .= $thisword." ";
				}
			}
			$outlines .= $prefix.$newline."\n";
		} else {
			$outlines .= $prefix.$thisline."\n";
		}
	}
	return $outlines;
}

function which_folder_active($ist, $soll, $ac="#9BBECA", $nc="#363E57", $nclass="msgreiter") {
	if($ist == $soll) {
		echo "bgcolor='".$ac."' class='".$nclass."'";
	} else {
		echo "bgcolor='".$nc."' class='".$nclass."' ";
		echo "onMouseOver=\"bgColor='#FF6600'\" onMouseOut=\"bgColor='".$nc."'\"";
	}
}

function FileExtension($filename) {
	return substr(strrchr($filename, "."), 1, strlen(strrchr($filename, ".")));
}

function is_ext_true($ext) {
	if(IMAGICK_ON) {
		// if ImageMagick for thumbnail creation
		switch($ext) {
			case "jpg":		$ext=1; break;
			case "jpeg":	$ext=1; break;
			case "tif":		$ext=1; break;
			case "tiff":	$ext=1; break;
			case "psd":		$ext=1; break;
			case "bmp":		$ext=1; break;
			case "pic":		$ext=1; break;
			case "eps":		$ext=1; break;
			case "ps":		$ext=1; break;
			case "ai":		$ext=1; break;
			case "ps2":		$ext=1; break;
			case "ps3":		$ext=1; break;
			case "pn":		$ext=1; break;
			case "wmf":		$ext=1; break;
			case "gif":		$ext=1; break;
			case "png":		$ext=1; break;
			case "tga":		$ext=1; break;
			case "pdf":		$ext=1; break;
			case "pict":	$ext=1; break;
			case "jp2":		$ext=1; break;
			case "jpc":		$ext=1; break;
			case "ico":		$ext=1; break;
			case "fax":		$ext=1; break;
			case "":		$ext=1; break;
			default: $ext=0;
		}
	} else {
		// if GD is used
		switch($ext) {
			case "jpg":		$ext=1; break;
			case "jpeg":	$ext=1; break;
			case "gif":		$ext=1; break;
			case "png":		$ext=1; break;
			default: $ext=0;
		}
	}	
	return $ext;
}

function make_date($datestring, $dateformat = "d.m.y") {
	$unixtime=strtotime($datestring);
	return ($unixtime) ? date($dateformat, $unixtime) : $datestring;
}

function set_chat_focus($do, $p) { //set_chat_focus("chat", 1)
	if($do == "chat" && $p == 1) {
		echo "<script language=\"JavaScript\" type=\"text/JavaScript\">\n<!--\n";
		echo "document.sendchatmessage.chatmsg.focus();\ndocument.sendchatmessage.chatmsg.value=get_cookie('chatstring');\n";
		echo "timer = chat_reload(20000);\nfunction chat_reload(zeit) {\n";
		echo "timer=setTimeout(\"write_cookie(1);self.location.href='phpwcms.php?do=chat&p=1&l=".$chatlist."'\", zeit);\n";
		echo "return timer;\n}\nfunction restart_reload(timer) {\n";
		echo "if(timer != null) { clearTimeout(timer); timer=null; timer = chat_reload(20000); }\nreturn timer;\n}\n//-->\n</script>\n";
	}
}

function forward_to($to, $link, $time=2500) { //Javascript forwarding
	if($to) echo "<script language=\"JavaScript\" type=\"text/JavaScript\">\n<!--\n setTimeout(\"document.location.href='".$link."'\", ".(intval($time))."); \n //-->\n</script>\n";
}

function switch_on_off($wert) {
	//switches the value off->on and on->off
	return (intval($wert)) ? 0 : 1;
}

function online_users($dbcon, $spacer="<br />", $wrap="<span class=\"useronline\">|<span>") {
	$wrap = explode("|", $wrap);
	$x=0; $xo="";
	if($o = mysql_query("SELECT logged_user FROM ".DB_PREPEND."phpwcms_userlog WHERE logged_in=1;", $dbcon)) {
		while($uo = mysql_fetch_row($o)) {
			$xo .= ($x) ? $spacer : "";
			$xo .= html_specialchars($uo[0]);
			$x++;
		}
		mysql_free_result($o);
	}
	return ($x) ? $wrap[0].$xo.$wrap[1] : "";
}

function get_filecat_childcount ($fcatid, $dbcon) {
	$sql = "SELECT COUNT(fkey_id) FROM ".DB_PREPEND."phpwcms_filekey WHERE fkey_deleted=0 AND fkey_cid=".intval($fcatid).";";
	if($result = mysql_query($sql, $dbcon)) {
		if($row = mysql_fetch_row($result)) $count = $row[0];
		mysql_free_result($result);
	}
	return intval($count);
}

function MailVal($Addr, $Level, $Timeout = 15000) {
// Version am 23.07.2003 berarbeitet fr die Verwendung von lngeren TLDs
// com:edu:gov:int:mil:net:org:shop:aero:biz:coop:info:museum:name:pro:arpa:
// Korrektur zu obigen Angaben

// Check if used OS is windows -> socket functions do not work
	if (strpos(PHP_OS, "WIN") >= 0 && $Level > 2) $Level = 2;

//  Valid Top-Level Domains
    $gTLDs = "com:edu:gov:int:mil:net:org:shop:aero:biz:coop:info:museum:name:pro:arpa:";
    $CCs   = "ad:ae:af:ag:ai:al:am:an:ao:aq:ar:as:at:au:aw:az:ba:bb:bd:be:bf:".
             "bg:bh:bi:bj:bm:bn:bo:br:bs:bt:bv:bw:by:bz:ca:cc:cf:cd:cg:ch:ci:".
             "ck:cl:cm:cn:co:cr:cs:cu:cv:cx:cy:cz:de:dj:dk:dm:do:dz:ec:ee:eg:".
             "eh:er:es:et:fi:fj:fk:fm:fo:fr:fx:ga:gb:gd:ge:gf:gh:gi:gl:gm:gn:".
             "gp:gq:gr:gs:gt:gu:gw:gy:hk:hm:hn:hr:ht:hu:id:ie:il:in:io:iq:ir:".
             "is:it:jm:jo:jp:ke:kg:kh:ki:km:kn:kp:kr:kw:ky:kz:la:lb:lc:li:lk:".
             "lr:ls:lt:lu:lv:ly:ma:mc:md:mg:mh:mk:ml:mm:mn:mo:mp:mq:mr:ms:mt:".
             "mu:mv:mw:mx:my:mz:na:nc:ne:nf:ng:ni:nl:no:np:nr:nt:nu:nz:om:pa:".
             "pe:pf:pg:ph:pk:pl:pm:pn:pr:pt:pw:py:qa:re:ro:ru:rw:sa:sb:sc:sd:".
             "se:sg:sh:si:sj:sk:sl:sm:sn:so:sr:st:su:sv:sy:sz:tc:td:tf:tg:th:".
             "tj:tk:tm:tn:to:tp:tr:tt:tv:tw:tz:ua:ug:uk:um:us:uy:uz:va:vc:ve:".
             "vg:vi:vn:vu:wf:ws:ye:yt:yu:za:zm:zr:zw:";

//  The countries can have their own 'TLDs', e.g. mydomain.com.au 
    $cTLDs = "com:net:org:edu:gov:mil:co:ne:or:ed:go:mi:"; 

    $fail = 0; 

//  Shift the address to lowercase to simplify checking 
    $Addr = strtolower($Addr); 

//  Split the Address into user and domain parts 
    $UD = explode("@", $Addr); 
    if (sizeof($UD) != 2 || !$UD[0]) $fail = 1; 

//  Split the domain part into its Levels 
    $Levels = explode(".", $UD[1]);
	$sLevels = sizeof($Levels); 
    if ($sLevels < 2) $fail = 1; 

//  Get the TLD, strip off trailing ] } ) > and check the length 
    $tld = $Levels[$sLevels-1]; 
    $tld = ereg_replace("[>)}]$|]$", "", $tld); 
	//shop:aero:coop:info:museum:name:arpa:
    if (strlen($tld) < 2 || strlen($tld) > 3 && $tld != "arpa" && $tld != "shop" && $tld != "aero" && $tld != "coop" && $tld != "info" && $tld != "museum" && $tld != "name") $fail = 1; 

    $Level--; 

//  If the string after the last dot isn't in the generic TLDs or country codes, it's invalid. 
    if ($Level && !$fail) { 
    $Level--; 
    if (!ereg($tld.":", $gTLDs) && !ereg($tld.":", $CCs)) $fail = 2; 
    } 

//  If it's a country code, check for a country TLD; add on the domain name. 
    if ($Level && !$fail) { 
    $cd = $sLevels - 2;
	$domain = $Levels[$cd].".".$tld; 
    if (ereg($Levels[$cd].":", $cTLDs)) { $cd--; $domain = $Levels[$cd].".".$domain; } 
    } 

//  See if there's an MX record for the domain 
    if ($Level && !$fail) { 
    $Level--; 
    if (!getmxrr($domain, $mxhosts, $weight)) $fail = 3; 
    } 

//  Attempt to connect to port 25 on an MX host 
    if ($Level && !$fail) { 
    $Level--; 
    while (!$sh && list($nul, $mxhost) = each($mxhosts)) 
      $sh = fsockopen($mxhost, 25); 
    if (!$sh) $fail = 4; 
    } 

//  See if anyone answers 
    if ($Level && !$fail) { 
    $Level--; 
    set_socket_blocking($sh, false); 
    $out = ""; $t = 0; 
    while ($t++ < $Timeout && !$out) 
      $out = fgets($sh, 256); 
    if (!ereg("^220", $out)) $fail = 5; 
    } 

    if ($sh) fclose($sh); 

    return $fail;
}

function remove_accents($string) {
	$string = strtr($string,
   					" ",
   					"SZszYAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy_");
	$string = strtr($string,
			  		array('' => 'TH', '' => 'th', '' => 'DH', '' => 'dh', '' => 'ss',
  						  '' => 'OE', '' => 'oe', '' => 'AE', '' => 'ae', '' => 'u')
					);
	return $string;
}

function read_textfile($filename) {
	if(is_file($filename)) {
		$fd = fopen($filename, "rb");
		$text = fread($fd, filesize($filename));
		fclose($fd);
		return $text;				
	} else {
		return false;
	}	
}

function write_textfile($filename, $text) {
	if($fp = fopen($filename, "w+b")) {;
		fwrite($fp, $text);
		fclose($fp);
		return true;	
	} else {
		return false;
	}
}

//added: 09-20-2003
function add_keywords_to_search ($list_of_keywords, $keywords, $spacer=" ", $start_spacer=1) {
	//adds available keywords to the values used by search engine in file section
	//returns a string
	$kw_string = "";
	if(sizeof($list_of_keywords) && $keywords) {
		$kw = explode(":", $keywords);
		if(sizeof($kw)) {
			foreach($kw as $value) {
				list($kw_cat, $kw_id) = explode("_", $value);
				$kw_string .= (($kw_string) ? $spacer : "").$list_of_keywords[intval($kw_id)];
			}
		}
	}
	return (($start_spacer) ? $spacer : "") . $kw_string;
}

function get_list_of_file_keywords() {
	//reads possible keywords defined by admin and returns
	//array with values if exists
	//else it returns false
	if($result = mysql_query("SELECT * FROM ".DB_PREPEND."phpwcms_filekey;")) {
		while($row = mysql_fetch_array($result)) {
			$file_key[intval($row["fkey_id"])] = html_specialchars($row["fkey_name"]);
		}
		mysql_free_result($result);
	}
	return (sizeof($file_key)) ? $file_key : false;
}

function get_int_or_empty($value, $emptyreturn="\"\"") {
	//is used to return configuration values
	//that's why the default empty return value is ""
	$value = intval($value);
	return ($value) ? $value : $emptyreturn;
}

function get_pix_or_percent($val) {
	//is used to return configuration width/height values
	//whether based on pixel or percent
	//that's why the default empty return value is ""
	//returns a string
	$val = trim($val);
	$intval = intval($val);
	if(strlen($val) > 1 && strlen($val)-1 == strrpos($val, "%") && $intval) {
		$val = (($intval > 100) ? "100" : $intval)."%";
	} else {
		$val = ($intval) ? $intval : "";
	}
	//return "\"".$val."\"";
	return $val;
}

function check_URL($url) {
	//checks if URL is valid
	$fp = @fopen($url, "r");
	if(!$fp) {
		$url_status = 0;
	} else {
		$url_status = 1;
		fclose($fp);
	}
	return $url_status;
}

function validate_email($email) {
	// checks if the Email is well formatted
	return preg_match("/[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/", $email); 
}

function validate_url($url) {
	// checks if the URL is well formatted
    return preg_match("/(((ht|f)tps*:\/\/)*)((([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3}))|(([0-9]{1,3}\.){3}([0-9]{1,3})))((\/|\?)[a-z0-9~#%&'_\+=:\?\.-]*)*)$/", $url); 
}

function convert_url($text) {
	// converts URLs in Texts to link
    $text = eregi_replace("((ht|f)tp(s*)://www\.|www\.)([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})((/|\?)[a-z0-9~#%&\\/'_\+=:\?\.-]*)*)", "http\\3://www.\\4", $text); 
    $text = eregi_replace("((ht|f)tp(s*)://)((([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3}))|(([0-9]{1,3}\.){3}([0-9]{1,3})))((/|\?)[a-z0-9~#%&'_\+=:\?\.-]*)*)", "\\0", $text); 
    return $text; 
}

function link_url($text) {
	// converts URLs in Texts to link
    $text = eregi_replace("((ht|f)tp(s*)://www\.|www\.)([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})((/|\?)[a-z0-9~#%&\\/'_\+=:\?\.-]*)*)", "http\\3://www.\\4", $text); 
    $text = eregi_replace("((ht|f)tp(s*)://)((([a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3}))|(([0-9]{1,3}\.){3}([0-9]{1,3})))((/|\?)[a-z0-9~#%&'_\+=:\?\.-]*)*)", "<a href=\"\\0\">\\0</a>", $text); 
    return $text; 
}

function convert_email($text) {
	// converts Email addresses in Texts to mailto link
	return eregi_replace("([_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3}))", "mailto:\\0", $text); 
}

function link_email($text) {
	// converts Email addresses in Texts to mailto link
	return eregi_replace("([_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3}))", "<a href='mailto:\\0'>\\0</a>", $text); 
}

function convert_all_links($text) {
	// combines convertMail and convertURL
	$text = link_url($text);
    $text = link_email($text);
    return $text;
}

function convert_url_email($text) {
	// combines convertMail and convertURL
	$text = convert_email($text);
    $text = convert_url($text);
    return $text;
}

function validate_url_email($text) {
	// combined url email validation
	if(validate_email($text) || validate_url($text)) {
		return 1;
	} else {
		return 0;
	}
}

function remove_multiple_whitespaces($text) {
	// removes all multiple whitespaces from string
	return preg_replace("/(\s)+/"," ",$text);
}

function cut_redirect($text) {
	// formats the redirect string
	// returns only the first 2 parts if availabe like
	// "part1 part2 part3" -> "part1 part2" 
	// if only 1 part is returned trim the string
	return trim(preg_replace("/((.*?)\s(.*?))\s(.*)/","$1",$text));
}

function format_redirect($text) {
	// combines remove_multiple_whitespaces and cut_redirect
	return cut_redirect(remove_multiple_whitespaces($text));
}

function gd_image_check($file) {
	// when GD thumbnail creation is enabled
	// then check if image can be used by GD image function
	// GIF, JPG, PNG
	$status = 1;
	if(!IMAGICK_ON) {
		$image_check = getimagesize($file);
		$status = (!$image_check) ? 0 : 1;
		if($status && $image_check["channels"] < 4 && ($image_check[2] == 1 || $image_check[2] == 2 || $image_check[2] == 3)) {
			$status = 1;
		} else { 
			$status = 0;
		}
	}	
	return $status;
}

?>