<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *    
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the album related related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	 
 	function displayAlbumCovers($dirToLookIn){
		global $ext_graphic, $main_table_width, $this_page, $media_dir, $mp3_dir, $root_dir, $album_name_truncate,
		$album_img_width, $album_img_height, $web_root, $img_height, $word_change_art, $auto_search_art, $word_play_album,
		$album_force_width,	$album_force_height, $fav_image_name, $url_seperator;

		// Let's see if they wanted to auto search for album art or not
		if ($auto_search_art == "true" and $_SESSION['jz_access_level'] <> "viewonly"){
			// First let's get all the albums for this location	
			$searchArray = readDirInfo($dirToLookIn, "dir");
			$search = "false";
			$i = 0;
			$c = 0;
			while (count($searchArray) > $i){
				$readDir = $dirToLookIn. "/". $searchArray[$i];
				$imgArray = readDirInfo($readDir, "file");
				$dataFound = "no";
				while (count($imgArray) > $c){
					if (preg_match("/\.($ext_graphic)$/i", $imgArray[$c])) {
						$dataFound = "yes";
					}
					$c++;
				}
				$c = 0;
				// Now, if we didn't find art let's auto search for it
				if ($dataFound == "no"){
					if ($searchArray[$i] <> ""){
						autoSearchArt(urldecode($_GET['artist']). "|||". $searchArray[$i]);
						$search = "true";
					}
				}
				$i++;
			}
			if ($search == "true"){
				// Ok, let's refresh the page for them
				echo '<meta http-equiv="refresh" content="0">';
				exit();
			}
		}
		// Let's get the top level info for later
		$dirArray = readDirInfo($dirToLookIn, "dir");
		
		// Now let's look at all the files and see if we find a favorite image
		$fav_image = "";
		if ($fav_image_name <> ""){
			for ($c=0; $c < count($dirArray); $c++){	
				$fileArray = readDirInfo($dirToLookIn. "/". $dirArray[$c], "file");
				for ($c2=0; $c2 < count($fileArray); $c2++){	
					if (preg_match("/\.($ext_graphic)$/i", $fileArray[$c2])) {
						$fileInfo = pathinfo($fileArray[$c2]);
						$fileExt = $fileInfo["extension"];
						if (strtolower($fav_image_name) == strtolower(str_replace(".". $fileExt,"",$fileArray[$c2]))){ 
							$fav_image = $fileArray[$c2];
						}
					}
				}
			}	
		}		

		/* Now let's setup our table */
		echo '<br><br><table class="jz_album_cover_table" width="'. $main_table_width. '%" cellpadding="0" cellspacing="0" border="0">'. "\n";
	
		
		$c = 0;
		$c2 = 0;
		$ctr = 3;					
		/* Now let's loop through that array, displaying everything */
		while (count($dirArray) > $c){
			$dirToSearch = $dirToLookIn. "/". $dirArray[$c];
			$fileArray = readDirInfo($dirToSearch, "file");
			$albumFound = "no";
			while (count($fileArray) > $c2){
				if (preg_match("/\.($ext_graphic)$/i", $fileArray[$c2]) and $albumFound == "no") {
					$albumFound = "yes";
					if ($ctr == 3){
						$ctr = 1;
						echo '</tr><tr class="jz_album_cover_table_tr">'. "\n";
					} else {
						$ctr = $ctr + 1;
					}
					/* Let's first see if we need to truncate the name or not */
					if (strlen($dirArray[$c]) > $album_name_truncate){
						$albumName = substr($dirArray[$c],0,$album_name_truncate). "...";
					} else {
						$albumName = $dirArray[$c];
					}
					/* Now let's fix the path for the image file */
					$img_root_path = str_replace($mp3_dir, $root_dir. $media_dir, $dirToSearch);
					
					// Let's set the name of the image file for below
					// First let's check to see if we found a favorite image name to use from above
					if ($fav_image <> ""){
						$img_src = $img_root_path. "/". $fav_image;
					} else {
						$img_src = $img_root_path. "/". $fileArray[$c2];
					}
									
					// First let's make sure they wanted to do resizing and that we're looking at a jpg or jpeg file
					if ($album_img_width <> "0" and $album_img_height <> "0" and strpos($fileArray[$c2],".jp") <> 0){
						// Now let's get the image dimensions and see if it needs resizing
						$imgFile = $dirToSearch. "/". $fileArray[$c2];
						$imgDst = $dirToSearch. "/". $dirArray[$c]. ".jpg.new";
						$imgDim = getimagesize($imgFile);
						$imgWidth = $imgDim[0];
						$imgHeight = $imgDim[1];
	
						// Now let's see if either is bigger or smaller than what we want
						if ($imgHeight <> $img_height){
							// Ok, we need to change the height of the image
							if (resizeImage($imgFile, $imgDst, $album_img_width, $album_img_height)){
								// Now let's rename the current one to .old
								@rename ($imgFile, $imgFile. ".old");
								// Now let's rename the new one
								@rename ($imgDst, $imgFile);
								// Now let's kill the old one
								@unlink ($imgFile. ".old");
							}
						}
					} 
				
					// Now let's clean up the image file name
					$img_src = str_replace("%2F","/",rawurlencode($img_src));				
					
					// Now let's display the art we found
					echo '<td width="33%" class="jz_album_cover_table_td" valign="top">'. "\n".
							'<a class="jz_album_cover_table_href" href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($_GET['genre']). '&artist='. urlencode($_GET['artist']). '&album='. urlencode($dirArray[$c]). '">'. $albumName. "</a><br>\n".
							'<a class="jz_album_cover_table_href" href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($_GET['genre']). '&artist='. urlencode($_GET['artist']). '&album='. urlencode($dirArray[$c]). '">';
							if ($album_force_height <> "" and $album_force_height <> "0"){
								echo '<img width="'. $album_force_width. '" height="'. $album_force_height. '" class="jz_album_cover_picture" src="'. $img_src. '?'. time(). '" title="'. $dirArray[$c]. '"></a>';
							} else {
								echo '<img class="jz_album_cover_picture" src="'. $img_src. '?'. time(). '" title="'. $dirArray[$c]. '"></a>';
							}
							echo '<br>';
							if ($_SESSION['jz_access_level'] == "admin"){
								echo '<a class="jz_album_cover_table_href" href="'. $this_page. $url_seperator. 'ptype=artsearch&info='. $_GET['genre']. '|||'. $_GET['artist']. '|||'. urlencode($dirArray[$c]). '&return=artist">'.
									 $word_change_art. '</a><br>'. "\n";
							}							
							if ($_SESSION['jz_access_level'] <> "viewonly"){
								$play_url = $this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=album&info='. urlencode($_GET['genre']). '/'. urlencode($_GET['artist']). '/'. urlencode($dirArray[$c]);
								$play_url = str_replace("?&","?",$play_url);
								echo '<a class="jz_album_cover_table_href" href="'. $play_url. '">';
								echo $word_play_album. "</a><br><br>";
							}
					echo'</td>'. "\n";
											
					}
					$c2 = $c2 + 1;
				
			}
			$c2 = 0;
			$c = $c + 1;
		}
		
		echo '</table><br>'. "\n";
	}
?>