<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *       
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the "display" related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/* This Fucntion Displays all the albums for this artist */
	function displayArtist($header="true", $subsearch=""){
		global $mp3_dir, $img_play, $ext_graphic, $this_page, $mp3_dir, $img_download, $album_name_truncate, $main_table_width,
		$word_play_all_albums_from, $word_randomize_all_albums_from, $root_dir, $media_dir, $allow_download, 
		$quick_list_truncate, $directory_level, $word_home, $sort_by_year, $web_root, $audio_types, $artist_img_width, 
		$artist_img_height, $web_root, $javascript, $main_table_width, $song_cellpadding, $word_check_all, $word_check_none, $word_play, 
		$word_selected, $word_delete, $img_delete, $word_session_playlist, $word_new_playlist, $playlist_directory, $img_playlist, 
		$img_add, $row_colors, $web_root, $root_dir, $playlist_directory, $playlist_ext, $img_random_play, $img_more, $img_random_play,
		$img_play_dis, $img_random_play_dis, $img_download_dis, $img_add_dis, $img_playlist_dis, $url_seperator;
		
		// First let's get all the POST and GET variables and clean them up
		$genre = jzstripslashes(urldecode($_GET['genre']));
		$artist = jzstripslashes(urldecode($_GET['artist']));
		
		// Now let's see if we had a sub search
		if ($subsearch <> ""){
			$artist = $artist. "/". $subsearch;
		}
		
		// First let's look and see if there are any sub folders here
		// If not we really should be looking at the song view instead
		$sub_found = "no";
		$dirToLookIn = $web_root. $root_dir. $media_dir. "/". $genre. "/". $artist;
		$retArray = readDirInfo($dirToLookIn, "dir");
		for ($ctr=0; $ctr < count($retArray); $ctr++){
			if ($retArray[$ctr] <> ""){
				$sub_found = "yes";
			}
		}
		
		// Now let's see if we should change page types or not
		if ($sub_found == "no" and $header == "true"){
			header("Location: ". $this_page. $url_seperator. "ptype=songs&genre=". urlencode($_GET['genre']). "&artist=&album=". urlencode($_GET['artist']));
			exit();
		}
		
		// Let's make sure they wanted a header
		if ($header == "true"){
			/* Let's add the page header based on the type of directory structure */
			switch ($directory_level) {
				case "3" : # 3 directories deep
					displayHeader($genre. " : ". $artist);
				break;
				
				case "2" : # 2 directories deep
					displayHeader($artist);
				break;
				
				case "1" : # 1 directories deep
					displayHeader($word_home);
				break;
			}
		}
		
		/* Let's set a variable so we know where to look later */
		$dirToLookIn = $mp3_dir. "/". $genre. "/". $artist;
		
		/* Let's get all the albumns in the directory using that function */
		$retArray = readDirInfo($dirToLookIn, "dir");
		
		/* Now let's get the main picture for this artist */	
		$artistImage = "";
		$albumsFound = "no";
		$d = dir($dirToLookIn);
		while($entry = $d->read()) {
			// Let's set a variable for below so we'll know we found some albums here
			if (is_dir($dirToLookIn. "/". $entry)){
				if ($entry == "." || $entry == "..") { continue;}
				$albumsFound = "yes";
			}
			/* Let's see if one of the files is an image that we're used to */
			if (preg_match("/\.($ext_graphic)$/i", $entry)) {
				$artistImage = $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $entry;
				// Now let's resize the image if necessary
				jzResizeArtist($dirToLookIn, $entry);
			}
		}
				
		// Let's setup our form for below
		$formAction = $this_page. $url_seperator. $_SERVER['QUERY_STRING'];
		echo '<form action="'. $formAction. '" name="albumForm" method="POST" onSubmit="return AreYouSure();">';
		
		// Ok, first let's make sure there are really albums here (DIRECOTRIES) and if not let's hide all this crap...
		if ($albumsFound == "yes"){
		
			/* Now let's create the table to put our stuff in */
			?>
			
			<table width="<?php echo $main_table_width; ?>%" cellpadding="0" cellspacing="0" border="0" class="jz_artist_table">
				<tr class="jz_artist_table_tr">
					<?php 
						/* Let's see if they are looking at 2 levels or 3 */
						if ($directory_level == "3" or $directory_level == "2"){
						
						// We also need to find out if there are going to be any album covers to display
						$albumArt = "no";
						$d = dir($dirToLookIn);
						while($entry = $d->read()) {
							// Let's make sure it's a real directory
							if ($entry == "." || $entry == "..") { continue;}
							// Now let's see if we can find any art under here but make sure it's a dir that we're looking at
							if (is_dir($dirToLookIn. "/". $entry)) { } else {continue;}
							$d2 = dir($dirToLookIn. "/". $entry);
							while($entry2 = $d2->read()) {
								// Let's make sure it's a real directory
								if ($entry2 == "." || $entry2 == "..") { continue;}
								if (preg_match("/\.($ext_graphic)$/i", $entry2)) {
									$albumArt = "yes";
								}
							}
							$d2->close();
						}
						$d->close();
						// Now let's see if this was found where it wasn't expected, meaning we don't want to show
						// sub album or artist images
						if ($header == "false"){
							$artistImage = "";
							$albumArt = "no";
						}
					?>
					<td width="<?php if($albumArt == "yes"){ echo "35%"; } else { echo "100%"; } ?>" valign="top" class="jz_artist_table_td">
						<?php 
							/* Let's make sure this variable is set */
							if (!isset($_SESSION['jz_access_level'])){ $_SESSION['jz_access_level'] = ""; }					
							/* Let's make sure they are not a view only user */
							if ($_SESSION['jz_access_level'] <> "viewonly"){
								echo $word_play_all_albums_from;
								echo "<i> ";
								/* Let's show them the play all links, for both normal and randomize */
								$link_url = urlencode($genre). "/". urlencode($artist);
								if (strlen($artist) > $quick_list_truncate){
									$ls_artist = substr($artist,0,$quick_list_truncate). "...";				
								} else {
									$ls_artist = $artist;
								}
								$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=artist&info='. $link_url);
								echo '<a class="jz_artist_table_href" href="'. $play_song_link. '">'. $ls_artist. '</a></i>';
								echo '<br>'. $word_randomize_all_albums_from. ' <i>';
								
								/* Let's create the Randomize URL */
								$link_url = "artist&info=". urlencode($genre). "/". urlencode($artist);	
								$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=artist&info='. $link_url);
								echo '<a class="jz_artist_table_href" href="'. $play_song_link. '">'. $ls_artist. '</a></i>';
							} else {
								if (strlen($artist) > $quick_list_truncate){
									$ls_artist = substr($artist,0,$quick_list_truncate). "...";				
								} else {
									$ls_artist = $artist;
								}
								echo $word_play_all_albums_from;
								echo "<i> ";
								echo $ls_artist. '</i>';
								echo '<br>'. $word_randomize_all_albums_from. ' <i>';
								echo  $ls_artist. '</i>';
							}	
						?>
						<br><br>
						<?php
							/* Let's initalize a variable for below */
							$album_year_array = "";
							/* Let's see if they wanted to sort by year, and if so let's read the data to do so */
							if ($sort_by_year == "true"){	
								/* Ok let's loop through each directory and read the year off 1 file in each dir */
								$loop_ctr = 0;
								while (count($retArray) > $loop_ctr){
									$searchDir = $web_root. $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $retArray[$loop_ctr];
									$d = dir($searchDir);
									$dirCtr = 0;
									while($entry = $d->read()) {
										/* Let's see if we've done this once and if so leave the loop */
										if ($dirCtr <> 0){
											/* Ok, let's stop the loop */
											break;
										}
										/* Let's see if one of the files is an image that we're used to */
										if (preg_match("/\.($audio_types)$/i", $entry)) {
											/* Now let's read the MP3 info */
											$mp3 = new mp3($searchDir. "/". $entry, true);
											$album_year = $mp3->year;
											$dirCtr = 1;
										}
									}
									$album_year_array[$loop_ctr] = $album_year. "|". $retArray[$loop_ctr];
									$loop_ctr = $loop_ctr + 1;
								}
								/* Now let's sort that new array */
								sort($album_year_array);
								
								/* Now let's set our old array equal to this new one */
								$retArray = $album_year_array;
							}
							
							$loop_ctr = 0;		
							/* Now let's loop through that array, displaying the albums */
							while (count($retArray) > $loop_ctr){
								/* Let's see if we need to break out the album name from the year sorted array above */
								if ($sort_by_year == "true"){
									/* Ok, now let's fix the album name */
									$albumNameArray = explode("|",$retArray[$loop_ctr]);
									$retArray[$loop_ctr] = $albumNameArray[1];
									$albumYear = $albumNameArray[0];
								} else {
									$retArray[$loop_ctr] = $retArray[$loop_ctr];
									$albumYear = "";
								}
								$albumName = $retArray[$loop_ctr];
								/* Let's figure out if we need to truncate the ablum name */
								if (strlen($albumName) > $album_name_truncate){
									$albumName = substr($albumName,0,$album_name_truncate). "...";
								}
								/* Let's make sure they are not a view only user */
								if ($_SESSION['jz_access_level'] <> "viewonly"){
									$link_url = urlencode($genre. "/". $artist. "/". $retArray[$loop_ctr]);				
									$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=artist&info='. $link_url);
									$play_song_link_rand = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=artist&info='. $link_url);
									
									echo '<a class="jz_artist_table_href" href="'. $play_song_link. '">'.$img_play. '</a> ';
									echo '<a class="jz_artist_table_href" href="'. $play_song_link_rand. '">'.$img_random_play. '</a> ';								
									/* Let's see if they can download or not */
									if ($allow_download == "true"){
										echo '<a class="jz_artist_table_href" href="'. $this_page. $url_seperator. 'ptype=zip&ztype=album&info='. urlencode($genre). "/". urlencode($artist). "/". urlencode($retArray[$loop_ctr]). '">'. $img_download. '</a>';
									}
									// Let's see if the user is an admin, and can therfore rename/delete stuff
									if ($_SESSION['jz_access_level'] == "admin"){
										// Ok, first let's echo out some javascript to open our popup window
										?>
										<script type="text/javascript">
											<!--//
												function newWin(obj){
													var sw = screen.width;
													var sh = screen.height;
													var winOpt = "width=320,height=300,left=" + ((sw - 300) / 2) + ",top=" + ((sh - 300) / 2) + ",menubar=no,toolbar=no,location=no,directories=no,status=no,scrollbars=yes,resizable=no";
													thisWin = window.open(obj.href,'Info',winOpt);
												}
											//-->
										</script>
										<?php
										echo '<a class="jz_artist_table_href" href="'. $root_dir. '/mp3info.php?type=album&info='. urlencode($genre). "/". urlencode($artist). "/". urlencode($retArray[$loop_ctr]). '" target="_blank" onclick="newWin(this); return false;">'. $img_more. '</a>';
									}
									echo ' <input class="jz_checkbox" name="track-'. $loop_ctr. '" type=checkbox value="'. $root_dir. $media_dir. '/'. urlencode($genre). '/'. urlencode($artist). '/'. urlencode($retArray[$loop_ctr]). '/"> '; 
								} else {
									echo $img_play_dis;
									echo $img_random_play_dis;								
									echo $img_download_dis. " ";
								}
								
								echo '<a class="jz_artist_table_href" href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($genre). '&artist='. urlencode($artist). '&album='. urlencode($retArray[$loop_ctr]). '">'. $albumName;
								/* Now if there was a year let's display it here */
								if ($albumYear <> ""){
									echo " (". $albumYear. ") ";
								}
								echo "</a><br>\n";
	
								$loop_ctr = $loop_ctr + 1;
							}					
							
							// Ok, before we show all this we need to know if they are using JavaScript or not, if not, tough, "NO PLAYLIST FOR YOU!"
							if ($javascript == "yes"){
								echo "<br>";
								// Now let's set a hidden form field to hold the data for the click
								echo '<input type="hidden" name="albumSubmitAction">';
								// Now let's set a field with the number of checkboxes that were here
								echo '<input type="hidden" name="numboxes" value="'. $loop_ctr. '">';
										
								// Now let's show our last row for all the other options
								echo '<table class="jz_track_table" width="260" cellpadding="5" cellspacing="0" border="0">'.
										'<tr class="'. $row_colors[0]. '">'.
											'<td width="100%" class="jz_track_table_songs_td">';
												// Now let's build the URL for the playlist
												if ($_SESSION['jz_access_level'] <> "viewonly"){
													echo "<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\"  onClick='albumForm.albumSubmitAction.value=\"addtoplaylist\";albumForm.submit()';\">". $img_add. '</a>&nbsp;&nbsp;';
												} else {
													echo $img_add_dis;
												}
												echo ' <select name="albumPlayListToPlay" class="jz_select">';
												echo '<option value="sessionplaylist">'. $word_session_playlist. '</option>';
												echo'<option value="newplaylist">'. $word_new_playlist. '</option>';
													// Now let's get all the other playlists that exist
													$retArray = readDirInfo($web_root. $root_dir. $playlist_directory, "file");
													for ($ctr=0; $ctr < count($retArray); $ctr++){
														// Let's make sure we're looking at a playlist file
														if (preg_match("/\.($playlist_ext)$/i", $retArray[$ctr])) {
															$optionDisp = str_replace(".". $playlist_ext, "",$retArray[$ctr]);
															if (strlen($optionDisp) > 15){
																$optionDisp = substr($optionDisp,0,15). "...";
															}
															// Now let's display the option and make it look pretty
															echo '<option value="'. $retArray[$ctr]. '">'. $optionDisp. '</option>';
														}
													}
												echo '</select> ';
												if ($_SESSION['jz_access_level'] <> "viewonly"){
													echo "&nbsp; <a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='albumForm.albumSubmitAction.value=\"viewplaylist\";albumForm.submit()';\">". $img_playlist. '</a>'.
													" <a class=\"jz_track_table_songs_href\" style=\"cursor:hand\"  onClick='albumForm.albumSubmitAction.value=\"playplaylist\";albumForm.submit()';\">". $img_play. '</a> '. 
													"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\"  onClick='albumForm.albumSubmitAction.value=\"randomplaylist\";albumForm.submit()';\">". $img_random_play. '</a>&nbsp;&nbsp;';
												} else {
													echo "&nbsp; ". $img_playlist_dis.
													"&nbsp;&nbsp;". $img_play_dis. "&nbsp;&nbsp;".
													$img_random_play_dis. '&nbsp;&nbsp;';
												}
										echo'</td>'.					
										'</tr>';
										if ($_SESSION['jz_access_level'] <> "viewonly"){
											echo '<tr class="'. $row_colors[0]. '">'.
												'<td width="100%" class="jz_track_table_songs_td">'.
													"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\"  onClick=\"CheckBoxes('albumForm',true);\">". $word_check_all. '</a>'.
													' &nbsp; | &nbsp; '.
													"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\"  onClick=\"CheckBoxes('albumForm',false);\">". $word_check_none. '</a>'. 
												'</td>'.					
											'</tr>';
										}	
								echo '</table>';
								echo '</form><br>';
							}
							// Let's see if there is a description for this artist
							$desc_file = $web_root. $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $artist. ".txt";
							$contents = "";
							if (is_file($desc_file) == true){
								/* Ok, it's there so let's open it and display it */
								$filename = $desc_file;
								$handle = fopen ($filename, "rb");
								$contents = fread ($handle, filesize ($filename));
								fclose ($handle);
							}
							// Let's show this if there was a descriptoin file and if we are not viewing this out of place
							if ($contents <> "" and $header <> "false"){
								echo $contents. "<br><br>";
							}
							
							// Now let's display the artist photo if available
							if (strlen($artistImage) <> 0){echo '<img src="'. urldecode($artistImage). '" border="0"><br><br>';} 
						?>
					</td>
					<?php } ?>
					<?php
						echo '<td width="2%" class="jz_artist_table_td"></td>'.
							 '<td width="63%" valign="top" class="jz_artist_table_td">';
								/* Now let's get all the album covers for the sub albums */
								// Let's also make sure they aren't looking at this out of place
								if ($header <> "false"){
									displayAlbumCovers($dirToLookIn);
								}
						echo '</td>';
					?>			
				</tr>
			</table>
		<?php
			// This closes the IF statement way up above where we tested to see if there were albums for this artist, or just songs
			} else {
				$loop_ctr = 0;
			}
			
			// Let's finish off some form data for later
			// Now let's set a hidden form field to hold the data for the click
			echo '<input type="hidden" name="submitAction">';
			// Now let's set a field with the number of checkboxes that were here
			echo '<input type="hidden" name="numboxes" value="'. $loop_ctr. '">';
		?>
		</form>		
		<?php	

		// Now let's make sure we are ONLY looking at the artist and not really in a song page
		if ($_GET['ptype'] <> "songs"){
			// Now let's look and see if there are any songs in this directory that we need to display
			$songsFound = lookForMedia(jzstripslashes(urldecode($dirToLookIn)));
			
			// Now let's show the playlist bar
			displayPlaylistBar($songsFound);	
		}			
	}
?>