<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *        
	* JINZORA | Web-based Media Streamer   
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the album display related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	// Now let's include all the sub functions
	include_once('genre.php');
	include_once('artist.php');
	include_once('head-foot.php');
	include_once('album.php');
	include_once('tracks.php');
	
	// Now let's put in all the standard display functions...
	
	// This function displays the playlist bar at the bottom
	function displayPlaylistBar($songs_found){
		global $mp3_dir, $audio_types, $video_types, $ext_graphic, $img_play, $img_download, 
		$get_mp3_info, $song_cellpadding, $row_colors, $main_table_width, $this_page, $word_play_album, $word_download_album,
		$root_dir, $media_dir, $this_site, $allow_download, $track_num_seperator, $directory_level, $web_root, 
		$num_other_albums, $word_album, $album_name_truncate, $word_play, $img_more, $search_album_art, 
		$word_search_for_album_art, $img_delete, $word_cancel, $word_delete, $word_are_you_sure_delete, $img_add, 
		$img_playlist, $word_check_all, $word_check_none, $word_selected, $word_session_playlist, 
		$word_new_playlist, $playlist_directory, $playlist_ext, $word_play_random, $img_random_play, $javascript, 
		$get_mp3_info, $colapse_tracks, $jinzora_skin, $word_search, $amg_search, $hide_tracks, $word_hide_tracks, 
		$word_show_tracks, $postnuke, $url_seperator;
		
		// Ok, before we show all this we need to know if they are using JavaScript or not, if not, tough, "NO PLAYLIST FOR YOU!"
		if ($javascript == "yes" and $_SESSION['jz_access_level'] <> "viewonly"){
			
			// Let's setup our form for the checkboxes
			if ($postnuke == "false"){
				$formAction = $this_page. $url_seperator.  $_SERVER['QUERY_STRING'];
			} else {
				$formAction = $this_page. $url_seperator.  $_SERVER['QUERY_STRING'];
			}
			echo '<form action="'. $formAction. '" name="trackForm" method="POST" onSubmit="return AreYouSure();">';
		
			// Now let's set a hidden form field to hold the data for the click
			echo '<input type="hidden" name="submitAction">';
					
			// Now let's show our last row for all the other options
			echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $song_cellpadding. '" cellspacing="0" border="0">'.
					'<tr class="'. $row_colors[0]. '">';
						// First let's make sure there are really tracks here
						if ($songs_found == "true"){
							echo '<td width="50%" class="jz_track_table_songs_td">'.
								"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick=\"CheckBoxes('trackForm',true);\">". $word_check_all. '</a>'.
								' | '. 
								"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick=\"CheckBoxes('trackForm',false);\">". $word_check_none. '</a>'. 
								'&nbsp;&nbsp;&nbsp;&nbsp;'. 
								"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"play\";trackForm.submit()';\">". $img_play. '</a> '. 
								"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"play\";trackForm.submit()';\">". $word_play. '</a> ';
								// Let's make sure they are an admin
								if ($_SESSION['jz_access_level'] == "admin"){
									echo "&nbsp;&nbsp;&nbsp;&nbsp;<a name=\"delete\" class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"delete\";if (AreYouSure()){trackForm.submit()}';\">". 
									$img_delete. '</a> '. 
									" <a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"delete\";if (AreYouSure()){trackForm.submit()}';\">". $word_delete. "</a>";
								}
							echo '</td>';
						}
					echo '<td width="50%" class="jz_track_table_songs_td" align="right">';
						// Let's make sure there are songs to add or don't show the button
						if ($songs_found == "true"){				
							echo "<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"addtoplaylist\";trackForm.submit()';\">". $img_add. '</a>';
						}
						echo ' <select name="playListToPlay" class="jz_select">';

								echo '<option value="sessionplaylist">'. $word_session_playlist. '</option>';
							
							echo'<option value="newplaylist">'. $word_new_playlist. '</option>';
								// Now let's get all the other playlists that exist
								$retArray = readDirInfo($web_root. $root_dir. $playlist_directory, "file");
								for ($ctr=0; $ctr < count($retArray); $ctr++){
									// Let's make sure we're looking at a playlist file
									if (preg_match("/\.($playlist_ext)$/i", $retArray[$ctr])) {
										// Now let's display the option and make it look pretty
										$optionDisp = str_replace(".". $playlist_ext, "",$retArray[$ctr]);
										if (strlen($optionDisp) > 15){
											$optionDisp = substr($optionDisp,0,15). "...";
										}
										echo '<option value="'. $retArray[$ctr]. '">'. $optionDisp. '</option>';
									}
								}
							echo '</select> '.
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"viewplaylist\";trackForm.submit()';\">". $img_playlist. '</a>&nbsp;'. 
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"playplaylist\";trackForm.submit()';\">". $img_play. '</a> '. 
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"randomplaylist\";trackForm.submit()';\">". $img_random_play. '</a>&nbsp;&nbsp;'. 
						'</td>'.					
					'</tr>'.			
			'</table></form>';
			echo '<br>';
		}
	}
	
	/* This function displays all the tools available to the user */
	function displayTools(){
		global $main_table_width, $this_page, $mp3_dir, $pathtoId3Tool, $web_root, $mp3_dir, $track_num_seperator,
		$root_dir, $mp3_dir, $image_dir, $playlist_dir, $web_root, $jinzora_temp_dir, $temp_zip_dir, $postnuke,$standalone, 
		$get_mp3_info, $cols_in_genre, $cellspacing, $song_cellpadding, $artist_truncate, $quick_list_truncate, 
		$main_table_width, $song_cellpadding, $artistArray, $ephPod_file_name, $ephPod_drive_letter, $ipod_size,
		$word_id3_tag_tools, $word_update_id3v1, $word_update_id3v2, $word_strip_id3v1, $word_strip_id3v2, $word_directory_other_tools,
		$word_upload_center, $word_select_for_ipod, $word_fix_file_case, $word_create_new_genre, $word_delete_genre,
		$word_update_id3v1_desc, $word_update_id3v2_desc, $word_strip_id3v1_desc, $word_strip_id3v2_desc, $word_upload_to_jinzora,
		$word_ipod_select_desc, $word_fix_file_case_desc, $word_create_new_genre_desc, $word_delete_genre_desc, $word_tools, $word_enter_setup, 
		$media_dir, $directory_level, $word_check_for_update, $word_new_genre, $jinzora_url, $version, $this_pgm, 
		$word_send_tech_email, $this_site, $slash_vars, $word_auto_update, $jinzora_url, $word_auto_update_beta, $path_to_wget, 
		$path_to_tar, $word_shoutcast_tools, $shoutcast, $word_start_shoutcast, $word_stop_shoutcast, $word_shoutcast_tools, $url_seperator, $shoutcast;
		
		/* This section got huge, so it's now in an include file */
		include_once('tools.php');
	}
	
	/* This function displays the search results */
	function displaySearch(){
		global $mp3_dir, $audio_types, $main_table_width, $artist_truncate, $img_download, 
		$img_play, $cellspacing, $row_colors, $this_page, $word_search_results, $directory_level, $allow_download,
		$web_root, $root_dir, $media_dir, $video_types, $audio_types, $directory_level, $url_seperator;

		// Now let's read the complete list of data for the search info
		$retArray = explode("\n",urldecode($_SESSION['complete_list']));
		$i=0; $oldAlbum = "NULLALBUM"; $match_found = "no";
		for ($ctr=0; $ctr < count($retArray); $ctr++){
			// Let's remove the root path from the search
			$searchData = str_replace($web_root. $root_dir. $media_dir,"",$retArray[$ctr]);
			if (stristr($searchData, $_POST['search'])) {
				if (preg_match("/\.($audio_types)$/i", $retArray[$ctr]) or preg_match("/\.($video_types)$/i", $retArray[$ctr])) {
					// Now that we've got a match, let's see where the match was so we don't display the same album over and over
					$dataArray = explode("----",$retArray[$ctr]);
					if ($dataArray[count($dataArray) -2] <> $oldAlbum){
						$match_found = "album";
						// But now let's make sure the match wasn't on the file name
						$oldAlbum = $dataArray[count($dataArray) -2];
					}
					if (stristr($dataArray[count($dataArray) -1], $_POST['search'])) {
						$match_found = "song";
					}
					
					if ($match_found <> "no"){
						// Now let's see where the match was
						if ($match_found == "album"){
							// Ok, for albums we need to strip off the file name
							$fileArray = explode("----",$retArray[$ctr]);
							$fileArray[count($fileArray) -1] = "";
							$retArray[$ctr] = implode("----",$fileArray). "----";
							
							$match_res = $retArray[$ctr];
						}
						if ($match_found == "song"){
							$match_res = $retArray[$ctr];
						}
						
						$resultsArray[$i] = str_replace($web_root. $root_dir. $media_dir, "",$match_res);
						$i++;			
					}
					$match_found = "no";
				}
			}
		}
		
		/* First let's show the header */
		displayHeader($word_search_results. " : ". $_POST['search']. " (". $i. ")");

		/* Ok, now that we've got the results let's display them */
		/* Let's open a table for this, shall we? */
		echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $cellspacing. '" cellspacing="0" border="0">';
		$i = 1;
		for ($ctr=0; $ctr < count($resultsArray); $ctr++){
			/* Let's break out the array */
			$dataArray = explode("----", $resultsArray[$ctr]);
			echo '<tr class='. $row_colors[$i]. '>';
					echo '<td width="2%" class="jz_track_table_songs_td">';
						$trackName = $dataArray[count($dataArray) -1];
						if ($trackName <> ""){
							$trackInfo = implode("/",$dataArray);
							echo '<a href="'. $this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($trackInfo). '">'. $img_play. '</a>';
						}
				echo'</td>'.
					'<td width="30%" class="jz_track_table_songs_td">';
						$trackName = $dataArray[count($dataArray) -1];
						if (is_numeric(substr($trackName,0,2))){
							$trackName = trim(substr($trackName,2));
							/* Now let's stip off the - */
							if (substr($trackName,0,1) == "-"){
								$trackName = trim(substr($trackName,1));
							}
						}
						/* Now let's strip off the .mp3 */
						$trackName = str_replace(".mp3","",$trackName);
						$trackInfo = implode("/",$dataArray);
						/* let's give them the link so they can play the song */
						echo '<a class="jz_track_table_songs_href" href="'. $this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($trackInfo). '">'. $trackName. '</a>';
				echo'</td>'.
					'<td width="10%" class="jz_track_table_songs_td">';
						// Now let's link to where this is
						if ($directory_level == "3"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=genre&genre='. urlencode($dataArray[0]). '">'. $dataArray[0]. '</a>';
						}
						if ($directory_level == "2"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=artist&genre=/&artist='. urlencode($dataArray[0]). '">'. $dataArray[0]. '</a>';
						}
						if ($directory_level == "1"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=songs&genre=/&artist=/&album='. urlencode($dataArray[0]). '">'. $dataArray[0]. '</a>';
						}
				echo'</td>'.
					'<td width="20%" class="jz_track_table_songs_td">';
						if (strlen($dataArray[1]) > $artist_truncate){
							$artist = substr($dataArray[1],0,$artist_truncate). "...";
						} else {
							$artist = $dataArray[1];
						}
						// Now let's link to where this is
						if ($directory_level == "3"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=artist&genre='. urlencode($dataArray[0]). '&artist='. urlencode($dataArray[1]). '">'. $artist. '</a>';
						}
						if ($directory_level == "2"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=songs&genre=/&artist='. urlencode($dataArray[0]). '&album='. urlencode($dataArray[1]). '">'. $artist. '</a>';
						}
						if ($directory_level == "1"){
							//echo $artist;
						}
				echo'</td>'.
					'<td width="20%" class="jz_track_table_songs_td">';
						if (strlen($dataArray[2]) > $artist_truncate){
							$album = substr($dataArray[2],0,$artist_truncate). "...";
						} else {
							$album = $dataArray[2];
						}
						// Now let's link to where this is
						if ($directory_level == "3"){
							echo '<a href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($dataArray[0]). '&artist='. urlencode($dataArray[1]). '&album='. urlencode($dataArray[2]). '">'. $album. '</a>';
						}
						if ($directory_level == "2"){
							//echo $album;
						}
						if ($directory_level == "1"){
							//echo $album;
						}
				echo'</td>'.
				'</tr>';
			$i = ++$i % 2;
		}		
		
		echo "</table><br>";
	}
	
	/* This function displays the login page then authenticaes the user for admin level access */
	function displayLogin(){
		global $word_login, $main_table_width, $cellspacing, $this_page, $word_username, $word_password, $word_remember_me, $url_seperator;
		
		// Let's show the header
		displayHeader($word_login);
		$formAction = $this_page;
		?>		
			<form action="<?php echo $formAction; ?>" method="post">
				<input type="hidden" name="returnPage" value="<?php echo $_GET['return']; ?>">
				<table width="<?php echo $main_table_width; ?>%" cellpadding="<?php echo $cellspacing; ?>" cellspacing="0" border="0">
					<tr>
						<td width="50%" align="right">
							<?php echo $word_username; ?>
						</td>
						<td width="50%">
							<input class="jz_input" type="text" name="username">
						</td>
					</tr>
					<tr>
						<td width="50%" align="right">
							<?php echo $word_password; ?>
						</td>
						<td width="50%">
							<input class="jz_input" type="password" name="admin_pass">
						</td>
					</tr>
					<tr>
						<td width="50%" align="right">
							
						</td>
						<td width="50%">
							<input class="jz_checkbox" type="checkbox" name="remember_me"> <?php echo $word_remember_me; ?>
						</td>
					</tr>
					<tr>
						<td width="100%" colspan="2" align="center">
							<input class="jz_submit" type="submit" name="submit_login" value="<?php echo $word_login; ?>">
						</td>
					</tr>
				</table>
			</form>
		<?php
	}
	
	// This function displays a playlists for editing
	function displayPlaylists($playList){
		global $web_root, $root_dir, $playlist_directory, $playlist_ext, $audio_types, $video_types,
		$main_table_width, $song_cellpadding, $this_page, $row_colors, $word_playlist,
		$word_check_all, $word_check_none, $word_session_playlist, $word_new_playlist,
		$img_delete, $word_delete, $word_selected, $img_playlist, $img_add, $img_play, 
		$media_dir, $word_delete, $word_playlist, $word_create_shoutcast_playlist, $shoutcast,
		$word_create_shoutcast_random_playlist, $url_seperator;

		// Ok, let's open the playlist they are editing so we can display it
		// Let's see if they submitted already and open the old list if they did
		if (!isset($_POST['editlistname'])){
			$filename = $web_root. $root_dir. $playlist_directory. "/". $_POST['editlistname'];
			// Now let's display the header
			displayHeader($word_playlist. ": ". str_replace(".". $playlist_ext,"",$_POST['editlistname']));
		} else {
			$filename = $web_root. $root_dir. $playlist_directory. "/". $playList;
			// Now let's display the header
			$headTitle = str_replace(".". $playlist_ext,"",$playList);
			if ($headTitle == "sessionplaylist"){
				$headTitle = substr($word_session_playlist,2,strlen($word_session_playlist)-4);
			}
			displayHeader($word_playlist. ": ". $headTitle);
		}
		
		// Ok, now that we've got it, we need to display it
		// Let's setup our form for the checkboxes
		$formAction = $this_page;
		echo '<form action="'. $formAction. '" name="trackForm" method="POST" onSubmit="return AreYouSure();">';
		echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $song_cellpadding. '" cellspacing="0" border="0">';
		
		// Now let's make sure the file name wasn't "newplaylist", if it doesn't exist they can't view it!
		if (stristr($filename,"newplaylist")){
			echo "<center>You can't really view a new playlist until you create it, now can you???</center><br>";
			// Now let's show them the playlist footer
			displayPlaylistFooter();
		
			// Now let's show them the footer
			displayFooter();
			exit();
		}
		
		// Let's see if this is the session playlist or not, and open that instead of a file
		if ($playList == "sessionplaylist"){
			$contents = $_SESSION['sessionPlaylist'];
		} else {
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
		}
		
		// Now let's clean up the contents
		$contents = urldecode($contents);
		
		// Ok, now that' we've read it, we need to split it into an array so we can read it line by line
		$retArray = explode("\n",$contents);
				
		/* Now let's populate our table with all the songs */
		$loop_ctr = 0;
		$i = 1;
		for ($ctr=0; $ctr < count($retArray); $ctr++){
			// Let's make sure this isn't a blank line
			if ($retArray[$ctr] <> ""){
				echo '<tr class="'. $row_colors[$i]. '">'. "\n".
					 '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						'<input class="jz_checkbox" type="checkbox" name="track-'. $ctr. '" value="'. $retArray[$ctr]. '">'. "\n".
					'</td>'. "\n".
					'<td width="98%" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Let's clean this up a bit...
						if (substr($retArray[$ctr],strlen($retArray[$ctr]) -1,1) == "/"){
							$retArray[$ctr] = substr($retArray[$ctr],0,strlen($retArray[$ctr]) -1);
						}
						echo str_replace("/"," &nbsp; | &nbsp; ",str_replace($web_root. $root_dir. $media_dir. "/","",$retArray[$ctr])).
					'</td>'.
				'</tr>'. "\n";
				$i = ++$i % 2;			
			}
		}
		echo "</table><br>";
		
		// Now let's show them the playlist footer
		displayPlaylistFooter($playList, $ctr, $i);
		
		// Now let's show them the footer
		displayFooter();
	}
	
	function displayPlaylistFooter($playList="", $ctr=0, $i=0){
		global $main_table_width, $song_cellpadding, $word_check_all, $word_check_none, $img_delete,
		$word_delete, $shoutcast, $img_play, $word_create_shoutcast_playlist, $word_playlist, 
		$word_create_shoutcast_random_playlist, $word_session_playlist,
		$web_root, $root_dir, $playlist_directory, $img_playlist, $row_colors, $playlist_ext, 
		$postnuke, $word_grab_url, $word_play, $this_page, $word_send_playlist, $this_site, $jinzora_url, $site_title, $url_seperator;
		
		// Now let's show them the options at the bottom
		// Now let's set a hidden form field to hold the data for the click
		echo '<input type="hidden" name="submitAction" value="viewplaylist">';
		// Now let's set a field to hold the name of the list we're working on
		if ($_POST['editlistname'] <> ""){
			echo '<input type="hidden" name="editlistname" value="'. $_POST['editlistname']. '">';
		} else {
			echo '<input type="hidden" name="editlistname" value="'. $playList. '">';
		}
		// Now let's set a field with the number of checkboxes that were here
		echo '<input type="hidden" name="numboxes" value="'. $ctr. '">';
				
		// Now let's show our last row for all the other options
		echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $song_cellpadding. '" cellspacing="0" border="0">'.
				'<tr class="'. $row_colors[$i]. '">'.
					'<td width="70%" class="jz_track_table_songs_td">'.
						"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick=\"CheckBoxes('trackForm',true);\">". $word_check_all. '</a>'.
						' | '. 
						"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick=\"CheckBoxes('trackForm',false);\">". $word_check_none. '</a>'. 
						'&nbsp;&nbsp;';
						// Let's make sure they are an admin
						if ($_SESSION['jz_access_level'] == "admin"){
							echo "&nbsp;&nbsp;<a name=\"delete\" class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"removefromplaylist\";trackForm.submit()';\">". 
							$img_delete. '</a> '. 
							" <a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"removefromplaylist\";trackForm.submit()';\">". $word_delete. ' '. $word_selected. "</a>".
							
							"&nbsp;&nbsp;<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"deleteplaylist\";trackForm.submit()';\">".
							$img_delete. '</a> '. 
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"deleteplaylist\";trackForm.submit()';\">". $word_delete. ' '. $word_playlist. "</a>";							
						}
						
						// Now let's let them play this playlist
						$playListName = str_replace(".". $playlist_ext,"",$playList);
						echo "&nbsp;&nbsp;<a class=\"jz_track_table_songs_href\" href='mailto:?subject=Jinzora%20Playlist - $playListName&body=You have been sent a Jinzora Playlist, enjoy!%0D%0A%0D%0ATo play this playlist simply click on the link below:%0D%0A". $this_site. $this_page. urlencode($url_seperator). "playlist=". urlencode($playList). "%0D%0A%0D%0A%0D%0AGenerated by ". $site_title. "%0D%0A". $jinzora_url. "'\">". $img_play. '</a>';
						echo "&nbsp;<a class=\"jz_track_table_songs_href\" href='mailto:?subject=Jinzora%20Playlist - $playListName&body=You have been sent a Jinzora Playlist, enjoy!%0D%0A%0D%0ATo play this playlist simply click on the link below:%0D%0A". $this_site. $this_page. urlencode($url_seperator). "playlist=". urlencode($playList). "%0D%0A%0D%0A%0D%0AGenerated by ". $site_title. "%0D%0A". $jinzora_url. "'\">". $word_send_playlist. '</a>';
						
						// Now let's see if they are doing Shoutcast or not
						if ($shoutcast == "true" and $_SESSION['jz_access_level'] == "admin" and $_SERVER['OS'] <> "Windows_NT"){
							echo "<br><a name=\"delete\" class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"createShoutcast\";trackForm.submit()';\">". 
							$img_play. '</a>'. 
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"createShoutcast\";trackForm.submit()';\">". $word_create_shoutcast_playlist. "</a>".
							"&nbsp;&nbsp;<a name=\"delete\" class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"createShoutcastRandom\";trackForm.submit()';\">". 
							$img_play. '</a>'. 
							"<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"createShoutcastRandom\";trackForm.submit()';\">". $word_create_shoutcast_random_playlist. "</a>";							
						}
				echo '</td>'.
					'<td width="30%" class="jz_track_table_songs_td" align="right">';
						// Now let's build the URL for the playlist
					echo ' <select name="playListToPlay" class="jz_select">';
						// First let's select the one they are looking at
						echo '<option value="sessionplaylist">'. $word_session_playlist. '</option>';
						// Now let's get all the other playlists that exist
						$retArray = readDirInfo($web_root. $root_dir. $playlist_directory, "file");
						for ($ctr=0; $ctr < count($retArray); $ctr++){
							// Let's make sure we're looking at a playlist file
							if (preg_match("/\.($playlist_ext)$/i", $retArray[$ctr])) {
								$optionDisp = str_replace(".". $playlist_ext, "",$retArray[$ctr]);
								if (strlen($optionDisp) > 15){
									$optionDisp = substr($optionDisp,0,15). "...";
								}
								// Now let's display the option and make it look pretty
								// Let's also check and see if it is the playlist we are looking at and if so select it!
								if ($retArray[$ctr] == $playList){ $selected = "selected"; } else { $selected = ""; }
								echo '<option '. $selected. ' value="'. $retArray[$ctr]. '">'. $optionDisp. '</option>';
							}
						}
						echo '</select> '.
						"&nbsp;&nbsp;<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"viewplaylist\";trackForm.submit()';\">". $img_playlist. '</a>'. 
						"&nbsp;&nbsp;<a class=\"jz_track_table_songs_href\" style=\"cursor:hand\" onClick='trackForm.submitAction.value=\"playplaylist\";trackForm.submit()';\">". $img_play. '</a>&nbsp;&nbsp;'. 
					'</td>'.					
				'</tr>'.			
		'</table></form><br>';
	}
?>
