<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *    
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the "general" related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
		
	// This function takes a directory and get's all sub directories and files and puts them in an array
	function readAllDirs($dirName, &$readCtr, &$mainArray){
		global $audio_types, $video_types;
		
		// Let's up the max_execution_time
		ini_set('max_execution_time','600');
		
		// Let's look at the directory we are in		
		if (is_dir($dirName)){
			$d = dir($dirName);
			while($entry = $d->read()) {
				// Let's make sure we are seeing real directories
				if ($entry == "." || $entry == "..") { continue;}
				
				// Now let's see if we are looking at a directory or not
				if (filetype($dirName. "/". $entry) <> "file"){
					// Ok, that was a dir, so let's move to the next directory down
					readAllDirs($dirName. "/". $entry, $readCtr, $mainArray);
				} else {
					// Ok, we found files, let's make sure they are audio or video files
					if (preg_match("/\.($audio_types)$/i", $entry) or preg_match("/\.($video_types)$/i", $entry) ) {
						$mainArray[$readCtr] = $dirName. "/". $entry;
						$readCtr++;
					}
				}			
			}
			// Now let's close the directory
			$d->close();
			
			// Now let's sort that array
			@sort($mainArray);
		}		
		// Ok, let's return the data
		return $mainArray;
	}
	
	// This function makes sure that the variable is TOTALLY clean of slashes
	function jzstripslashes($variable){
		// Lets loop through until the variable is clean
		while (stristr($variable,"\\") <> ""){
			$variable = stripslashes($variable);
		}
		
		while (stristr($variable,"//") <> ""){
			$variable = str_replace("//","/",($variable));
		}
		// Now let's send the clean variable back
		return $variable;
	}

	/* This function reads the directory specifed and returns the results into a sorted array */
	function readDirInfo($dirName, $type){
	
		// Let's up the max_execution_time
		ini_set('max_execution_time','600');
		
		$ctr = 0;
		$retArray[0] = "";
		/* let's change the directory name based on the number of directories to search */	
		// First let's make sure this is really a dir...
		if (is_dir($dirName)){
			$d = dir($dirName);
			while($entry = $d->read()) {
				/* Let's make sure this isn't the local directory we're looking at */
				if ($entry == "." || $entry == "..") { continue;}
				
				/* Let's see if they wanted to look for a directory or not */
				if ($type == "dir"){
					if (filetype($dirName. "/". $entry) == "dir" or filetype($dirName. "/". $entry) == "link"){
						/* Now let's create an array so we can sort the Genres for display */
						$retArray[$ctr] = $entry;
						$ctr = $ctr + 1;
					}
				}
				if ($type == "file"){
					if (stristr($entry,".") <> ""){
						/* Now let's create an array so we can sort the Genres for display */
						$retArray[$ctr] = $entry;
						$ctr++;
					}
				}
			}
			$d->close();
			/* Let's make sure we found something, and if we didn't let's not sort an empty array */
			if (count($retArray) <> 0){
				/* Now let's sort the array */
				sort($retArray);
			}
		}
		
		/* Now let's return the array to them */
		return $retArray;
	}

	/* This function creates a zip file for easy downloading */
	function createZipFile(){
		global $this_site, $mp3_dir, $temp_zip_dir, $web_root, $path_to_zip, 
		$jinzora_temp_dir, $root_dir, $media_dir, $audio_types, $video_types, 
		$ext_graphic, $slash_vars;
		
		// Let's up the max_execution_time
		ini_set('max_execution_time','600');
		
		// let's create the zip file using the built in zlib module
		// First we'll look at all the files in the directory they selected
		$archive = new zipfile;
		
		// Now let's see if they wanted a single song or not
		if ($_GET['ztype'] <> "song"){
			$searchDir = $web_root. $root_dir. $media_dir. "/". $_GET['info'];
			$retArray = readDirInfo($searchDir,"file");
			// Now we'll loop through adding each file as we go...
			for ($ctr=0; $ctr < count($retArray); $ctr++){
				$file = $searchDir. "/". $retArray[$ctr];
				$file_size = filesize($file);
				$handle = fopen($file, "rb");
				$file_data = fread($handle, $file_size);
				fclose($handle);
				
				// Now let's add the data to the archive
				$archive->add_file($file_data,$retArray[$ctr]);
				unset($file_data);
			}
		} else {
			$file = $web_root. $root_dir. $media_dir. "/". $_GET['info'];
			$file_size = filesize($file);
			$fp = fopen($file, "rb");
			$file_data = fread($fp, $file_size);
			fclose($fp);
			
			// Now let's figure out the actual file name
			$fileNameArray = explode("/",$_GET['info']);
			
			// Now let's add the data to the archive
			$archive->add_file($file_data,$fileNameArray[count($fileNameArray)-1]);
		}		
		
		// Now let's figure out what we'll name this file...
		$zipFileName = $_GET['info'];
		// Now let's replace the slashes with dashes...
		$zipFileName = str_replace("/","-",$zipFileName);
		
		// Now that we've got the data, let's send them the file!
		header("Content-type: application/zip");
		header('Content-Disposition: inline; filename="'. $zipFileName. '.zip"');
		echo $archive->file();
		
		exit();
	}
	

	/* This will open the display as a PostNuke module */
	function openPostNuke(){
		global $bgcolor1, $bgcolor2, $phpnuke, $default_access,
		$web_root, $root_dir, $jinzora_temp_dir, $cms_user_access;
		
		if (!defined("LOADED_AS_MODULE") and $phpnuke == "false") {
		 	die ("You can't access this file directly...<br><br>Generally this means that Jinzora was ".
				 "installed as a PostNuke module and you're trying to access it outside of PostNuke");
		}	
		
		// Let's see if the cookie has been set, but check that it shouldn't have changed
		if (isset($_COOKIE['jz_user_name'])){
			if ($phpnuke == "false"){
				if (pnUserGetVar('uname') <> $_COOKIE['jz_user_name']){
					if (pnUserGetVar('uname') == "" and $_COOKIE['jz_user_name'] == "anonymous"){} else {;
						unset($_COOKIE['jz_user_name']);
						unset($_SESSION['jz_access_level']);
					}
				}
			} else {
				$cookie = cookiedecode($_COOKIE['user']);
				$username = $cookie[1];
				if ($username == ""){
					$username = "anonymous";
				}
				if ($username <> $_COOKIE['jz_user_name']){
					unset($_COOKIE['jz_user_name']);
					unset($_SESSION['jz_access_level']);
				}
			}
		}
		
		// Let's set how long the cookie will last
		// TO DO: Make this a variable
		$expire = time()+60*60*24*365;
			
		// Now let's get the users name IF we need it
		if ($phpnuke == "false"){
			if (pnUserGetVar('uname') <> ""){
				setcookie ("jz_user_name", pnUserGetVar('uname'), $expire, "/","",0);
				// Ok, they've logged into the CMS, so let's set their access level
				$_SESSION['jz_access_level'] = $cms_user_access;
			} else {
				setcookie ("jz_user_name", "anonymous", $expire, "/","",0);
			}
		} else {
			$cookie = cookiedecode($_COOKIE['user']);
			$username = $cookie[1];
			if ($username == ""){
				$username = "anonymous";
			}
			setcookie ("jz_user_name", $username, $expire, "/","",0); 
			if ($username <> "anonymous"){
				// Ok, they've logged into the CMS, so let's set their access level
				$_SESSION['jz_access_level'] = $cms_user_access;
			}
		}
		
		// Now let's set the default access level IF it isn't
		if (!isset($_SESSION['jz_access_level'])){
			$_SESSION['jz_access_level'] = $default_access;
		}
		
		// Now let's get their access level
		include_once($web_root. $root_dir. '/users.php');
		
		/* Now let's parse the user array to find the correct user, match their password, and get their admin level */
		$ctr = 0;
		while (count($user_array) > $ctr){
			if (strtolower($_COOKIE['jz_user_name']) == strtolower($user_array[$ctr][0])){
				/* Ok, we have a match on the username, let's see if it's the right password */
				// First let's make sure we need to change it or not
				if (!isset($_SESSION['jz_access_level'])){
					$_SESSION['jz_access_level'] = $default_access;
					echo '<meta http-equiv="refresh" content="0">';
					exit();
				} else {
					// Ok, it was set, but is it right???
					if ($_SESSION['jz_access_level'] <> $user_array[$ctr][2]){
						$_SESSION['jz_access_level'] = $user_array[$ctr][2];
					}
				}
			}
			/* Let's move to the next item in the array */
			$ctr = $ctr + 1;
		}
		
		// Now let's make sure the cookie is set, and if not refresh
		if (!isset($_COOKIE['jz_user_name'])){
			echo "";
			echo '<meta http-equiv="refresh" content="0">';
			exit();
		}
		
		include_once("header.php");
		
		$bgc02 = ($postnuke) ? $bgcolor4 : $bgcolor2;
		echo "$submit<style type=\"text/css\">" .
			".jz_row1 { background-color:$bgcolor1; }.jz_row2 { background-color:$bgc02; }</style>";
		
		OpenTable();
	}

	/* This will close the display as a PostNuke module */	
	function closePostNuke(){
		CloseTable();
		include_once("footer.php");		
	}
	
	function check_for_numerics($str) {
		for ($i = 0; $i < strlen($str); $i++) {
			if (is_numeric($str[$i]))
			{
			return (boolean) TRUE;
			}
		}
	}
	
	// This function will write out error messages to the log files...
	function writeLogData($logName, $data){
		global $web_root, $root_dir, $jinzora_temp_dir;
		
		// Let's see what file they wanted to open and open it up!
		if ($logName == "error"){
			$fileName = $web_root. $root_dir. $jinzora_temp_dir. "/jinzora-error.log";
			$handle = fopen ($fileName, "a");
			$data = date("n/j/y g:i:s",time()). " - ". $data. "\n";
			fwrite($handle,$data);				
			fclose($handle);			
		}
	}
	
	/* This function will resize the JPEG's we pass into the site for us and produce PNG's */
	function resizeImage($source_image, $destination_image, $destination_width, $destination_height){
		global $keep_porportions;
		
		// First we need to see if GD is installed or not...
		ob_start();
		phpinfo(INFO_MODULES);
		$gd=ob_get_contents();
		ob_end_clean();
		if (stristr($gd, 'GD Version') == ""){
			// Ok, no GD, let's write that to the log...
			writeLogData('error','Sorry, GD Libraries not found while trying to resize an image...');
			return false;
		}
		
		/* get the picture and set the output picture */
		$image = $source_image;
		$new_image = $destination_image;
		
		/* Let's grab the source image that was uploaded to work with it */
		$src_img = @imagecreatefromjpeg($image);
		
		if ($src_img <> ""){
			/* Let's get the width and height of the source image */
			$src_width = imagesx($src_img); $src_height = imagesy($src_img);
			
			/* Let's set the width and height of the new image we'll create */
			$dest_width = $destination_width; $dest_height = $destination_height;
			
			/* Now if the picture isn't a standard resolution (like 640x480) we
			   need to find out what the new image size will be by figuring
			   out which of the two numbers is higher and using that as the scale */
			// First let's make sure they wanted to keep the porportions or not
			if ($keep_porportions == "true"){
				if ($src_width > $src_height){
					/* ok so the width is the bigger number so the width doesn't change
					   We need to figure out the percent of change by dividing the source width
					   by the dest width */
					$scale = $src_width / $destination_width;
					$dest_height = $src_height / $scale;
				} else {
					/* ok so the width is the bigger number so the width doesn't change
					   We need to figure out the percent of change by dividing the source width
					   by the dest width */
					$scale = $src_height / $destination_height;
					$dest_width = $src_width / $scale;
				}
			} else {
				$dest_height = $destination_height;
				$dest_width = $destination_width;
			}
					
			/* Now let's create our destination image with our new height/width */		
			$dest_img = imagecreate($dest_width,$dest_height);
			
			/* Now let's copy the data from the old picture to the new one witht the new settings */
			imagecopyresized($dest_img, $src_img, 0, 0, 0 ,0, $dest_width, $dest_height, $src_width, $src_height);
			
			/* Now let's create our new image */
			@imagejpeg($dest_img, $new_image);
			
			/* Now let's clean up all our temp images */
			imagedestroy($src_img);
			imagedestroy($dest_img);
			
			return true;
		} else {
			return false;
		}
	}	
	
	// This function will search Google for album art
	function albumArtSearch($info){
		global $word_search_results, $word_download, $this_page, $web_root, $root_dir, $jinzora_temp_dir,
		$artist_truncate, $album_name_truncate, $directory_level, $url_seperator;
		
		// First let's show the page header
		displayHeader($word_search_results);
		
		// Let's setup our contents variable for later
		$contents = "";
		
		// First let's make sure there aren't any blanks in the search feild
		// That would be where there are 6 | symbols....
		$info = str_replace("||||||","|||",urldecode($info));
		
		// Now let's parse out the artist and album info
		$infoArray = explode("|||",$info);
		
		// Now let's read the last two entries, that will be the arist and album name
		// We'll also wrap them in quotes for our search later
		$searchData1 = $infoArray[count($infoArray) - 2];
		$searchData2 = $infoArray[count($infoArray) - 1];
		$searchData3 = $infoArray[count($infoArray) - 3];

		// Let's directly open Google to get the data
		$fp = fsockopen('images.google.com',80);
		$path = '/images?as_q='. urlencode($searchData1. '" "'. $searchData2. '"'). '&svnum=10&hl=en&ie=UTF-8&oe=UTF-8&btnG=Google+Search&as_epq=&as_oq=&as_eq=&imgsz=&as_filetype=jpg&imgc=&as_sitesearch=&safe=off';
		fputs($fp, "GET $path HTTP/1.1\n");
		fputs($fp, "Content-type: application/x-www-form-urlencoded\n");		
		fputs($fp, "Connection: close\n\n");
		
		// Now let's read all the data
		while (!feof($fp))
			$contents .= fgets($fp,128);
		fclose($fp);
		
		// Ok, now that we have all the contents we need to parse it out
		$contents = substr($contents,strpos($contents, " Search took"),100000000);
		$contents = substr($contents,strpos($contents, "<img "),10000000);
	
		// Let's fix the path to the images
		$contents = str_replace("src=/image","src=http://images.google.com/image",$contents);
		
		// Let's go into a loop until there are no more images left
		$imgTest = "1";
		$ctr = 0;
		while ($imgTest <> 0){
			// Let's strip out the image tag
			$fulImgTag = substr($contents,0,strpos($contents,"</a>"));
			$fulImgTag = substr($fulImgTag,9,100000);
			$image[$ctr] = substr($fulImgTag,0,strpos($fulImgTag," "));
			$contents = substr($contents,10,100000);
			$contents = substr($contents,strpos($contents,"<img src"),100000);
			$imgTest = strpos($contents,"img");
			$ctr++;
			if ($ctr == 13){
				$imgTest = 0;
			}
		}
		
		// Let's setup a form for below
		// Let's see if they wanted to return to the tools page or not
		if (isset($_GET['return'])){
			echo '<form action="'. $this_page. $url_seperator. 'return='. $_GET['return']. '" method="post">';
		} else {
			echo '<form action="'. $this_page. '" method="post">';
		}
		echo '<input type="hidden" name="albumArtInfo" value="'. str_replace("|||","/",$_GET['info']). '">';
		
		// Now let's tell them what they searched for
		$infoArray = explode("|||",$_GET['info']);
		if ($directory_level == "3"){
			echo '<center><strong>';
			if ($searchData3 <> ""){
				echo $searchData3 . " | ";
			}
			echo $searchData1. "<br>". $searchData2. "</strong><br><br></center>";
		}
		if ($directory_level == "2"){
			echo '<center><strong>'. $infoArray[1]. "<br>". $infoArray[2]. "</strong><br><br></center>";
		}		
		
		// Now let's setup our table for below
		echo '<table width="100%" cellspacing="0" cellpadding="0" border="0">';
		
		// Ok let's loop through the images we found
		$ctr = 0;
		$ctr2 = 2;
		$artFound = false;
		while (count($image) > $ctr){
			// Let's make sure it wasn't one of the default google images and that it really is a .jpg or .jpeg file
			if (strpos($image[$ctr],"res") == 0 and strpos($image[$ctr],".jp") <> 0){
				// Now that we've found images let's display them
				if ($ctr2 == 2){
					$ctr2 = 0;
					echo "</tr><tr>";
				} else {
					$ctr2 = $ctr2 + 1;
				}
				echo '<td width="33%" align="center">';
				echo '<img src="'. $image[$ctr]. '?'. time(). '" border="0"><br>'.
					 '<input type="hidden" name="image-'. $ctr. '" value="'. str_replace("http://images.google.com/images?","",$image[$ctr]). '"><br><input type="submit" name="saveimage-'. $ctr. '" value="'. $word_download. '" class="jz_submit"><br><br>';
				echo '</td>';	
				$artFound = true;
			}
			// Let's increment our counter
			$ctr++;
		}
		// Let's close our table
		echo '</table>';

		// Let's increment the counter for below
		$ctr++;
		
		// Let's get the title for the image
		$titleArray = explode("|||",$_GET['info']);
		$artistName = $titleArray[count($titleArray)-2];
		$albumName = $titleArray[count($titleArray)-1];
		if (strlen($artistName) > $artist_truncate){
			$artistName = substr($titleArray[count($titleArray)-2],0,$artist_truncate);
			$artistName = $artistName. "...";
		}
		if (strlen($albumName) > $album_name_truncate){
			$albumName = substr($titleArray[count($titleArray)-1],0,$album_name_truncate);
			$albumName = $albumName. "...";
		}		
		
		$title = $artistName. "\n\n". $albumName;
		
		// Now let's create our blank image
		if (createBlankImage($web_root. $root_dir. "/style/images/default.jpg", 5, $title, "0 255 0", "0 0 0", 0, 100, "center", "center") == true){
			// Now let's give them a blank, default one
			// Now let's setup our table for below
			echo '<table width="100%" cellspacing="0" cellpadding="0" border="0">'.
					'<tr><td width="100%" align="center">'.
						'<img src="'. $root_dir. $jinzora_temp_dir. '/temp-image.jpg?'. time(). '" border="0"><br>'.
						'<input type="hidden" name="defaultimage" value="DEFAULT"><br>'.
						'<input type="submit" name="savedefault" value="'. $word_download. '" class="jz_submit"><br><br><br>'.
					'</td></tr></table>'.
			'</form>';		
		} else {
			echo '<table width="100%" cellspacing="0" cellpadding="0" border="0">'.
					'<tr><td width="100%" align="center">'.
						'Sorry, there was an error getting any images...<br><br>'.
					'</td></tr></table>'.
			'</form>';	
		}
	}
	
	
	function createBlankImage($image, $font, $text, $color, $shadow, $drop, $maxwidth, $alignment, $valign, $padding="5"){
		global $web_root, $root_dir, $jinzora_temp_dir;
		
		// First we need to see if GD is installed or not...
		ob_start();
		phpinfo(INFO_MODULES);
		$gd=ob_get_contents();
		ob_end_clean();
		if (stristr($gd, 'GD Version') == ""){
			// Ok, no GD, let's write that to the log...
			writeLogData('error','Sorry, GD Libraries not found while trying to grab an image from google');
			return false;
		}
		
		/* Now let's create our destination image with our new height/width */		
		$src_img = imagecreatefromjpeg($image);
		$dest_img = imagecreate($maxwidth,$maxwidth);		
		$color = imagecolorallocate($dest_img, 255, 255, 255);
		
		/* Now let's copy the data from the old picture to the new one witht the new settings */
		imagecopyresized($dest_img, $src_img, 0, 0, 0 ,0, $maxwidth, $maxwidth, $maxwidth, $maxwidth);
	
		$fontwidth = ImageFontWidth($font);
		$fontheight = ImageFontHeight($font);
		
		$margin = floor($padding + $drop)/2; // So that shadow is not off image on right align & bottom valign
		
		if ($maxwidth != NULL) {
		$maxcharsperline = floor( ($maxwidth - ($margin * 2)) / $fontwidth);
		$text = wordwrap($text, $maxcharsperline, "\n", 1);
		}
		
		$lines = explode("\n", $text);
		
		switch($valign){
		
		 case "center":
		  $y = (imageSY($dest_img) - ($fontheight * sizeof($lines)))/2;
		  break;
		
		 case "bottom":
		  $y = imageSY($dest_img) - (($fontheight * sizeof($lines)) + $margin);
		  break;
		
		 default:
		  $y = $margin;
		  break;
		}
		
		switch($alignment){
			 case "right":
			   while (list($numl, $line) = each($lines)) {
					 ImageString($dest_img, $font, (imagesx($dest_img) - $fontwidth*strlen($line))-$margin+$drop, ($y+$drop), $line, $shadow);
					 ImageString($dest_img, $font, (imagesx($dest_img) - $fontwidth*strlen($line))-$margin, $y, $line, $color);
					 $y += $fontheight;
			   }
			 break;
			
			 case "center":
			   while (list($numl, $line) = each($lines)) {
					 ImageString($dest_img, $font, floor((imagesx($dest_img) - $fontwidth*strlen($line))/2)+$drop, ($y+$drop), $line, $shadow);
					 ImageString($dest_img, $font, floor((imagesx($dest_img) - $fontwidth*strlen($line))/2), $y, $line, $color);
					 $y += $fontheight;
			   }
			 break;
			
			 default:
			   while (list($numl, $line) = each($lines)) {
				ImageString($dest_img, $font, $margin+$drop, ($y+$drop), $line, $shadow);
				ImageString($dest_img, $font, $margin, $y, $line, $color);
				$y += $fontheight;
			   }
			 break;
			}
		
		/* Now let's create our new image */
		$new_image = $web_root. $root_dir. $jinzora_temp_dir. "/temp-image.jpg";
		imagejpeg($dest_img, $new_image);
		
		/* Now let's clean up all our temp images */
		imagedestroy($src_img);
		imagedestroy($dest_img);
		
		return true;
	}
	
	// This function actaully gets and saves the selectd album art
	function grabAlbumArt(){
		global $web_root, $root_dir, $media_dir, $this_page, $this_site, $jinzora_temp_dir, $url_seperator;
			
		// Let's loop through and find which one they clicked on
		$found = false;
		$ctr = 0;
		$contents = "";
		while ($found <> true){
			// Let's first see if they pressed the DEFAULT button or not
			if (isset($_POST['savedefault'])){
				// Let's see if they wanted the default image
				// Now let's copy that image into place
				$fileInfo = explode("/", $_POST['albumArtInfo']);
				$imgName = $fileInfo[count($fileInfo)-1];
				$finalFile = $web_root. $root_dir. $media_dir. "/". $_POST['albumArtInfo']. "/". $imgName. ".jpg";
				$sourceFile = $web_root. $root_dir. $jinzora_temp_dir. "/temp-image.jpg";
				// Let's make sure the old file didn't exist
				@unlink($finalFile);			
				// Now let's copy the source into place
				copy ($sourceFile, $finalFile);
				$found = "true";
			} else {
				if (isset($_POST["saveimage-". $ctr])){
					// Ok we found the button they pressed				
					$found = true;				
					
					// Ok, let's get the full filename and path to the new file we'll create
					$fileInfo = explode("/", $_POST['albumArtInfo']);
					$imgName = $fileInfo[count($fileInfo)-1];
					$fileName = $web_root. $root_dir. $media_dir. "/". $_POST['albumArtInfo']. "/". $imgName. ".jpg";
						
					// Now let's open Google and get the contents of the image
					$fp = fsockopen('images.google.com',80);
					$path = '/images?'. $_POST["image-". $ctr];
					fputs($fp, "GET $path HTTP/1.0\n");
					//fputs($fp, "Host: $host\n");
					fputs($fp, "Connection: close\n\n");
					
					$blnHeader = true;
					while (!feof($fp)){
						if ($blnHeader) {
							if (fgets($fp,1024) == "\r\n"){
								$blnHeader = false;
							}
							//echo fgets($fp,1024). "<br>";
						} else {
							$contents .= fread($fp,1024);
						}	
					}
					fclose($fp);
					
					// Let's make sure the old file didn't exist
					@unlink($fileName);
					
					// Now that we have the data, let's write it to the new file
					if (!file_exists($fileName)){
						@touch($fileName);
					}
					if (is_writable($fileName)) {
						$handle = fopen ($fileName, "w");
						fwrite($handle,$contents);				
						fclose($handle);			
					}
				}
			}
			$ctr = $ctr + 1;
		}
		
		// Ok, now that we're done let's send them back to where they started
		$locdata = explode("/",$_POST['albumArtInfo']);
		// Let's make sure we get data for each
		if ($locdata[count($locdata)-3] <> "") { $genre = $locdata[count($locdata)-3]; } else { $genre = "/";}
		if ($locdata[count($locdata)-2] <> "") { $artist = $locdata[count($locdata)-2]; } else { $artist = "/";}
		if ($locdata[count($locdata)-1] <> "") { $album = $locdata[count($locdata)-1]; } else { $album = "/";}

		// Now let's figure out where to send them back to
		if (isset($_GET['return'])){
			if ($_GET['return'] == "tool"){
				header("Location: ". $this_site. $this_page. $url_seperator. 'ptype=tools&action=searchforart');
			}
			if ($_GET['return'] == "artist"){
				header("Location: ". $this_site. $this_page. $url_seperator. 'ptype=artist&genre='. urlencode($genre). '&artist='. urlencode($artist));
			}
			if ($_GET['return'] == "songs"){
				header("Location: ". $this_site. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($genre). '&artist='. urlencode($artist). '&album='. urlencode($album));
			}
		} else {
			header("Location: ". $this_site. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($genre). '&artist='. urlencode($artist). '&album='. urlencode($album));
		}

	}
	
	
	// This function will resize the album images
	function jzResizeAlbum($dirToSearch, $artistImage){
		global $album_img_width, $album_img_height, $img_height;
			
		// Now let's see if the artist image needs to be resized
		if ($album_img_width <> "0" and $album_img_height <> "0"){
			// Now let's get the image dimensions and see if it needs resizing
			$imgFile = $dirToSearch. "/". $artistImage;
			$imgDst = $dirToSearch. "/". $artistImage. ".new";
			$imgDim = getimagesize($imgFile);
			$imgWidth = $imgDim[0];
			$imgHeight = $imgDim[1];
			
			
			// Now let's see if either is bigger or smaller than what we want
			if ($imgHeight <> $img_height){
				// Ok, we need to change the height of the image
				if (resizeImage($imgFile, $imgDst, $album_img_width, $album_img_height) == true){
					// Now let's delete the old image file if it exists
					if (is_file($imgFile. ".old")){
						unlink($imgFile. ".old");				
					}
					// Now let's backup the old file
					@rename ($imgFile, $imgFile. ".old");
					// Now let's put the new file in place
					@rename ($imgDst, $imgFile);						
				}
			}
		}
	}
	
	// This function will resize the artist images
	function jzResizeArtist($dirToSearch, $Image){
		global $artist_img_width, $artist_img_height;
			
		// Now let's see if the artist image needs to be resized
		if ($artist_img_width <> "0" and $artist_img_height <> "0"){
			// Now let's get the image dimensions and see if it needs resizing
			$imgFile = $dirToSearch. "/". $Image;
			$imgDst = $dirToSearch. "/". $Image. ".new";
			$imgDim = getimagesize($imgFile);
			$imgWidth = $imgDim[0];
			$imgHeight = $imgDim[1];	
			
			// Now let's see if either is bigger or smaller than what we want
			if ($imgHeight <> $artist_img_height){
				// Ok, we need to change the height of the image
				if (resizeImage($imgFile, $imgDst, $artist_img_width, $artist_img_height) == true){
					// Now let's backup the old file
					@rename ($imgFile, $imgFile. ".old");
					// Now let's put the new file in place
					@rename ($imgDst, $imgFile);
				}						
			}
		}
	}
	
	// This function looks to see if we can find any media where we are, and if we can display it
	function lookForMedia($dirToLookIn){
		global $audio_types, $video_types, $audio_types, $video_types, $ext_graphic, $img_play, $img_download, 
		$get_mp3_info, $song_cellpadding, $row_colors, $main_table_width, $this_page, $word_play_album, $word_download_album,
		$root_dir, $media_dir, $this_site, $allow_download, $track_num_seperator, $directory_level, $web_root, 
		$num_other_albums, $word_album, $album_name_truncate, $word_play, $img_more, $search_album_art, 
		$word_search_for_album_art, $img_delete, $word_cancel, $word_delete, $word_are_you_sure_delete, $img_add, 
		$img_playlist, $word_check_all, $word_check_none, $word_selected, $word_session_playlist, 
		$word_new_playlist, $playlist_directory, $playlist_ext, $word_play_random, $img_random_play, $javascript, 
		$get_mp3_info, $colapse_tracks, $jinzora_skin, $word_search, $amg_search, $hide_tracks, $word_hide_tracks, 
		$word_show_tracks, $postnuke, $download_mp3_only, $this_site, $word_change_art, $album_force_height, $album_force_width,
		$hide_id3_comments, $img_more_dis, $img_play_dis, $img_download_dis, $url_seperator, $enable_ratings, $img_rate, 
		$img_star, $img_half_star, $num_top_ratings, $num_suggestions, $enable_suggestions;

		// Ok, let's read that directory so we can see what's there
		$retArray = readDirInfo($dirToLookIn, "file");
		
		// Let's look at what we got back
		$media_found = false;
		for ($ctr=0; $ctr < count($retArray); $ctr++){
			// Now let's make sure it's a media file
			if (preg_match("/\.($audio_types)$/i", $retArray[$ctr]) or preg_match("/\.($video_types)$/i", $retArray[$ctr])) {
				// Ok, we found stuff, let's set our variable for later
				$media_found = true;
			}
		}
		// Now let's include the top tracks IF they wanted it
		if ($enable_ratings == "true"){
			switch ($directory_level) {
				case "3" : # 3 directories deep
					if ($_GET['ptype'] <> "genre" and $_GET['ptype'] <> "artist" and $_GET['ptype'] <> "songs"){
						include_once('toptracks.php');
					}
				break;
				
				case "2" : # 2 directories deep
					if ($_GET['ptype'] <> "artist" and $_GET['ptype'] <> "songs"){
						include_once('toptracks.php');
					}
				break;
				
				case "1" : # 1 directories deep
					if ($_GET['ptype'] <> "songs"){
						include_once('toptracks.php');
					}
				break;
			}
		}
		
		// Now let's see if we found media above
		if ($media_found == true){
			// Ok, we found media, so let's display it in the songs table
			displaySongs(false);
			return "true";
		} else {
			return "false";
		}
	}
	
	function deleteSelected(){
		global $web_root;
		
		// Ok, first we need to loop through what they selected
		$numBoxes = $_POST['numboxes'];
		$ctr = 0;
		$ctr2 = 0;		
		while ($numBoxes > $ctr){
			// Now let's see what they selected
			if (isset($_POST['track-'. $ctr])){
				// Ok, now we've got the tracks, let's create an array for them
				// First we need to make sure that there are no double slashes, so we'll loop through and kill them
				$trackPath = $_POST['track-'. $ctr];
				while (strpos($trackPath,"//") <> 0){
					$trackPath = str_replace("//","/",$trackPath);
				}
				$trackArray[$ctr2] = $web_root. $trackPath;
				$ctr2 = $ctr + 1;
			}
			$ctr = $ctr + 1;
		}
		
		// Now let's sort the array
		if (count($trackArray) <> 0){
			sort($trackArray);
		}
		
		// Now let's delete what we found
		$ctr = 0;
		while (count($trackArray) > $ctr){
			// Alright, let's do it!
			unlink($trackArray[$ctr]);
			$ctr = $ctr + 1;
		}
		
	}
	
	// This function removes items from a playlist
	function deleteFromPlaylist($listName){
		global $web_root, $root_dir, $playlist_directory, $playlist_ext;
		
		// Let's see if they wanted to open the session playlist for editing or not
		if ($listName == "sessionplaylist"){
			$contents = $_SESSION['sessionPlaylist'];
		} else {
			// Ok, now we need to read the old list into an array first
			$filename = $web_root. $root_dir. $playlist_directory. "/". $listName;
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
		}
		
		// Now let's create an array out of that
		$contArray = explode("\n",$contents);
		
		// Ok, now let's go through this array and remove any blank items
		$ctr = 0;
		$ctr2 = 0;
		while (count($contArray) > $ctr){
			if ($contArray[$ctr] <> ""){
				$oldArray[$ctr2] = $contArray[$ctr];
				$ctr2++;
			}
			$ctr++;
		}
		
		// Ok, now we have that array, we need to get an array with what they wanted to kill
		$ctr = 0;
		$ctr2 = 0;
		$numBoxes = $_POST['numboxes'];
		while ($numBoxes > $ctr){
			// Now let's see what they selected
			if ($_POST['track-'. $ctr] <> ""){
				// Ok, now we've got the tracks, let's create an array for them
				// First we need to make sure that there are no double slashes, so we'll loop through and kill them
				$trackPath = $_POST['track-'. $ctr];
				while (strpos($trackPath,"//") <> 0){
					$trackPath = str_replace("//","/",$trackPath);
				}
				$delArray[$ctr2] = $trackPath;
				$ctr2 = $ctr2 + 1;
			}
			$ctr = $ctr + 1;
		}

		// Now let's remove stuff from the original array so we can rewrite the file
		$finalArray = array_values(array_diff($oldArray, $delArray));		
		
		// Let's again make sure they aren't editing the session playlist or not
		if ($listName == "sessionplaylist"){
			// First let's kill the old session list
			$_SESSION['sessionPlaylist'] = "";
			$ctr = 0;
			while (count($finalArray) > $ctr){
				$_SESSION['sessionPlaylist'] .= $finalArray[$ctr]. "\n";
				$ctr = $ctr + 1;
			}
		} else {
			// Let's open the file for writing
			$handle = fopen ($filename, "w");
			$ctr = 0;
			while (count($finalArray) > $ctr){
				fwrite($handle,$finalArray[$ctr]. "\n");
				$ctr = $ctr + 1;
			}
			// Now let's close the file
			fclose($handle);
		}
		
		// Now let's return to where we were...
		displayPlaylists($listName);
		exit();
	}
	
	// This function deletes a playlist
	function deletePlaylist($playlist){
		global $web_root, $root_dir, $playlist_directory;
		
		// Let's see if it's the session playlist or not
		if ($playlist == "sessionplaylist"){
			$_SESSION['sessionPlaylist'] = "";
		} else {
			// Ok, they wanted to kill it, so let's kill it!
			unlink ($web_root. $root_dir. $playlist_directory. "/". $playlist);
		}
	}
	
	function returnGenres() {
		return array(
			0   => 'Blues',
			1   => 'Classic Rock',
			2   => 'Country',
			3   => 'Dance',
			4   => 'Disco',
			5   => 'Funk',
			6   => 'Grunge',
			7   => 'Hip-Hop',
			8   => 'Jazz',
			9   => 'Metal',
			10  => 'New Age',
			11  => 'Oldies',
			12  => 'Other',
			13  => 'Pop',
			14  => 'R&B',
			15  => 'Rap',
			16  => 'Reggae',
			17  => 'Rock',
			18  => 'Techno',
			19  => 'Industrial',
			20  => 'Alternative',
			21  => 'Ska',
			22  => 'Death Metal',
			23  => 'Pranks',
			24  => 'Soundtrack',
			25  => 'Euro-Techno',
			26  => 'Ambient',
			27  => 'Trip-Hop',
			28  => 'Vocal',
			29  => 'Jazz+Funk',
			30  => 'Fusion',
			31  => 'Trance',
			32  => 'Classical',
			33  => 'Instrumental',
			34  => 'Acid',
			35  => 'House',
			36  => 'Game',
			37  => 'Sound Clip',
			38  => 'Gospel',
			39  => 'Noise',
			40  => 'Alternative Rock',
			41  => 'Bass',
			42  => 'Soul',
			43  => 'Punk',
			44  => 'Space',
			45  => 'Meditative',
			46  => 'Instrumental Pop',
			47  => 'Instrumental Rock',
			48  => 'Ethnic',
			49  => 'Gothic',
			50  => 'Darkwave',
			51  => 'Techno-Industrial',
			52  => 'Electronic',
			53  => 'Pop-Folk',
			54  => 'Eurodance',
			55  => 'Dream',
			56  => 'Southern Rock',
			57  => 'Comedy',
			58  => 'Cult',
			59  => 'Gangsta',
			60  => 'Top 40',
			61  => 'Christian Rap',
			62  => 'Pop/Funk',
			63  => 'Jungle',
			64  => 'Native US',
			65  => 'Cabaret',
			66  => 'New Wave',
			67  => 'Psychadelic',
			68  => 'Rave',
			69  => 'Showtunes',
			70  => 'Trailer',
			71  => 'Lo-Fi',
			72  => 'Tribal',
			73  => 'Acid Punk',
			74  => 'Acid Jazz',
			75  => 'Polka',
			76  => 'Retro',
			77  => 'Musical',
			78  => 'Rock & Roll',
			79  => 'Hard Rock',
			80  => 'Folk',
			81  => 'Folk-Rock',
			82  => 'National Folk',
			83  => 'Swing',
			84  => 'Fast Fusion',
			85  => 'Bebob',
			86  => 'Latin',
			87  => 'Revival',
			88  => 'Celtic',
			89  => 'Bluegrass',
			90  => 'Avantgarde',
			91  => 'Gothic Rock',
			92  => 'Progressive Rock',
			93  => 'Psychedelic Rock',
			94  => 'Symphonic Rock',
			95  => 'Slow Rock',
			96  => 'Big Band',
			97  => 'Chorus',
			98  => 'Easy Listening',
			99  => 'Acoustic',
			100 => 'Humour',
			101 => 'Speech',
			102 => 'Chanson',
			103 => 'Opera',
			104 => 'Chamber Music',
			105 => 'Sonata',
			106 => 'Symphony',
			107 => 'Booty Bass',
			108 => 'Primus',
			109 => 'Porn Groove',
			110 => 'Satire',
			111 => 'Slow Jam',
			112 => 'Club',
			113 => 'Tango',
			114 => 'Samba',
			115 => 'Folklore',
			116 => 'Ballad',
			117 => 'Power Ballad',
			118 => 'Rhytmic Soul',
			119 => 'Freestyle',
			120 => 'Duet',
			121 => 'Punk Rock',
			122 => 'Drum Solo',
			123 => 'Acapella',
			124 => 'Euro-House',
			125 => 'Dance Hall',
			126 => 'Goa',
			127 => 'Drum & Bass',
			128 => 'Club-House',
			129 => 'Hardcore',
			130 => 'Terror',
			131 => 'Indie',
			132 => 'BritPop',
			133 => 'Negerpunk',
			134 => 'Polsk Punk',
			135 => 'Beat',
			136 => 'Christian Gangsta Rap',
			137 => 'Heavy Metal',
			138 => 'Black Metal',
			139 => 'Crossover',
			140 => 'Contemporary Christian',
			141 => 'Christian Rock',
			142 => 'Merengue',
			143 => 'Salsa',
			144 => 'Trash Metal',
			145 => 'Anime',
			146 => 'Jpop',
			147 => 'Synthpop'
			);
	} 
	
	function deldir($dir){
		$current_dir = opendir($dir);
		while($entryname = readdir($current_dir)){
			if(is_dir("$dir/$entryname") and ($entryname != "." and $entryname!="..")){
				deldir("${dir}/${entryname}");
			}elseif($entryname != "." and $entryname!=".."){
				unlink("${dir}/${entryname}");
			}
		}
		closedir($current_dir);
		rmdir(${dir});
	}
	
	
	// This fucntion reads and finds any excluded content
	function readExcludeFile ($file){
		if (is_file($file)){
			// Ok, there is a file so let's read it, ok?
			$handle = fopen ($file, "rb");
			$contents = fread ($handle, filesize ($file));
			fclose ($handle);
			
			// Now let's build an array out of the file
			$excludeArray = explode("\n", $contents);
			
			return $excludeArray;
		}
	}
	
	// This function creates the caching data for faster access
	function createFileCaches($update="false", $recreate="false"){
		global $web_root, $root_dir, $media_dir, $jinzora_temp_dir, $directory_level, 
		$new_days, $postnuke, $use_cache_file;
		
		// First let's see if they were using a cached file
		if ($use_cache_file == "true"){
			$read_file_cache = "true";
			// Now let's see if the files are there, and if so open them, if not we'll create them
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/album_list.lst")){ $read_file_cache = "false"; }
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/artist_list.lst")){ $read_file_cache = "false"; }
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/genre_list.lst")){ $read_file_cache = "false"; }
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/album_only_list.lst")){ $read_file_cache = "false"; }
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/artist_only_list.lst")){ $read_file_cache = "false"; }
			if (!is_file($web_root. $root_dir. $jinzora_temp_dir. "/complete_list.lst")){ $read_file_cache = "false"; }
			
			// Now let's see if the files are there and if so let's read them
			if ($read_file_cache == "true"){
				// Ok, all the files were there, so let's read them in
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/album_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['album_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/artist_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['artist_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/genre_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['genre_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/album_only_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['album_only_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/artist_only_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['artist_only_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$filename = $web_root. $root_dir. $jinzora_temp_dir. "/complete_list.lst";
				$handle = fopen ($filename, "rb");
				$_SESSION['complete_list'] = fread ($handle, filesize ($filename));
				fclose ($handle);
				$update = "false";
			} else {
				$update = "true";
			}
		}
		
		// Let's make sure we need to update this before we do
		if (!isset($_SESSION['album_list']) or $update == "true" or $recreate == "true"){
			// First let's clear the session variables
			$_SESSION['album_list'] = "";
			$_SESSION['artist_list'] = "";
			$_SESSION['genre_list'] = "";
			$_SESSION['album_only_list'] = "";
			$_SESSION['artist_only_list'] = "";
			$_SESSION['complete_list'] = "";
			
			// Now let's initalize these variables
			$album_list = ""; $artist_list = ""; $genre_list = ""; $album_only_list = ""; $artist_only_list = ""; $complete_list = "";
			
			// First we need to read the directories to create the file info
			$topDir = $web_root. $root_dir. $media_dir;
			$topArray = readDirInfo($topDir, "dir");				
			
			// Let's loop through the array and write the data
			for ($ctr=0; $ctr < count($topArray); $ctr++){
				if ($topArray[$ctr] <> ""){
					// Now let's write the data to our toplevel file
					if ($directory_level == "3"){
						$genre_list .= rawurlencode($topArray[$ctr]). "\n";
					}
					if ($directory_level == "2"){
						$artist_list .= rawurlencode($topArray[$ctr]). "\n";	
					}
					if ($directory_level == "1"){
						$album_list .= rawurlencode($topArray[$ctr]). "\n";	
					}					
					
					// Now let's go through that array and create the next level down
					$secondArray = readDirInfo($topDir. "/". $topArray[$ctr], "dir");
					for ($ctr2=0; $ctr2 < count($secondArray); $ctr2++){
						if ($secondArray[$ctr2] <> ""){
							if ($directory_level == "3"){
								$artist_list .= rawurlencode($secondArray[$ctr2]). "--". rawurlencode($topArray[$ctr]). "\n";
								$artist_only_list .= "--". rawurlencode($topArray[$ctr]. "--");
							}
							if ($directory_level == "2"){
								$album_list .= rawurlencode($secondArray[$ctr2]). "--". rawurlencode($topArray[$ctr]). "\n";
								$album_only_list .= rawurlencode($topArray[$ctr]);								
							}
							// Now let's go one directory deeper
							$thirdArray = readDirInfo($topDir. "/". $topArray[$ctr]. "/". $secondArray[$ctr2], "dir");
							for ($ctr3=0; $ctr3 < count($thirdArray); $ctr3++){
								if ($thirdArray[$ctr3] <> ""){
									if ($directory_level == "3" and $thirdArray[$ctr3] <> ""){
										$album_list .= rawurlencode($thirdArray[$ctr3]). "--". rawurlencode($topArray[$ctr]). "--". rawurlencode($secondArray[$ctr2]). "\n";
										$album_only_list .= rawurlencode($topArray[$ctr]). "--". rawurlencode($secondArray[$ctr2]). "\n";
									}
								}
							}
						}
					}				
				}	
			}		
			
			// Now let's get a complete listing of all files...
			$readCtr = 0; $complete_list = "";
			$mainArray = readAllDirs($web_root. $root_dir. $media_dir, $readCtr, $mainArray);
			for ($ctr=0; $ctr < count($mainArray); $ctr++){
				$complete_list .= str_replace("/","----",str_replace($web_root. $root_dir. $media_dir. "/", "",$mainArray[$ctr])). "\n";
			}
			
			// Now let's update the file caches, if they wanted us to!
			if ($use_cache_file == "true"){
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/album_list.lst", "w");
				fwrite($handle,$album_list);				
				fclose($handle);
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/artist_list.lst", "w");
				fwrite($handle,$artist_list);				
				fclose($handle);
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/genre_list.lst", "w");
				fwrite($handle,$genre_list);				
				fclose($handle);
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/album_only_list.lst", "w");
				fwrite($handle,$album_only_list);				
				fclose($handle);
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/artist_only_list.lst", "w");
				fwrite($handle,$artist_only_list);				
				fclose($handle);
				$handle = fopen ($web_root. $root_dir. $jinzora_temp_dir. "/complete_list.lst", "w");
				fwrite($handle,$complete_list);				
				fclose($handle);
				$_SESSION['album_list'] = $album_list;
				$_SESSION['artist_list'] = $artist_list;
				$_SESSION['genre_list'] = $genre_list;
				$_SESSION['album_only_list'] = $album_only_list;
				$_SESSION['artist_only_list'] = $artist_only_list;
				$_SESSION['complete_list'] = $complete_list;
			} else {
				// Now let's set everything
				$_SESSION['album_list'] = $album_list;
				$_SESSION['artist_list'] = $artist_list;
				$_SESSION['genre_list'] = $genre_list;
				$_SESSION['album_only_list'] = $album_only_list;
				$_SESSION['artist_only_list'] = $artist_only_list;
				$_SESSION['complete_list'] = $complete_list;
			}
		}
	}
		
	// This function displays links for all the missing album art
	function searchForAlbumArt(){
		global $web_root, $root_dir, $media_dir, $this_page, $ext_graphic, $this_site, $module_name, $postnuke, $url_seperator;
		
		if ($postnuke <> "false"){
			include("settings.php");
			include("system.php");
			$this_page = "/modules.php?op=modload&name=". $_GET['name']. "&file=index";
		}
		
		// First let's see if the cache has been created or not
		if (!isset($_SESSION['album_list'])){
			createFileCaches(true);
		}

		// First let's search through using the album session variable
		$searchArray = explode("\n", urldecode($_SESSION['album_list']));		

		for ($ctr=0; $ctr < count($searchArray); $ctr++){
			$found = "no";
			$pathArray = explode("--",$searchArray[$ctr]);
			// Let's make sure there is something to read
			if ($pathArray[0] == ""){
				// Ok, we're done let's return to the tools and let them know
				header("Location: ". $this_site. $this_page. $url_seperator. "ptype=tools");
				exit();		
			}
			// Now let's search for the data
			$retArray = readDirInfo($web_root. $root_dir. $media_dir. "/". $pathArray[1]. "/". $pathArray[2]. "/". $pathArray[0], "file");
			for ($i=0; $i < count($retArray); $i++){
				if (preg_match("/\.($ext_graphic)$/i", $retArray[$i])) {
					$found = "yes";				
				}
			}
			
			// Now let's see if that file exists and if not we'll show a link to the search
			if ($found == "no"){
				// Now let's send them to this one
				header("Location: ". $this_site. $this_page. $url_seperator. "ptype=artsearch&info=". urlencode($pathArray[1]). "|||". urlencode($pathArray[2]). "|||". urlencode($pathArray[0]). '&return=tool');		
				exit();
			}
		}
	}
	
	// This function tries to get 1 album cover automatically for the user
	function autoSearchArt($info){
		global $web_root, $root_dir, $media_dir, $jinzora_temp_dir;
		
		// Ok, let's search for the 1 item
		// Let's setup our contents variable for later
		$contents = "";
		
		// Now let's parse out the artist and album info
		$infoArray = explode("|||",urldecode($info));
		
		// Now let's read the last two entries, that will be the arist and album name
		// We'll also wrap them in quotes for our search later
		$albctr = count($infoArray) - 1;
		$artctr = count($infoArray) - 2;
				
		// Let's directly open Google to get the data
		$fp = fsockopen('images.google.com',80);
		$path = '/images?as_q='. urlencode($infoArray[$artctr]. '" "'. $infoArray[$albctr]. '"'). '&svnum=10&hl=en&ie=UTF-8&oe=UTF-8&btnG=Google+Search&as_epq=&as_oq=&as_eq=&imgsz=&as_filetype=jpg&imgc=&as_sitesearch=&safe=off';
		fputs($fp, "GET $path HTTP/1.1\n");
		fputs($fp, "Content-type: application/x-www-form-urlencoded\n");		
		fputs($fp, "Connection: close\n\n");
		
		while (!feof($fp))
			$contents .= fgets($fp,128);
		fclose($fp);		
			
		// Ok, now that we have all the contents we need to parse it out
		$contents = substr($contents,strpos($contents, " search button"),1000000);
		$contents = substr($contents,strpos($contents, "<img "),100000);
	
		// Let's fix the path to the images
		$contents = str_replace("src=/image","src=http://images.google.com/image",$contents);
		
		// Let's go into a loop until there are no more images left
		$imgTest = "1";
		$ctr = 0;
		while ($imgTest <> 0){
			// Let's strip out the image tag
			$fulImgTag = substr($contents,0,strpos($contents,"</a>"));
			$fulImgTag = substr($fulImgTag,9,100000);
			$image[$ctr] = substr($fulImgTag,0,strpos($fulImgTag," "));
			$contents = substr($contents,10,100000);
			$contents = substr($contents,strpos($contents,"<img src"),100000);
			$imgTest = strpos($contents,"img");
			$ctr = $ctr + 1;
			if ($ctr == 13){
				$imgTest = 0;
			}
		}
		
		// Ok let's loop through the images we found
		$ctr = 0;
		$ctr2 = 2;
		$artFound = false;
		while (count($image) > $ctr){
			// Let's make sure it wasn't one of the default google images and that it really is a .jpg or .jpeg file
			if (strpos($image[$ctr],"res") == 0 and strpos($image[$ctr],".jp") <> 0 and $artFound == false){
				$img_src = str_replace("http://images.google.com/images?","",$image[$ctr]);
				$artFound = true;
			}
			// Let's increment our counter
			$ctr = $ctr + 1;
		}
		
		// Now let's make sure we got something back, and if not we'll create a default one
		if ($artFound <> true){
			// Ok, let's give them the default image
			$imgNameArray = explode("|||",$info);
			$imgName = $imgNameArray[count($imgNameArray)-1];
			// Now let's get the title			
			$title = urldecode(str_replace("|||","\n\n",$info));
			// Now let's create the default image
			createBlankImage($web_root. $root_dir. "/style/images/default.jpg", 5, $title, "0 255 0", "0 0 0", 0, 100, "center", "center");
			// Now let's copy the new image into place
			copy ($web_root. $root_dir. $jinzora_temp_dir. "/temp-image.jpg", $web_root. $root_dir. $media_dir. "/". urldecode($_GET['genre']). "/". urldecode(str_replace("|||","/",$info)). "/". $imgName. ".jpg");
			// Now let's delete the image we created
			unlink ($web_root. $root_dir. $jinzora_temp_dir. "/temp-image.jpg");
		} else {		
			// Now let's save the one we got back
			$imgNameArray = explode("|||",$info);
			$imgName = $imgNameArray[count($imgNameArray)-1];
			$fileName = $web_root. $root_dir. $media_dir. "/". urldecode($_GET['genre']). "/". urldecode(str_replace("|||","/",$info). "/". $imgName. ".jpg");
			
			// Now let's open Google and get the contents of the image
			$fp = fsockopen('images.google.com',80);
			$path = '/images?'. $img_src;
			fputs($fp, "GET $path HTTP/1.0\n");
			fputs($fp, "Connection: close\n\n");
			
			// Let's clear out our variable
			$contents = "";
			
			$blnHeader = true;
			while (!feof($fp)){
				if ($blnHeader) {
					if (fgets($fp,1024) == "\r\n"){
						$blnHeader = false;
					}
				} else {
					$contents .= fread($fp,1024);
				}	
			}
			fclose($fp);
			
			// Now that we have the data, let's write it to the new file
			$handle = fopen ($fileName, "w");
			fwrite($handle,$contents);				
			fclose($handle);
		}
	}
	
	
	
	
	
	
	
	
	
?>
