<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *        
	* JINZORA | Web-based Media Streamer   
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the Genre/Artist display related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	/* This function displays all the Genres or Artists */
	function displayColumns($dirToLookIn){
		global $cols_in_genre, $cellspacing, $this_page, $img_play, $artist_truncate, 
		$main_table_width, $img_random_play, $word_genres, $mp3_dir, 
		$directory_level, $word_artist, $word_album, $web_root, $root_dir, $jinzora_temp_dir,
		$img_more, $media_dir, $show_sub_numbers, $postnuke, $show_all_checkboxes, 
		$num_rand_albums, $ext_graphic, $img_more_dis, $img_play_dis, $img_random_play_dis, $url_seperator;
		
		// First let's get all the POST and GET variables and clean them up
		$genre = jzstripslashes(urldecode($_GET['genre']));
		$artist = jzstripslashes(urldecode($_GET['artist']));
		$album = jzstripslashes(urldecode($_GET['album']));		
		
		// First let's look and see if there are any sub folders here
		// If not we really should be looking at the song view instead
		$sub_found = "no";
		$dirToLookIn = $web_root. $root_dir. $media_dir. "/". $genre. "/". $artist;
		$retArray = readDirInfo($dirToLookIn, "dir");
		for ($ctr=0; $ctr < count($retArray); $ctr++){
			if ($retArray[$ctr] <> ""){
				$sub_found = "yes";
			}
		}
		
		// Now let's see if we should change page types or not
		if ($sub_found == "no"){
			header("Location: ". $this_page. $url_seperator. "ptype=songs&genre=&artist=&album=". urlencode($_GET['genre']));
			exit();
		}
		
		/* First let's display the header */
		/* Let's see if they are viewing the Genre or not */
		if ($genre <> "" and $genre <> "/"){
			displayHeader($genre);
		} else {
			switch ($directory_level) {
				case "3" : # 3 directories deep
					displayHeader($word_genres);
				break;
				case "2" : # 2 directories deep
					displayHeader($word_artist);
				break;
				case "1" : # 2 directories deep
					displayHeader($word_album);
				break;				
			}
		}

		// Now let's get all the data from our session variables
		if ($_GET['ptype'] == ""){
			if ($directory_level == "3"){
				$retArray = explode("\n",urldecode($_SESSION['genre_list']));
			}
			if ($directory_level == "2"){
				$retArray = explode("\n",urldecode($_SESSION['artist_list']));
			}		
		} else {
			$retArray = readDirInfo($web_root. $root_dir. $media_dir. "/". $_GET['genre'], "dir");
		}

		// Let's see if the user has logged in and if they have any personal exclude files or not
		if (isset($_COOKIE['jz_user_name'])){
			// Ok, now let's see if they have any personal exclude files or not
			$exclude_file = $web_root. $root_dir. $jinzora_temp_dir. "/". $_COOKIE['jz_user_name']. "-exclude.lst";
			$personalExcludeArray = readExcludeFile($exclude_file);
		}
		
		// Now let's see if we have a global exclude file and remove the stuff they don't want to see
		$exclude_file = $web_root. $root_dir. $jinzora_temp_dir. "/global-exclude.lst";
		$globalExcludeArray = readExcludeFile($exclude_file);
		
		// Now let's merge the two arrays
		$excludeArray  = array_merge($personalExcludeArray, $globalExcludeArray);
		
		// Now let's remove our exclusions
		$retArray = array_values(array_diff($retArray,$excludeArray));
		$desc_image_found = "no";
		/* Now let's see if there is a description file for the entire site */
		if ($genre == "" or $genre == "/"){
			$desc_file = $mp3_dir. "/site-description.txt";
			if (is_file($desc_file)){
				/* Ok, it's there so let's open it and display it */
				$filename = $desc_file;
				$handle = fopen ($filename, "rb");
				$contents = fread ($handle, filesize ($filename));
				fclose ($handle);
				echo '<center><span class="j_site_desc">'. $contents. "</span></center><br>";
			}		
		} else {
			// Ok, let's see if there is a description image/file for this Genre
			$desc_image_found = "no";
			$desc_file = $mp3_dir. "/". $_GET['genre']. "/". $_GET['genre']. ".jpg";
			if (is_file($desc_file)){
				echo "HERE";
				//Ok we found a description image
				$desc_image_found = "yes";
			}
			$desc_text_found = "no";
			$contents = "";
			$desc_file = $mp3_dir. "/". $_GET['genre']. "/". $_GET['genre']. ".txt";
			if (is_file($desc_file)){
				//Ok we found a description image
				//So let's open the file and read its contents
				$filename = $desc_file;
				$handle = fopen ($filename, "rb");
				$contents = fread ($handle, filesize ($filename));
				fclose ($handle);
				$desc_text_found = "yes";
			}
			
			// Now let's setup our table for the description of this Genre IF we found something
			if ($desc_image_found == "yes" or $desc_text_found == "yes"){
				echo '<table class="jz_col_table" width="100%" cellpadding="0" cellspacing="0" border="0">'.
						'<tr class="jz_col_table_tr">'.
							'<td align="left" valign="top">';
								if ($desc_image_found == "yes"){
									echo '<img src="'. $root_dir. $media_dir. "/". $_GET['genre']. ".jpg". '" border="0"></td><td width="1%" align="left" valign="top">&nbsp;</td>';
								}
						echo'<td align="left" valign="top">'.
									$contents.
							'</td>'.
						'</tr>'.
					'</table>';
			}
		}
		
		// Ok, now let's see if they wanted some random albums to show...
		if ($num_rand_albums <> "0" and $genre <> ""){
			$c=0;
			$c2=0;
			// Ok, now let's look for some random album art for this Genre
			// Let's use the album_list session variable for this
			$albumArray = explode("\n",urldecode($_SESSION['album_list']));
			// Now let's randomize that array...
			shuffle($albumArray);
			for ($ctr=0; $ctr < count($albumArray); $ctr++){
				if ($albumArray[$ctr] <> "" and stristr($albumArray[$ctr], $genre)){
					// Now let's see if there is art here by first splitting up the values so we can get the path
					$pathArray = explode("--",$albumArray[$ctr]);
					$searchDir = $web_root. $root_dir. $media_dir. "/". urldecode($pathArray[1]). "/". urldecode($pathArray[2]). "/". urldecode($pathArray[0]); 
					$imgArray = readDirInfo($searchDir,"file");
					for ($i=0; $i < count($imgArray); $i++){
						if (preg_match("/\.($ext_graphic)$/i", $imgArray[$i])) {
							if ($c2 < $num_rand_albums){
								$imageArray[$c2] = '<a href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($pathArray[1]). '&artist='. urlencode($pathArray[2]). '&album='. urlencode($pathArray[0]). '"><img src="'. $root_dir. $media_dir. "/". rawurlencode($pathArray[1]). "/". rawurlencode($pathArray[2]). "/". rawurlencode($pathArray[0]). "/". $imgArray[$i]. '?'. time(). '" border="0"></a>';
								$c2++;
							}
							$i = count($imgArray);
						}
					}
					$c++;
				}
			}
			// Now let's display what we found...
			if (count($imageArray <> 0)){
				echo '<table width="100%" cellpadding="0" cellspacing="0" border="0">'.
							'<tr>'.
								'<td width="1%" align="right" valign="middle">';
									for ($ctr=0; $ctr < count($imageArray); $ctr++){
										echo $imageArray[$ctr]. " ";
									}
							echo'</td>'.
							'</tr>'.
						'</table><br>';
			}
		}
		/* Now let's start our table to put the stuff in */
		echo '<table class="jz_col_table_main" width="'. $main_table_width. '%" border="0" cellpadding="'. $cellspacing. '" cellspacing="0">'. "\n";
		echo '<tr class="jz_col_table_tr">'. "\n";

		$ctr = 1;
		$loop_ctr = 0;
		$dir_ctr = 0;
		/* Let's find out how wide the colums will be in percent */
		$col_width = 100 / $cols_in_genre;
		
		/* Let's count how many directories are here so we can build the table */
		while (count($retArray) > $dir_ctr){		
			$dir_ctr++;
		}
		
		// Now let's make sure we don't divide by zero (Thanks flavio!)
		if ($dir_ctr < 1){ $dir_ctr = 1; }
		
		/* Let's make sure we have enough items to fill the number of colums that we wanted (say we wanted 3 cols but we only have 1 item) */
		if ($dir_ctr < $cols_in_genre){
			/* Ok, let's make this a better number */
			$col_width = 100 / $dir_ctr;
		}
		
		/* Now let's figure out how many artists per column */
		/* adding the .49 make sure it always rounds up */
		$folder_per_column = round($dir_ctr / $cols_in_genre + .49,0);
		$first_loop = "";
				
		/* Now let's loop through that array, displaying the Genres */
		while (count($retArray) > $loop_ctr){	
			// Let's make sure that we found albums to display
			if ($retArray[$loop_ctr] <> ""){
				/* Let's count so we know where we are in making the columns */
				/* Then we'll add the links to the sub pages */
				
				if ($ctr == 1){
					if ($first_loop == ""){
						$first_loop = "no";
						echo '<td width="'. $col_width. '%" class=j_artistcols valign=top align="left">';
					} else {
						echo '</td><td width="'. $col_width. '%" class=j_artistcols valign=top align="left">';
					}
				}
				
				/* Let's see if we need to truncate the name */
				$displayItem = $retArray[$loop_ctr];
				if (strlen($displayItem) > $artist_truncate){
					$displayItem = substr($displayItem,0,$artist_truncate). "...";
				}
				
				/* Now let's display the link to play both the entire Genre and a random version of it */
				if ($genre <> ""){
					/* Ok so we are looking at the individual Genre */
					// Now let's see if they wanted to see status for the directories
					if ($show_sub_numbers == "true"){
						// Now let's look at the session variable to get all the matches
						$i = substr_count(urldecode($_SESSION['album_only_list']),"--". $retArray[$loop_ctr]. "\n");

						// let's make sure i isn't 0
						if ($i <> 0){
							$fldr_ctr = " (". $i. ")";
						} else {
							$fldr_ctr = "";
						}
					} else {
						$fldr_ctr = "";
					}
					$link_url = urlencode($genre). "/". urlencode($retArray[$loop_ctr]);			
					
					// Let's setup our form for below
					$formAction = $this_page. $url_seperator. $_SERVER['QUERY_STRING'];
					echo '<form action="'. $formAction. '" name="trackForm" method="POST" onSubmit="return AreYouSure();">';
						
					echo '<table class="jz_col_table" width="100%" cellpadding="0" cellspacing="0" border="0">'.
							'<tr class="jz_col_table_tr">';
								/* Let's make sure this variable is set */
								if (!isset($_SESSION['jz_access_level'])){ $_SESSION['jz_access_level'] = ""; }			
								/* Let's make sure they are not a view only user */
								if ($_SESSION['jz_access_level'] <> "viewonly"){
									// Now let's show them the info button
									echo'<td width="1%" align="left" valign="top">'.										
											'<a class="jz_col_table_href" href="'. $root_dir. '/mp3info.php?type=artist&info='. urlencode($genre). "/". urlencode($retArray[$loop_ctr]). '" target="_blank" onclick="newWindow(this); return false;">'. $img_more. '</a>'.
										'</td>';
									$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=artist&info='. $link_url);
									$play_song_link_rand = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=artist&info='. $link_url);
									echo'<td width="1%" align="left" valign="top">'.										
										'<a class="jz_col_table_href" href="'. $play_song_link. '">'. $img_play. '</a>'.
									'</td>'.
									'<td width="1%" align="left" valign="top">'.
										'<a class="jz_col_table_href" href="'. $play_song_link_rand. '">'. $img_random_play. '</a>'.
									'</td>';
							
								// Let's give them the check box for the playlist addition IF they wanted it
								echo '<td width="1%" valign="top">';
									if ($show_all_checkboxes == "true"){
								   		echo '<input class="jz_checkbox" name="track-'. $loop_ctr. '" type=checkbox value="'. $root_dir. $media_dir. '/'. urlencode($genre). "/". urlencode($retArray[$loop_ctr]). '/">'; 
									} else {
										echo "&nbsp;";
									}
								echo '</td>';
								echo '<td width="1%" valign="top">&nbsp;</td>';
								} else {
									// Ok, they are view only, so let's show them the disabled icons
									echo'<td width="1%" align="left" valign="top">'.										
											$img_more_dis.
										'</td>'.
										'<td width="1%" align="left" valign="top">'.										
											$img_play_dis.
										'</td>'.
										'<td width="1%" align="left" valign="top">'.
											$img_random_play_dis.
										'</td>';
								}
							echo '<td width="96%" valign="top" align="left">';
									// Now we need to see if they are in 3/2 level mode, or just 1 level
									if ($directory_level == "1") {
										echo '<a class="jz_col_table_href" href="'. $this_page. $url_seperator. 'ptype=songs&genre=/&artist=/&album='. urlencode($retArray[$loop_ctr]). '">'. $displayItem. $fldr_ctr. "</a><br>\n";
									} else {
										echo '<a class="jz_col_table_href" href="'. $this_page. $url_seperator. 'ptype=artist&genre='. urlencode($genre). '&artist='. urlencode($retArray[$loop_ctr]). '">'. $displayItem. $fldr_ctr. "</a><br>\n";
									}
									/* Ok, let's see if there is a description file for this section */
									$desc_file = $mp3_dir. "/". $_GET['genre']. "/". $retArray[$loop_ctr]. ".txt";
									if (is_file($desc_file)){
										/* Ok, it's there so let's open it and display it */
										$filename = $desc_file;
										$handle = fopen ($filename, "rb");
										$contents = fread ($handle, filesize ($filename));
										fclose ($handle);
										echo $contents. "<br>";
									}
									
							echo '</td>'.
							'</tr>'.
						'</table>';					 
				 } else {
					/* Ok, so we are looking at the top level */
					// Now let's see if they wanted to see status for the directories
					if ($show_sub_numbers == "true"){
						// Now let's look at the session variable to get all the matches
						switch ($directory_level) {
							case "3" : # This if for 3 dir mode
								$i = substr_count(urldecode($_SESSION['artist_only_list']),"--". $retArray[$loop_ctr]. "--");

							break;
							case "2" : # This if for 3 dir mode
								$i = substr_count(urldecode($_SESSION['album_only_list']),"--". $retArray[$loop_ctr]. "--");
							break;
						}
						if ($i <> 0){  
							$fldr_ctr = " (". $i. ")";
						} else {
							$fldr_ctr = "";
						}
					} else {
						$fldr_ctr = "";
					}
					$link_url = urlencode($retArray[$loop_ctr]);
					
					// Let's setup our form for below
					$formAction = $this_page. $_SERVER['QUERY_STRING'];
					echo '<form action="'. $formAction. '" name="trackForm" method="POST" onSubmit="return AreYouSure();">';
		
					echo '<table width="100%" cellpadding="0" cellspacing="0" border="0" class="jz_col_table">'.
							'<tr class="jz_col_table_tr">';
								/* Let's see if they are only a viewing user or not */
								if ($_SESSION['jz_access_level'] <> "viewonly"){
									// Now let's show them the info button
									echo'<td width="1%" align="left" valign="top">'.										
											'<a class="jz_col_table_href" href="'. $root_dir. '/mp3info.php?type=genre&info='. urlencode($genre). "/". urlencode($retArray[$loop_ctr]). '" target="_blank" onclick="newWindow(this); return false;">'. $img_more. '</a>'.
										'</td>';										
									$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=artist&info='. $link_url);
									$play_song_link_rand = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=artist&info='. $link_url);
									echo'<td width="1%" align="left" valign="top">'.	
											'<a class="jz_col_table_href" href="'. $play_song_link. '">'.$img_play. '</a>'.
										'</td>'.
										'<td width="1%" align="left" valign="top">'.
											'<a class="jz_col_table_href" href="'. $play_song_link_rand. '">'. $img_random_play. '</a>'.
										'</td>';
								} else {
									// Ok, they are view only, so let's show them the disabled icons
									echo'<td width="1%" align="left" valign="top">'.										
											$img_more_dis.
										'</td>'.
										'<td width="1%" align="left" valign="top">'.										
											$img_play_dis.
										'</td>'.
										'<td width="1%" align="left" valign="top">'.
											$img_random_play_dis.
										'</td>';
								}
								// Let's give them the check box for the playlist addition IF they wanted it
								if ($show_all_checkboxes == "true"){
									echo '<td width="1%" valign="top">';
									echo '<input class="jz_checkbox" name="track-'. $loop_ctr. '" type=checkbox value="'. $root_dir. $media_dir. '/'. urlencode($retArray[$loop_ctr]). '/">'; 
									echo '</td>';
								}
								echo '<td width="1%" valign="top">&nbsp;</td>';
							   echo '<td width="96%" valign="top">';
							   		
									/* Let's see if they are looking at 2 levels or 3 */
									switch ($directory_level) {
										case "3" : # 3 directories deep
											// First let's give them the check box
											echo '<a class="jz_col_table_href" href="'. $this_page. $url_seperator. 'ptype=genre&genre='. urlencode($retArray[$loop_ctr]). '">'. $displayItem. $fldr_ctr. "</a><br>\n";
										break;
										
										case "2" : # 2 directories deep
											echo '<a class="jz_col_table_href" href="'. $this_page. $url_seperator. 'ptype=artist&genre='. urlencode($retArray[$loop_ctr]). '">'. $displayItem. $fldr_ctr. "</a><br>\n";
										break;
										
										case "1" : # 1 directories deep
											echo '<a class="jz_col_table_href" href="'. $this_page. $url_seperator. 'ptype=songs&genre=&artist=&album='. urlencode($retArray[$loop_ctr]). '">'. $displayItem. $fldr_ctr. "</a><br>\n";
										break;									
									}
									/* Ok, let's see if there is a description file for this section */
									$desc_file = $mp3_dir. "/". $retArray[$loop_ctr]. ".txt";
									if (is_file($desc_file)){
										/* Ok, it's there so let's open it and display it */
										$filename = $desc_file;
										$handle = fopen ($filename, "rb");
										$contents = fread ($handle, filesize ($filename));
										fclose ($handle);
										echo $contents. "<br>";
									}
									
							echo '</td>'.
							'</tr>'.
						'</table>';
				}
				if ($ctr == $folder_per_column){
					$ctr = 1;
				} else {
					$ctr = $ctr + 1;
				}
				
				// This ends the IF statement from about line 117, where we test to see if we found stuff or not
			}
			
			
			$loop_ctr = $loop_ctr + 1;
		}
		
		// Now let's set a hidden form field so we'll know how many boxes there were
		echo '<input type="hidden" name="numboxes" value="'. $loop_ctr. '">';

		/* Now let's close our table */
		echo '</table><br>'. "\n";
		
		// Now let's look and see if there are any songs in this directory that we need to display
		$songsFound = lookForMedia(jzstripslashes(urldecode($dirToLookIn)));
		
		// Now let's show the playlist bar
		displayPlaylistBar($songsFound);
	}
?>