<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *        
	* JINZORA | Web-based Media Streamer    
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the Header and Footer display related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
		
	/* This function adds the header to the top of the pages */
	function displayHeader($title){
		global $this_page, $img_home, $img_blank, $css, $main_table_width,
		$mp3_dir, $quick_list_truncate, $img_random_play, $postnuke, $word_genre, 
		$word_artist, $word_album, $word_tools, $word_search, $word_pleasechoose, 
		$word_login, $random_play_amounts, $word_random_select, $random_play_types, 
		$word_logout, $directory_level, $img_up_arrow, $site_title, $javascript, 
		$word_go_button, $word_home, $header_drops, $genre_drop, $artist_drop, 
		$album_drop, $quick_drop, $root_dir, $this_site, $word_playlist, $web_root,
		$root_dir, $jinzora_temp_dir, $word_show_hidden, $phpnuke, $embedded_header, 
		$show_tools_link, $word_tracks, $song_drop, $audio_types, $video_types, $media_dir, $img_more,
		$img_random_play_dis, $url_seperator, $help_access;
		
		// First let's see if the cache has been created or not
		if (!isset($_SESSION['album_list'])){
			createFileCaches(true);
		}
		
		// First let's get all the POST and GET variables and clean them up
		$genre = jzstripslashes(urldecode($_GET['genre']));
		$artist = jzstripslashes(urldecode($_GET['artist']));
		$album = jzstripslashes(urldecode($_GET['album']));
		
		// Ok, now we need to see if they are embedding this or not
		if ($embedded_header <> ""){
			// Ok, they are embedding, we think anyway
			if (is_file($embedded_header)){
				// Ok, there's a file there so let's include it
				include_once($embedded_header);
			}
		}
				
		/* Let's set the head and a title if we are in standalone mode */
		if ($postnuke == "false" and $embedded_header == ""){
			echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">'.
				 '<html>'.
				 '<head>'.
				 '<link rel="shortcut icon" href="style/favicon.ico" type="image/x-icon" />'.
				 '<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">'.
				 "<title>". $site_title. "</title>";
		}
		
		/* Let's include the javascript */
		echo '<script type="text/javascript" src="'. $root_dir. '/jinzora.js"></script>';
		
		// let's close our head
		if ($postnuke == "false" and $embedded_header == ""){
			echo '</head>';
		}
		
		/* Let's output the style sheets */
		echo $css;
		
		/* Let's initilize some variables */
		$ctr = 0;
		$ctr2 = 0;
		$ctr3 = 0;
		$albumArray = "";
		$genreArray = "";
		$artistArray = "";
		$songArray = "";
		$num_genre = "";
		$num_artist = "";
		$num_album = "";
		$num_song = "";
	
		// Now let's get our arrays from the session content
		if ($directory_level == "3"){
			$genreArray = explode("\n",urldecode($_SESSION['genre_list']));
			$artistArray = explode("\n",urldecode($_SESSION['artist_list']));
			$albumArray = explode("\n",urldecode($_SESSION['album_list']));
			if ($song_drop == "true"){
				$songArray = explode("\n",urldecode($_SESSION['complete_list']));
			}
		}
		if ($directory_level == "2"){
			$genreArray = explode("\n",urldecode($_SESSION['artist_list']));
			$artistArray = explode("\n",urldecode($_SESSION['album_list']));
			if ($song_drop == "true"){
				$songArray = explode("\n",urldecode($_SESSION['complete_list']));
			}
		}
		if ($directory_level == "1"){
			$genreArray = explode("\n",urldecode($_SESSION['album_list']));
			if ($song_drop == "true"){
				$songArray = explode("\n",urldecode($_SESSION['complete_list']));
			}
		}
		
		// Let's see if the user has logged in and if they have any personal exclude files or not
		if (isset($_COOKIE['jz_user_name'])){
			// Ok, now let's see if they have any personal exclude files or not
			$exclude_file = $web_root. $root_dir. $jinzora_temp_dir. "/". $_COOKIE['jz_user_name']. "-exclude.lst";
			$personalExcludeArray = readExcludeFile($exclude_file);
		}
		
		// Now let's see if we have a global exclude file and remove the stuff they don't want to see
		$exclude_file = $web_root. $root_dir. $jinzora_temp_dir. "/global-exclude.lst";
		$globalExcludeArray = readExcludeFile($exclude_file);
		
		// Now let's merge the two arrays
		if (isset($personalExcludeArray) and isset($globalExcludeArray)){
			$excludeArray  = array_merge($personalExcludeArray, $globalExcludeArray);
			// Now let's remove our exclusions
			if ($genre_drop == "true"){
				$genreArray = array_values(array_diff($genreArray,$excludeArray));
			}
			if ($artist_drop == "true"){
				$artistArray = array_values(array_diff($artistArray,$excludeArray));
			}
			if ($album_drop == "true" and $directory_level == "3"){	
				$albumArray = array_values(array_diff($albumArray,$excludeArray));
			}
			if ($song_drop == "true"){
				$songArray  = array_values(array_diff($songArray,$excludeArray));
			}
		} else {
			$excludeArray  = "";
		}

		/* Now let's sort all the arrays that we found, but let's make sure they exist first */
		if ($genreArray <> ""){
			sort ($genreArray);
			$num_genre = count($genreArray) - 1;		
		}
		if ($artistArray <> ""){
			sort ($artistArray);
			$num_artist = count($artistArray) - 1;		
		}
		if ($albumArray <> ""){
			sort ($albumArray);
			$num_album = count($albumArray) - 1;		
		}
		if ($songArray <> ""){
			// Ok, now let's sort it by the last column
			for ($ctr=0; $ctr < count($songArray); $ctr++){
				$titleArray = explode("----",$songArray[$ctr]);
				$songArray[$ctr] = $titleArray[count($titleArray)-1]. "|||||". $songArray[$ctr];
			}
			sort ($songArray);
			// Ok, now let's put it back
			for ($ctr=0; $ctr < count($songArray); $ctr++){
				$finalArray = explode("|||||",$songArray[$ctr]);
				$songArray[$ctr] = $finalArray[1];
			}
			$num_song = count($songArray) - 1;		
		}

		?>
		<table width="<?php echo $main_table_width; ?>%" cellpadding="0" cellspacing="0" border="0" class="jz_header_table">
			<tr class="jz_header_table_tr">
				<td width="80" class="jz_header_table_outer" valign="top">
					<table width="80" cellpadding="0" cellspacing="0" border="0">
						<tr class="jz_header_table_tr">
							<td width="80">
								<?php
									echo '<a href="'. $this_page. '">'. $img_home. "</a> ";
									/* Let's make sure they are not a view only user */
									if (isset($_SESSION['jz_access_level']) and $_SESSION['jz_access_level'] <> "viewonly"){
										if (($genre) <> ""){
												$link_url = "genre&info=". $genre;
											if ($artist <> ""){
												$link_url = "artist&info=". $genre. "/". $artist;
											}
											if ($album <> ""){
												$link_url = "album&info=". $genre. "/". $artist. "/". $album;
											}
											// Let's see if we are looking at a playlist or not
											if (stristr($title,$word_playlist. ": ") == ""){
												$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype='. $link_url);
												echo '<a href="'. $play_song_link. '">'. $img_random_play. '</a> ';
											}
										} else {
											// Let's see if we are looking at a playlist or not										
											if (stristr($title,$word_playlist. ": ") == ""){
												$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=allgenre">');
												echo '<a href="'. $play_song_link. $img_random_play. '</a> ';
											}
										}
									} else {
										echo $img_random_play_dis. " ";
									}
									
									// Let's setup the link for the help docs IF they have access to it
									if ($help_access == $_SESSION['jz_access_level'] or $help_access == "all"){
										echo '<a href="'. $root_dir. '/docs/help.php" target="_blank" onclick="helpWin(this); return false;">'. $img_more. '</a>';
									}
								?>
							</td>
						</tr>
					</table>
				</td>
				<td width="100%" class="jz_header_table_outer" valign="top">
					<table width="100%" cellpadding="0" cellspacing="0" border="0" height="0">
						<tr class="jz_header_table_tr">
							<td width="50%" align="left" valign="top" class="jz_header_table_td">
								<span class="jz_headerTitle"><?php echo jzstripslashes($title); ?></span>
								<?php
									// Let's see if there is a file that we want to put in the header here
									if (is_file($web_root. $root_dir. $media_dir. "/header.txt")){
										// Ok, let's read that puppy!
										$filename = $web_root. $root_dir. $media_dir. "/header.txt";
										$handle = fopen ($filename, "rb");
										$contents = fread ($handle, filesize ($filename));
										fclose ($handle);
										echo "<br><br>". $contents;
									}
								?>
							</td>
							<td width="50%" align="right" valign="top" class="jz_header_table_td">
							<?php		
								// First let's see if the username is set and if not make it blank
								if (!isset($_COOKIE['jz_user_name'])){ $_COOKIE['jz_user_name'] = ""; }					
								/* Let's see if this is the main page, and if so show some other stuff */
								// Let's see if the user has logged in, and if not let's show that link
								if ($_COOKIE['jz_user_name'] == "anonymous" and $postnuke == "false"){
									echo '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'ptype=login&return='. str_replace("&","||||",str_replace("ptype","ptype",$_SERVER['QUERY_STRING'])). '">'. $word_login. '</a> | ';
								} else {
									// Now let's make sure they aren't in Postnuke/PHPNuke mode
									if ($postnuke <> "true"){
										echo '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'ptype=logout">'. $word_logout. '</a> | ';
									} 
									// Now let's see if they have a exclude file, and if so give them the link to delete it
									if (is_file($web_root. $root_dir. $jinzora_temp_dir. "/". $_COOKIE['jz_user_name']. "-exclude.lst")){
										echo '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'ptype=showhidden">'. $word_show_hidden. '</a> | ';
									}
								}

								/* Now let's see if they've logged in or not and give them the appropriate level of access */
								/* Let's make sure this variable is set */
								if (!isset($_SESSION['jz_access_level'])){ $_SESSION['jz_access_level'] = ""; }
								switch ($_SESSION['jz_access_level']) {
									case "admin" : # Ok, they are an admin
										// let's see if they are in Postnuke Mode and NOT show them this if they are
										echo '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'ptype=tools">'. $word_tools. '</a> | ';	
										?>
										<form action="<?php echo $this_page. $url_seperator. "ptype=search"; ?>" method="post">
											<?php echo $word_search; ?> <input class="jz_input" type="text" name="search" size="15">
											<input class="jz_submit" type="submit" name="searchData" value="<?php echo $word_go_button; ?>">
										</form>		
										<?php
									break;
									
									case "poweruser" : # Ok, they are a power user
										?>
											<form action="<?php echo $this_page. $url_seperator. "ptype=search"; ?>" method="post">
												<?php echo $word_search; ?> <input class="jz_input" type="text" name="search" size="15">
												<input class="jz_submit" type="submit" name="searchData" value="<?php echo $word_go_button; ?>">
											</form>		
										<?php
									break;
									
									case "user" : # Ok, they are a standard user
										?>
											<form action="<?php echo $this_page. $url_seperator. "ptype=search"; ?>" method="post">
												<?php echo $word_search; ?> <input class="jz_input" type="text" name="search" size="15">
												<input class="jz_submit" type="submit" name="searchData" value="<?php echo $word_go_button; ?>">
											</form>
										<?php
									break;
									
									case "viewonly" : # Ok, they are a viewonly user
									break;										
								}
								/* Let's show them some UP arrows */
								?>
								<table width="100%" cellpadding="0" cellspacing="0" border="0">
									<tr>
										<td width="100%" align="right">
											<?php
												// Let's show them the up arrow, unless they are viewing the first page
												if ($_GET['ptype'] <> ""){
													echo $img_up_arrow. " ". '<a class="jz_header_table_href" href="'. $this_page. '">'. $word_home. '</a> ';
												}
												
												/* Now if they are viewing the artist let's show them the next level up arrow */

												if ($_GET['ptype'] == "artist" or $_GET['ptype'] == "songs"){
													/* Now let's set for 1, 2, or 3 level directory structure */
													switch ($directory_level) {
														case "3" : # 3 directories deep
															if ($genre <> ""){
																echo $img_up_arrow. " ". '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'genre='. urlencode($genre). '&ptype=genre">'. jzstripslashes(urldecode($genre)). "</a> ";
															}
														break;
														
														case "2" : # 2 directories deep

														break;
													}
												}
												
												/* Now if they are viewing the album let's show them the next level up arrow */
												if (($_GET['ptype'] == "songs" and $directory_level <> "1") or stristr($artist,"/")){
													if ($artist <> ""){
														// Now we need to eheck for slashes in the data and create the links accordingly...
														if (stristr($artist,"/")){
															// Ok, we found slashes, so we need to create multiple selections here...
															$artistArray = explode("/",$artist);
															$art_link = "";
															for ($ctr=0; $ctr < count($artistArray); $ctr++){
																if ($art_link <> ""){
																	$art_link .= "/". $artistArray[$ctr];
																} else {
																	$art_link .= $artistArray[$ctr];
																}
																echo $img_up_arrow. " ". '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'genre='. urlencode($genre). '&artist='. urlencode($art_link). '&ptype=artist">'. $artistArray[$ctr]. '</a> ';
															}														
														} else {
															echo $img_up_arrow. " ". '<a class="jz_header_table_href" href="'. $this_page. $url_seperator. 'genre='. urlencode($genre). '&artist='. urlencode($artist). '&ptype=artist">'. jzstripslashes(urldecode($artist)). '</a>';
														}
													}
												}
											?>
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<?php
				/* Let's see if they wanted to turn the drop down boxes off */
				if ($header_drops == "true"){
			?>
			<tr class="jz_header_table_tr">
				<td width="100%" class="jz_header_table_outer" valign="top" colspan="2" class="jz_header_table_td">
					<table width="100%" cellpadding="0" cellspacing="0" border="0">
						<tr class="jz_header_table_tr">
							<?php
								// Let's make sure they wanted to see the Genre drop down
								if ($genre_drop == "true"){
							?>
							<td width="20%" class="jz_header_table_td">
								<?php 
									/* Let's see if they are looking at 2 levels or 3 */
									/* Now let's set for 1, 2, or 3 level directory structure */
									switch ($directory_level) {
										case "3" : # 3 directories deep
											echo $word_genre. ": ". $num_genre; 
										break;
										
										case "2" : # 2 directories deep
											echo $word_artist. ": ". $num_genre; 
										break;
										
										case "1" : # 1 directories deep
											echo $word_album. ": ". $num_genre; 
										break;										
									}
								?><br> 
								<form action="<?php echo $this_page; ?>" method="post">
									<?php
										/* Now we need to know if the browser does JavaScript or not */
										if ($javascript == "yes"){
											echo '<select name="genre" onChange="submit()" class="jz_select">';
										} else {
											echo '<select name="genre" class="jz_select">';
										}
									?>
										<option value="" selected><?php echo $word_pleasechoose; ?></option>
										<?php
											for ($ctr=0; $ctr < count($genreArray); $ctr++){
												if ($genreArray[$ctr] <> ""){	
													$title = $genreArray[$ctr];
													if (strlen($title) > $quick_list_truncate){
														$title = substr($title,0,$quick_list_truncate). "...";
													}
													/* Now let's set for 1, 2, or 3 level directory structure */
													switch ($directory_level) {
														case "3" : # 3 directories deep
															echo '<option value="ptype=genre&genre='. urlencode($genreArray[$ctr]). '">'. $title. '</option>';
														break;
														
														case "2" : # 2 directories deep
															echo '<option value="ptype=artist&genre=/&artist='. urlencode($genreArray[$ctr]). '">'. $title. '</option>';
														break;
														
														case "1" : # 1 directories deep
															echo '<option value="ptype=songs&genre=/&artist=/&album='. urlencode($genreArray[$ctr]). '">'. $title. '</option>';
														break;
													}
												}
											}
										?>
									</select>
									<?php
										/* If the browser doesn't do JavaScript let's give them GO buttons */
										if ($javascript == "no"){
											echo '<input class="jz_submit" type="submit" name="submitdata" value="'. $word_go_button. '">';
										}
									?>
								</form>
							</td>
							<?php 
								} # Now let's close the IF statemet from above
							
								/* Let's see if they are looking at 2 levels or 3 */
								if (($directory_level == "3" or $directory_level == "2") and $artist_drop == "true"){
							?>
							<td width="20%" class="jz_header_table_td">
								<?php 
									switch ($directory_level) {
										case "3" : # 3 directories deep
											echo $word_artist. ": ". $num_artist; 
										break;
										
										case "2" : # 2 directories deep
											echo $word_album. ": ". $num_artist; 
										break;
									}
								?><br>
								<form action="<?php echo $this_page; ?>" method="post">
									<?php
										/* Now we need to know if the browser does JavaScript or not */
										if ($javascript == "yes"){
											echo '<select name="artist" onChange="submit()" class="jz_select">';
										} else {
											echo '<select name="artist" class="jz_select">';
										}
									?>
										<option value="" selected><?php echo $word_pleasechoose; ?></option>
										<?php
											for ($ctr=0; $ctr < count($artistArray); $ctr++){
												if ($artistArray[$ctr] <> ""){
													/* Let's check and make sure the title isn't too long */
													$artistDisplay = explode("--",$artistArray[$ctr]);
													$title = $artistDisplay[0];
													if (strlen($title) > $quick_list_truncate){
														$title = substr($title,0,$quick_list_truncate). "...";
													}
													/* Now let's set for 1, 2, or 3 level directory structure */
													switch ($directory_level) {
														case "3" : # 3 directories deep
															echo '<option value="ptype=artist&genre='. urlencode($artistDisplay[1]). '&artist='. urlencode($artistDisplay[0]). '">'. $title. '</option>';
														break;
														
														case "2" : # 2 directories deep
															echo '<option value="ptype=songs&genre=/&artist='. urlencode($artistDisplay[1]). '&album='. urlencode($artistDisplay[0]). '">'. $title. '</option><br>';
														break;													
													}
												}
											}
										?>
									</select>
									<?php
										/* If the browser doesn't do JavaScript let's give them GO buttons */
										if ($javascript == "no"){
											echo '<input class="jz_submit" type="submit" name="submitdata" value="'. $word_go_button. '">';
										}
									?>
								</form>
							</td>
							<?php }	?>
							<?php 
								/* Let's see if they are looking at 2 levels or 3 */
								if ($directory_level == "3" and $album_drop == "true"){
							?>
									<td width="20%" width="25%" class="jz_header_table_td">
										<?php echo $word_album. ": ". $num_album; ?><br>
										<form action="<?php echo $this_page; ?>" method="post">
											<?php
												/* Now we need to know if the browser does JavaScript or not */
												if ($javascript == "yes"){
													echo '<select name="album" onChange="submit()" class="jz_select">';
												} else {
													echo '<select name="album" class="jz_select">';
												}
											?>
												<option value="" selected><?php echo $word_pleasechoose; ?></option>
												<?php
													for ($ctr=0; $ctr < count($albumArray); $ctr++){
														if ($albumArray[$ctr] <> ""){
															/* Let's check and make sure the title isn't too long */
															$albumDisplay = explode("--",$albumArray[$ctr]);
															$title = $albumDisplay[0];
															if (strlen($title) > $quick_list_truncate){
																$title = substr($title,0,$quick_list_truncate). "...";
															}
															echo '<option value="ptype=songs&genre='. urlencode($albumDisplay[1]). '&artist='. urlencode($albumDisplay[2]). '&album='. urlencode($albumDisplay[0]). '">'. $title. '</option>';
														}
													}
												?>
											</select>
											<?php
												/* If the browser doesn't do JavaScript let's give them GO buttons */
												if ($javascript == "no"){
													echo '<input class="jz_submit" type="submit" name="submitdata" value="'. $word_go_button. '">';
												}
											?>
										</form>
									</td>
							<?php } ?>
							
							
							<?php 
								/* Let's see if they are looking at 2 levels or 3 */
								if ($song_drop == "true"){
							?>
									<td width="20%" width="25%" class="jz_header_table_td">
										<?php echo $word_tracks. ": ". $num_song; ?><br>
										<form action="<?php echo $this_page; ?>" method="post">
											<?php
												/* Now we need to know if the browser does JavaScript or not */
												if ($javascript == "yes"){
													echo '<select name="album" onChange="submit()" class="jz_select">';
												} else {
													echo '<select name="album" class="jz_select">';
												}
											?>
												<option value="" selected><?php echo $word_pleasechoose; ?></option>
												<?php
													for ($ctr=0; $ctr < count($songArray); $ctr++){
														if ($songArray[$ctr] <> ""){
															/* Let's check and make sure the title isn't too long */
															$songDisplay = explode("----",str_replace($web_root. $root_dir. $media_dir,"",$songArray[$ctr]));
															$title = $songDisplay[count($songDisplay)-1];
															if (preg_match("/\.($audio_types)$/i", $title) || preg_match("/\.($video_types)$/i", $title)) {
																if (strlen($title) > $quick_list_truncate){
																	$title = substr($title,0,$quick_list_truncate). "...";
																}
																if ($directory_level == "3"){
																	$info = urlencode($songDisplay[count($songDisplay)-4]). "/". urlencode($songDisplay[count($songDisplay)-3]). "/". urlencode($songDisplay[count($songDisplay)-2]). "/". urlencode($songDisplay[count($songDisplay)-1]);
																}
																if ($directory_level == "2"){
																	$info = urlencode($songDisplay[count($songDisplay)-3]). "/". urlencode($songDisplay[count($songDisplay)-2]). "/". urlencode($songDisplay[count($songDisplay)-1]);
																}
																if ($directory_level == "2"){
																	$info = urlencode($songDisplay[count($songDisplay)-2]). "/". urlencode($songDisplay[count($songDisplay)-1]);
																}
																echo '<option value="ptype=quickplay&style=normal&qptype=song&info='. $info. '">'. $title. '</option>';
															}
														}
													}
												?>
											</select>
											<?php
												/* If the browser doesn't do JavaScript let's give them GO buttons */
												if ($javascript == "no"){
													echo '<input class="jz_submit" type="submit" name="submitdata" value="'. $word_go_button. '">';
												}
											?>
										</form>
									</td>
							<?php } ?>
							
							
							<?php if ($quick_drop == "true" and $_SESSION['jz_access_level'] <> "viewonly"){ ?>
								<td width="20%" class="jz_header_table_td">
									<?php echo $word_random_select; ?><br>
									<form action="<?php echo $this_page; ?>" method="post">
										<select name="random_play_number" class="jz_select_sm1">
											<?php
												$random_play = explode("|", $random_play_amounts);
												$ctr = 0;
												while (count($random_play) > $ctr){
													echo '<option value="'. $random_play[$ctr]. '">'. $random_play[$ctr]. '</option>';
													$ctr = $ctr + 1;
												}
											?>

										</select>
										<select name="random_play_type" class="jz_select_sm2">
											<?php
												// Now let' see what we need to remove from the list
												if ($directory_level == "2"){
													// Ok, let's remove "Genre" from the list
													$random_play_types = str_replace("Genres","",$random_play_types);
												}
												if ($directory_level == "1"){
													// Ok, let's remove "Genre" from the list
													$random_play_types = str_replace("Genres","",$random_play_types);
													$random_play_types = str_replace("Artists","",$random_play_types);
												}
												$random_play = explode("|", $random_play_types);
												$ctr = 0;
												while (count($random_play) > $ctr){
													// Let's make sure this isn't blank
													if ($random_play[$ctr] <> ""){
														echo '<option value="'. $random_play[$ctr]. '">'. $random_play[$ctr]. '</option>';
													}
													$ctr = $ctr + 1;
												}
											?>
										</select>
										<input class="jz_submit" type="submit" name="submit_random" value="<?php echo $word_go_button; ?>" class="submit">
									</form>
								</td>
							<?php } ?>
						</tr>
					</table>
				</td>
			</tr>	
			<?php
				// This closes the IF statement for the header drops
				} 
		// This closes our big table above		
		echo '</table><br>';
	}
	
	
	function displayFooter(){
		global $main_table_width, $jinzora_url, $this_pgm, $version, $allow_lang_choice,
				$word_language, $this_page, $web_root, $root_dir, $javascript, $word_go_button,
				$allow_theme_change, $postnuke, $jinzora_skin, $show_loggedin_level, 
				$word_secure_warning, $word_theme, $lang_file, $shoutcast, $sc_refresh,
				$sc_host, $sc_port, $sc_password, $playlist_directory, $embedded_footer, $url_seperator;				
				
		?>
			<table width="<?php echo $main_table_width; ?>%" class="jz_footer_table">
				<tr class="jz_footer_table_tr">
					<td width="<?php echo $main_table_width; ?>%" align="center" class="jz_footer_table_td">
						<br>
						<?php echo '<a class="jz_header_table_href" href="'. $jinzora_url. '">'. $this_pgm. " ". $version. '</a>'; ?>
						<br>
						<?php if ($allow_lang_choice == "true"){ ?>
						<br>
						<?php echo $word_language; ?>
						<form action="<?php echo $this_page; ?>" method="post">
								<?php 
									if ($javascript == "yes"){
										echo '<select name="new_language" onChange="submit()" class="jz_select">';
									} else {
										echo '<select name="new_language" class="jz_select">';
									}
									/* Let's get all the possible languages and display them */
									$lang_dir = $web_root. $root_dir. "/lang";
									$d = dir($lang_dir);
									while($entry = $d->read()) {
										/* Let's make sure this isn't the local directory we're looking at */
										if ($entry == "." || $entry == "..") { continue;}
										if (str_replace(".php","",$entry) == $lang_file){
											echo '<option selected value="'. str_replace(".php","",$entry). '">'. str_replace(".php","",$entry). '</option>';
										} else {
											echo '<option value="'. str_replace(".php","",$entry). '">'. str_replace(".php","",$entry). '</option>';
										}
									}
								?>
							</select>
							<?php 
								if ($javascript == "no"){
									echo '<input class="submit" type="submit" name="submitdata" value="'. $word_go_button. '">';
								}
							?>
						</form>
						<?php } ?>
						<?php 
							/* let's see if they are allowed to change the theme on the fly */
							if ($allow_theme_change == "true"){ 
								echo '<form action="'. $this_page. '" method="post">';
								if ($javascript == "yes"){
									echo $word_theme. ' <select name="new_theme" onChange="submit()" class="jz_select">';
								} else {
									echo $word_theme. ' <select name="new_theme" class="jz_select">';
								}
								/* Ok, now let's get the list of themes from the file system */
								$theme_dir = $web_root. $root_dir. "/style";
								$d = dir($theme_dir);
								while($entry = $d->read()) {
									/* Let's make sure this isn't the local directory we're looking at */
									if ($entry == "." || $entry == ".." || $entry == "favicon.ico" || $entry == "images") { continue;}
									// If this is a postnuke site they don't get to see the theme changer...  sorry, no theme for you!
									if ($entry == "postnuke" and $postnuke == "false") { continue;}
									if ($entry == $jinzora_skin){
										echo '<option selected value="'. $entry. '">'. $entry. '</option>';
									} else {
										echo '<option value="'. $entry. '">'. $entry. '</option>';
									}
								}
								if ($javascript == "yes"){
									echo '</select>';
								} else {
									echo '</select><input type="submit" name="submitdata" value="'. $word_go_button. '">';
								}
								echo '</form>';
							}							

							if ($show_loggedin_level == "true"){
								echo "<br>You are logged in with ". $_SESSION['jz_access_level']. " level access";
							}
							
							/* let's echo one line break to make it look pretty */
							if ($allow_lang_choice == "true" or $allow_theme_change == "true") { echo "<br>&nbsp;"; }
						?>
						<?php
							// Let's show them some shoutcast info
							if ($shoutcast == "true"){
								// Let's put this in a little frame...
								include('sc-stats.php');
							} else {
								echo '<br>&nbsp;';
							}
						?>	
					</td>
				</tr>
			</table>
		<?php	
		// Now let's see if they are embedding and if they wanted a footer
		if ($embedded_footer <> ""){
			// Ok, they want an embedded footer, so let's get to it!
			if (is_file($embedded_footer)){
				// Ok, it's there so freakin' include it!
				include_once($embedded_footer);
			}
		} else {
			// Ok let's close out the HTML for them
			echo '</html>';
		}
	}
?>