<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *   
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s
	* (but can be used for any media file that can stream from HTTP).
	* Jinzora can be integrated into a PostNuke site, run as a standalone application,
	* or integrated into any PHP website.  It is released under the GNU GPL.
	*
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	*
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the "display" related functions
	* Created: 9.24.03 by Frank Zeko jinzora@dogstone.com
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	// Let's modify the include path for Jinzora
	ini_set('include_path','.');
	
	// Let's include the main, user settings file
	include_once('settings.php');
	include_once('system.php');
	include_once('classes.php');
	include_once('general.php');
	include_once('id3classes/getid3.php');
	
	/* Let's include the javascript */
	echo '<script type="text/javascript" src="'. $root_dir. '/jinzora.js"></script>';
	
	// Now let's get the security level of the user
	// Now let's get their access level
	include_once($web_root. $root_dir. '/users.php');
	for ($ctr=0; $ctr < count($user_array); $ctr++){
		if (strtolower($_COOKIE['jz_user_name']) == strtolower($user_array[$ctr][0])){
			/* Ok, we have a match on the username, let's see if it's the right password */
			$_SESSION['jz_access_level'] = $user_array[$ctr][2];
		}
	}
	
	// Let's set the filename from the GET variable
	// We need to decode it from the URL and strip the slashes from it
	if (isset($_GET['file'])){
		$file = stripslashes(urldecode($_GET['file']));
	} else {
		$file = "";
	}
	
	// Now let's see if they wanted to update the track or not
	if (isset($_POST['closeupdate']) or isset($_POST['updatedata'])){
		// Ok, they posted the form, let's update the information for them...
		$file = $_POST['filename'];
		// First let's write the ID3v1 tag
		include_once('id3classes/getid3.id3v1.php');
		include_once('id3classes/getid3.id3v2.php');
		
		// Now let's get all the possible arrays and their values so we can test the right ID3v1 genre
		$genreArray = returnGenres();
		$genreNum = "0";
		for ($i=0; $i < count($genreArray); $i++){
			if (strtolower($_POST['genre']) == strtolower($genreArray[$i])){
				$genreNum = $i;
			}
		}
		WriteID3v1($file, $_POST['trackname'], $_POST['artistname'], $_POST['albumname'], $_POST['year'], $_POST['description'], $genreNum, $_POST['tracknumber']);
		
		// Now let's write the v2 tag
		$data['id3v2']['TIT2']['encodingid']     = 0;
		$data['id3v2']['TIT2']['data']           = $_POST['trackname'];
		$data['id3v2']['TOPE']['encodingid']     = 0;
		$data['id3v2']['TOPE']['data']           = $_POST['artistname'];
		$data['id3v2']['TOAL']['encodingid']     = 0;
		$data['id3v2']['TOAL']['data']           = $_POST['albumname'];
		$data['id3v2']['TIT1']['encodingid']     = 0;
		$data['id3v2']['TIT1']['data']           = $_POST['description'];
		$data['id3v2']['TCON']['encodingid']     = 0;
		$data['id3v2']['TCON']['data']           = $_POST['genre'];
		$data['id3v2']['TRCK']['encodingid']     = 0;
		$data['id3v2']['TRCK']['data']           = $_POST['tracknumber'];
		$data['id3v2']['TYER']['encodingid']     = 0;
		$data['id3v2']['TYER']['data']           = $_POST['year'];
		WriteID3v2($file, $data['id3v2'], 3, 0, true, 0, true);
		
		// Now let's change the file name
		// First we need the path
		$pathArray = explode("/",$_POST['filename']);
		$i = 0;
		while (count($pathArray) > $i){
			if ($pathArray[$i] <> ""){
				if ($i <> count($pathArray)-1){
					$path .= "/". $pathArray[$i];
				}
			}
			$i++;
		}
		$newFile =  $path. "/". $_POST['newfilename'];
		$oldFile = $path. "/". $pathArray[count($pathArray)-1];
		
		// Ok, now let's move the file
		if ($oldFile <> $newFile){
			rename ($oldFile,$newFile);
		}
		
		// Now let's close the window by creating a little javascript function IF they wanted that
		if (isset($_POST['closeupdate'])){
			closeWindow();
			exit();
		}
	}
	
	// Now let's see if they wanted to rate a track or not
	if (isset($_POST['ratetrack'])){
		$client_ip = $_SERVER['REMOTE_ADDR'];
		$rating_file = $web_root. $root_dir. "/ratings/". str_replace("/","---",jzstripslashes($_POST['filename'])). ".rating";
		$new_rating = $_POST['rating'];
		
		// First let's see if this user has rated this file yet or not
		if (is_file($rating_file)){
			$handle = fopen ($rating_file, "rb");
			$contents = fread ($handle, filesize ($rating_file));
			fclose ($handle);
			// Now let's look to see if they've rated it yet
			if (stristr($contents,$_COOKIE['jz_user_name']. "|")){
				$not_rated = "false";
			} else {
				$not_rated = "true";
			}
		} else {
			$not_rated = "true";
		}
		
		// Ok, if they haven't rated it yet, let's
		if ($not_rated == "true"){
			if (!is_file($rating_file)){
				touch($rating_file);
			}
			if (is_writable($rating_file)){
				$handle = fopen ($rating_file, "a");
				fwrite($handle,$client_ip. "|". $new_rating. "|". $_COOKIE['jz_user_name']. "|". str_replace("/","---",jzstripslashes($_POST['filename'])). "\n");				
				fclose($handle);	
			}
		}
		
		closeWindow();
		exit();
	}
	
	// Now let's see if they wanted to close the window or not
	if (isset($_POST['justclose']) or isset($_POST['closealbum'])){
		closeWindow();
		exit();
	}	
	
	// Let's see if they wanted to update a description
	if (isset($_POST['updatedesc'])){
		$fileName = $_POST['filename'];
		$handle = fopen ($fileName, "w");
		fwrite($handle,$_POST['desc_contents']);				
		fclose($handle);	
		
		closeWindow();		
		exit();
	}
	
	// Let's see if they wanted to update a description
	if (isset($_POST['updateartdesc'])){
		$fileName = $_POST['filename'];
		$handle = fopen ($fileName, "w");
		fwrite($handle,$_POST['desc_contents']);				
		fclose($handle);	
		
		$fileName = $_POST['long_file_name'];
		$handle = fopen ($fileName, "w");
		fwrite($handle,$_POST['long_desc']);				
		fclose($handle);	
		
		closeWindow();		
		exit();
	}
	
	// Let's see if they wanted to update a description
	if (isset($_POST['updatealbumdesc'])){
		$fileName = $_POST['desc_filename'];
		$handle = fopen ($fileName, "w");
		fwrite($handle,$_POST['desc_contents']);				
		fclose($handle);	
		
		closeWindow();		
		exit();
	}
	
	// Let's see if they wanted to update a description
	if (isset($_POST['updatesongdesc'])){
		$fileName = $_POST['desc_filename'];
		$handle = fopen ($fileName, "w");
		fwrite($handle,$_POST['long_desc']);				
		fclose($handle);	
		
		closeWindow();		
		exit();
	}
	
	

	// Let's see if they wanted to delete the ablum
	if (isset($_POST['deletealbum'])){
		// Ok, let's kill it, but first let's kill all the files...
		if ($directory_level == "3"){
			$origgenreName = "/". $_POST['origgenreName'];
		} else {
			$origgenreName = "";
		}
		if ($directory_level == "2"){		
			$origartistName = "/". $_POST['origartistName'];
		} else {
			$origartistName = "";
		}
		$origalbumName = "/". $_POST['origalbumName'];
		
		deldir($web_root. $root_dir. $media_dir. $origgenreName. $origartistName. $origalbumName);

		// Now let's close this window and refresh the parent
		closeWindow();
		exit();
	}

	// Let's see if they wanted to update the data or not
	if (isset($_POST['closeupdateartistdata'])){
		// Ok, now we need to figure out what they wanted to do:
		$origGenre = $web_root. $root_dir. $media_dir. "/". $origgenreName;
		$origArtist = $web_root. $root_dir. $media_dir. "/". $origgenreName. "/". $origartistName;
		$origAlbum = $web_root. $root_dir. $media_dir. "/". $origgenreName. "/". $origartistName. "/". $origalbumName;
		
		// Ok, now let's get the new stuff
		$newGenre = $web_root. $root_dir. $media_dir. "/". $genreName;
		$newArtist = $web_root. $root_dir. $media_dir. "/". $genreName. "/". $origartistName; 
		$newAlbum = $web_root. $root_dir. $media_dir. "/". $genreName. "/". $origartistName. "/". $origalbumName;

		// Ok, let's see what we need to do, if anything...
		if ($newGenre <> $origGenre){
			// Ok, we need to move the album to a new genre too
			// First let's see if the new artist folder exists
			if ($_ENV['OS'] <> "Windows_NT"){
				exec ('mv "'. $origGenre. "/". $origartistName. '" "'.$newGenre. "/". $origartistName. '"');
			}
			if ($_ENV['OS'] == "Windows_NT"){
				exec ('move "'. $origGenre. "/". $origartistName. '" "'.$newGenre. "/". $origartistName. '"');
			}			
			
			$origArtist = $web_root. $root_dir. $media_dir. "/". $genreName. "/". $artistName;
			$origAlbum = $web_root. $root_dir. $media_dir. "/". $genreName. "/". $artistName. "/". $origalbumName;
		}
		if ($newArtist <> $origArtist){
			// Ok, we need to move the album to a new artist
			// First we need to see if we need to create a new directory for the new stuff
			if (!is_dir($newArtist)){
				mkdir($newArtist, 0700);
			}
			$origAlbum;
			rename($origAlbum, $newArtist. "/". $origalbumName);
			// Now we need to fix the variables incase we need to do more moves
			$origAlbum = $web_root. $root_dir. $media_dir. "/". $origgenreName. "/". $artistName. "/". $origalbumName;
		}
		if ($newAlbum <> $origAlbum){
			// Ok, we need to rename the album
			rename ($origAlbum, $newAlbum);
		}
		
		// Now let's close this window and refresh the parent
		closeWindow();
		
		exit();
	}
	
	// Let's see if they wanted to update an ablum
	if (isset($_POST['closeupdatealbumdata'])){
	
		$origGenre = $_POST['origgenreName'];
		$origArist = $_POST['origartistName'];
		$origAlbum = $_POST['origalbumName'];
		$newGenre = $_POST['origgenreName'];
		$newArtist = $_POST['origartistName'];
		$newAlbum = $_POST['albumName'];
		
		// Ok, now let's move it
		if ($_ENV['OS'] <> "Windows_NT"){
			exec ('mv "'. $web_root. $root_dir. $media_dir. "/". $origGenre. "/". $origArist. "/". $origAlbum. '" "'. $web_root. $root_dir. $media_dir. "/". $newGenre. "/". $origartistName. "/". $newAlbum. '"');
		}
		if ($_ENV['OS'] == "Windows_NT"){
			exec ('move "'. $web_root. $root_dir. $media_dir. "/". $origGenre. "/". $origArist. "/". $origAlbum. '" "'. $web_root. $root_dir. $media_dir. "/". $newGenre. "/". $origartistName. "/". $newAlbum. '"');
		}
		closeWindow();
		exit();
	}
	
	// Now let's see if they wanted to exclude an artist
	if (isset($_POST['excludeartist'])){
		// Ok, let's exclude what they wanted
		excludeItem($_POST['origartistName']);

		
		
		exit();

	}
	
	// Now let's see if they wanted to exclude an artist
	if (isset($_POST['excludegenre'])){
		// Ok, let's exclude what they wanted
		excludeItem($_POST['origgenreName']);
		
		// Now let's close this window and refresh the parent
		closeWindow();
		
		exit();
	}
	
	// Now let's delete the genre
	if (isset($_POST['deletegenre'])){
		echo $_POST['origgenreName'];
		deldir($web_root. $root_dir. $media_dir. "/". $_POST['origgenreName']);
		
		// Now let's close this window and refresh the parent
		closeWindow();
		
		exit();
	}
	
	
	// This function will close the window
	function closeWindow(){
		echo '<body onload="opener.location.reload(true);window.close();">';
	}	
	
	
	// Let's see what kind of page this is:
	if (isset($_GET['type'])){
		switch ($_GET['type']){
			case "album" : # Ok they wanted to see album info
				displayAlbumInfo();
			break;
			
			case "artist" : # Ok they wanted to see album info
				displayArtistInfo();
			break;
			
			case "genre" : # Ok they wanted to see album info
				displayGenreInfo();
			break;
			
			case "lyrics" : # Ok they wanted to view some lyrics
				displayLyrics();
			break;
			
			case "rate" :
				displayRating();
			break; 
			
			default : # Ok, they must have wanted a single track
				displayTrackInfo();
			break;
		}
	} else {
		displayTrackInfo();
	}
	
	// This function starts off our pages
	function displayPageTop(){
		global $root_dir;
		
		// Let's start our page
		echo '<title>Item Details</title>'.
			 '<body marginwidth=0 marginheight=0 style="margin: 0px">';
		
		// Let's output the style sheets
		echo "<link rel=\"stylesheet\" href=\"$root_dir/style/sunflower/default.css\" type=\"text/css\">";
	}
	
	function displayLyrics(){
		global $web_root, $root_dir, $media_dir;
		
		// Let's display the top of our page	
		displayPageTop();
		
		// Now let's get the data from the file
		$filename = $web_root. $root_dir. $media_dir. "/". urldecode($_GET['info']);
		$handle = fopen ($filename, "rb");
		$contents = fread ($handle, filesize ($filename));
		fclose ($handle);
		
		echo'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table" height="100%">'. "\n".
			'<tr class="jz_row1">'. "\n".
				'<td width="100%" class="jz_track_table_songs_td" valign="top">'. $contents. "\n".
				'<br><br><center><input class="jz_submit" value="Close Window" type="button" onClick="window.close();"></center><br><br>'. "\n".
				'</td>'. "\n".
			'</tr>'. "\n".
			'</table>'. "\n";
	}
	
	// This function let's the user view/edit a single album
	function displayAlbumInfo(){
		global $directory_level, $web_root, $root_dir, $media_dir, $song_cellpadding;
		
		// Let's display the top of our page	
		displayPageTop();
		
		// Let's parse out some of the data we'll need
		$infoArray = explode("/",urldecode($_GET['info']));
		
		// Now let's see what dir mode we are in
		switch ($directory_level){
			case "3" : # Ok, 3 dir mode
				$albumName = $infoArray[count($infoArray) -1];
				$artistName = $infoArray[count($infoArray) -2];
				$genreName = $infoArray[count($infoArray) -3];
			break;
			
			case "2" : # Ok, 2 dir mode
				$albumName = $infoArray[count($infoArray) -1];
				$artistName = $infoArray[count($infoArray) -2];
				$genreName = "";
			break;
			
			case "1" : # Ok, 1 dir mode
				$albumName = $infoArray[count($infoArray) -1];
				$artistName = "";
				$genreName = "";
			break;
		}
		
		$filename =  $web_root. $root_dir. $media_dir. "/". urldecode($_GET['info']). "/album-desc.txt";
		if (is_file($filename)){
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$contents = "";
		}

		echo '<form action="mp3info.php" method="POST" name="mp3infoform">'. "\n".
		'<input type="hidden" name="desc_filename" value="'. $filename. '">'.
		'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table">'. "\n".
			'<tr class="jz_row1">'. "\n".
					'<td width="30%" class="jz_track_table_songs_td">Album Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<input class="jz_input" type="hidden" name="origalbumName" size="30" value="'.$albumName.'">'.
					'<input class="jz_input" type="text" name="albumName" size="30" maxlength="100" value="'.$albumName.'"></td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Artist Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<input class="jz_input" type="hidden" name="origartistName" size="30" value="'.$artistName.'">'.
					$artistName. '</td>'. "\n";
			// Ok if in 3 dir mode
			if ($directory_level == 3){
				echo '<tr class="jz_row1">'. "\n".
						'<td width="30%" class="jz_track_table_songs_td">Genre:</td>'. "\n".
						'<td class="jz_track_table_songs_td">'.
						// Ok, let's build our select list of Genres
						'<input class="jz_input" type="hidden" name="origgenreName" value="'.$genreName.'">'.
						$genreName. '</td></tr>'. "\n";
			}
		echo'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Album Desc:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<textarea name="desc_contents" rows="10">'. $contents. '</textarea>'.
					'</td>'. "\n";
		echo'<tr class="jz_row1">'. "\n".
				'<td width="100%" colspan="2" class="jz_track_table_songs_td" align="center" valign="center">';
		if ($_SESSION['jz_access_level'] == "admin"){
			echo '<br><input type=submit class="jz_submit" name="closeupdatealbumdata" value="Update & Close"> '. 
				 '<input type=submit class="jz_submit" name="deletealbum" value="Delete Album">'.
				 '<br><br><input type=submit class="jz_submit" name="updatealbumdesc" value="Update Description"> ';
		}
			echo '<input type=submit class="jz_submit" name="closealbum" value="Close"><br><br>'.
				'</td>'. "\n".		
					
					
			'</tr>'. "\n".
			'</table>'. "\n".
		'</form></body>'. "\n";		
	}
	
	function displayArtistInfo(){
		global $directory_level, $web_root, $root_dir, $media_dir, $song_cellpadding;
		
		// Let's display the top of our page	
		displayPageTop();
		
		// Let's parse out some of the data we'll need
		$infoArray = explode("/",urldecode($_GET['info']));
		
		// Now let's see what dir mode we are in
		switch ($directory_level){
			case "3" : # Ok, 3 dir mode
				$artistName = $infoArray[count($infoArray) -1];
				$genreName = $infoArray[count($infoArray) -2];
				$desc1 = "Genre";
				$desc2 = "Aritst";
				$desc3 = "Album";
			break;
			
			case "2" : # Ok, 2 dir mode
				$artistName = $infoArray[count($infoArray) -1];
				$genreName = "";
				$desc1 = "Aritst";
				$desc2 = "Album";
				$desc3 = "";
			break;
			
			case "1" : # Ok, 1 dir mode
				$albumName = "";
				$artistName = "";
				$genreName = "";
				$desc1 = "Album";
				$desc2 = "";
				$desc3 = "";
			break;
		}		
		
		// Now let's see if there is a description file here
		$filename =  $web_root. $root_dir. $media_dir. "/". urldecode($_GET['info']). ".txt";
		if (is_file($filename)){
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$contents = "";
		}
		
		$dataArray = explode("/",urldecode($_GET['info']));
		$long_file_name =  $web_root. $root_dir. $media_dir. "/". urldecode($_GET['info']). "/". $dataArray[count($dataArray) -1]. ".txt";
		if (is_file($long_file_name)){
			$handle = fopen ($long_file_name, "rb");
			$long_desc = fread ($handle, filesize ($long_file_name));
			fclose ($handle);
		} else {
			$long_desc = "";
		}
		
		echo '<form action="mp3info.php" method="POST" name="mp3infoform">'. "\n".
		'<input type="hidden" name="filename" value="'. $filename. '">'.
		'<input type="hidden" name="long_file_name" value="'. $long_file_name. '">'.
		'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table">'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">'. $desc2. ':</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<input class="jz_input" type="hidden" name="origartistName" size="30" value="'.$artistName.'">'.
					$artistName.
			'<tr class="jz_row1">'. "\n".
					'<td width="30%" class="jz_track_table_songs_td">Genre:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					// Ok, let's build our select list of Genres
					'<input class="jz_input" type="hidden" name="origgenreName" value="'.$genreName.'">'.
					'<select class="jz_select" name="genreName">';
						// let's get all the different genre's they already have
						$genreDir = $web_root. $root_dir. $media_dir;
						$d = dir($genreDir);
						$i = 0;
						while($entry = $d->read()) {
							/* Let's make sure this isn't the local directory we're looking at */
							if ($entry == "." || $entry == "..") { continue;}
							if (is_dir($genreDir. "/". $entry)){
								$genreArray[$i] = $entry;
								$i++;
							}
						}
						// Now let's sort that array
						sort($genreArray);
						
						// Now let's create our select box
						for ($i=0; $i < count($genreArray); $i++){
							// Let's see if we find a match
							if ($genreName == $genreArray[$i]){
								echo '<option selected value="'. $genreArray[$i]. '">'. $genreArray[$i]. '</option>';
							} else {
								echo '<option value="'. $genreArray[$i]. '">'. $genreArray[$i]. '</option>';
							}
						}
					echo '</select>'.					
					'</td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
				'<td class="jz_track_table_songs_td">Short Desc:</td>'. "\n".
				'<td class="jz_track_table_songs_td">'.
				'<textarea name="desc_contents" rows="10">'. $contents. '</textarea>'.
			'</tr><tr class="jz_row1">'. "\n".
				'<td class="jz_track_table_songs_td">Long Desc:</td>'. "\n".
				'<td class="jz_track_table_songs_td">'.
				'<textarea name="long_desc" rows="10">'. $long_desc. '</textarea>'.
			'</tr><tr class="jz_row2">'. "\n".
				'<td width="100%" colspan="2" class="jz_track_table_songs_td" align="center" valign="center">';
			if ($_SESSION['jz_access_level'] == "admin"){
				echo '<br><input type=submit class="jz_submit" name="closeupdateartistdata" value="Update & Close"> ';
			}
			echo '<input type=submit class="jz_submit" name="closealbum" value="Close">';
			if ($_SESSION['jz_access_level'] == "admin"){
				echo ' <input type=submit class="jz_submit" name="updateartdesc" value="Update Description">'.
					'<br><br><input type=submit class="jz_submit" name="deleteartist" value="Delete Artist">'.
					' <input type=submit class="jz_submit" name="excludeartist" value="Exclude Artist">';
			}
			echo '<br><br><br>'.
				'</td>'. "\n".		
					
					
			'</tr>'. "\n".
			'</table>'. "\n".
		'</form></body>'. "\n";
	}
	
	// This function displays the rating page
	function displayRating(){
		global $directory_level, $web_root, $root_dir, $media_dir, $song_cellpadding;
		
		// Let's display the top of our page	
		displayPageTop();
		
		//Now let's figure out the track name
		$trackArray = explode("/",urldecode($_GET['info']));
		$trackName = $trackArray[count($trackArray)-1];
		
		echo '<form action="mp3info.php" method="POST" name="mp3infoform">'. "\n".
		'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table">'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Track:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					$trackName.
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Rating:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<select name="rating">'.
						'<option value="5">5 Stars</option>'.
						'<option value="4.5">4.5 Stars</option>'.
						'<option value="4">4 Stars</option>'.
						'<option value="3.5">3.5 Stars</option>'.
						'<option value="3">3 Stars</option>'.
						'<option value="2.5">2.5 Stars</option>'.
						'<option value="2">2 Stars</option>'.
						'<option value="1.5">1.5 Stars</option>'.
						'<option value="1">1 Stars</option>'.
						'<option value=".5">.5 Stars</option>'.						
						'<option value="0">0 Stars</option>'.						
					'</select>'.
					'<input type="hidden" name="filename" value="'. urldecode($_GET['info']). '">'.
			'</tr><tr class="jz_row1">'. "\n".
				'<td width="100%" colspan="2" class="jz_track_table_songs_td" align="center" valign="center">'.
				'<br><input type=submit class="jz_submit" name="ratetrack" value="Rate & Close"><br>'.
				'<br><br><br><br>'.
				'</td>'. "\n".		
			'</tr>'. "\n".
			'</table>'. "\n".
		'</form></body>'. "\n";
	}
	
	
	function displayGenreInfo(){
		global $directory_level, $web_root, $root_dir, $media_dir, $song_cellpadding;
		
		// Let's display the top of our page	
		displayPageTop();
		
		// Let's parse out some of the data we'll need
		$infoArray = explode("/",urldecode($_GET['info']));
		
		// Now let's see what dir mode we are in
		switch ($directory_level){
			case "3" : # Ok, 3 dir mode
				$genreName = $infoArray[count($infoArray) -1];
				$desc1 = "Genre";
				$desc2 = "Aritst";
				$desc3 = "Album";
			break;
			
			case "2" : # Ok, 2 dir mode
				$artistName ="";
				$genreName = "";
				$desc1 = "Album";
				$desc2 = "";
				$desc3 = "";
			break;
			
			case "1" : # Ok, 1 dir mode
				$albumName = "";
				$artistName = "";
				$genreName = "";
				$desc1 = "";
				$desc2 = "";
				$desc3 = "";
			break;
		}
		
		// Now let's see if there is a description file here
		$filename =  $web_root. $root_dir. $media_dir. urldecode($_GET['info']). ".txt";
		if (is_file($filename)){
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
		} else {
			$contents = "";
		}
		
		echo '<form action="mp3info.php" method="POST" name="mp3infoform">'. "\n".
		'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table">'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">'. $desc1. ':</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<input class="jz_input" type="hidden" name="origgenreName" size="30" value="'.$genreName.'">'.
					$genreName.
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Description:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'.
					'<textarea name="desc_contents" rows="10">'. $contents. '</textarea>'.
					'<input type="hidden" name="filename" value="'. $filename. '">'.
			'</tr><tr class="jz_row1">'. "\n".
				'<td width="100%" colspan="2" class="jz_track_table_songs_td" align="center" valign="center">';
			if ($_SESSION['jz_access_level'] == "admin"){
				echo '<br><input type=submit class="jz_submit" name="deletegenre" value="Delete Genre" onClick="return AreYouSure();">'.
				' <input type=submit class="jz_submit" name="excludegenre" value="Exclude Genre">'.
				'<br><br><input type=submit class="jz_submit" name="updatedesc" value="Update Description"> ';
			}
			echo '<input type=submit class="jz_submit" name="closealbum" value="Close"><br>'.
				'<br><br><br><br><br><br><br><br><br><br>'.
				'</td>'. "\n".		
			'</tr>'. "\n".
			'</table>'. "\n".
		'</form></body>'. "\n";
	}
	
	// This function let's the user view/edit a single track
	function displayTrackInfo(){
		global $root_dir, $song_cellpadding;
		
		// Let's start our page
		echo '<title>Jinzora Song Details</title>'.
			 '<body marginwidth=0 marginheight=0 style="margin: 0px">';
		
		// Let's output the style sheets
		echo "<link rel=\"stylesheet\" href=\"$root_dir/style/sunflower/default.css\" type=\"text/css\">";
		$file = $_GET['file'];
		
		// Let's set some defaults
		$bitrate = ""; $length = ""; $filesize = ""; $name = ""; $artists = ""; $album = ""; $year = "";
		$track = ""; $genre = ""; $frequency = ""; $description = "";
		
		// Let's read all the info
		$fileInfo = GetAllFileInfo($file);
		if (!empty($fileInfo['audio']['bitrate'])) {
			$bitrate = (round($fileInfo['audio']['bitrate'] / 1000));
		}
		if (!empty($fileInfo['playtime_string'])) {
			$length = $fileInfo['playtime_string'];
		}
		if (!empty($fileInfo['filesize'])) {
			$filesize = round($fileInfo['filesize']/1000000,2);
		}
		if (!empty($fileInfo['comments']['title'][0])) {
			$name = $fileInfo['comments']['title'][0];
		}
		if (!empty($fileInfo['comments']['artist'][0])) {
			$artists = $fileInfo['comments']['artist'][0];
		}
		if (!empty($fileInfo['comments']['album'][0])) {
			$album = $fileInfo['comments']['album'][0];
		}
		if (!empty($fileInfo['comments']['year'][0])) {
			$year = $fileInfo['comments']['year'][0];
		}
		if (!empty($fileInfo['comments']['track'][0])) {
			$track = $fileInfo['comments']['track'][0];
		}
		if (!empty($fileInfo['comments']['genre'][0])) {
			$genre = $fileInfo['comments']['genre'][0];
		}
		if (!empty($fileInfo['audio']['sample_rate'])) {
			$frequency = round($fileInfo['audio']['sample_rate']/1000,1);
		}
		if (!empty($fileInfo['comments']['comment'][0])) {
			$description = $fileInfo['comments']['comment'][0];
		}
		$filename = $_GET['file'];
		
		// Now let's clean up the file name
		$fileNameArray = explode("/", $filename);
		$filename = $fileNameArray[count($fileNameArray) -1];
		
		// Now let's see if the file is writeable so we'll know if we can change it
		$fileWritable = "no";
		if (is_writable($_GET['file'])){ $fileWritable = "yes"; }
		
		$fileInfo = pathinfo(urldecode($_GET['file']));
		$fileExt = $fileInfo["extension"];
		$desc_file_name =  str_replace($fileExt, "", urldecode($_GET['file'])). "txt";
		if (is_file($desc_file_name)){
			$handle = fopen ($desc_file_name, "rb");
			$desc_contents = fread ($handle, filesize ($desc_file_name));
			fclose ($handle);
		} else {
			$desc_contents = "";
		}
	
		echo '<form action="mp3info.php" method="POST" name="mp3infoform">'. "\n".
		'<input type="hidden" name="desc_filename" value="'. $desc_file_name. '">'.
		'<table width="100%" cellpadding="'. $song_cellpadding. '" cellspacing="0" class="jz_track_table">'. "\n".
			'<tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Track Number:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="tracknumber" size="3" maxlength="3" value="'.$track.'"></td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Track Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="trackname" size="30" maxlength="100" value="'.$name.'"></td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td" valign="top">File Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input type="hidden" name="filename" value="'.$_GET['file'].'"><input class="jz_input" type="text" name="newfilename" size="30" maxlength="100" value="'.$filename.'">'. "\n";
					// Let's see if the file WASN't writable
					if ($fileWritable == "no"){
						echo "<br><font color=red>Not Writable!!!</font>";
					}
					echo '</td>'. "\n";
	   echo '</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Artist Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="artistname" size="30" maxlength="100" value="'.$artists.'"></td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Album Name:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="albumname" size="30" maxlength="100" value="'.$album.'"></td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Genre:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="genre" size="30" maxlength="100" value="'.$genre.'"></td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Year:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="year" size="30" maxlength="100" value="'.$year.'"></td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Track Time:</td>'. "\n".
					'<td class="jz_track_table_songs_td">' .$length.'</td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Bit Rate:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'. $bitrate. ' kbps</td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">Sample Rate:</td>'. "\n".
					'<td class="jz_track_table_songs_td">'. $frequency. ' Hz</td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">File Size:</td>'. "\n".
					'<td class="jz_track_table_songs_td">' .$filesize. ' Mb </td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td class="jz_track_table_songs_td">ID3 Description:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><input class="jz_input" type="text" name="description" size="30" maxlength="100" value="'.$description.'"></td>'. "\n".
			'</tr><tr class="jz_row1">'. "\n".
					'<td class="jz_track_table_songs_td">Long Desc:</td>'. "\n".
					'<td class="jz_track_table_songs_td"><textarea name="long_desc" rows="5">'. $desc_contents. '</textarea></td>'. "\n".
			'</tr><tr class="jz_row2">'. "\n".
					'<td width="100%" colspan="2" class="jz_track_table_songs_td" align="center" valign="center">';
					// Now let's see if we get back the lyrics from leo's lyrics...
					$contents = "";
					$fp = fsockopen('api.leoslyrics.com',80);
					$path = '/api_search.php?auth=Jinzora&artist='. urlencode($artists). '&songtitle='. urlencode($name). '&search= true';
					fputs($fp, "GET $path HTTP/1.1\n");
					fputs($fp, "Content-type: application/x-www-form-urlencoded\n");		
					fputs($fp, "Connection: close\n\n");
					// Now let's read all the data
					$blnHeader = true;
					while (!feof($fp)){
						if ($blnHeader) {
							if (fgets($fp,1024) == "\r\n"){
								$blnHeader = false;
							}
							//echo fgets($fp,1024). "<br>";
						} else {
							$contents .= fread($fp,1024);
						}	
					}
					fclose($fp);

					// Now let's see if we got an exact match
					if (stristr($contents,'exactMatch="true"')){
						$lyrics = "";
						// Ok, now let's get the ID number
						$song_hid = substr($contents,strpos($contents,"hid=")+5,50);
						$song_hid = substr($song_hid,0,strpos($song_hid,'"'));
						// Now that we've got the HID let's get the lyrics
						// Now let's see if we get back the lyrics from leo's lyrics...
						$fp = fsockopen('api.leoslyrics.com',80);
						$path = '/api_lyrics.php?auth=Jinzora&hid='. urlencode($song_hid). '&file= NULL';
						fputs($fp, "GET $path HTTP/1.1\n");
						fputs($fp, "Content-type: application/x-www-form-urlencoded\n");		
						fputs($fp, "Connection: close\n\n");
					
						// Now let's read all the data
						$blnHeader = true;
						while (!feof($fp)){
							if ($blnHeader) {
								if (fgets($fp,1024) == "\r\n"){
									$blnHeader = false;
								}
								//echo fgets($fp,1024). "<br>";
							} else {
								$lyrics .= fread($fp,1024);
							}	
						}
						fclose($fp);
						
						// Now let's make sure that was successful
						if (stristr($lyrics,"SUCCESS")){
							// Now let's clean them up
							$lyrics = substr($lyrics,strpos($lyrics,"<text>")+6,999999);
							$lyrics = stripslashes(substr($lyrics,0,strpos($lyrics,"</text>")));
							// Now let's display them...
							echo '<br>Lyrics Provided by <a href="http://www.leoslyrics.com" target="_blank">Leo'. "'s Lyrics</a><br>";
							echo '<textarea rows="20" cols="45" class="jz_input">'. $lyrics. '</textarea><br>';
						} else {
							echo '<br><a target="_blank" href="http://www.leoslyrics.com/search.php?search=%22'. urlencode($artists). '%22+%22'. urlencode($name). '%22&sartist=1&ssongtitle=1">Search for Lyrics</a><br>';
						}
					} else {
						echo '<br><a target="_blank" href="http://www.leoslyrics.com/search.php?search=%22'. urlencode($artists). '%22+%22'. urlencode($name). '%22&sartist=1&ssongtitle=1">Search for Lyrics</a><br>';						
					}
					
					// Now let's make sure they are an admin and therefore can edit
					if ($_SESSION['jz_access_level'] == "admin"){					
						echo '<br><input type=submit class="jz_submit" name="closeupdate" value="Update & Close"><input type="hidden" name="filename" value="'. $file. '"> '. 
							 '<input type=submit class="jz_submit" name="updatedata" value="Update">'.
							 '<br><br><input type=submit class="jz_submit" name="updatesongdesc" value="Update Desc">'.
							 ' <input type=submit class="jz_submit" name="justclose" value="Close">';
					} else {
						echo '<br><input type=submit class="jz_submit" name="justclose" value="Close">';
					}
					echo '<br><br>'.
					'</td>'. "\n".
			'</tr>'. "\n".
		'</table>'. "\n".
		'</form></body>'. "\n";
	}
	
	
	function excludeItem($excludeItem){
		global $web_root, $root_dir, $jinzora_temp_dir;
		// Now let's figure out the exclude file, the users file or the global one
		if (!isset($_COOKIE['jz_user_name'])){
			// Ok, the global one
			$filename = $web_root. $root_dir. $jinzora_temp_dir. "/global-exclude.lst";
		} else {
			// Ok, the user one
			$filename = $web_root. $root_dir. $jinzora_temp_dir. "/". $_COOKIE['jz_user_name']. "-exclude.lst";
		}

		// Now let's add a line break to the excluded item
		$excludeItem = $excludeItem. "\n";
		
		// Ok, now let's write this to the exclude file
		$handle = fopen ($filename, "a");
		fwrite($handle,$excludeItem);				
		fclose($handle);
		
		closeWindow();
	}
	
	
?>