<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	* JINZORA | Web-based Media Streamer
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: To create a block for a PostNuke based site
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	// Let's modify the include path for Jinzora
	$mod_name ="jinzora"
	
	// Now let's include the settings file
	include('modules/Music/settings.php');
	
	// Let's just set PostNuke to true, I mean if you're looking at this....
	$postnuke = "true";
	
	// Now let's include the system settings
	include('modules/$mod_name/system.php');
	
	// Now let's include the general functions
	include_once('modules/$mod_name/general.php');
	include_once('modules/$mod_name/classes.php');
	
	// Now let's get a random album cover
	// Let's start by reading the top level directory for Jinzora
	$startDir = $web_root. $root_dir. $media_dir;
	$genreArray = readDirInfo($startDir, "dir");
	$ctr1 = 0;
	$final_ctr = 0;
	while (count($genreArray) > $ctr1){
		// Now let's look in here...
		$artistArray = readDirInfo($startDir. "/". $genreArray[$ctr1], "dir");
		$ctr2 = 0;
		while (count($artistArray) > $ctr2){
			// Now let's look in here...
			$albumArray = readDirInfo($startDir. "/". $genreArray[$ctr1]. "/". $artistArray[$ctr2], "dir");
			$ctr3 = 0;
			while (count($albumArray) > $ctr3){
				// Now let's look for album covers
				$fileArray = readDirInfo($startDir. "/". $genreArray[$ctr1]. "/". $artistArray[$ctr2]. "/". $albumArray[$ctr3], "file");
				$ctr4 = 0;
				while (count($fileArray) > $ctr4){
					//Now let's see if this is an image file, and if so add it to the final array
					if (preg_match("/\.($ext_graphic)$/i", $fileArray[$ctr4])) {
						$finalArray[$final_ctr] = $genreArray[$ctr1]. "|||". $artistArray[$ctr2]. "|||". $albumArray[$ctr3]. "|||". $fileArray[$ctr4];
						$final_ctr = $final_ctr + 1;
					}
					$ctr4 = $ctr4 + 1;
				}
				$ctr3 = $ctr3 + 1;
			}
			$ctr2 = $ctr2 + 1;
		}
		$ctr1 = $ctr1 + 1;
	}
	
	// Ok now that we have our array, let's shuffle it
	shuffle($finalArray);
	
	// Ok, now let's get the first albumCover from the array
	$imageArray = explode("|||",$finalArray[0]);
	$imgSource = $root_dir. $media_dir. "/". $imageArray[0]. "/". $imageArray[1]. "/". $imageArray[2]. "/". $imageArray[3];
	$imgTitle = $imageArray[1]. " - ". $imageArray[2];
	$artistHref = 'modules.php?name=$mod_name&file=index&ptype=artist&genre='. $imageArray[0]. '&artist='. $imageArray[1];
	$linkHref = 'modules.php?name=$mod_name&file=index&ptype=songs&genre='. $imageArray[0]. '&artist='. $imageArray[1]. '&album='. $imageArray[2];
	$playHref = 'modules.php?name=$mod_name&file=index&ptype=quickplay&style=normal&qptype=album&info='. $imageArray[0]. "/". $imageArray[1]. "/". $imageArray[2];
	// Let's set the album name and truncate it if we need to
	$albumName = $imageArray[2];
	if (strlen($albumName) > $album_name_truncate){
		$albumName = substr($albumName,0,$album_name_truncate). "...";
	}
	$artistName = $imageArray[1];
	if (strlen($artistName) > $artist_truncate){
		$artistName = substr($artistName,0,$artist_truncate). "...";
	}	
	$content .='<center><a href="'. $artistHref. '">'. $artistName. '</a><br><a href="'. $linkHref. '">'. $albumName. '</a><br>';
	$content .='<a href="'. $playHref. '"><img title="'. $imgTitle. '" src="'. $imgSource. '" border="0"></a><br>';
	$content .=$word_random_select. "<br>";
	$content .= "<form method=\"post\" action=\"modules.php?name=$mod_name&file=index\">";
	$content .= "<select name=\"random_play_number\" class=\"jz_select_sm1\">";
				$random_play = explode("|", $random_play_amounts);
				$ctr = 0;
				while (count($random_play) > $ctr){
					$content .='<option value="'. $random_play[$ctr]. '">'. $random_play[$ctr]. '</option>';
					$ctr = $ctr + 1;
				}
		
		$content .="</select>";
		$content .="<select name=\"random_play_type\" class=\"jz_select_sm2\">";
				$random_play = explode("|", $random_play_types);
				$ctr = 0;
				while (count($random_play) > $ctr){
					$content .='<option value="'. $random_play[$ctr]. '">'. $random_play[$ctr]. '</option>';
					$ctr = $ctr + 1;
				}
		
		$content .="</select>";
		$content .="<input class=\"jz_submit\" type=\"submit\" name=\"submit_random\" value=\"$word_go_button\" class=\"submit\">";
	$content .="</form>";
		// Now let's include the shoutcast stuff if we're shoutcasting
		if ($shoutcast == "true"){
			$pnblock = "true";
			include('sc-stats.php');
		}
	?>
</center>











