<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *      
	* JINZORA | Web-based Media Streamer 
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL. 
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:h
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the "playlist" related functions
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	/* This function let's the user play a Genre, Artist, Album, or song */
		
	function quickplay(){
		global $playlist_dir, $this_site, $mp3_dir, $audio_types, $root_dir, $media_dir, 
		$video_types, $playlist_ext, $single_file_playlist, $web_root, $temp_zip_dir, 
		$jinzora_temp_dir, $slash_var, $pathToMPG, $jukebox, $playlist_gen_type;

		// Let's reset the maximum executution time, as this may take a while....
		ini_set('max_execution_time','600');
		
		/* Let's set the base for the tracks and a counter for later*/
		$base_url = $this_site;
		$ctr = 0;
	
		// Let's clean up any variables that we would use
		$info = $_GET['info'];
		
		// Now let's read all the files from that point down IF it's not a single file
		if ($_GET['qptype'] <> "song"){
			$readCtr = 0;
			$fileArray = str_replace($web_root. $root_dir. $media_dir. "/", "",readAllDirs($web_root. $root_dir. $media_dir. "/". $info, $readCtr, $mainArray));
		} else {
			$fileArray[0] = $info;
		}

		/* Let's see if they wanted a random shuffle here or not */
		if ($_GET['style'] == "random"){
			shuffle ($fileArray);
		}
		
		// Let's initalize the output variable
		$output_content = "";
		
		// If this is an M3U playlist lets make it pretty
		if (strtolower($playlist_ext) == "m3u" and $jukebox <> "true") {
			$output_content .= "#EXTM3U";
		}
		
		for ($ctr=0; $ctr < count($fileArray); $ctr++){
			if (preg_match("/\.($video_types)$/i", $fileArray[0])){
				// Now let's let them play that one file
				$fileName = $this_site. str_replace("%2F","/",rawurlencode(jzstripslashes("/". $root_dir. $media_dir. "/". $fileArray[$ctr])));
				header("Location: ". $fileName);
				exit();
			} else {	
				/* Let's see if they wanted an HTML playlist instead */	
				if (strtolower($playlist_ext) == "html") {
					/* Now let's figure out the track name for our HTML file */
					$ctr2 = 0; $item = ""; 
					$trackName = $fileArray[$ctr];
					while ($item <> "/"){
						$item = substr($trackName,strlen($trackName)-$ctr2,1);
						$ctr2 = $ctr2 + 1;
					}
					/* Now let's parse out the track name using what we found above */
					$trackName = substr($trackName,strlen($trackName)-$ctr2 + 2,100000);

					/* Now let's get our URL */
					$trackURL = str_replace(stripslashes($mp3_dir), $root_dir. $media_dir, $fileArray[$ctr]);
					
					/* Now let's display it */
					echo '<a href="'. $trackURL. '">'. str_replace("%20"," ",$trackName). '</a><br>';
					
				} else {
					// First let's clean up the content
					$path = str_replace(stripslashes($this_site. $mp3_dir). "/", "", $fileArray[$ctr]);
					$path = str_replace("%2F","/",rawurlencode($path));
					
					// Now let's get the full path to the file so we can make the playlist pretty by reading the ID3 info from the file
					$fileInfo = GetAllFileInfo($web_root. $root_dir. $media_dir. "/". $fileArray[$ctr]);
					$filename = $web_root. $root_dir. $media_dir. "/". $fileArray[$ctr];
					$length = ""; $name = ""; $artist = "";
					if (!empty($fileInfo['playtime_seconds'])) {
						$length = round($fileInfo['playtime_seconds']);
					}
					if (!empty($fileInfo['comments']['title'][0])) {
						$name = $fileInfo['comments']['title'][0];
					}
					if (!empty($fileInfo['comments']['artist'][0])) {
						$artists = $fileInfo['comments']['artist'][0];
					}
					if ($name == ""){
						// Let's explode the filename so we can get this
						$dataArray = explode("/",$filename);
						$name = $dataArray[count($dataArray)-1];
					}
					if ($artist == ""){
						// Let's explode the filename so we can get this
						$dataArray = explode("/",$filename);
						$artist = $dataArray[count($dataArray)-3];
					}
					if ($jukebox <> "true"){					
						$output_content .= "#EXTINF:". $length. ",". $artist. " - ". $name. "\n";
						// Now we need to strip off the extra slashes...
						while (stristr($path,"//") <> ""){
							$path = str_replace("//","/",$path);
						}
						$output_content .=  $this_site. $root_dir. $media_dir. "/". $path. "\n";
					} else {
						$content .=	$web_root. $root_dir. $media_dir. "/". urldecode($path). "\n";
					}
				}
			}
		}
		
		/* Let's see if this is a video type or an audio type and output the appropriate header */
		if (preg_match("/\.($audio_types)$/i", $fileArray[0])){
			/* Let's see if they wanted an HTML playlist */
			if (strtolower($playlist_ext) <> "html" and $playlist_ext <> "ps2" and $jukebox <> "true") {
				header("Content-type: audio/mpegurl");
				header("Content-Disposition: inline; filename=playlist.m3u");
				header("Cache-control: private");
				echo $output_content;
				//echo "<a href=test.php>test</a>";
				exit;
			}
			// Let's see if this if for the PS2 or not
			// PS2 can only get a location tag
			if ($playlist_ext == "ps2"){
				header("Location: ". $fileArray[0]);
				exit();
			}
		} else {
			// Now let's clean up the file...
			$fileName = $root_dir. $media_dir. "/". $fileArray[0];
			while (strpos($fileName,"//") <> 0){
				$fileName = str_replace("//","/",$fileName);
			}
			header("Location: ". $fileName);
			exit();
		}
		
		if ($jukebox == "true"){	
			// Ok, let's play the file with MPG321
			// First let's create the playlist file
			$fileName = $web_root. $root_dir. $jinzora_temp_dir. "/jinzora-jukbox.pls.m3u";
			$handle = fopen($fileName, "w");
			fwrite($handle,$content);	
			fclose ($handle);
				
			// Now let's play it!, but first kill any running MPG123's
			exec ('killall mpg123');
			session_write_close();
			exec ($pathToMPG. "/mpg123 -q --list ". $fileName. " 0 1> /dev/null 2>&1 &"); 
		}
		exit();
	}
	
	/* This function generates the random playlist from the drop down boxes in the header */
	function generateRandom(){
		global $web_root, $root_dir, $media_dir, $audio_types, $this_site;
		
		/* Let's initalize some variables */
		$final_ctr = 0;
				
		/* Ok, now let's see what kind of random list they wanted */
		switch ($_POST['random_play_type']) {
			case "Songs" : # Ok, they wanted some random songs
				// Now let's read EVERYTHING and create that session variable
				$mainArray = ""; $readCtr = 0;
				readAllDirs($web_root. $root_dir. $media_dir, $readCtr, $mainArray);
				for ($ctr=0; $ctr < count($mainArray); $ctr++){
					if ($mainArray[$ctr] <> ""){
						$finalArray[$final_ctr] = str_replace("/","----",str_replace($web_root. $root_dir. $media_dir,"",$mainArray[$ctr]));
						$final_ctr++;
					}
				}
								
				/* Now let's shuffle it */
				shuffle($finalArray);
				
				/* Now let's get jut the entries we wanted */
				$ctr2 = 0;
				for ($ctr=0; $ctr < count($finalArray); $ctr++){
					if ($ctr < $_POST['random_play_number']){
						$songArray[$ctr2] = $this_site. $root_dir. $media_dir. "/". str_replace("----","/",$finalArray[$ctr]);
						$ctr2 = $ctr2 + 1;
					}
				}

				/* Now let's create the playlist */
				createPlayList($songArray);
			break;
			
			case "Albums" : # Ok, they wanted some random Albums
				/* Ok, let's get some songs for them! */
				/* First let's read the first directory */
				$genreArray = readDirInfo($web_root. $root_dir. $media_dir, "dir");
				/* Now let's loop through that and read all the other dirs */
				$ctr = 0;
				while (count($genreArray) > $ctr){
					$artistArray = readDirInfo($web_root. $root_dir. $media_dir. "/". $genreArray[$ctr], "dir");
					/* Now let's loop through that */
					$ctr2 = 0;
					while (count($artistArray) > $ctr2){
						$albumArray = readDirInfo($web_root. $root_dir. $media_dir. "/". $genreArray[$ctr]. "/". $artistArray[$ctr2], "dir");
						/* Now let's loop through that */
						$ctr3 = 0;
						while (count($albumArray) > $ctr3){
							$finalArray[$final_ctr] = $root_dir. $media_dir. "/". $genreArray[$ctr]. "/". $artistArray[$ctr2]. "/". $albumArray[$ctr3];
							$final_ctr = $final_ctr + 1;
							$ctr3 = $ctr3 + 1;
						}
						$ctr2 = $ctr2 + 1;
					}
					$ctr = $ctr + 1;
				}
				/* Ok, now that we have our albums, we'll need the tracks in those albums */
				/* First let's shuffle the array */
				shuffle($finalArray);
				
				/* Now let's create a temp array */
				$tempArray = $finalArray;
				
				/* Now let's loop throught the number of albums that they wanted and get the tracks */
				$ctr = 0;
				$final_ctr = 0;
				while (count($tempArray) > $ctr){
					/* Let's make sure we haven't looked at too many albums */
					if ($ctr < $_POST['random_play_number']){
						/* Now let's get the tracks for these dirs */
						$retArray = readDirInfo($web_root. $tempArray[$ctr], "file");
						$ctr1 = 0;
						/* Now let's loop through that array reading the tracks as we go */
						while (count($retArray) > $ctr1){
							/* Let's make sure it's an audio file */
							if (preg_match("/\.($audio_types)$/i", $retArray[$ctr1])) {
								$albumArray[$final_ctr] =  $this_site. $tempArray[$ctr]. "/". $retArray[$ctr1];
								$final_ctr = $final_ctr + 1;
							}
							$ctr1 = $ctr1 + 1;
						}
					}
					$ctr = $ctr + 1;
				}
				
				/* Now let's create the playlist */
				createPlayList($albumArray);
			break;
			
			case "Artists" : # Ok, they wanted some random Artists
				/* Ok, let's get some songs for them! */
				/* First let's read the first directory */
				$genreArray = readDirInfo($web_root. $root_dir. $media_dir, "dir");
				/* Now let's loop through that and read all the other dirs */
				$ctr = 0;
				while (count($genreArray) > $ctr){
					$artistArray = readDirInfo($web_root. $root_dir. $media_dir. "/". $genreArray[$ctr], "dir");
					/* Now let's loop through that */
					$ctr2 = 0;
					while (count($artistArray) > $ctr2){
						$finalArray[$final_ctr] = $root_dir. $media_dir. "/". $genreArray[$ctr]. "/". $artistArray[$ctr2];
						$final_ctr = $final_ctr + 1;
						$ctr2 = $ctr2 + 1;
					}
					$ctr = $ctr + 1;
				}
				/* Ok, now that we have our albums, we'll need the tracks in those albums */
				/* First let's shuffle the array */
				shuffle($finalArray);
				
				/* Now let's create a temp array */
				$tempArray = $finalArray;
				
				/* Now let's loop throught the number of artists that they wanted and get the tracks */
				$ctr = 0;
				$ctr3 = 0;
				$final_ctr = 0;
				while (count($tempArray) > $ctr){
					/* Let's make sure we haven't looked at too many artists */
					if ($ctr < $_POST['random_play_number']){
						/* Now let's get the albums and tracks for these dirs */
						$albumArray = readDirInfo($web_root. $tempArray[$ctr], "dir");
						$ctr1 = 0;
						/* Now let's loop through that array reading the albums as we go */
						while (count($albumArray) > $ctr1){
							$trackArray = readDirInfo($web_root. $tempArray[$ctr]. "/". $albumArray[$ctr1], "file");
							$ctr2 = 0;
							while (count($trackArray) > $ctr2){
								/* Let's make sure it's an audio file */
								if (preg_match("/\.($audio_types)$/i", $trackArray[$ctr2])) {
									/* Let's use our little function to fix the special characters */
									$songArray[$ctr3] = $this_site. $tempArray[$ctr]. "/". $albumArray[$ctr1]. "/". $trackArray[$ctr2];	
									$ctr3 = $ctr3 + 1;
								}
								$ctr2 = $ctr2 + 1;
							}
							$ctr1 = $ctr1 + 1;
						}
						
					}
					$ctr = $ctr + 1;
				}
				
				/* Now let's create the playlist */
				createPlayList($songArray);
			
			break;
			
			case "Genres" : # Ok, they wanted some random Genres
				/* Ok, let's get some songs for them! */
				/* First let's read the first directory */
				$genreArray = readDirInfo($web_root. $root_dir. $media_dir, "dir");
				/* Now let's loop through that and read all the other dirs */
				$ctr = 0;
				$final_ctr = 0;
				while (count($genreArray) > $ctr){
					$finalArray[$final_ctr] = $root_dir. $media_dir. "/". $genreArray[$ctr]. "/". $artistArray[$ctr2];
					$final_ctr = $final_ctr + 1;
					$ctr = $ctr + 1;
				}
				/* Ok, now that we have our albums, we'll need the tracks in those albums */
				/* First let's shuffle the array */
				shuffle($finalArray);
				
				/* Now let's create a temp array */
				$tempArray = $finalArray;
				
				/* Now let's loop throught the number of albums that they wanted and get the tracks */
				$ctr = 0;
				$ctr3 = 0;
				$final_ctr = 0;
				while (count($tempArray) > $ctr){
					/* Let's make sure we haven't looked at too many artists */
					if ($ctr < $_POST['random_play_number']){
						/* Now let's get the albums and tracks for these dirs */
						$artistArray = readDirInfo($web_root. $tempArray[$ctr], "dir");
						$ctr1 = 0;
						/* Now let's loop through that array reading the albums as we go */
						while (count($artistArray) > $ctr1){
							$albumArray = readDirInfo($web_root. $tempArray[$ctr]. "/". $artistArray[$ctr1], "dir");
							$ctr2 = 0;
							while (count($albumArray) > $ctr2){
								/* Let's make sure it's an audio file */
								$trackArray = readDirInfo($web_root. $tempArray[$ctr]. "/". $artistArray[$ctr1]. "/". $albumArray[$ctr2], "file");
								$ctr3 = 0;
								while (count($trackArray) > $ctr3){
									/* Let's make sure it's an audio file */
									if (preg_match("/\.($audio_types)$/i", $trackArray[$ctr3])) {
										$songArray[$final_ctr] = $this_site. $tempArray[$ctr]. "/". $artistArray[$ctr1]. "/". $albumArray[$ctr2]. "/". $trackArray[$ctr3];
										$final_ctr = $final_ctr + 1;
									}
									$ctr3 = $ctr3 + 1;
								}
								$ctr2 = $ctr2 + 1;
							}
							$ctr1 = $ctr1 + 1;
						}
						
					}
					$ctr = $ctr + 1;
				}
				
				/* Now let's create the playlist */
				createPlayList($songArray);
			
			break;
			
		}

	}
	
	/* This function actually creates the playlist */
	function createPlayList($listArray){	
		global $playlist_ext, $web_root, $root_dir, $media_dir, $this_site, $playlist_gen_type;
		
		/* Let's see if this is a video type or an audio type and output the appropriate header */
		header("Content-type: audio/mpegurl");
		header("Content-Disposition: ". $playlist_gen_type. "; filename=playlist.". $playlist_ext);
		header("Cache-control: private"); #IE seems to need this.
		
		// If this is an M3U playlist lets make it pretty
		if (strtolower($playlist_ext) == "m3u") {
			echo "#EXTM3U\n";
		}		
				
		/* Now let's output our playlist */
		$ctr = 0;
		while (count($listArray) > $ctr){
			// Now let's get the full path to the file so we can make the playlist pretty by reading the ID3 info from the file
			$filename = str_replace($this_site,$web_root,urldecode($listArray[$ctr]));
			$fileInfo = GetAllFileInfo($filename);
			$length = ""; $name = ""; $artists = "";
			if (!empty($fileInfo['playtime_seconds'])) {
				$length = round($fileInfo['playtime_seconds']);
			}
			if (!empty($fileInfo['comments']['title'][0])) {
				$name = $fileInfo['comments']['title'][0];
			}
			if (!empty($fileInfo['comments']['artist'][0])) {
				$artists = $fileInfo['comments']['artist'][0];
			}
			
			if ($name == ""){
				// Let's explode the filename so we can get this
				$dataArray = explode("/",$filename);
				$name = $dataArray[count($dataArray)-1];
			}
			if ($artist == ""){
				// Let's explode the filename so we can get this
				$dataArray = explode("/",$filename);
				$artist = $dataArray[count($dataArray)-3];
			}
			echo "#EXTINF:". $length. ",". $artists. " - ". $name. "\n";
			echo str_replace(" ","%20",$listArray[$ctr]). "\n";
			$ctr = $ctr + 1;
		}
		exit();
	}
	
	function playSelected(){
		global $this_site;
		
		// Ok, first we need to loop through what they selected
		$numBoxes = $_POST['numboxes'];
		$ctr = 0;
		$ctr2 = 0;		
		while ($numBoxes > $ctr){
			// Now let's see what they selected
			if ($_POST['track-'. $ctr] <> ""){
				// Ok, now we've got the tracks, let's create an array for them
				// First we need to make sure that there are no double slashes, so we'll loop through and kill them
				$trackPath = $_POST['track-'. $ctr];
				while (strpos($trackPath,"//") <> 0){
					$trackPath = str_replace("//","/",$trackPath);
				}
				$trackArray[$ctr2] = $this_site. $trackPath;
				$ctr2 = $ctr + 1;
			}
			$ctr = $ctr + 1;
		}
		
		// Let's make sure that array wasn't empty
		if (count($trackArray) <> 0){
			// Now let's sort the array
			sort($trackArray);

			// Now let's create the playlist
			createPlayList($trackArray);		
		}	
	}
	
	
	// This function generates the playlist from the one stored on the server
	function playPlaylistFile($file, $type="standard", $random="false"){
		global $playlist_directory, $web_root, $root_dir, $media_dir, $this_site, $audio_types, $video_types;
		
		// Let's see if they wanted the session playlist or a real one
		if ($file == "sessionplaylist"){
			// Ok, let's read the session playlist then
			$contents = $_SESSION['sessionPlaylist'];
		} else {
			// Ok, we know what file to open, so let's get at it!
			$filename = $web_root. $root_dir. $playlist_directory. "/". $file;
			$handle = fopen ($filename, 'r');
			$contents = fread($handle,filesize($filename));
			fclose($handle);
		}
		
		// Ok, now let's split that into an array
		$playlistArray = explode("\n", $contents);
		
		// Now let's loop through that array
		$ctr = 0;
		$ctr2 = 0;
		while (count($playlistArray) > $ctr){
			// Let's make sure this line wasn't blank
			if ($playlistArray[$ctr] <> ""){
				// Now that we've got the lines, let's format them and build another array for later
				$trackArray[$ctr2] =  $playlistArray[$ctr];
				$ctr2 = $ctr2 + 1;
			}
			$ctr = $ctr + 1;
		}
		
		// Now that we've got the file in an array, let's see if there are any directories that we need to turn into actual files
		$ctr2 = 0;
		$ctr3 = 0;
		for ($ctr=0; $ctr < count($trackArray); $ctr++){
			// let's look at the last character to see if it is a slash, telling us where to look...
			if (substr($trackArray[$ctr],strlen($trackArray[$ctr])-1,1) == "/"){
				// Ok, now we need to search that directory for the files in it and all sub dirs
				// When we read it let's remove the trailing slash
				$filePath = urldecode(substr($trackArray[$ctr],0,strlen($trackArray[$ctr])-1));
				readAllDirs($filePath,$ctr2,$mainArray);
				$ctr2++;
			} else {
				$finalArray[$ctr3] = $trackArray[$ctr];
				$ctr3++;
			}
		}
		
		// Now that we got all that data back, let's put it into yet another new array, for our final array
		// But, let's make sure there is data from above for this
		if (isset($mainArray)){
			if (count($mainArray) <> 0){
				for ($i=0; $i < count($mainArray); $i++){
					$finalArray[$ctr3] = $mainArray[$i];
					$ctr3++;
				}
			}
		}
				
		// Ok, now that we've got our new array, let's parse it out correctly into a real playlist
		for ($ctr=0; $ctr < count($finalArray); $ctr++){
			// First let's make sure the item isn't blank
			if ($finalArray[$ctr] <> ""){
				// Ok, now let's reconstruct this line
				$finalArray[$ctr] = $this_site. str_replace("%2F","/",rawurlencode(str_replace($web_root,"",$finalArray[$ctr])));
			}
		}
		
		// Let's see if we need to shuffle the playlist
		if ($random == "true"){
			shuffle($finalArray);
		}

		// Now let's play the playlist or create the Shoutcase one
		if ($type == "shoutcast"){
			createShoutcast($finalArray, $file);
		} else {
			createPlayList($finalArray);
		}

	}
	
	
	// This function adds the posted data to the end of the playlist
	function addToPlayList($selectedPlaylist){
		global $playlist_directory, $web_root, $root_dir, $media_dir, $this_site, $this_page, $playlist_ext, $url_seperator;

		// Ok, we know what playlist to add to, let's first get the data we want to add
		// Ok, first we need to loop through what they selected
		$ctr2 = 0;
		for ($ctr=0; $ctr < $_POST['numboxes']; $ctr++){
			// Now let's see what they selected
			if (isset($_POST['track-'. $ctr] )){
				if ($_POST['track-'. $ctr] <> ""){
					// Ok, now we've got the data they selected, let's build an array
					// First we need to make sure that there are no double slashes, so we'll loop through and kill them
					$trackPath = $_POST['track-'. $ctr];
					while (strpos($trackPath,"//") <> 0){
						$trackPath = str_replace("//","/",$trackPath);
					}
					$trackArray[$ctr2] = $web_root. $trackPath;
					$ctr2 = $ctr + 1;
				}
			}
		}
			
		// Ok, now we've got our array of what they selected, let's add it to the playlist file
		// First let's look at the playlist type to know what to do
		switch($selectedPlaylist){
			case "newplaylist" : # Ok, they want a new playlist
				// First let's look and see if they've created the playlist already and if not give them the option to do it
				// Let's create a small form to hold the name of the playlist and set the type for later
				// We also need to store all the data from all the check boxes that they checked
				echo '<form action="'. $this_page. $url_seperator. $_SERVER['QUERY_STRING']. '" method="POST" name="playlistForm">'.
					 '<input type="hidden" name="playlistName">'.
					 '<input type="text" name="submitAction" value="addtoplaylist" style="width: 0px; border: 0px white;">'.
					 '<input type="hidden" name="numboxes" value="'. $_POST['numboxes']. '">';
					// Now let's recreate all the check boxes
					$ctr2 = 0;
					for ($ctr=0; $ctr < $_POST['numboxes']; $ctr++){
						echo '<input type="hidden" name="track-'. $ctr. '" value="'. $_POST['track-'. $ctr]. '">';
					}
				echo '</form>';
				// Let's call the JavaSript to get the name of the new playlist
				?>
					<script language="JavaScript"><!--
					
						function getPlayListName(){
							var strInput;
							strInput = window.prompt("New Playlist Name?");
							document.playlistForm.playlistName.value = strInput;
						}
						
						function submitForm(){
							document.playlistForm.submit();
						}
						
						getPlayListName();
						submitForm();				
						
					//--></script>
				<?php
				exit();	
			break;
			
			case "sessionplaylist" : # Ok, they want a session playlist
				// First we need to open the old playlist so we can make sure we don't get dupes
				$oldPlaylist = explode("\n",$_SESSION['sessionPlaylist']);
				// Now let's merge the two arrays
				$finalArray = array_unique(array_merge($trackArray,$oldPlaylist));
				
				// Now let's kill the old list so we can recreate it below
				$_SESSION['sessionPlaylist'] = "";
							
				// Now let's loop through our array writing data as we go
				for ($ctr=0; $ctr < count($finalArray); $ctr++){
					// Let's make sure the item isn't blank
					if ($finalArray[$ctr] <> ""){
						// Ok let's write the data
						$_SESSION['sessionPlaylist'] .= $finalArray[$ctr]. "\n";
					}
				}
			break;
			
			default : # Ok, they must want to add to OR create a new playlist
				if ($_POST['playlistName'] <> ""){
					// Ok, they wanted to create a new playlist to add to
					$fileName = $web_root. $root_dir. $playlist_directory. "/". $_POST['playlistName']. ".". $playlist_ext;
				} else {
					// Let's set the filename from the existing playlist
					$fileName = $web_root. $root_dir. $playlist_directory. "/". $selectedPlaylist;
					
					// Let's open the file and create an array from it so we can compare for dupes
					$handle = fopen($fileName, "r");
					$contents = fread($handle,filesize($fileName));
					fclose($handle);
					$oldPlaylist = explode("\n",$contents);
					
					// Now let's merge the two arrays
					$trackArray = array_unique(array_merge($oldPlaylist,$trackArray));
				}
						
			
				// let's open the file for appending, ok?
				$handle = fopen($fileName, "w");
				// Now let's loop through our array writing data as we go
				for ($ctr=0; $ctr < count($trackArray); $ctr++){
					// Let's make sure the item isn't blank
					if ($trackArray[$ctr] <> ""){
						// Ok let's write the data
						$result = fwrite($handle,$trackArray[$ctr]. "\n");
					}
				}
				// Now let's close the file	
				fclose ($handle);
			break;
			
		}
				
	}
	
	// This function builds the Shoutcast playlist file and stores it on the server
	function createShoutcast($trackArray, $playlist){
		global $web_root, $root_dir, $media_dir, $playlist_directory, $this_site, $word_create_shoutcast_playlist;
		
		// Ok, now that we have our array back, we need to clean it up for the shoutcast playlist
		for ($ctr=0; $ctr < count($trackArray); $ctr++){
			$trackArray[$ctr] = str_replace($this_site, $web_root,urldecode($trackArray[$ctr]));	
		}
		
		// Ok, now that it's cleaned up, let's create the streamfile
		$handle = fopen($web_root. $root_dir. $playlist_directory. "/shoutcast.lst", "w");	
		for ($ctr=0; $ctr < count($trackArray); $ctr++){
			$result = fwrite($handle,$trackArray[$ctr]. "\n");
		}
		fclose ($handle);
		
		// Now let's restart Shoutcast to play the new list
		exec ("killall sc_trans_linux -USR1 > /dev/null 2>&1 &");		
		exec ("killall sc_trans_linux -WINCH > /dev/null 2>&1 &");
		//exec ("nice -5 -- /usr/local/shoutcast/sc_trans_linux /usr/local/shoutcast/sc_trans.conf > /dev/null 2>&1 &");	
		
		displayPlaylists($playlist);
		
		exit();
	
	}
	
	
	
	
	
	
	
	
	
	
	
	
?>