<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *         
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains the display functions for the Top track rating system
	* Created: 9.24.03 by Ross Carlson
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	
	function cmp ($a,$b) { 
		$cmp = strcmp($a[0],$b[0]);
		return $cmp ? $cmp : -1;
	}
	
	// Ok, let's index the ratings directory and get the top 5 tracks
	$retArray = readDirInfo($web_root. $root_dir. "/ratings", "file");
	
	// Ok, now let's read each file and get the ratings
	for ($ctr=0; $ctr < count($retArray); $ctr++){
		if ($retArray[$ctr] <> ""){
			$filename = $web_root. $root_dir. "/ratings/". $retArray[$ctr];
			$handle = fopen ($filename, "rb");
			$contents = fread ($handle, filesize ($filename));
			fclose ($handle);
			
			// Now let's get the full rating for this song
			$rateArray = explode("\n",$contents);
			for ($c=0; $c < count($rateArray); $c++){
				$numArray = explode("|",$rateArray[$c]);
				$rating = $rating + $numArray[1];
			}
			$rating = $rating / ($c - 1);
			$finalRateArray[$ctr][1] = str_replace("---","/",str_replace(".rating","",$retArray[$ctr]));
			$finalRateArray[$ctr][0] = $rating - 10;
			
			unset($rating);
		}
	}
	
	// Now let's sort that array
	if (count($finalRateArray) <> 0){
		usort($finalRateArray, "cmp");
	}
	
	// Let's make sure they wanted to see top tracks
	if ($num_top_ratings <> "0" and count($finalRateArray) <> 0){
		displayRatedTracks($finalRateArray, "true", $num_top_ratings);
	}
	
	function displayRatedTracks($finalRateArray, $displayTop, $numTracks){
		global $mp3_dir, $audio_types, $video_types, $ext_graphic, $img_play, $img_download, 
		$get_mp3_info, $song_cellpadding, $row_colors, $main_table_width, $this_page, $word_play_album, $word_download_album,
		$root_dir, $media_dir, $this_site, $allow_download, $track_num_seperator, $directory_level, $web_root, 
		$num_other_albums, $word_album, $album_name_truncate, $word_play, $img_more, $search_album_art, 
		$word_search_for_album_art, $img_delete, $word_cancel, $word_delete, $word_are_you_sure_delete, $img_add, 
		$img_playlist, $word_check_all, $word_check_none, $word_selected, $word_session_playlist, 
		$word_new_playlist, $playlist_directory, $playlist_ext, $word_play_random, $img_random_play, $javascript, 
		$get_mp3_info, $colapse_tracks, $jinzora_skin, $word_search, $amg_search, $hide_tracks, $word_hide_tracks, 
		$word_show_tracks, $postnuke, $download_mp3_only, $this_site, $word_change_art, $album_force_height, $album_force_width,
		$hide_id3_comments, $img_more_dis, $img_play_dis, $img_download_dis, $url_seperator, $enable_ratings, $img_rate, 
		$img_star, $img_half_star, $num_top_ratings, $num_suggestions;
		
		if ($displayTop == "true"){
			echo "<strong>Top $num_top_ratings rated Tracks</strong><br>";
		}
		echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $song_cellpadding. '" cellspacing="0" border="0">';
		/* Now let's populate our table with all the songs */
		$i = 1;
		for ($loop_ctr=0; $loop_ctr < count($finalRateArray); $loop_ctr++){
			if (preg_match("/\.($audio_types)$/i", $finalRateArray[$loop_ctr][1]) || preg_match("/\.($video_types)$/i", $finalRateArray[$loop_ctr][1]) || preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])) {
				/* Now let's look and see if there is a corresponding descriptive text file, and if so display it */
				$fileInfo = pathinfo($finalRateArray[$loop_ctr][1]);
				$fileExt = $fileInfo["extension"];
				$desc_file_array[1] = $fileExt;
				$desc_file_array[0] = str_replace(".". $fileExt, "",$finalRateArray[$loop_ctr][1]);
	
				// Let's see if this was a .fake file name and if so read it for the data
				if (preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
					$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $finalRateArray[$loop_ctr][1];
				} else {
					$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $desc_file_array[0]. ".txt";
				}
				$mp3_comment = "";
				if (is_file($desc_file) == true){
					/* Ok, it's there so let's open it and display it */
					$filename = $desc_file;
					$handle = fopen ($filename, "rb");
					$mp3_comment = fread ($handle, filesize ($filename));
					fclose ($handle);
				}
				// Let's initalize all these variables in each loop so we don't get dupes
				$mp3_freq = " - "; $mp3_bitrate = " - "; $mp3_size = " - "; $mp3_leng = " - "; $trackDispName = ""; $desc_file = ""; 
				// let's pull id3 and mp3 data from this file using our fancy classes IF they wanted us to
				if ($get_mp3_info == "true"){	
					$fileInfo = pathinfo($finalRateArray[$loop_ctr][1]);
					$fileExt = $fileInfo["extension"];
					$fileInfo = GetAllFileInfo($web_root. $root_dir. $media_dir. "/". $finalRateArray[$loop_ctr][1],$fileExt);
					if (!empty($fileInfo['audio']['bitrate'])) {
						$mp3_bitrate = (round($fileInfo['audio']['bitrate'] / 1000)). ' kbps';
					}
					if (!empty($fileInfo['playtime_string'])) {
						$mp3_leng = $fileInfo['playtime_string'];
					}
					if (!empty($fileInfo['playtime_string'])) {
						$mp3_size = round($fileInfo['filesize']/1024000,1). ' Mb';
					}
					if (!empty($fileInfo['comments']['title'][0])) {
						$trackDispName = $fileInfo['comments']['title'][0];
					}
					// Let's make sure they wanted the ID3 comments...
					if ($hide_id3_comments == "false"){
						if (!empty($fileInfo['comments']['comment'][0]) and ($mp3_comment == "")) {
							$mp3_comment = $fileInfo['comments']['comment'][0];
						}
					}
					if (!empty($fileInfo['audio']['sample_rate'])) {
						$mp3_freq = round($fileInfo['audio']['sample_rate']/1000,1). " kHz";
					}
					
				} else {
					$mp3_freq = " - "; 
					$mp3_bitrate = " - "; 
					$mp3_size = " - "; 
					$mp3_comment = ""; 
					$mp3_leng = " - "; 
					$trackDispName = "";
				}
				
				// let's see if the display name was blank
				if ($trackDispName == ""){
					// Ok, let's figure it out by first removing the extension
					$trackNameArray = explode("/",$finalRateArray[$loop_ctr][1]);
					$trackNameInfo = $trackNameArray[count($trackNameArray)-1];
						
					$fileInfo = pathinfo($trackNameInfo);
					$fileExt = $fileInfo["extension"];
					$trackDispName = str_replace(".". $fileExt,"",$trackNameInfo);
					
					// Ok, now we need to strip off the track number at the beginning, if it's there
					if (is_numeric(substr($trackDispName,0,2))){
						// Ok, let's strip that and the seperator
						$trackDispName = substr($trackDispName,2,strlen($trackDispName) - 2);
						$sepArray = explode("|",$track_num_seperator);
						for ($ctr=0; $ctr < count($sepArray); $ctr++){
							if (strpos($trackDispName,$sepArray[$ctr]) == 0){
								$trackDispName = substr($trackDispName,strlen($sepArray[$ctr])-1, strlen($trackDispName));
							}
						}
					}
				}
				
				echo '<tr class="'. $row_colors[$i]. '">'. "\n";
				/* Let's make sure they aren't a view only user */
				if ($_SESSION['jz_access_level'] <> "viewonly"){
						if ($allow_download == "true"){
							echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
							// Now let's make sure this isn't a fake track
							if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
							// Now let's see if they wanted to download the zip file or the MP3 directly
								if ($download_mp3_only == "true"){
									$link_url = $root_dir. $media_dir. "/". rawurlencode($genre). "/". rawurlencode($artist). "/". rawurlencode($album). "/". rawurlencode($finalRateArray[$loop_ctr][1]);
									// Now let's strip any double slashes from here
									$link_url = jzstripslashes(str_replace("%2F","/",$link_url));
									echo '<a class="jz_track_table_songs_href" href="'. $link_url. '">'. $img_download. '</a>'. "\n";
								} else {
									$link_url = urlencode($genre). "/". urlencode($artist). "/". urlencode($album). "/". urlencode($finalRateArray[$loop_ctr][1]);
									// Now let's strip any double slashes from here
									$link_url = jzstripslashes(str_replace("%2F","/",$link_url));
									echo '<a class="jz_track_table_songs_href" href="'. $this_page. $url_seperator. 'ptype=zip&ztype=song&info='. $link_url. '">'. $img_download. '</a>'. "\n";
								}
							}
						echo'</td>'. "\n";
						}
						
						// This is the link for the mp3 file details popup window
						echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
							// Now let's make sure this isn't a fake track
							if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
								$link_url = $web_root. $root_dir. $media_dir. "/" .$genre. "/". $artist. "/". $album. "/". $finalRateArray[$loop_ctr][1];
								$link_url = jzstripslashes($link_url);
								echo '<a href="'. $root_dir. '/mp3info.php?file='. urlencode($link_url).' " target="_blank" onclick="newWin(this); return false;">'. $img_more. '</a>'. "\n";
							}
						echo '</td>'. "\n";
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
							/* Now let's create the URL for the link */
							$link_url = jzstripslashes($genre. "/". $artist. "/". $album. "/". $finalRateArray[$loop_ctr][1]);
							$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($link_url));
							echo '<a class="jz_track_table_songs_href" href="'. $play_song_link. '">'. $img_play. '</a>'. "\n";
						}
					echo '</td>'. "\n";
					
				} else {			
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
					// Now let's make sure this isn't a fake track
					if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1]) and !preg_match("/\.($video_types)$/i", $finalRateArray[$loop_ctr][1])){
						echo '<input class="jz_checkbox" type="checkbox" disabled>'. "\n";
					}
					echo '</td>'. "\n";	
					// This is the link for the mp3 file details popup window
					echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
							echo $img_more_dis. "\n";
						}
					echo '</td>'. "\n";
						
	
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
							echo $img_play_dis. "\n";
						}
					echo '</td>'. "\n";
				}
					
					
				echo '<td width="38%" valign="top" class="jz_track_table_songs_td">'. "\n";
						/* Let's look and see if the file name has digits at the beginning, indicating the track number and if so don't show it */
						$trackName = $finalRateArray[$loop_ctr][1];
						
						/* Now let's strip off the file extension by removing the extension */
						$fileInfo = pathinfo($root_dir. $media_dir. "/". $genre. "/". $artist. "/". $album. "/". $trackName);
						$fileExt = $fileInfo["extension"];
						$trackName = str_replace(".". $fileExt,"",$trackName);
						if (is_numeric(substr($trackName,0,2))){
							$trackName = substr($trackName,2);
							/* Now let's stip off the track seperator */
							/* First let's build an array of all the possible track seperators and test them all */
							$trackSepArray = explode("|",$track_num_seperator);
							$ctr = 0;
							while (count($trackSepArray) > $ctr){
								if (stristr($trackName,$trackSepArray[$ctr]) <> ""){
									$trackName = trim(str_replace($trackSepArray[$ctr],"",$trackName));
								}							
								$ctr = $ctr + 1;
							}
						} 
						
						/* Now let's create the URL for the link */
						/* Let's make sure they aren't a view only user */
						if ($_SESSION['jz_access_level'] <> "viewonly" and !preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
							$link_url = $genre. "/". $artist. "/". $album. "/". $finalRateArray[$loop_ctr][1];
							$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($link_url));
							echo '<a class="jz_track_table_songs_href" href="'. $play_song_link. '">'. $trackDispName. '</a>'. "\n";
						} else {
							if (!preg_match("/\.(fake.txt)$/i", $finalRateArray[$loop_ctr][1])){
								echo $trackDispName. "\n";
							} else {
								// Now let's strip the .fake off the display name
								echo substr($trackDispName,0,strlen($trackDispName)-5). "\n";
							}	
						}
						
						/* Now let's look and see if there is a corresponding lyric file and if so display a link for it */
						$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $desc_file_array[0]. ".lyrics.txt";
						if (is_file($desc_file) == true){	
							echo ' - <a class="jz_track_table_songs_href" href="'. $this_site. $url_seperator. $root_dir. '/mp3info.php?type=lyrics&info='. urlencode($genre). '/'. rawurlencode($artist). '/'. rawurlencode($album). "/". rawurlencode($desc_file_array[0]). '.lyrics.txt" onclick="lyricsWindow(this); return false;">View Lyrics</a>';
						}
						
						// Now let's look and see if the track had a description in the ID3 tag, and if so display it
						if ($mp3_comment <> ""){
							// Ok, let's display it...
							echo "<br>". $mp3_comment;
						}
						
			   echo '</td>'. "\n";
			   
			   echo '<td width="12%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
					// Now let's get the rating for it, if it's there
					
					$rating = $finalRateArray[$loop_ctr][0] + 10;
					$rating = $rating + .49;
					while ($rating > 1){
						$rating = $rating - 1;
						echo $img_star;
					}
					while ($rating > .5){
						$rating = $rating - .5;
						echo $img_half_star;
					}
					
					echo '</td>'. "\n";
			   
				echo '<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_leng. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_bitrate. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_freq. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_size. "\n".
					'</td>'. "\n".
				'</tr>'. "\n";			
				$i = ++$i % 2;
			}
			// Now let's see how many tracks to display
			if ($loop_ctr == $numTracks - 1){
				$loop_ctr = count($finalRateArray) + 1;
			}
		}
		echo "</table><br>";
	}
	
	// Now let's do the Jinzora's picks part
	include_once('suggestions.php');
?>