<?php
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *         
	* JINZORA | Web-based Media Streamer  
	*
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a PostNuke site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* Jinzora Author:
	* Ross Carlson: ross@jasbone.com 
	* http://jinzora.jasbone.com
	* Documentation: http://jinzora.jasbone.com/docs	
	* Support: http://jinzora.jasbone.com/forum
	* Downloads: http://jinzora.jasbone.com/downloads
	* License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* Contributors:
	* Please see http://jinzora.jasbone.com/modules.php?op=modload&name=jz_whois&file=index
	*
	* Code Purpose: This page contains all the track display related functions
	* Created: 9.24.03 by Ross Carlson
	*
	*
	* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	/* This function displays all the songs for this album */
	function displaySongs($displayHeader=true){
		global $mp3_dir, $audio_types, $video_types, $ext_graphic, $img_play, $img_download, 
		$get_mp3_info, $song_cellpadding, $row_colors, $main_table_width, $this_page, $word_play_album, $word_download_album,
		$root_dir, $media_dir, $this_site, $allow_download, $track_num_seperator, $directory_level, $web_root, 
		$num_other_albums, $word_album, $album_name_truncate, $word_play, $img_more, $search_album_art, 
		$word_search_for_album_art, $img_delete, $word_cancel, $word_delete, $word_are_you_sure_delete, $img_add, 
		$img_playlist, $word_check_all, $word_check_none, $word_selected, $word_session_playlist, 
		$word_new_playlist, $playlist_directory, $playlist_ext, $word_play_random, $img_random_play, $javascript, 
		$get_mp3_info, $colapse_tracks, $jinzora_skin, $word_search, $amg_search, $hide_tracks, $word_hide_tracks, 
		$word_show_tracks, $postnuke, $download_mp3_only, $this_site, $word_change_art, $album_force_height, $album_force_width,
		$hide_id3_comments, $img_more_dis, $img_play_dis, $img_download_dis, $url_seperator, $enable_ratings, $img_rate, 
		$img_star, $img_half_star, $num_top_ratings, $num_suggestions;
			
		// Let's figure out all the paths and make sure we don't need to fix any special characters
		$genre = jzstripslashes(urldecode($_GET['genre']));
		$artist = jzstripslashes(urldecode($_GET['artist']));
		$album = jzstripslashes(urldecode($_GET['album']));
		
		// Let's initialize some variables
		$album_cover = "";
		
		// Let's make sure we didn't call this from somewhere else and that we don't need to display the header
		if ($displayHeader == true){
			/* Let's add the page header based on the type of directory structure */
			switch ($directory_level) {
				case "3" : # 3 directories deep
					if ($genre <> ""){ $head_genre = $genre. " : "; }
					if ($artist <> ""){ $head_artist = $artist. "<br>"; } else { $head_artist = ""; }
					displayHeader($head_genre. $head_artist. $album);
				break;
				
				case "2" : # 2 directories deep
					if ($artist <> ""){ $head_artist = $artist. " : "; } else { $head_artist = ""; }
					displayHeader($head_artist. $album);
				break;
				
				case "1" : # 1 directories deep
					displayHeader($album);
				break;
			}
		} 
		
		// First let's see if we need to delete anything for them
		if ($_GET['delsong'] <> ""){
			// Ok, let's make sure they really want to delete the file
			if ($_POST['reallydel'] <> ""){
				// Ok, delete the damn file already!!!
				unlink($web_root. $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $album. "/". $_GET['delsong']);			
			} else {
				echo $word_are_you_sure_delete. " <br>". $_GET['delsong']. "<br><br>";
				
				// Let's build the URL for below
				if ($_GET['ptype'] <> "") { $ptype = "&ptype=". $_GET['ptype']; } else { $ptype = ""; }
				if ($_GET['genre'] <> "") { $genre = "&genre=". $genre; } else { $genre = ""; }
				if ($artist <> "") { $artist = "&artist=". $artist; } else { $artist = ""; }
				if ($album <> "") { $album = "&album=". $album; } else { $album = ""; }
				$formAction = $this_page. $url_seperator. $ptype. $genre. $artist. $album. "&delsong=". $_GET['delsong'];
				
				// Now let's show our form for this
				echo '<form action="'. $formAction. '" method="post">';
				echo '<input name="reallydel" value="'. $word_delete. '" type="submit" class="jz_submit"> ';
				echo '<input name="cancel" value="'. $word_cancel. '" type="submit" class="jz_submit">';
				echo '</form>';
				exit();
			}
		}
				
		
		/* Let's set the directory that we are looking at */
		$dirToLookIn = $mp3_dir. "/". $genre. "/". $artist. "/". $album;
		
		/* Let's get the album cover if it's in the directory */
		$d = dir($dirToLookIn);
		while($entry = $d->read()) {
			if (preg_match("/\.($ext_graphic)$/i", $entry)) {
				$album_cover =  $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $album. "/". $entry;
				// Now let's resize the image if necessary
				jzResizeAlbum($web_root. $root_dir. $media_dir. "/". $genre. "/". $artist. "/". $album, $entry);
				// Now let's clean up the album cover
				$album_cover = str_replace("%2F","/",rawurlencode($album_cover));
			}
		}
		
		
		// Let's make sure we didn't call this from somewhere else and that we don't need to display the header
		if ($displayHeader == true){
		
			/* Let's setup the table for all the information */
			?>
			<table class="jz_track_album_table" width="<?php echo $main_table_width; ?>%" cellpadding="0" cellspacing="0" border="0">
				<tr class="jz_track_album_table_tr">
					<?php
						// let's see if we found album art or not, and if not let them search for it
						if ($album_cover <> ""){
							// Ok we found art, let's display it
							$link_url = urlencode($genre). "/". urlencode($artist). "/". urlencode($album);
							echo '<td width="5%" valign="top" align="center">';
							// Now need to make sure they aren't view only
							if ($_SESSION['jz_access_level'] <> "viewonly"){
								$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=album&info='. $link_url);
								echo '<a class="jz_track_album_table_href" href="'. $play_song_link. '">';
							}
							echo '<img class="jz_album_cover_picture" title="'. $word_play. " ". $album. '" src="'. $album_cover. '" border="0"></a>';
							// Now let's show them the change link
							if ($_SESSION['jz_access_level'] == "admin"){
								echo '<br><a class="jz_album_cover_table_href" href="'. $this_page. $url_seperator. 'ptype=artsearch&info='. urlencode($_GET['genre']). '|||'. urlencode($_GET['artist']). '|||'. urlencode($_GET['album']). '&return=songs">'.
									 $word_change_art. '</a>';
							}
							echo '</td>'.
								 '<td width="1%">&nbsp;</td>';
						}
						
						// Let's start this cell
						echo '<td width="29%" valign="top" class="jz_track_album_table_td">';
	
						/* Let's make sure this variable is set */
						if (!isset($_SESSION['jz_access_level'])){ $_SESSION['jz_access_level'] = ""; }					
						// Let's the the link for below
						$link_url = urlencode($genre. "/". $artist. "/". $album);
						$search_url = urlencode($genre). "|||". urlencode($artist). "|||". urlencode($album);
						// Let's set the album name and truncate it if needed
						$albumName = $album;
						if (strlen($albumName) > $album_name_truncate){
							$albumName = substr($albumName,0,$album_name_truncate). "...";
						}
						/* Let's make sure they aren't a view only user */
						if ($_SESSION['jz_access_level'] <> "viewonly"){
							// Let's put this into a table to make it look pretty
							if ($album_cover == "" and $search_album_art == "true" and $_SESSION['jz_access_level'] == "admin"){
							// If we didn't find art, let's give them the option of seraching for it
								echo '<table width="100%" cellpadding="0" cellspacing="0" border="0">'.
										'<tr>'.
											'<td width="25" valign="top" class="jz_track_album_table_td">'.
												'<a class="jz_track_album_table_href" href="'. $this_page. $url_seperator. 'ptype=artsearch&info='. $search_url. '">'. $img_more. '</a>'.
											'</td>'.
											'<td width="100%" class="jz_track_album_table_td">'.
												$word_search_for_album_art. "<br><i>". 
												'<a class="jz_track_album_table_href" href="'. $this_page. $url_seperator. 'ptype=artsearch&info='. $search_url. '">'. 
												$album.							
												"</a></i><br><br>".
											'</td>'.
										'</tr>'.
									'</table>';
							}
						}
						// Let's start our table for below
						echo '<table width="100%" cellpadding="0" cellspacing="0" border="0">';
						if ($_SESSION['jz_access_level'] <> "viewonly"){
							$play_album_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=album&info='. $link_url);
							$play_album_rand_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=random&qptype=album&info='. $link_url);
								echo'<tr>'.
										'<td width="25" valign="top" class="jz_track_album_table_td">'.
											'<a class="jz_track_album_table_href" href="'. $play_album_link. '">'. $img_play. '</a>'.
										'</td>'.
										'<td width="100%" class="jz_track_album_table_td">'.
											$word_play_album.
										'</td>'.
									'</tr>'.
									'<tr>'.
										'<td width="20" class="jz_track_album_table_td">'.
											'&nbsp;'.
										'</td>'.
										'<td width="100%" class="jz_track_album_table_td">'.
											'<i><a class="jz_track_album_table_href" href="'. $play_album_link. '">'. urldecode($albumName). '</a></i>'.
										'</td>'.
									'</tr>'.
									'<tr>'.
										'<td colspan="2" width="25" valign="top" height="5" class="jz_track_album_table_td"></td>'.
									'</tr>'.
									'<tr>'.
										'<td width="25" valign="top" class="jz_track_album_table_td">'.
											'<a class="jz_track_album_table_href" href="'. $play_album_rand_link. '">'. $img_random_play. '</a>'.
										'</td>'.
										'<td width="100%" class="jz_track_album_table_td">'.
											$word_play_random.
										'</td>'.
									'</tr>'.
									'<tr>'.
										'<td width="20" class="jz_track_album_table_td">'.
											'&nbsp;'.
										'</td>'.
										'<td width="100%" class="jz_track_album_table_td">'.
											'<i><a class="jz_track_album_table_href" href="'. $play_album_rand_link. '">'. urldecode($albumName). '</a></i>'.
										'</td>'.
									'</tr>';
									if ($allow_download == "true"){
										// First let's get the size for this album
										$album_size = "";
										$d = dir($dirToLookIn);
										$dirSize = 0;
										while($entry = $d->read()) {
											// Let's make sure we are seeing real directories
											if ($entry == "." || $entry == "..") { continue;}
											$dirSize = $dirSize + filesize($dirToLookIn. "/". $entry);
										}
										$album_size = round($dirSize/1024000,0). " MB";
										// Now let's close the directory
										$d->close();										
										
										echo '<tr>'.
												'<td colspan="2" width="25" valign="top" height="5" class="jz_track_album_table_td"></td>'.
											'</tr>'.
											'<tr>'.
											'<td width="25" valign="top" class="jz_track_album_table_td">'.
												'<a class="jz_track_album_table_href" href="'. $this_page. $url_seperator. 'ptype=zip&ztype=album&info='. $link_url. '">'. $img_download. '</a>'.
										'</td>'.
											'<td width="100%" class="jz_track_album_table_td">'.
												$word_download_album.
											'</td>'.
										'</tr>'.
										'<tr>'.
											'<td width="20" class="jz_track_album_table_td">'.
												'&nbsp;'.
											'</td>'.
											'<td width="100%" class="jz_track_album_table_td">'.
												'<i><a class="jz_track_album_table_href" href="'. $this_page. $url_seperator. 'ptype=zip&ztype=album&info='. $link_url. '">'. $albumName. ' ('. $album_size. ')'. '</a></i>'.
											'</td>'.
										'</tr>';
									}
								}
								// Let's see if they wanted the search turned on
								if ($amg_search == "true"){
									echo '<tr>'.
											'<td colspan="2" width="25" valign="top" height="5" class="jz_track_album_table_td"></td>'.
										'</tr>'.
										'<tr>'.
											'<td width="25" valign="top" class="jz_track_album_table_td">';
												if ($_SESSION['jz_access_level'] <> "viewonly"){
													echo $img_download;
												} else {
													echo $img_download_dis;
												}
										echo'</td>'.
											'<td width="100%" class="jz_track_album_table_td">'.
												$word_search. " AMG".
											'</td>'.
										'</tr>'.
										'<tr>'.
											'<td width="20" class="jz_track_album_table_td">'.
												'&nbsp;'.
											'</td>'.
											'<td width="100%" class="jz_track_album_table_td">'.
												"<form action=\"http://www.allmusic.com/cg/amg.dll\" method=POST target=\"_blank\" name=AMGSearchForm>".
												"<input type=hidden name=P value=amg>".
												"<input type=hidden name=sql size=15 maxlength=30 value=\"$albumName\">".
												"<input type=hidden name=opt1 value=2>".
												"<i><a onClick='AMGSearchForm.submit()';\" class=\"jz_track_album_table_href\" href=\"#\">$albumName</a></i>".
												'</form>'.
											'</td>'.
										'</tr>';
								}
								echo '</table>';
							

						/* Ok, now let's see if there is a descriptive text for this song */
						$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/album-desc.txt";
						$contents = "";
						if (is_file($desc_file) == true){
							/* Ok, it's there so let's open it and display it */
							$filename = $desc_file;
							$handle = fopen ($filename, "rb");
							$contents = fread ($handle, filesize ($filename));
							fclose ($handle);
							
							// Now let's do some find and replaces incase they wanted to use some variables here...
							$contents = str_replace("ARTIST_NAME",$artist,$contents);
							$contents = str_replace("ALBUM_NAME",$album,$contents);
						}	
						
						// Let's close out our cell from above
						echo '</td>';
						
						// Let's make sure they really wanted to see other albums
						// and if so create a new cell for it
						echo '<td width="65%" valign="top" class="jz_track_album_table_td" align="right">';
						// Now let's echo the results of the album description if we found it
						echo '<table width="100%" cellpadding="0" cellspacing="0" border="0">'.
								'<tr>'.
									'<td width="50%" class="jz_artist_table_td">'. 
										$contents;
										// Ok, let's look and see if there are any sub dirs here, if there are they MUST be additional albums...
										$searchArray = readDirInfo($web_root. $root_dir. $media_dir. $genre. "/". $artist. "/". $album, "dir");
										if (count($searchArray) <> 0 and $_GET['ptype'] == "songs"){
											// Ok, we must have found a sub dir, so we'll need to display it!
											displayArtist("false", $album);
										}
								echo'</td>'.
									'<td width="50%" align="right" valign="top">';
									
										// Let's see if we can find other albums by this artist and display their pictures
										$sourceDir = $web_root. $root_dir. $media_dir. "/". $genre. "/". $artist;
										$retArray = readDirInfo($sourceDir, "dir");
										$ctr = 0;
										$ctr3 = 0;
										// Now let's shuffle that array
										shuffle($retArray);
										while (count($retArray) > $ctr ){
											// Ok, now we have all the other albums by this artist, so let's see if we can find images
											$albumArray = readDirInfo($sourceDir. "/". $retArray[$ctr], "file");
											$ctr2 = 0;
											while (count($albumArray) > $ctr2){
												// Now let's make sure it's a graphic file we're looking at
												if (preg_match("/\.($ext_graphic)$/i", $albumArray[$ctr2])) {
													// Ok, let's display the album covers if they haven't seen to many already and that this isn't what they are already looking at
													if ($num_other_albums > $ctr3 and $retArray[$ctr] <> $album){
														echo ' <a href="'. $this_page. $url_seperator. 'ptype=songs&genre='. urlencode($genre). '&artist='. urlencode($artist). '&album='. urlencode($retArray[$ctr]). '">';
														// Let's see if they wanted to force the size of this picture
														if ($album_force_height <> "" and $album_force_height <> "0"){
															// Ok, let's force it
															echo '<img width="'. $album_force_width. '" height="'. $album_force_height. '" title="'. $retArray[$ctr]. '" src="'. str_replace("%2F","/",rawurlencode($root_dir. $media_dir. "/". $genre. "/". $artist. "/". $retArray[$ctr]. "/". $albumArray[$ctr2])). '" border="0"></a> &nbsp; ';
														} else {
															// Ok, no force, let's just show it
															echo '<img title="'. $retArray[$ctr]. '" src="'. str_replace("%2F","/",rawurlencode($root_dir. $media_dir. "/". $genre. "/". $artist. "/". $retArray[$ctr]. "/". $albumArray[$ctr2])). '" border="0"></a> &nbsp; ';
														}
														
														
														$ctr3 = $ctr3 + 1;
													}
												}
												$ctr2 = $ctr2 + 1;
											}
											$ctr = $ctr + 1;
										}
									
									
								echo '</td>'.
								'</tr>'.
							'</table>';
						$ctr3 = 0;
						
						echo '</td>';
					?>
				</tr>
			</table>
			<br><br>
		<?php
		// This ends the test above to see if we are showing the header info
		}
		
		?>
		<script type="text/javascript">
			<!--//
				function newWin(obj){
					var sw = screen.width;
					var sh = screen.height;
					var winOpt = "width=360,height=550,left=" + ((sw - 360) / 2) + ",top=" + ((sh - 550) / 2) + ",menubar=no,toolbar=no,location=no,directories=no,status=no,scrollbars=yes,resizable=no";
					thisWin = window.open(obj.href,'Info',winOpt);
				}
			//-->
		</script>
		
		<?php
		
		// This tag hides all the tracks IF they wanted to enable this
		if ($hide_tracks == "true" and $_GET['ptype'] <> "songs"){
			echo '<input name="songDisplayButton" class="jz_submit" value="'. $word_show_tracks. '" type="button" onclick="showHideCon('. "'songs','yes');". '">';
			echo '<DIV id=songsContent style="display: none;">';
		}
		
		// Let's setup our form for the checkboxes
		if ($postnuke == "false"){
			$formAction = $this_page. $url_seperator.  $_SERVER['QUERY_STRING'];
		} else {
			$formAction = $this_page. $url_seperator.  $_SERVER['QUERY_STRING'];
		}
		echo '<form action="'. $formAction. '" name="trackForm" method="POST" onSubmit="return AreYouSure();">';
		echo '<table class="jz_track_table" width="'. $main_table_width. '%" cellpadding="'. $song_cellpadding. '" cellspacing="0" border="0">';
		
		/* Let's get all the sings in the directory using that function */
		$retArray = readDirInfo($dirToLookIn, "file");
	
		/* Now let's populate our table with all the songs */
		$loop_ctr = 0;
		$i = 1;
		while (count($retArray) > $loop_ctr){
			if (preg_match("/\.($audio_types)$/i", $retArray[$loop_ctr]) || preg_match("/\.($video_types)$/i", $retArray[$loop_ctr]) || preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])) {
				
				/* Now let's look and see if there is a corresponding descriptive text file, and if so display it */
				$fileInfo = pathinfo($retArray[$loop_ctr]);
				$fileExt = $fileInfo["extension"];
				$desc_file_array[1] = $fileExt;
				$desc_file_array[0] = str_replace(".". $fileExt, "",$retArray[$loop_ctr]);

				// Let's see if this was a .fake file name and if so read it for the data
				if (preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
					$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $retArray[$loop_ctr];
				} else {
					$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $desc_file_array[0]. ".txt";
				}
				$mp3_comment = "";
				if (is_file($desc_file) == true){
					/* Ok, it's there so let's open it and display it */
					$filename = $desc_file;
					$handle = fopen ($filename, "rb");
					$mp3_comment = fread ($handle, filesize ($filename));
					fclose ($handle);
				}
				// Let's initalize all these variables in each loop so we don't get dupes
				$mp3_freq = " - "; $mp3_bitrate = " - "; $mp3_size = " - "; $mp3_leng = " - "; $trackDispName = ""; $desc_file = ""; 
				// let's pull id3 and mp3 data from this file using our fancy classes IF they wanted us to
				if ($get_mp3_info == "true"){	
					$fileInfo = pathinfo($retArray[$loop_ctr]);
					$fileExt = $fileInfo["extension"];
					$fileInfo = GetAllFileInfo($dirToLookIn. "/". $retArray[$loop_ctr],$fileExt);
					
					if (!empty($fileInfo['audio']['bitrate'])) {
						$mp3_bitrate = (round($fileInfo['audio']['bitrate'] / 1000)). ' kbps';
					}
					if (!empty($fileInfo['playtime_string'])) {
						$mp3_leng = $fileInfo['playtime_string'];
					}
					if (!empty($fileInfo['playtime_string'])) {
						$mp3_size = round($fileInfo['filesize']/1024000,1). ' Mb';
					}
					if (!empty($fileInfo['comments']['title'][0])) {
						$trackDispName = $fileInfo['comments']['title'][0];
					}
					// Let's make sure they wanted the ID3 comments...
					if ($hide_id3_comments == "false"){
						if (!empty($fileInfo['comments']['comment'][0]) and ($mp3_comment == "")) {
							$mp3_comment = $fileInfo['comments']['comment'][0];
						}
					}
					if (!empty($fileInfo['audio']['sample_rate'])) {
						$mp3_freq = round($fileInfo['audio']['sample_rate']/1000,1). " kHz";
					}
					
				} else {
					$mp3_freq = " - "; 
					$mp3_bitrate = " - "; 
					$mp3_size = " - "; 
					$mp3_comment = ""; 
					$mp3_leng = " - "; 
					$trackDispName = "";
				}
				
				// let's see if the display name was blank
				if ($trackDispName == ""){
					// Ok, let's figure it out by first removing the extension
					$fileInfo = pathinfo($retArray[$loop_ctr]);
					$fileExt = $fileInfo["extension"];
					$trackDispName = str_replace(".". $fileExt,"",$retArray[$loop_ctr]);
					
					// Ok, now we need to strip off the track number at the beginning, if it's there
					if (is_numeric(substr($trackDispName,0,2))){
						// Ok, let's strip that and the seperator
						$trackDispName = substr($trackDispName,2,strlen($trackDispName) - 2);
						$sepArray = explode("|",$track_num_seperator);
						for ($ctr=0; $ctr < count($sepArray); $ctr++){
							if (strpos($trackDispName,$sepArray[$ctr]) == 0){
								$trackDispName = substr($trackDispName,strlen($sepArray[$ctr])-1, strlen($trackDispName));
							}
						}
					}
				}
				
				echo '<tr class="'. $row_colors[$i]. '">'. "\n";
				/* Let's make sure they aren't a view only user */
				if ($_SESSION['jz_access_level'] <> "viewonly"){
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
					// Now let's make sure this isn't a fake track
					if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr]) and !preg_match("/\.($video_types)$/i", $retArray[$loop_ctr])){
						echo '<input class="jz_checkbox" type="checkbox" name="track-'. $loop_ctr. '" value="'. str_replace($web_root,"",$dirToLookIn). "/". $retArray[$loop_ctr]. '">'. "\n";
					}
					echo '</td>'. "\n";
						
						if ($allow_download == "true"){
							echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
							// Now let's make sure this isn't a fake track
							if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
							// Now let's see if they wanted to download the zip file or the MP3 directly
								if ($download_mp3_only == "true"){
									$link_url = $root_dir. $media_dir. "/". rawurlencode($genre). "/". rawurlencode($artist). "/". rawurlencode($album). "/". rawurlencode($retArray[$loop_ctr]);
									// Now let's strip any double slashes from here
									$link_url = str_replace("//","/",str_replace("%2F","/",$link_url));
									echo '<a class="jz_track_table_songs_href" href="'. $link_url. '">'. $img_download. '</a>'. "\n";
								} else {
									$link_url = urlencode($genre). "/". urlencode($artist). "/". urlencode($album). "/". urlencode($retArray[$loop_ctr]);
									// Now let's strip any double slashes from here
									$link_url = str_replace("//","/",str_replace("%2F","/",$link_url));
									echo '<a class="jz_track_table_songs_href" href="'. $this_page. $url_seperator. 'ptype=zip&ztype=song&info='. $link_url. '">'. $img_download. '</a>'. "\n";
								}
							}
						echo'</td>'. "\n";
						}
						
						// This is the link for the mp3 file details popup window
						echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
							// Now let's make sure this isn't a fake track
							if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
								$link_url = $web_root. $root_dir. $media_dir. "/" .$genre. "/". $artist. "/". $album. "/". $retArray[$loop_ctr];
								echo '<a href="'. $root_dir. '/mp3info.php?file='. urlencode($link_url).' " target="_blank" onclick="newWin(this); return false;">'. $img_more. '</a>'. "\n";
							}
						echo '</td>'. "\n";
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
							/* Now let's create the URL for the link */
							$link_url = $genre. "/". $artist. "/". $album. "/". $retArray[$loop_ctr];
							$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($link_url));
							echo '<a class="jz_track_table_songs_href" href="'. $play_song_link. '">'. $img_play. '</a>'. "\n";
						}
					echo '</td>'. "\n";
					// Now let's see if they wanted to enable ratings
					if ($enable_ratings == "true"){
						echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
							// Now let's make sure this isn't a fake track
							if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
								/* Now let's create the URL for the link */
								echo '<a class="jz_track_table_songs_href" href="'. $root_dir. '/mp3info.php?type=rate&info='. rawurlencode($genre). '/'. rawurlencode($artist). '/'. rawurlencode($album). "/". rawurlencode($retArray[$loop_ctr]). '" onclick="ratingWindow(this); return false;">'. $img_rate. '</a>';
							}
						echo '</td>'. "\n";
					}
				} else {			
					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
					// Now let's make sure this isn't a fake track
					if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr]) and !preg_match("/\.($video_types)$/i", $retArray[$loop_ctr])){
						echo '<input class="jz_checkbox" type="checkbox" disabled>'. "\n";
					}
					echo '</td>'. "\n";	
					// This is the link for the mp3 file details popup window
					echo '<td width="1%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
							echo $img_more_dis. "\n";
						}
					echo '</td>'. "\n";
						

					echo '<td width="2%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
						// Now let's make sure this isn't a fake track
						if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
							echo $img_play_dis. "\n";
						}
					echo '</td>'. "\n";
				}
					
					
				echo '<td width="38%" valign="top" class="jz_track_table_songs_td">'. "\n";
						/* Let's look and see if the file name has digits at the beginning, indicating the track number and if so don't show it */
						$trackName = $retArray[$loop_ctr];
						
						/* Now let's strip off the file extension by removing the extension */
						$fileInfo = pathinfo($root_dir. $media_dir. "/". $genre. "/". $artist. "/". $album. "/". $trackName);
						$fileExt = $fileInfo["extension"];
						$trackName = str_replace(".". $fileExt,"",$trackName);
						if (is_numeric(substr($trackName,0,2))){
							$trackName = substr($trackName,2);
							/* Now let's stip off the track seperator */
							/* First let's build an array of all the possible track seperators and test them all */
							$trackSepArray = explode("|",$track_num_seperator);
							$ctr = 0;
							while (count($trackSepArray) > $ctr){
								if (stristr($trackName,$trackSepArray[$ctr]) <> ""){
									$trackName = trim(str_replace($trackSepArray[$ctr],"",$trackName));
								}							
								$ctr = $ctr + 1;
							}
						} 
						
						/* Now let's create the URL for the link */
						/* Let's make sure they aren't a view only user */
						if ($_SESSION['jz_access_level'] <> "viewonly" and !preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
							$link_url = $genre. "/". $artist. "/". $album. "/". $retArray[$loop_ctr];
							$play_song_link = str_replace("?&","?",$this_page. $url_seperator. 'ptype=quickplay&style=normal&qptype=song&info='. urlencode($link_url));
							echo '<a class="jz_track_table_songs_href" href="'. $play_song_link. '">'. $trackDispName. '</a>'. "\n";
						} else {
							if (!preg_match("/\.(fake.txt)$/i", $retArray[$loop_ctr])){
								echo $trackDispName. "\n";
							} else {
								// Now let's strip the .fake off the display name
								echo substr($trackDispName,0,strlen($trackDispName)-5). "\n";
							}	
						}
						
						/* Now let's look and see if there is a corresponding lyric file and if so display a link for it */
						$desc_file = $mp3_dir. "/". $genre. "/". $artist. "/". $album. "/". $desc_file_array[0]. ".lyrics.txt";
						if (is_file($desc_file) == true){	
							echo ' - <a class="jz_track_table_songs_href" href="'. $this_site. $url_seperator. $root_dir. '/mp3info.php?type=lyrics&info='. urlencode($genre). '/'. rawurlencode($artist). '/'. rawurlencode($album). "/". rawurlencode($desc_file_array[0]). '.lyrics.txt" onclick="lyricsWindow(this); return false;">View Lyrics</a>';
						}
						
						// Now let's look and see if the track had a description in the ID3 tag, and if so display it
						if ($mp3_comment <> ""){
							// Ok, let's display it...
							echo "<br>". $mp3_comment;
						}
						
			   echo '</td>'. "\n";
			   // Now let's see if they wanted the ratings module
			   if ($enable_ratings == "true"){
			   		echo '<td width="12%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n";
					// Now let's get the rating for it, if it's there
					$filename = $web_root. $root_dir. "/ratings/". str_replace("/","---",jzstripslashes($genre. '/'. $artist. '/'. $album. "/".  $retArray[$loop_ctr])). '.rating';
					if (is_file($filename)){
						// Now let's read the ratings file and get the rating
						$handle = fopen ($filename, "rb");
						$contents = fread ($handle, filesize ($filename));
						fclose ($handle);
						$rateArray = explode("\n",$contents);
						$rating = 0;
						for ($ctr=0; $ctr < count($rateArray); $ctr++){
							$ratingArray = explode("|",$rateArray[$ctr]);
							$rating = $rating + $ratingArray[1];
						}
						$rating = $rating / ($ctr - 1);
						$rating = $rating + .49;
						while ($rating > 1){
							$rating = $rating - 1;
							echo $img_star;
						}
						while ($rating > .5){
							$rating = $rating - .5;
							echo $img_half_star;
						}
					} else {
						echo "&nbsp;";
					}
					echo '</td>'. "\n";
				}
				echo '<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_leng. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_bitrate. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_freq. "\n".
					'</td>'. "\n".
					'<td width="10%" align="center" valign="top" class="jz_track_table_songs_td">'. "\n".
						$mp3_size. "\n".
					'</td>'. "\n".
				'</tr>'. "\n";			
				$i = ++$i % 2;
			}
			
			$loop_ctr = $loop_ctr + 1;
		}
		// Now let's set a field with the number of checkboxes that were here
		echo '<input type="hidden" name="numboxes" value="'. $loop_ctr. '">';
		
		echo "</table><br>";
		echo '</div>';		
		// Now let's show them the playlist bar if we are in song page type
		if ($_GET['ptype'] == "songs"){
			displayPlaylistBar("true");
		}
	}
	
?>