<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/


session_start();

require_once ('./include/inc_conf/conf.inc.php');
require_once ('./include/inc_lib/default.inc.php');
require_once ('./include/inc_lib/general.inc.php');

//define language and check if language file is available
if(isset($_POST['form_lang'])) {
	$_SESSION["wcs_user_lang"] = slweg($_POST['form_lang']);
}
if(!isset($_SESSION["wcs_user_lang"])) {
	$_SESSION["wcs_user_lang"] = strtolower($phpwcms["default_lang"]);
}
if(file_exists('./include/inc_lang/backend/'.$_SESSION["wcs_user_lang"].'/lang.inc.php')) {
	$lang_file_include = './include/inc_lang/backend/'.$_SESSION["wcs_user_lang"].'/lang.inc.php';
} else {
	$lang_file_include = './include/inc_lang/backend/en/lang.inc.php';
}
require_once ($lang_file_include);
require_once ('./include/inc_lang/code.lang.inc.php');

//WYSIWYG EDITOR:
//0 = no wysiwyg editor (default)
//1 = HTMLAREA (compatible with IE5.5+ and Mozilla 1.3+ based webbrowsers)
$_SESSION["wysiwyg_editor"] = 0;
$phpwcms["wysiwyg_editor"] = intval($phpwcms["wysiwyg_editor"]);
if($phpwcms["wysiwyg_editor"]) {
	include_once ("./include/inc_lib/ext/phpsniff/phpSniff.core.php");
	include_once ("./include/inc_lib/ext/phpsniff/phpSniff.class.php");
	$c =& new phpSniff();
	
	switch($phpwcms["wysiwyg_editor"]) {
		case 1:	if($c->browser_is("ie5.5+") || $c->browser_is("mz1.3+") || $c->browser_is("ns7+")) $_SESSION["wysiwyg_editor"] = 1;
				break;
		case 2:	if($c->browser_is("ie5.5+")) $_SESSION["wysiwyg_editor"] = 2;
				break;
		case 3: if($c->browser_is("ie5.5+")) $_SESSION["wysiwyg_editor"] = 2;
				if(!$_SESSION["wysiwyg_editor"]) {
					if($c->browser_is("mz1.3+") || $c->browser_is("ns7+")) $_SESSION["wysiwyg_editor"] = 1;
				}
				break;		
	}
}

if($_POST['form_aktion'] == "login") {

	$login_passed = 0;
	$wcs_user = slweg(trim($_POST['form_loginname']));
	$wcs_pass = slweg(trim($_POST['form_password']));
	
	$sql_query =	"SELECT * FROM ".DB_PREPEND."phpwcms_user WHERE usr_login='".
					aporeplace($wcs_user)."' AND usr_pass=PASSWORD('".
					aporeplace($wcs_pass)."') AND usr_aktiv=1;";

	if($result = mysql_query($sql_query)) {
		if($row = mysql_fetch_array($result)) {
			$_SESSION["wcs_user"]			= $wcs_user;
			$_SESSION["wcs_pass"]			= $wcs_pass;
			$_SESSION["wcs_user_name"] 		= ($row["usr_name"]) ? $row["usr_name"] : $wcs_user;
			$_SESSION["wcs_user_id"]		= $row["usr_id"];
			$_SESSION["wcs_user_aktiv"]		= $row["usr_aktiv"];
			$_SESSION["wcs_user_rechte"]	= $row["usr_rechte"];
			$_SESSION["wcs_user_email"]		= $row["usr_email"];
			$_SESSION["wcs_user_avatar"]	= $row["usr_avatar"];
			$_SESSION["wcs_user_logtime"]	= time();
			$_SESSION["wcs_user_admin"]		= $row["usr_admin"];
			$_SESSION["wcs_user_thumb"]		= 1;
			if($row["usr_lang"]) {
				$_SESSION["wcs_user_lang"]	= $row["usr_lang"];
			}
						
			$_SESSION["structure"]	= unserialize($row["usr_var_structure"]);
			$_SESSION["klapp"]		= unserialize($row["usr_var_privatefile"]);
			$_SESSION["pklapp"]		= unserialize($row["usr_var_publicfile"]);
			
			$login_passed = 1;		
		}
		mysql_free_result($result);
	}
	
	if($login_passed) {
		//Schreiben der Login-Daten in Datenbank
		$check = mysql_query(	"SELECT COUNT(*) FROM ".DB_PREPEND."phpwcms_userlog WHERE logged_user='".
								$wcs_user."' AND logged_in=1;", $db );
		if($row = mysql_fetch_row($check)) {
			if(!$row[0]) {
				//Wenn kein User gefhrt wird, dann neu anlegen
				mysql_query("INSERT INTO ".DB_PREPEND."phpwcms_userlog ".
							"(logged_user, logged_username, logged_start, logged_change, ".
							"logged_in, logged_ip) VALUES ('".
							$wcs_user."', '".$_SESSION["wcs_user_name"]."', ".time().", ".
							time().", 1, '".$_SERVER['REMOTE_ADDR']."');", $db );				
			}
		}
		mysql_free_result($check);
		header("Location: ".$phpwcms["site"].$phpwcms["root"]."phpwcms.php");
		exit();
	} else {
		$err = 1;
	}	
} else {
	//Updaten, wenn User ausgewhlt
	$sql = 	"UPDATE ".DB_PREPEND."phpwcms_userlog SET logged_in = 0, logged_change = UNIX_TIMESTAMP( NOW( ) ) ".
			"WHERE logged_in = 1 AND ( UNIX_TIMESTAMP( NOW( ) ) - logged_change ) > ".$phpwcms["max_time"].";";
	mysql_query($sql, $db);
}

?>
<html>
<head>
<title>phpwcms: LOGIN</title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo PHPWCMS_CHARSET ?>">
<link href="include/inc_css/phpwcms.css" rel="stylesheet" type="text/css">
</head>

<body bgcolor="#D9DEE3" text="#000000" link="#000000" vlink="#000000" alink="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" onLoad="document.login_formular.form_loginname.focus();">
<table width="770" border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF">
  <tr>
    <td colspan="3"><img src="img/phpwcms/phpwcms_logo_1.gif" alt="phpwcms v1.1-RC1" width="200" height="45"></td>
    <td width="1"><img src="img/leer.gif" width="1" height="45"></td>
    <td colspan="3" bgcolor="#92A1AF">&nbsp;</td>
    <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
  <tr>
    <td colspan="7"><img src="img/leer.gif" width="1" height="1"></td>
    <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
  <tr>
    <td colspan="3" bgcolor="#92A1AF"><img src="img/leer.gif" width="1" height="25"></td>
    <td><img src="img/leer.gif" width="1" height="25"></td>
    <td align="center" bgcolor="#FF3300"><img src="img/leer.gif" width="15" height="1"></td>
    <td align="center" bgcolor="#FF3300">&nbsp;</td>
    <td align="center" bgcolor="#FF3300"><img src="img/leer.gif" width="15" height="1"></td>
    <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
  <tr>
    <td colspan="8"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
  <tr>
    <td width="14" rowspan="3" bgcolor="#D9DEE3"><img src="img/leer.gif" width="14" height="1"></td>
    <td bgcolor="#D9DEE3"><img src="img/leer.gif" width="1" height="12"></td>
    <td width="11" rowspan="3" bgcolor="#D9DEE3"><img src="img/leer.gif" width="11" height="1"></td>
    <td rowspan="3"><img src="img/leer.gif" width="1" height="1"></td>
    <td width="15" rowspan="3"><img src="img/leer.gif" width="15" height="1"></td>
    <td><img src="img/leer.gif" width="1" height="12"></td>
    <td width="15" rowspan="3"><img src="img/leer.gif" width="15" height="1"></td>
    <td width="1" rowspan="3"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
  <tr>
    <td width="175" align="right" valign="top" bgcolor="#D9DEE3"><?php
	
	echo '<span class="title">'.$BL['usr_online'].'</span><br />';
	echo '<img src="img/leer.gif" width="1" height="3"><br />';			
	echo online_users($db, '<br />', '<span class="useronline">|</span>');
	
	?></td>
    <td width="538" valign="top" class="v11b"><table width="229" border="0" cellpadding="0" cellspacing="0">
      <form name="login_formular" method="post" action="login.php" autocomplete="off">
        <tr><td width="389" class="title"><?php echo $BL["login_text"] ?></td></tr>
		<tr><td><img src="img/leer.gif" width="1" height="3"></td></tr>
		<?php if($err) { echo '<tr><td class="error">'.$BL["login_error"].'</td></tr>'; } ?>
        <tr><td><img src="img/leer.gif" width="1" height="10"></td></tr>
        <tr><td class="v10"><?php echo $BL["login_username"] ?>:</td></tr>
        <tr><td><input name="form_loginname" type="text" id="form_loginname" class="f11b" style="width:250px;" size="30" maxlength="30" value="<?php echo html_specialchars($wcs_user); ?>"></td></tr>
        <tr><td><img src="img/leer.gif" width="1" height="3"></td></tr>
        <tr><td class="v10"><?php echo $BL["login_userpass"] ?>:</td></tr>
        <tr><td><input name="form_password" type="password" id="form_password" class="f11b" style="width:250px;" size="30" maxlength="20"></td></tr>
        <tr><td><img src="img/leer.gif" width="1" height="3"></td></tr>
        <tr><td class="v10"><?php echo $BL["login_lang"] ?>:</td></tr>
		<tr><td><img src="img/leer.gif" width="1" height="1"></td></tr>
        <tr>
        <td><select name="form_lang" id="form_lang" class="f11" style="width:250px;">
<?php
// check available languages installed and build language selector menu
$lang_dirs = opendir("./include/inc_lang/backend");
while($lang_codes = readdir( $lang_dirs )) {
	if( $lang_codes != "." && $lang_codes != ".." && file_exists("./include/inc_lang/backend/".$lang_codes."/lang.inc.php")) {
		echo '<option value="'.$lang_codes.'"';
		echo ($lang_codes == $_SESSION["wcs_user_lang"]) ? " selected" : "";
		echo '>';
		echo (isset($BL[strtoupper($lang_codes)])) ? $BL[strtoupper($lang_codes)] : strtoupper($lang_codes);
		echo "</option>\n";
	}
}
closedir( $lang_dirs );


?>
        </select></td>
        </tr>
        <tr><td><img src="img/leer.gif" width="1" height="18"></td></tr>
        <tr><td><input name="Submit" type="submit" class="button10" value="<?php echo $BL["login_button"] ?>"><input name="form_aktion" type="hidden" id="form_aktion" value="login"></td></tr>
      </form>
    </table></td>
  </tr>
  <tr>
    <td width="175" bgcolor="#D9DEE3"><img src="img/leer.gif" width="1" height="15"></td>
    <td><img src="img/leer.gif" width="1" height="30"></td>
  </tr>
  <tr><td colspan="8"><img src="img/leer.gif" width="1" height="1"></td></tr>
  <tr>
    <td width="14" bgcolor="#FF3300"><img src="img/leer.gif" width="14" height="1"></td>
    <td width="175" bgcolor="#FF3300"><img src="img/phpwcms/phpwcms_copyright_1.gif" alt="copyright &copy; 2003 webverbund.de" width="135" height="7"></td>
    <td width="11" bgcolor="#FF3300"><img src="img/leer.gif" width="11" height="1"></td>
    <td><img src="img/leer.gif" width="1" height="25"></td>
    <td colspan="3" bgcolor="#92A1AF">&nbsp;</td>
    <td><img src="img/leer.gif" width="1" height="25"></td>
  </tr>
  <tr>
    <td><img src="img/leer.gif" width="14" height="1"></td>
    <td><img src="img/leer.gif" width="175" height="1"></td>
    <td><img src="img/leer.gif" width="11" height="1"></td>
    <td><img src="img/leer.gif" width="1" height="1"></td>
    <td width="15"><img src="img/leer.gif" width="11" height="1"></td>
    <td><img src="img/leer.gif" width="538" height="1"></td>
    <td width="15"><img src="img/leer.gif" width="15" height="1"></td>
    <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
</table>
</body>
</html>