<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

session_start();

//require_once ('./include/inc_lang/backend/en/lang.inc.php');
require_once ('./include/inc_conf/conf.inc.php');
if(!(trim($_SESSION["wcs_user_lang"]))) $_SESSION["wcs_user_lang"] = strtolower($phpwcms["default_lang"]);
require_once ('./include/inc_lang/backend/'.$_SESSION["wcs_user_lang"].'/lang.inc.php');
require_once ('./include/inc_lib/default.inc.php');
require_once ('./include/inc_lib/general.inc.php');
require_once ('./include/inc_lib/checklogin.inc.php');
require_once ('./include/inc_lib/navi_text.inc.php');
require_once ('./include/inc_lib/checkmessage.inc.php');

$phpwcms["version"] = "1.1-RC2"; // 01-01-2004

$subnav = ""; //Sub Navigation
if(isset($_GET["p"])) $p = intval($_GET["p"]); //which page should be opened

//which backend section and which $do action
$do = $_GET["do"];
switch ($do) {

	case "articles":	//articles
						include_once "./include/inc_lib/admin.functions.inc.php";
						$wcsnav["articles"] = "<strong class=\"navtexta\">".$wcsnav["articles"]."</strong>";
						include "./include/inc_lib/article.contenttype.inc.php"; //loading array with actual content types
						include "./include/inc_lib/article.functions.inc.php"; //loading article funtions
						$subnav .= subnavtext($BL['be_subnav_article_center'], "phpwcms.php?do=articles", $p, "", 0);
						$subnav .= subnavtext($BL['be_subnav_article_new'], "phpwcms.php?do=articles&p=1", $p, "1", 0);
						break;
	
	case "files":		//files
						$wcsnav["files"] = "<strong class=\"navtexta\">".$wcsnav["files"]."</strong>";
						$subnav .= subnavtext($BL['be_subnav_file_center'], "phpwcms.php?do=files", $p, "", 0);
						$subnav .= subnavtext($BL['be_subnav_file_ftptakeover'], "phpwcms.php?do=files&p=8", $p, "8", 0);
						break;
	
	case "modules":		//modules
						$wcsnav["modules"] = "<strong class=\"navtexta\">".$wcsnav["modules"]."</strong>";
						$subnav .= subnavtext($BL['be_subnav_mod_artists'], "phpwcms.php?do=modules", $p, "", 0);
						break;
						
	case "messages":	//messages
						$wcsnav["messages"] = "<strong class=\"navtexta\">".$wcsnav["messages"]."</strong>";
						$subnav .= subnavtext($BL['be_subnav_msg_center'], "phpwcms.php?do=messages", $p, "", 0);
						$subnav .= subnavtext($BL['be_subnav_msg_new'], "phpwcms.php?do=messages&p=1", $p, "1", 0);
						if($_SESSION["wcs_user_admin"] == 1) {
							$subnav .= '<tr><td colspan="2"><img src="img/leer.gif" height="5" width="1"></td></tr>'."\n";
							$subnav .= subnavtext($BL['be_subnav_msg_newsletter'], "phpwcms.php?do=messages&p=2", $p, "2", 0);
						}
						break;
	
	case "discuss":		//discuss
						$wcsnav["discuss"] = "<strong class=\"navtexta\">".$wcsnav["discuss"]."</strong>";
						break;
	
	case "chat":		//chat
						$wcsnav["chat"] = "<strong class=\"navtexta\">".$wcsnav["chat"]."</strong>";
						$subnav .= subnavtext($BL['be_subnav_chat_main'], "phpwcms.php?do=chat", $p, "", 0);
						$subnav .= subnavtext($BL['be_subnav_chat_internal'], "phpwcms.php?do=chat&p=1", $p, "1", 0);
						break;
	
	case "profile":		//profile
						$wcsnav["profile"] = "<strong class=\"navtexta\">".$wcsnav["profile"]."</strong>";
						switch($_POST["form_aktion"]) { //Aktualisieren der wcs account & profile Daten
							case "update_account":	include "./include/inc_lib/profile.updateaccount.inc.php"; break;
							case "update_detail":	include "./include/inc_lib/profile.update.inc.php"; break;
							case "create_detail":	include "./include/inc_lib/profile.create.inc.php"; break;						
						}
						$subnav .= subnavtext($BL['be_subnav_profile_login'], "phpwcms.php?do=profile", $p, "", 0);
						$subnav .= subnavtext($BL['be_subnav_profile_personal'], "phpwcms.php?do=profile&p=1", $p, "1", 0);
						break;
	
	case "logout":		//Logout
						mysql_query("UPDATE ".DB_PREPEND."phpwcms_userlog SET logged_change=".time().", logged_in=0 WHERE logged_user='".$_SESSION["wcs_user"]."' AND logged_in=1;");
						session_destroy();
						header("Location: ".$phpwcms["site"].$phpwcms["root"]."login.php");
						exit();
						break;
						
	case "admin":		//Admin
						if($_SESSION["wcs_user_admin"] == 1) {
							include_once "./include/inc_lib/admin.functions.inc.php";
							$subnav .= subnavtext($BL['be_subnav_admin_sitestructure'], "phpwcms.php?do=admin&p=6", $p, "6", 0);
							$subnav .= '<tr><td colspan="2"><img src="img/leer.gif" height="5" width="1"></td></tr>'."\n";
							$subnav .= subnavtext($BL['be_subnav_admin_pagelayout'], "phpwcms.php?do=admin&p=8", $p, "8", 0);
							$subnav .= subnavtext($BL['be_subnav_admin_templates'], "phpwcms.php?do=admin&p=11", $p, "11", 0);
							$subnav .= subnavtext($BL['be_subnav_admin_css'], "phpwcms.php?do=admin&p=10", $p, "10", 0);
							$subnav .= '<tr><td colspan="2"><img src="img/leer.gif" height="5" width="1"></td></tr>'."\n";
							$subnav .= subnavtext($BL['be_subnav_admin_users'], "phpwcms.php?do=admin", $p, "", 0);
							$subnav .= subnavtext($BL['be_subnav_admin_filecat'], "phpwcms.php?do=admin&p=7", $p, "7", 0);
							$subnav .= '<tr><td colspan="2"><img src="img/leer.gif" height="15" width="1"></td></tr>'."\n";
							$phpinfo_subnavid = "subnavid".randpassword(5);
							$subnav .= '<tr><td align="right" class="subnavinactive"><a href="include/inc_act/act_phpinfo.php" target="_blank" ';
							$subnav .= "onMouseOver=\"".$phpinfo_subnavid.".src='img/subnav/subnav_1.gif'\" onMouseOut=\"".$phpinfo_subnavid.".src='img/subnav/subnav_0.gif'\">";
							$subnav .= 'phpinfo()</a></td><td><img name="'.$phpinfo_subnavid.'" src="img/subnav/subnav_0.gif" width="15" height="13" border="0"></td></tr>';
							if($phpwcms["phpmyadmin"]) {
								$phpinfo_subnavid = "subnavid".randpassword(5);
								$subnav .= '<tr><td align="right" class="subnavinactive"><a href="include/inc_ext/phpMyAdmin/" target="_blank" ';
								$subnav .= "onMouseOver=\"".$phpinfo_subnavid.".src='img/subnav/subnav_1.gif'\" onMouseOut=\"".$phpinfo_subnavid.".src='img/subnav/subnav_0.gif'\">";
								$subnav .= 'phpMyAdmin</a></td><td><img name="'.$phpinfo_subnavid.'" src="img/subnav/subnav_0.gif" width="15" height="13" border="0"></td></tr>';
							}
						}
						break;

} //Ende Auswahl Aktion


//Subnav Wrap Text Tabelle
if($subnav) {
	$subnav  = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n".$subnav;
	$subnav .= "<tr><td colspan=\"2\"><img src=\"img/leer.gif\" width=\"1\" height=\"15\"></td></tr>\n</table>";
}

//Wenn der User kein Admin ist, anderenfalls
if(!intval($_SESSION["wcs_user_admin"])) {
	unset($wcsnav["admin"]);
} else {
	if($_GET["do"] == "admin") {
		$do = $_GET["do"];
		$wcsnav["admin"] = '<strong class="navtexta">'.$wcsnav["admin"].'</strong>';
	}	
}

//komplettes Script Cachen, um spter header-Umleitungen zu ermglichen
if($phpwcms["compress_page"]) { 
	ob_start("ob_gzhandler"); //mit GZIP-Kompression
} else {
	ob_start(); //ohne Kompression
}
?>
<html>
<head>
<title><?php echo $BL['be_page_title'] ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo PHPWCMS_CHARSET ?>">
<link href="include/inc_css/phpwcms.css" rel="stylesheet" type="text/css">
<script src="include/inc_js/phpwcms.js" type="text/javascript"></script>
<?php
if($do == "messages" && $p == 1) include_once("./include/inc_lib/message.sendjs.inc.php");
if($do == "articles" && $p == 2 && intval($_GET["aktion"]) == 2) {
	echo '<script language="Javascript" type="text/JavaScript" src="include/inc_js/selectbox.js"></script>'."\n";
}

?>
</head>

<body bgcolor="#D9DEE3" text="#000000" link="#000000" vlink="#000000" alink="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" <?php echo $body_onload; ?>>
<table width="770" border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF">
	<tr>
	  <td colspan="3"><a href="phpwcms.php" target="_top"><img src="img/phpwcms/phpwcms_logo_1.gif" alt="phpwcms v1.1-RC1" width="200" height="45" border="0"></a></td>
	  <td width="1"><img src="img/leer.gif" width="1" height="45"></td>
	  <td colspan="3" bgcolor="#92A1AF">&nbsp;</td>
	  <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
	</tr>
	<tr>
	  <td colspan="7"><img src="img/leer.gif" width="1" height="1"></td>
      <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
	</tr>
	<tr>
	  <td colspan="3" bgcolor="#92A1AF"><img src="img/leer.gif" width="1" height="25"></td>
	  <td><img src="img/leer.gif" width="1" height="25"></td>
	  <td colspan="3" bgcolor="#FF3300"><table width="568" border="0" cellpadding="0" cellspacing="0">
	  		<tr>
    			<td width="15"><img src="img/leer.gif" width="15" height="25"></td>
    			<td width="478" class="navtext"><?php 
	  
				//Generieren der Menzeile mit Grafik
				//foreach ($wcsnav as $wcsnav_output) echo $wcsnav_output;
				$nav_x=0;
				foreach ($wcsnav as $wcsnav_output) { //Generieren der Menzeile mit Text
					echo ($nav_x) ? "&nbsp;&nbsp;&nbsp;".$wcsnav_output : $wcsnav_output;	  	
					$nav_x++;
				}
				
				?></td>
				<td width="60" align="right" class="navtext"><a href="phpwcms.php?do=logout" target="_top"><?php echo $BL['be_nav_logout'] ?></a></td>
				<td width="15"><img src="img/leer.gif" width="15" height="25"></td>
			</tr>
		</table></td>
	  <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
	</tr>
	<tr><td colspan="8"><img src="img/leer.gif" width="1" height="1"></td></tr>
	<tr>
	  <td width="14" rowspan="3" bgcolor="#D9DEE3"><img src="img/leer.gif" width="14" height="1"></td>
      <td bgcolor="#D9DEE3"><img src="img/leer.gif" width="1" height="12"></td>
      <td width="11" rowspan="3" bgcolor="#D9DEE3"><img src="img/leer.gif" width="11" height="1"></td>
      <td><img src="img/leer.gif" width="1" height="12"></td>
      <td width="15" rowspan="3"><img src="img/leer.gif" width="15" height="1"></td>
      <td><img src="img/leer.gif" width="1" height="12"></td>
      <td width="15" rowspan="3"><img src="img/leer.gif" width="15" height="1"></td>
      <td width="1" rowspan="3"><img src="img/leer.gif" width="1" height="1"></td>
	</tr>
	<tr>
		<td width="175" align="right" valign="top" bgcolor="#D9DEE3"><?php 
		
	echo $subnav;
	echo '<img src="img/leer.gif" width="1" height="5"><br /><span class="title">';
	echo $BL['usr_online'];
	echo '</span><br /><img src="img/leer.gif" width="1" height="3"><br />';			
	echo online_users($db, "<br />", "<span class=\"subnavinactive\">|</span>");
		
		?></td>
	    <td><img src="img/leer.gif" width="1" height="275"></td>
      <td width="538" valign="top" class="v11b"><?php
	//In diesem Bereich dann Einfgen der entsprechenden Seiteninhalte analog zum gewhlten Menpunkt
	switch($do) {

		case "profile":	//Profile
						switch($p) {
							case 1:		include_once "./include/inc_tmpl/profile.data.tmpl.php";
										break;
							default:	include_once "./include/inc_tmpl/profile.account.tmpl.php";
						}
						break;	
		
		case "files":	//Hochladen sowie Downloaden und Verwalten von Dateien
						switch($p) {
							case 8:		//FTP File upload
										include_once "./include/inc_lib/files.create.dirmenu.inc.php";
										include_once "./include/inc_tmpl/files.ftptakeover.tmpl.php";		
										break;
							default:	include_once "./include/inc_tmpl/files.reiter.tmpl.php"; //Files Navigation/Reiter
										switch($files_folder) {		
											case 0:	//Listing der Privaten Dateien
													if(isset($_GET["mkdir"]) || intval($_POST["dir_aktion"]) == 1) include_once "./include/inc_tmpl/files.private.newdir.tmpl.php";
													if(isset($_GET["editdir"]) || intval($_POST["dir_aktion"]) == 2) include_once "./include/inc_tmpl/files.private.editdir.tmpl.php";
													if(isset($_GET["upload"]) || intval($_POST["file_aktion"]) == 1) {
														include_once "./include/inc_lib/files.create.dirmenu.inc.php";
														include_once "./include/inc_lib/imagick.convert.inc.php";
														include_once "./include/inc_tmpl/files.private.upload.tmpl.php";
													}
													if(isset($_GET["editfile"]) || intval($_POST["file_aktion"]) == 2) {
														include_once "./include/inc_lib/files.create.dirmenu.inc.php";
														include_once "./include/inc_tmpl/files.private.editfile.tmpl.php";
													}
													include_once "./include/inc_lib/files.private-functions.inc.php"; //Listing-Funktionen einfgen
													include_once "./include/inc_lib/files.private.additions.inc.php"; //Zustzliche Private Funktionen
													break;
											case 1: //Funktionen zum Listen von Public Files
													include_once "./include/inc_lib/files.public-functions.inc.php"; //Public Listing-Funktionen einfgen
													include_once "./include/inc_tmpl/files.public.list.tmpl.php"; //Elemetares fr Public Listing
													break;					
											case 2:	//Dateien im Papierkorb
													include_once "./include/inc_tmpl/files.private.trash.tmpl.php";
													break;					
											case 3:	//Dateisuche
													include_once "./include/inc_tmpl/files.search.tmpl.php";
													break;		
										}
										include_once "./include/inc_tmpl/files.abschluss.tmpl.php"; //Abschlieende Tabellenzeile = dicke Linie
						}
						break;
		
		case "chat":	//Chat
						switch($p) {
							case 0: include_once "./include/inc_tmpl/chat.main.tmpl.php"; break; //Chat Startseite
							case 1: include_once "./include/inc_tmpl/chat.list.tmpl.php"; break; //Chat/Listing
						}
						break;
		
	   case "messages":	//Messages
	   					switch($p) {
							case 0: include_once "./include/inc_tmpl/message.center.tmpl.php"; break; //Messages Overview
							case 1: include_once "./include/inc_tmpl/message.send.tmpl.php";   break;	//New Message
							case 2: //Newsletter subscription
									if($_SESSION["wcs_user_admin"] == 1) include_once "./include/inc_tmpl/message.subscription.tmpl.php";
									break; 
						}
						break;
		
		case "modules":	//Modules
						switch($p) {
							//module artist
							case 0: $modules["artist"]["page"] = intval($_GET['f']); //which artist page is activated
									
if(!isset($_GET["s"])) {
//as long as no edit or create selected
							
?><table width="538" border="0" cellspacing="0" cellpadding="0">
		<tr><td class="title">artists, categories and genres</td></tr>
		<tr><td><img src="img/leer.gif" width="1" height="6"></td></tr>
		<tr><td><table width="538" border="0" cellpadding="2" cellspacing="0">
          <tr>
            <td width="90" align="center" background="img/background/bg_eckeli.gif" <?php which_folder_active($modules["artist"]["page"], 0, "#92A1AF") ?>><a href="phpwcms.php?do=modules&p=0&f=0">artists</a></td>
            <td width="90" align="center" background="img/background/bg_eckeli.gif" <?php which_folder_active($modules["artist"]["page"], 1, "#92A1AF") ?>><a href="phpwcms.php?do=modules&p=0&f=1">category</a></td>
            <td width="90" align="center" background="img/background/bg_eckeli.gif" <?php which_folder_active($modules["artist"]["page"], 2, "#92A1AF") ?>><a href="phpwcms.php?do=modules&p=0&f=2">genre</a></td>
			<td width="252" align="right" class="subnavinactive"><?php
			
	echo '<img src="img/button/add_7x7.gif"> <a href="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'&s=0" target="_top">';
	switch ($modules["artist"]["page"]) {
		case 0:	echo "add artist</a>&nbsp;"; break;
		case 1:	echo "add category</a>&nbsp;"; break;
		case 2:	echo "add genre</a>&nbsp;"; break;
	}			
		?></td>
          </tr>
        </table></td></tr>
		<tr><td bgcolor="#92A1AF"><img src="img/leer.gif" width="1" height="2"></td>
		</tr>
	</table><?php

	switch ($modules["artist"]["page"]) {
	
		case 0:	// loop listing available artists
				include "./include/inc_module/mod_artists/inc_tmpl/list.artist.tmpl.php";	break;
		case 1:	// loop listing available categories
				include "./include/inc_module/mod_artists/inc_tmpl/list.category.tmpl.php";	break;
		case 2:	// loop listing available genres
				include "./include/inc_module/mod_artists/inc_tmpl/list.genre.tmpl.php";	break;
	}

} else {

	// if edit or create entry
	switch ($modules["artist"]["page"]) {
		case 0:	// edit or create artist
				include "./include/inc_module/mod_artists/inc_tmpl/edit.artist.tmpl.php";	break;
		case 1:	// edit or create category
				include "./include/inc_module/mod_artists/inc_tmpl/edit.category.tmpl.php";	break;
		case 2:	// edit or create genre
				include "./include/inc_module/mod_artists/inc_tmpl/edit.genre.tmpl.php";	break;
	}											

}
									break;
									// finish module artist

						}
						break;
		
		case "admin":	//Administration
						if($_SESSION["wcs_user_admin"] == 1) {
							switch($p) {
								case 0: //User Administration
										switch(intval($_GET["s"])) {
											case 1: include_once "./include/inc_tmpl/admin.newuser.tmpl.php";  break; //New User
											case 2: include_once "./include/inc_tmpl/admin.edituser.tmpl.php"; break; //Edit User
										}
										include_once "./include/inc_tmpl/admin.listuser.tmpl.php";
										break;
								case 6: //article structure
										include_once "./include/inc_lib/admin.structure.inc.php";										
										if(isset($_GET["struct"])) {										
											include_once "./include/inc_tmpl/admin.structform.tmpl.php";
										} else {
											include_once "./include/inc_tmpl/admin.structlist.tmpl.php";
										}
	  									break;
								case 7:	//File Categories
										include_once "./include/inc_tmpl/admin.filecat.tmpl.php";
										break;
								case 8:	//Page Layout
										include_once "./include/inc_tmpl/admin.pagelayout.tmpl.php";
										break;
							   case 10:	//Frontend CSS
										include_once "./include/inc_tmpl/admin.frontendcss.tmpl.php";
										break;
							   case 11:	//Templates
							   			include_once "./include/inc_tmpl/admin.templates.tmpl.php";
										break;

							}
						}
						break;

	   case "articles":	//Artikelbearbeitung
	   					switch ($p) {
	   						case 0: include_once "./include/inc_tmpl/article.structlist.tmpl.php";	break;
							case 1: include_once "./include/inc_tmpl/article.new.tmpl.php";			break; //Neuen Artikel anlegen
							case 2: include_once "./include/inc_lib/article.editcontent.inc.php";	break; //Contentedit
						}
						break;

		default:		//Wenn kein Menpunkt ausgewhlt ist, dann Standardseite anzeigen (bersicht)
						include_once "./include/inc_tmpl/default.tmpl.php";	
	}

?></td>
    </tr>
	<tr>
	  <td width="175" bgcolor="#D9DEE3"><img src="img/leer.gif" width="1" height="15"></td>
	  <td><img src="img/leer.gif" width="1" height="15"></td>
	  <td><img src="img/leer.gif" width="1" height="15"></td>
	</tr>
	<tr><td colspan="8"><img src="img/leer.gif" width="1" height="1"></td></tr>
	<tr>
	  <td width="14" bgcolor="#FF3300"><img src="img/leer.gif" width="14" height="1"></td>
	  <td width="175" bgcolor="#FF3300"><img src="img/phpwcms/phpwcms_copyright_1.gif" alt="copyright &copy; 2003 webverbund.de" width="135" height="7"></td>
	  <td width="11" bgcolor="#FF3300"><img src="img/leer.gif" width="11" height="1"></td>
	  <td><img src="img/leer.gif" width="1" height="25"></td>
	  <td colspan="3" bgcolor="#92A1AF">&nbsp;</td>
	  <td><img src="img/leer.gif" width="1" height="25"></td>
  </tr>
	<tr>
	  <td><img src="img/leer.gif" width="14" height="1"></td>
	  <td><img src="img/leer.gif" width="175" height="1"></td>
	  <td><img src="img/leer.gif" width="11" height="1"></td>
	  <td><img src="img/leer.gif" width="1" height="1"></td>
	  <td width="15"><img src="img/leer.gif" width="15" height="1"></td>
	  <td><img src="img/leer.gif" width="538" height="1"></td>
      <td width="15"><img src="img/leer.gif" width="15" height="1"></td>
      <td width="1"><img src="img/leer.gif" width="1" height="1"></td>
  </tr>
</table>
<?php
set_chat_focus($do, $p); //Set Focus for chat insert filed
forward_to($forward_to_message_center, $phpwcms["site"].$phpwcms["root"]."phpwcms.php?do=messages", 2500); //If new message was sent -> automatic forwarding to message center
?>
</body>
</html>
<?php
ob_end_flush();
?>