<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2003 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

// creates an RSS 1.0 compatible feed

require_once ("include/inc_conf/conf.inc.php");
require_once ("include/inc_conf/conf.rss.inc.php");
require_once ("include/inc_lib/default.inc.php");
require_once ("include/inc_lib/ext/rsswriter/rss10.inc.php");


define("SITE_URL", $phpwcms["site"].$phpwcms["root"]);

//method to get the right rss (article) category that should be shown
//if there is only the ?alias try to find the right category
if(isset($_GET["rssfeed"])) {
	$rss["cat_id"] = intval($_GET["rssfeed"]);
} else {
	$rss["cat_id"] = "all";
	if(sizeof($_GET)) {
		foreach($_GET as $key => $value) {
			$alias = trim($key);
			break;
		}
		$sql  = "SELECT acat_id FROM ".DB_PREPEND."phpwcms_articlecat WHERE acat_alias LIKE '";
		$sql .= str_replace("'", "''", $alias)."' LIMIT 1;";
		if($result = mysql_query($sql, $db)) {
			if($row = mysql_fetch_row($result)) {
				$rss["cat_id"] = $row[0];
			}
			mysql_free_result($result);
		}
	}
}

$sql  =	"SELECT *, UNIX_TIMESTAMP(article_tstamp) AS article_date ";
$sql .=	"FROM ".DB_PREPEND."phpwcms_article LEFT JOIN ".DB_PREPEND."phpwcms_articlecat ON ";
$sql .=	DB_PREPEND."phpwcms_article.article_cid=".DB_PREPEND."phpwcms_articlecat.acat_id WHERE ";
$sql .=	($rss["cat_id"] !== "all") ? DB_PREPEND."phpwcms_article.article_cid=".$rss["cat_id"]." AND " : "";
$sql .= DB_PREPEND."phpwcms_article.article_public=1 AND ".DB_PREPEND."phpwcms_article.article_aktiv=1 AND ";
$sql .= DB_PREPEND."phpwcms_article.article_deleted=0 AND ".DB_PREPEND."phpwcms_article.article_begin < NOW() ";
$sql .= "AND ".DB_PREPEND."phpwcms_article.article_end > NOW() ";
$sql .= "ORDER BY ".DB_PREPEND."phpwcms_article.article_cid, ".DB_PREPEND."phpwcms_article.article_tstamp;";

$rss["output"] = new RSSWriter(	$rss["link"], htmlspecialchars($rss["title"]), htmlspecialchars($rss["description"]) );

if($result = mysql_query($sql, $db)) {
	while($row = mysql_fetch_array($result)) {
		
		$rss["output"]->addItem(	$rss["link"]."index.php?id=0,".$row["article_id"].",0,0,1,0", 
									htmlspecialchars($row["article_title"]), 
							array(	"category"		=> htmlspecialchars(($row["acat_name"])?$row["acat_name"]:"index"),
									"description"	=> html_parser(htmlspecialchars(($row["article_summary"])?$row["article_summary"]:$row["article_subtitle"])),
									"dc:date"		=> date("Y-m-d", $row["article_date"]),
									"dc:creator"	=> htmlspecialchars($row["article_username"])
								  )
								);
		
		
	}
	mysql_free_result($result);
}
		
$rss["output"]->serialize();


// remove all unwanted placeholder or do place holders
function html_parser($string) {
	// parse the $string and replace all possible
	// values with $replace
	
	$search[0]	= '/\[ID (\d+)\](.*?)\[\/ID\]/';			$replace[0]	= '<a href="index.php?id=0,$1,0,0,1,0">$2</a>';
	$search[1]	= '/\[ID (\w+)\](.*?)\[\/ID\]/';			$replace[1]	= '<a href="index.php?$1">$2</a>';
	$search[2]	= '/\[EXT (.*?)\](.*?)\[\/EXT\]/';			$replace[2]	= '<a href="$1" target="_blank">$2</a>';
	$search[3]	= '/\[INT (.*?)\](.*?)\[\/INT\]/';			$replace[3]	= '<a href="$1" target="_top">$2</a>';
	$search[4]	= '/\{RANDOM_GIF:(.*?)\}/';					$replace[4]	= ' // ';
	$search[5]	= '/\{RANDOM_JPEG:(.*?)\}/';				$replace[5]	= ' // ';
	$search[6]	= '/\{RANDOM_PNG:(.*?)\}/';					$replace[6]	= ' // ';

	$search[7]		= '/\{IMAGE:(.*?)\}/';					$replace[7]	= '<img src="'.SITE_URL.'picture/$1" border="0">';
	$search[8]		= '/\{IMAGE_LEFT:(.*?)\}/';				$replace[8]	= '<img src="'.SITE_URL.'picture/$1" border="0" align="left">';
	$search[9]		= '/\{IMAGE_RIGHT:(.*?)\}/';			$replace[9]	= '<img src="'.SITE_URL.'picture/$1" border="0" align="right">';
	$search[10]		= '/\{IMAGE_CENTER:(.*?)\}/';			$replace[10]= '<div align="center"><img src="'.SITE_URL.'picture/$1" border="0"></div>';

	$search[11]	 	= '/\{SPACER:(\d+)x(\d+)\}/';			$replace[11]= '<img src="'.SITE_URL.'img/leer.gif" border="0" width="$1" height="$2">';
	
	$search[12]		= '/\[RSS (\d+)\](.*?)\[\/RSS\]/';		$replace[12]= '<a href="'.SITE_URL.'rss.php?rssfeed=$1" target="_blank">$2</a>';
	$search[13]		= '/\[RSS (\w+)\](.*?)\[\/RSS\]/';		$replace[13]= '<a href="'.SITE_URL.'rss.php?$1" target="_blank">$2</a>';

	$search[14]		= '/\[BACK\](.*?)\[\/BACK\]/i';			$replace[14]= '<a href="javascript:history.back();" target="_top" alt="go back">$1</a>';
	$search[15]		= '/\{RANDOM:(.*?)\}/e';				$replace[15]	= ' ';

	$search[16]		= '/\[(span|div)_style:(.*?)\](.*?)\[\/style\]/';	$replace[16]	= '<$1 style="$2">$3</$1>';
	$search[17]		= '/\[(span|div)_class:(.*?)\](.*?)\[\/class\]/';	$replace[17]	= '<$1 class="$2">$3</$1>';

	$search[18]		= '/\[i\](.*?)\[\/i\]/i';			$replace[18]	= '<i>$1</i>';
	$search[19]		= '/\[u\](.*?)\[\/u\]/i';			$replace[19]	= '<u>$1</u>';
	$search[20]		= '/\[s\](.*?)\[\/s\]/i';			$replace[20]	= '<strike>$1</strike>';
	$search[21]		= '/\[b\](.*?)\[\/b\]/i';			$replace[21]	= '<strong>$1</strong>';
	
	$search[22]		= '/\[PRINT\](.*?)\[\/PRINT\]/i';	$replace[14]= ' ';
	
	return preg_replace($search, $replace, $string);
}

?>